module Model exposing (..)

import SmartPhoneType exposing (Smartphone)
import Zoom exposing (Zoom)


type alias Model =
    { data : List Smartphone
    , error : Maybe String
    , csvdata : String
    , scatterplotOptions : ScatterPlotOption
    , parallelPlotOption : ParallelPlotOption
    , treeOption : TreeOption
    , starplotOption : StarPlotOption
    , plotVisible :
        { scatterPlot : Bool
        , parallelCoordinatesPlot : Bool
        , treeView : Bool
        , starPlot : Bool
        }
    }


type alias ScatterPlotOption =
    { attribute1 : String
    , attribute2 : String
    , att1List : List (Maybe Float)
    , att2List : List (Maybe Float)
    , unit1 : String
    , unit2 : String
    }


type alias ParallelPlotOption =
    { orderedList : List (Smartphone -> Maybe Float)
    , orderedLabels : List String
    , orderedUnitLabels : List String
    , selectedFilter : FilterOptions
    }


type alias TreeOption =
    { zoomOption : Zoom
    , dropCount : Int
    , inputDropCount : String
    , selectedFilter : FilterOptions
    }


type alias FilterOptions =
    { brand : String
    , g5 : String
    , nfc : String
    , ir_blaster : String
    }


type alias StarPlotOption =
    { modelID1 : String
    , modelID2 : String
    , input1 : String
    , input2 : String
    , nextChange : Int
    }
