(function(scope){
'use strict';

function F(arity, fun, wrapper) {
  wrapper.a = arity;
  wrapper.f = fun;
  return wrapper;
}

function F2(fun) {
  return F(2, fun, function(a) { return function(b) { return fun(a,b); }; })
}
function F3(fun) {
  return F(3, fun, function(a) {
    return function(b) { return function(c) { return fun(a, b, c); }; };
  });
}
function F4(fun) {
  return F(4, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return fun(a, b, c, d); }; }; };
  });
}
function F5(fun) {
  return F(5, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return fun(a, b, c, d, e); }; }; }; };
  });
}
function F6(fun) {
  return F(6, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return fun(a, b, c, d, e, f); }; }; }; }; };
  });
}
function F7(fun) {
  return F(7, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return fun(a, b, c, d, e, f, g); }; }; }; }; }; };
  });
}
function F8(fun) {
  return F(8, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) {
    return fun(a, b, c, d, e, f, g, h); }; }; }; }; }; }; };
  });
}
function F9(fun) {
  return F(9, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) { return function(i) {
    return fun(a, b, c, d, e, f, g, h, i); }; }; }; }; }; }; }; };
  });
}

function A2(fun, a, b) {
  return fun.a === 2 ? fun.f(a, b) : fun(a)(b);
}
function A3(fun, a, b, c) {
  return fun.a === 3 ? fun.f(a, b, c) : fun(a)(b)(c);
}
function A4(fun, a, b, c, d) {
  return fun.a === 4 ? fun.f(a, b, c, d) : fun(a)(b)(c)(d);
}
function A5(fun, a, b, c, d, e) {
  return fun.a === 5 ? fun.f(a, b, c, d, e) : fun(a)(b)(c)(d)(e);
}
function A6(fun, a, b, c, d, e, f) {
  return fun.a === 6 ? fun.f(a, b, c, d, e, f) : fun(a)(b)(c)(d)(e)(f);
}
function A7(fun, a, b, c, d, e, f, g) {
  return fun.a === 7 ? fun.f(a, b, c, d, e, f, g) : fun(a)(b)(c)(d)(e)(f)(g);
}
function A8(fun, a, b, c, d, e, f, g, h) {
  return fun.a === 8 ? fun.f(a, b, c, d, e, f, g, h) : fun(a)(b)(c)(d)(e)(f)(g)(h);
}
function A9(fun, a, b, c, d, e, f, g, h, i) {
  return fun.a === 9 ? fun.f(a, b, c, d, e, f, g, h, i) : fun(a)(b)(c)(d)(e)(f)(g)(h)(i);
}

console.warn('Compiled in DEV mode. Follow the advice at https://elm-lang.org/0.19.1/optimize for better performance and smaller assets.');


// EQUALITY

function _Utils_eq(x, y)
{
	for (
		var pair, stack = [], isEqual = _Utils_eqHelp(x, y, 0, stack);
		isEqual && (pair = stack.pop());
		isEqual = _Utils_eqHelp(pair.a, pair.b, 0, stack)
		)
	{}

	return isEqual;
}

function _Utils_eqHelp(x, y, depth, stack)
{
	if (x === y)
	{
		return true;
	}

	if (typeof x !== 'object' || x === null || y === null)
	{
		typeof x === 'function' && _Debug_crash(5);
		return false;
	}

	if (depth > 100)
	{
		stack.push(_Utils_Tuple2(x,y));
		return true;
	}

	/**/
	if (x.$ === 'Set_elm_builtin')
	{
		x = $elm$core$Set$toList(x);
		y = $elm$core$Set$toList(y);
	}
	if (x.$ === 'RBNode_elm_builtin' || x.$ === 'RBEmpty_elm_builtin')
	{
		x = $elm$core$Dict$toList(x);
		y = $elm$core$Dict$toList(y);
	}
	//*/

	/**_UNUSED/
	if (x.$ < 0)
	{
		x = $elm$core$Dict$toList(x);
		y = $elm$core$Dict$toList(y);
	}
	//*/

	for (var key in x)
	{
		if (!_Utils_eqHelp(x[key], y[key], depth + 1, stack))
		{
			return false;
		}
	}
	return true;
}

var _Utils_equal = F2(_Utils_eq);
var _Utils_notEqual = F2(function(a, b) { return !_Utils_eq(a,b); });



// COMPARISONS

// Code in Generate/JavaScript.hs, Basics.js, and List.js depends on
// the particular integer values assigned to LT, EQ, and GT.

function _Utils_cmp(x, y, ord)
{
	if (typeof x !== 'object')
	{
		return x === y ? /*EQ*/ 0 : x < y ? /*LT*/ -1 : /*GT*/ 1;
	}

	/**/
	if (x instanceof String)
	{
		var a = x.valueOf();
		var b = y.valueOf();
		return a === b ? 0 : a < b ? -1 : 1;
	}
	//*/

	/**_UNUSED/
	if (typeof x.$ === 'undefined')
	//*/
	/**/
	if (x.$[0] === '#')
	//*/
	{
		return (ord = _Utils_cmp(x.a, y.a))
			? ord
			: (ord = _Utils_cmp(x.b, y.b))
				? ord
				: _Utils_cmp(x.c, y.c);
	}

	// traverse conses until end of a list or a mismatch
	for (; x.b && y.b && !(ord = _Utils_cmp(x.a, y.a)); x = x.b, y = y.b) {} // WHILE_CONSES
	return ord || (x.b ? /*GT*/ 1 : y.b ? /*LT*/ -1 : /*EQ*/ 0);
}

var _Utils_lt = F2(function(a, b) { return _Utils_cmp(a, b) < 0; });
var _Utils_le = F2(function(a, b) { return _Utils_cmp(a, b) < 1; });
var _Utils_gt = F2(function(a, b) { return _Utils_cmp(a, b) > 0; });
var _Utils_ge = F2(function(a, b) { return _Utils_cmp(a, b) >= 0; });

var _Utils_compare = F2(function(x, y)
{
	var n = _Utils_cmp(x, y);
	return n < 0 ? $elm$core$Basics$LT : n ? $elm$core$Basics$GT : $elm$core$Basics$EQ;
});


// COMMON VALUES

var _Utils_Tuple0_UNUSED = 0;
var _Utils_Tuple0 = { $: '#0' };

function _Utils_Tuple2_UNUSED(a, b) { return { a: a, b: b }; }
function _Utils_Tuple2(a, b) { return { $: '#2', a: a, b: b }; }

function _Utils_Tuple3_UNUSED(a, b, c) { return { a: a, b: b, c: c }; }
function _Utils_Tuple3(a, b, c) { return { $: '#3', a: a, b: b, c: c }; }

function _Utils_chr_UNUSED(c) { return c; }
function _Utils_chr(c) { return new String(c); }


// RECORDS

function _Utils_update(oldRecord, updatedFields)
{
	var newRecord = {};

	for (var key in oldRecord)
	{
		newRecord[key] = oldRecord[key];
	}

	for (var key in updatedFields)
	{
		newRecord[key] = updatedFields[key];
	}

	return newRecord;
}


// APPEND

var _Utils_append = F2(_Utils_ap);

function _Utils_ap(xs, ys)
{
	// append Strings
	if (typeof xs === 'string')
	{
		return xs + ys;
	}

	// append Lists
	if (!xs.b)
	{
		return ys;
	}
	var root = _List_Cons(xs.a, ys);
	xs = xs.b
	for (var curr = root; xs.b; xs = xs.b) // WHILE_CONS
	{
		curr = curr.b = _List_Cons(xs.a, ys);
	}
	return root;
}



var _List_Nil_UNUSED = { $: 0 };
var _List_Nil = { $: '[]' };

function _List_Cons_UNUSED(hd, tl) { return { $: 1, a: hd, b: tl }; }
function _List_Cons(hd, tl) { return { $: '::', a: hd, b: tl }; }


var _List_cons = F2(_List_Cons);

function _List_fromArray(arr)
{
	var out = _List_Nil;
	for (var i = arr.length; i--; )
	{
		out = _List_Cons(arr[i], out);
	}
	return out;
}

function _List_toArray(xs)
{
	for (var out = []; xs.b; xs = xs.b) // WHILE_CONS
	{
		out.push(xs.a);
	}
	return out;
}

var _List_map2 = F3(function(f, xs, ys)
{
	for (var arr = []; xs.b && ys.b; xs = xs.b, ys = ys.b) // WHILE_CONSES
	{
		arr.push(A2(f, xs.a, ys.a));
	}
	return _List_fromArray(arr);
});

var _List_map3 = F4(function(f, xs, ys, zs)
{
	for (var arr = []; xs.b && ys.b && zs.b; xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A3(f, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map4 = F5(function(f, ws, xs, ys, zs)
{
	for (var arr = []; ws.b && xs.b && ys.b && zs.b; ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A4(f, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map5 = F6(function(f, vs, ws, xs, ys, zs)
{
	for (var arr = []; vs.b && ws.b && xs.b && ys.b && zs.b; vs = vs.b, ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A5(f, vs.a, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_sortBy = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		return _Utils_cmp(f(a), f(b));
	}));
});

var _List_sortWith = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		var ord = A2(f, a, b);
		return ord === $elm$core$Basics$EQ ? 0 : ord === $elm$core$Basics$LT ? -1 : 1;
	}));
});



var _JsArray_empty = [];

function _JsArray_singleton(value)
{
    return [value];
}

function _JsArray_length(array)
{
    return array.length;
}

var _JsArray_initialize = F3(function(size, offset, func)
{
    var result = new Array(size);

    for (var i = 0; i < size; i++)
    {
        result[i] = func(offset + i);
    }

    return result;
});

var _JsArray_initializeFromList = F2(function (max, ls)
{
    var result = new Array(max);

    for (var i = 0; i < max && ls.b; i++)
    {
        result[i] = ls.a;
        ls = ls.b;
    }

    result.length = i;
    return _Utils_Tuple2(result, ls);
});

var _JsArray_unsafeGet = F2(function(index, array)
{
    return array[index];
});

var _JsArray_unsafeSet = F3(function(index, value, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[index] = value;
    return result;
});

var _JsArray_push = F2(function(value, array)
{
    var length = array.length;
    var result = new Array(length + 1);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[length] = value;
    return result;
});

var _JsArray_foldl = F3(function(func, acc, array)
{
    var length = array.length;

    for (var i = 0; i < length; i++)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_foldr = F3(function(func, acc, array)
{
    for (var i = array.length - 1; i >= 0; i--)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_map = F2(function(func, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = func(array[i]);
    }

    return result;
});

var _JsArray_indexedMap = F3(function(func, offset, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = A2(func, offset + i, array[i]);
    }

    return result;
});

var _JsArray_slice = F3(function(from, to, array)
{
    return array.slice(from, to);
});

var _JsArray_appendN = F3(function(n, dest, source)
{
    var destLen = dest.length;
    var itemsToCopy = n - destLen;

    if (itemsToCopy > source.length)
    {
        itemsToCopy = source.length;
    }

    var size = destLen + itemsToCopy;
    var result = new Array(size);

    for (var i = 0; i < destLen; i++)
    {
        result[i] = dest[i];
    }

    for (var i = 0; i < itemsToCopy; i++)
    {
        result[i + destLen] = source[i];
    }

    return result;
});



// LOG

var _Debug_log_UNUSED = F2(function(tag, value)
{
	return value;
});

var _Debug_log = F2(function(tag, value)
{
	console.log(tag + ': ' + _Debug_toString(value));
	return value;
});


// TODOS

function _Debug_todo(moduleName, region)
{
	return function(message) {
		_Debug_crash(8, moduleName, region, message);
	};
}

function _Debug_todoCase(moduleName, region, value)
{
	return function(message) {
		_Debug_crash(9, moduleName, region, value, message);
	};
}


// TO STRING

function _Debug_toString_UNUSED(value)
{
	return '<internals>';
}

function _Debug_toString(value)
{
	return _Debug_toAnsiString(false, value);
}

function _Debug_toAnsiString(ansi, value)
{
	if (typeof value === 'function')
	{
		return _Debug_internalColor(ansi, '<function>');
	}

	if (typeof value === 'boolean')
	{
		return _Debug_ctorColor(ansi, value ? 'True' : 'False');
	}

	if (typeof value === 'number')
	{
		return _Debug_numberColor(ansi, value + '');
	}

	if (value instanceof String)
	{
		return _Debug_charColor(ansi, "'" + _Debug_addSlashes(value, true) + "'");
	}

	if (typeof value === 'string')
	{
		return _Debug_stringColor(ansi, '"' + _Debug_addSlashes(value, false) + '"');
	}

	if (typeof value === 'object' && '$' in value)
	{
		var tag = value.$;

		if (typeof tag === 'number')
		{
			return _Debug_internalColor(ansi, '<internals>');
		}

		if (tag[0] === '#')
		{
			var output = [];
			for (var k in value)
			{
				if (k === '$') continue;
				output.push(_Debug_toAnsiString(ansi, value[k]));
			}
			return '(' + output.join(',') + ')';
		}

		if (tag === 'Set_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Set')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Set$toList(value));
		}

		if (tag === 'RBNode_elm_builtin' || tag === 'RBEmpty_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Dict')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Dict$toList(value));
		}

		if (tag === 'Array_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Array')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Array$toList(value));
		}

		if (tag === '::' || tag === '[]')
		{
			var output = '[';

			value.b && (output += _Debug_toAnsiString(ansi, value.a), value = value.b)

			for (; value.b; value = value.b) // WHILE_CONS
			{
				output += ',' + _Debug_toAnsiString(ansi, value.a);
			}
			return output + ']';
		}

		var output = '';
		for (var i in value)
		{
			if (i === '$') continue;
			var str = _Debug_toAnsiString(ansi, value[i]);
			var c0 = str[0];
			var parenless = c0 === '{' || c0 === '(' || c0 === '[' || c0 === '<' || c0 === '"' || str.indexOf(' ') < 0;
			output += ' ' + (parenless ? str : '(' + str + ')');
		}
		return _Debug_ctorColor(ansi, tag) + output;
	}

	if (typeof DataView === 'function' && value instanceof DataView)
	{
		return _Debug_stringColor(ansi, '<' + value.byteLength + ' bytes>');
	}

	if (typeof File !== 'undefined' && value instanceof File)
	{
		return _Debug_internalColor(ansi, '<' + value.name + '>');
	}

	if (typeof value === 'object')
	{
		var output = [];
		for (var key in value)
		{
			var field = key[0] === '_' ? key.slice(1) : key;
			output.push(_Debug_fadeColor(ansi, field) + ' = ' + _Debug_toAnsiString(ansi, value[key]));
		}
		if (output.length === 0)
		{
			return '{}';
		}
		return '{ ' + output.join(', ') + ' }';
	}

	return _Debug_internalColor(ansi, '<internals>');
}

function _Debug_addSlashes(str, isChar)
{
	var s = str
		.replace(/\\/g, '\\\\')
		.replace(/\n/g, '\\n')
		.replace(/\t/g, '\\t')
		.replace(/\r/g, '\\r')
		.replace(/\v/g, '\\v')
		.replace(/\0/g, '\\0');

	if (isChar)
	{
		return s.replace(/\'/g, '\\\'');
	}
	else
	{
		return s.replace(/\"/g, '\\"');
	}
}

function _Debug_ctorColor(ansi, string)
{
	return ansi ? '\x1b[96m' + string + '\x1b[0m' : string;
}

function _Debug_numberColor(ansi, string)
{
	return ansi ? '\x1b[95m' + string + '\x1b[0m' : string;
}

function _Debug_stringColor(ansi, string)
{
	return ansi ? '\x1b[93m' + string + '\x1b[0m' : string;
}

function _Debug_charColor(ansi, string)
{
	return ansi ? '\x1b[92m' + string + '\x1b[0m' : string;
}

function _Debug_fadeColor(ansi, string)
{
	return ansi ? '\x1b[37m' + string + '\x1b[0m' : string;
}

function _Debug_internalColor(ansi, string)
{
	return ansi ? '\x1b[36m' + string + '\x1b[0m' : string;
}

function _Debug_toHexDigit(n)
{
	return String.fromCharCode(n < 10 ? 48 + n : 55 + n);
}


// CRASH


function _Debug_crash_UNUSED(identifier)
{
	throw new Error('https://github.com/elm/core/blob/1.0.0/hints/' + identifier + '.md');
}


function _Debug_crash(identifier, fact1, fact2, fact3, fact4)
{
	switch(identifier)
	{
		case 0:
			throw new Error('What node should I take over? In JavaScript I need something like:\n\n    Elm.Main.init({\n        node: document.getElementById("elm-node")\n    })\n\nYou need to do this with any Browser.sandbox or Browser.element program.');

		case 1:
			throw new Error('Browser.application programs cannot handle URLs like this:\n\n    ' + document.location.href + '\n\nWhat is the root? The root of your file system? Try looking at this program with `elm reactor` or some other server.');

		case 2:
			var jsonErrorString = fact1;
			throw new Error('Problem with the flags given to your Elm program on initialization.\n\n' + jsonErrorString);

		case 3:
			var portName = fact1;
			throw new Error('There can only be one port named `' + portName + '`, but your program has multiple.');

		case 4:
			var portName = fact1;
			var problem = fact2;
			throw new Error('Trying to send an unexpected type of value through port `' + portName + '`:\n' + problem);

		case 5:
			throw new Error('Trying to use `(==)` on functions.\nThere is no way to know if functions are "the same" in the Elm sense.\nRead more about this at https://package.elm-lang.org/packages/elm/core/latest/Basics#== which describes why it is this way and what the better version will look like.');

		case 6:
			var moduleName = fact1;
			throw new Error('Your page is loading multiple Elm scripts with a module named ' + moduleName + '. Maybe a duplicate script is getting loaded accidentally? If not, rename one of them so I know which is which!');

		case 8:
			var moduleName = fact1;
			var region = fact2;
			var message = fact3;
			throw new Error('TODO in module `' + moduleName + '` ' + _Debug_regionToString(region) + '\n\n' + message);

		case 9:
			var moduleName = fact1;
			var region = fact2;
			var value = fact3;
			var message = fact4;
			throw new Error(
				'TODO in module `' + moduleName + '` from the `case` expression '
				+ _Debug_regionToString(region) + '\n\nIt received the following value:\n\n    '
				+ _Debug_toString(value).replace('\n', '\n    ')
				+ '\n\nBut the branch that handles it says:\n\n    ' + message.replace('\n', '\n    ')
			);

		case 10:
			throw new Error('Bug in https://github.com/elm/virtual-dom/issues');

		case 11:
			throw new Error('Cannot perform mod 0. Division by zero error.');
	}
}

function _Debug_regionToString(region)
{
	if (region.start.line === region.end.line)
	{
		return 'on line ' + region.start.line;
	}
	return 'on lines ' + region.start.line + ' through ' + region.end.line;
}



// MATH

var _Basics_add = F2(function(a, b) { return a + b; });
var _Basics_sub = F2(function(a, b) { return a - b; });
var _Basics_mul = F2(function(a, b) { return a * b; });
var _Basics_fdiv = F2(function(a, b) { return a / b; });
var _Basics_idiv = F2(function(a, b) { return (a / b) | 0; });
var _Basics_pow = F2(Math.pow);

var _Basics_remainderBy = F2(function(b, a) { return a % b; });

// https://www.microsoft.com/en-us/research/wp-content/uploads/2016/02/divmodnote-letter.pdf
var _Basics_modBy = F2(function(modulus, x)
{
	var answer = x % modulus;
	return modulus === 0
		? _Debug_crash(11)
		:
	((answer > 0 && modulus < 0) || (answer < 0 && modulus > 0))
		? answer + modulus
		: answer;
});


// TRIGONOMETRY

var _Basics_pi = Math.PI;
var _Basics_e = Math.E;
var _Basics_cos = Math.cos;
var _Basics_sin = Math.sin;
var _Basics_tan = Math.tan;
var _Basics_acos = Math.acos;
var _Basics_asin = Math.asin;
var _Basics_atan = Math.atan;
var _Basics_atan2 = F2(Math.atan2);


// MORE MATH

function _Basics_toFloat(x) { return x; }
function _Basics_truncate(n) { return n | 0; }
function _Basics_isInfinite(n) { return n === Infinity || n === -Infinity; }

var _Basics_ceiling = Math.ceil;
var _Basics_floor = Math.floor;
var _Basics_round = Math.round;
var _Basics_sqrt = Math.sqrt;
var _Basics_log = Math.log;
var _Basics_isNaN = isNaN;


// BOOLEANS

function _Basics_not(bool) { return !bool; }
var _Basics_and = F2(function(a, b) { return a && b; });
var _Basics_or  = F2(function(a, b) { return a || b; });
var _Basics_xor = F2(function(a, b) { return a !== b; });



var _String_cons = F2(function(chr, str)
{
	return chr + str;
});

function _String_uncons(string)
{
	var word = string.charCodeAt(0);
	return !isNaN(word)
		? $elm$core$Maybe$Just(
			0xD800 <= word && word <= 0xDBFF
				? _Utils_Tuple2(_Utils_chr(string[0] + string[1]), string.slice(2))
				: _Utils_Tuple2(_Utils_chr(string[0]), string.slice(1))
		)
		: $elm$core$Maybe$Nothing;
}

var _String_append = F2(function(a, b)
{
	return a + b;
});

function _String_length(str)
{
	return str.length;
}

var _String_map = F2(function(func, string)
{
	var len = string.length;
	var array = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = string.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			array[i] = func(_Utils_chr(string[i] + string[i+1]));
			i += 2;
			continue;
		}
		array[i] = func(_Utils_chr(string[i]));
		i++;
	}
	return array.join('');
});

var _String_filter = F2(function(isGood, str)
{
	var arr = [];
	var len = str.length;
	var i = 0;
	while (i < len)
	{
		var char = str[i];
		var word = str.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += str[i];
			i++;
		}

		if (isGood(_Utils_chr(char)))
		{
			arr.push(char);
		}
	}
	return arr.join('');
});

function _String_reverse(str)
{
	var len = str.length;
	var arr = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = str.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			arr[len - i] = str[i + 1];
			i++;
			arr[len - i] = str[i - 1];
			i++;
		}
		else
		{
			arr[len - i] = str[i];
			i++;
		}
	}
	return arr.join('');
}

var _String_foldl = F3(function(func, state, string)
{
	var len = string.length;
	var i = 0;
	while (i < len)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += string[i];
			i++;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_foldr = F3(function(func, state, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_split = F2(function(sep, str)
{
	return str.split(sep);
});

var _String_join = F2(function(sep, strs)
{
	return strs.join(sep);
});

var _String_slice = F3(function(start, end, str) {
	return str.slice(start, end);
});

function _String_trim(str)
{
	return str.trim();
}

function _String_trimLeft(str)
{
	return str.replace(/^\s+/, '');
}

function _String_trimRight(str)
{
	return str.replace(/\s+$/, '');
}

function _String_words(str)
{
	return _List_fromArray(str.trim().split(/\s+/g));
}

function _String_lines(str)
{
	return _List_fromArray(str.split(/\r\n|\r|\n/g));
}

function _String_toUpper(str)
{
	return str.toUpperCase();
}

function _String_toLower(str)
{
	return str.toLowerCase();
}

var _String_any = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (isGood(_Utils_chr(char)))
		{
			return true;
		}
	}
	return false;
});

var _String_all = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (!isGood(_Utils_chr(char)))
		{
			return false;
		}
	}
	return true;
});

var _String_contains = F2(function(sub, str)
{
	return str.indexOf(sub) > -1;
});

var _String_startsWith = F2(function(sub, str)
{
	return str.indexOf(sub) === 0;
});

var _String_endsWith = F2(function(sub, str)
{
	return str.length >= sub.length &&
		str.lastIndexOf(sub) === str.length - sub.length;
});

var _String_indexes = F2(function(sub, str)
{
	var subLen = sub.length;

	if (subLen < 1)
	{
		return _List_Nil;
	}

	var i = 0;
	var is = [];

	while ((i = str.indexOf(sub, i)) > -1)
	{
		is.push(i);
		i = i + subLen;
	}

	return _List_fromArray(is);
});


// TO STRING

function _String_fromNumber(number)
{
	return number + '';
}


// INT CONVERSIONS

function _String_toInt(str)
{
	var total = 0;
	var code0 = str.charCodeAt(0);
	var start = code0 == 0x2B /* + */ || code0 == 0x2D /* - */ ? 1 : 0;

	for (var i = start; i < str.length; ++i)
	{
		var code = str.charCodeAt(i);
		if (code < 0x30 || 0x39 < code)
		{
			return $elm$core$Maybe$Nothing;
		}
		total = 10 * total + code - 0x30;
	}

	return i == start
		? $elm$core$Maybe$Nothing
		: $elm$core$Maybe$Just(code0 == 0x2D ? -total : total);
}


// FLOAT CONVERSIONS

function _String_toFloat(s)
{
	// check if it is a hex, octal, or binary number
	if (s.length === 0 || /[\sxbo]/.test(s))
	{
		return $elm$core$Maybe$Nothing;
	}
	var n = +s;
	// faster isNaN check
	return n === n ? $elm$core$Maybe$Just(n) : $elm$core$Maybe$Nothing;
}

function _String_fromList(chars)
{
	return _List_toArray(chars).join('');
}




function _Char_toCode(char)
{
	var code = char.charCodeAt(0);
	if (0xD800 <= code && code <= 0xDBFF)
	{
		return (code - 0xD800) * 0x400 + char.charCodeAt(1) - 0xDC00 + 0x10000
	}
	return code;
}

function _Char_fromCode(code)
{
	return _Utils_chr(
		(code < 0 || 0x10FFFF < code)
			? '\uFFFD'
			:
		(code <= 0xFFFF)
			? String.fromCharCode(code)
			:
		(code -= 0x10000,
			String.fromCharCode(Math.floor(code / 0x400) + 0xD800, code % 0x400 + 0xDC00)
		)
	);
}

function _Char_toUpper(char)
{
	return _Utils_chr(char.toUpperCase());
}

function _Char_toLower(char)
{
	return _Utils_chr(char.toLowerCase());
}

function _Char_toLocaleUpper(char)
{
	return _Utils_chr(char.toLocaleUpperCase());
}

function _Char_toLocaleLower(char)
{
	return _Utils_chr(char.toLocaleLowerCase());
}



/**/
function _Json_errorToString(error)
{
	return $elm$json$Json$Decode$errorToString(error);
}
//*/


// CORE DECODERS

function _Json_succeed(msg)
{
	return {
		$: 0,
		a: msg
	};
}

function _Json_fail(msg)
{
	return {
		$: 1,
		a: msg
	};
}

function _Json_decodePrim(decoder)
{
	return { $: 2, b: decoder };
}

var _Json_decodeInt = _Json_decodePrim(function(value) {
	return (typeof value !== 'number')
		? _Json_expecting('an INT', value)
		:
	(-2147483647 < value && value < 2147483647 && (value | 0) === value)
		? $elm$core$Result$Ok(value)
		:
	(isFinite(value) && !(value % 1))
		? $elm$core$Result$Ok(value)
		: _Json_expecting('an INT', value);
});

var _Json_decodeBool = _Json_decodePrim(function(value) {
	return (typeof value === 'boolean')
		? $elm$core$Result$Ok(value)
		: _Json_expecting('a BOOL', value);
});

var _Json_decodeFloat = _Json_decodePrim(function(value) {
	return (typeof value === 'number')
		? $elm$core$Result$Ok(value)
		: _Json_expecting('a FLOAT', value);
});

var _Json_decodeValue = _Json_decodePrim(function(value) {
	return $elm$core$Result$Ok(_Json_wrap(value));
});

var _Json_decodeString = _Json_decodePrim(function(value) {
	return (typeof value === 'string')
		? $elm$core$Result$Ok(value)
		: (value instanceof String)
			? $elm$core$Result$Ok(value + '')
			: _Json_expecting('a STRING', value);
});

function _Json_decodeList(decoder) { return { $: 3, b: decoder }; }
function _Json_decodeArray(decoder) { return { $: 4, b: decoder }; }

function _Json_decodeNull(value) { return { $: 5, c: value }; }

var _Json_decodeField = F2(function(field, decoder)
{
	return {
		$: 6,
		d: field,
		b: decoder
	};
});

var _Json_decodeIndex = F2(function(index, decoder)
{
	return {
		$: 7,
		e: index,
		b: decoder
	};
});

function _Json_decodeKeyValuePairs(decoder)
{
	return {
		$: 8,
		b: decoder
	};
}

function _Json_mapMany(f, decoders)
{
	return {
		$: 9,
		f: f,
		g: decoders
	};
}

var _Json_andThen = F2(function(callback, decoder)
{
	return {
		$: 10,
		b: decoder,
		h: callback
	};
});

function _Json_oneOf(decoders)
{
	return {
		$: 11,
		g: decoders
	};
}


// DECODING OBJECTS

var _Json_map1 = F2(function(f, d1)
{
	return _Json_mapMany(f, [d1]);
});

var _Json_map2 = F3(function(f, d1, d2)
{
	return _Json_mapMany(f, [d1, d2]);
});

var _Json_map3 = F4(function(f, d1, d2, d3)
{
	return _Json_mapMany(f, [d1, d2, d3]);
});

var _Json_map4 = F5(function(f, d1, d2, d3, d4)
{
	return _Json_mapMany(f, [d1, d2, d3, d4]);
});

var _Json_map5 = F6(function(f, d1, d2, d3, d4, d5)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5]);
});

var _Json_map6 = F7(function(f, d1, d2, d3, d4, d5, d6)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6]);
});

var _Json_map7 = F8(function(f, d1, d2, d3, d4, d5, d6, d7)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7]);
});

var _Json_map8 = F9(function(f, d1, d2, d3, d4, d5, d6, d7, d8)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7, d8]);
});


// DECODE

var _Json_runOnString = F2(function(decoder, string)
{
	try
	{
		var value = JSON.parse(string);
		return _Json_runHelp(decoder, value);
	}
	catch (e)
	{
		return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, 'This is not valid JSON! ' + e.message, _Json_wrap(string)));
	}
});

var _Json_run = F2(function(decoder, value)
{
	return _Json_runHelp(decoder, _Json_unwrap(value));
});

function _Json_runHelp(decoder, value)
{
	switch (decoder.$)
	{
		case 2:
			return decoder.b(value);

		case 5:
			return (value === null)
				? $elm$core$Result$Ok(decoder.c)
				: _Json_expecting('null', value);

		case 3:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('a LIST', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _List_fromArray);

		case 4:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _Json_toElmArray);

		case 6:
			var field = decoder.d;
			if (typeof value !== 'object' || value === null || !(field in value))
			{
				return _Json_expecting('an OBJECT with a field named `' + field + '`', value);
			}
			var result = _Json_runHelp(decoder.b, value[field]);
			return ($elm$core$Result$isOk(result)) ? result : $elm$core$Result$Err(A2($elm$json$Json$Decode$Field, field, result.a));

		case 7:
			var index = decoder.e;
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			if (index >= value.length)
			{
				return _Json_expecting('a LONGER array. Need index ' + index + ' but only see ' + value.length + ' entries', value);
			}
			var result = _Json_runHelp(decoder.b, value[index]);
			return ($elm$core$Result$isOk(result)) ? result : $elm$core$Result$Err(A2($elm$json$Json$Decode$Index, index, result.a));

		case 8:
			if (typeof value !== 'object' || value === null || _Json_isArray(value))
			{
				return _Json_expecting('an OBJECT', value);
			}

			var keyValuePairs = _List_Nil;
			// TODO test perf of Object.keys and switch when support is good enough
			for (var key in value)
			{
				if (value.hasOwnProperty(key))
				{
					var result = _Json_runHelp(decoder.b, value[key]);
					if (!$elm$core$Result$isOk(result))
					{
						return $elm$core$Result$Err(A2($elm$json$Json$Decode$Field, key, result.a));
					}
					keyValuePairs = _List_Cons(_Utils_Tuple2(key, result.a), keyValuePairs);
				}
			}
			return $elm$core$Result$Ok($elm$core$List$reverse(keyValuePairs));

		case 9:
			var answer = decoder.f;
			var decoders = decoder.g;
			for (var i = 0; i < decoders.length; i++)
			{
				var result = _Json_runHelp(decoders[i], value);
				if (!$elm$core$Result$isOk(result))
				{
					return result;
				}
				answer = answer(result.a);
			}
			return $elm$core$Result$Ok(answer);

		case 10:
			var result = _Json_runHelp(decoder.b, value);
			return (!$elm$core$Result$isOk(result))
				? result
				: _Json_runHelp(decoder.h(result.a), value);

		case 11:
			var errors = _List_Nil;
			for (var temp = decoder.g; temp.b; temp = temp.b) // WHILE_CONS
			{
				var result = _Json_runHelp(temp.a, value);
				if ($elm$core$Result$isOk(result))
				{
					return result;
				}
				errors = _List_Cons(result.a, errors);
			}
			return $elm$core$Result$Err($elm$json$Json$Decode$OneOf($elm$core$List$reverse(errors)));

		case 1:
			return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, decoder.a, _Json_wrap(value)));

		case 0:
			return $elm$core$Result$Ok(decoder.a);
	}
}

function _Json_runArrayDecoder(decoder, value, toElmValue)
{
	var len = value.length;
	var array = new Array(len);
	for (var i = 0; i < len; i++)
	{
		var result = _Json_runHelp(decoder, value[i]);
		if (!$elm$core$Result$isOk(result))
		{
			return $elm$core$Result$Err(A2($elm$json$Json$Decode$Index, i, result.a));
		}
		array[i] = result.a;
	}
	return $elm$core$Result$Ok(toElmValue(array));
}

function _Json_isArray(value)
{
	return Array.isArray(value) || (typeof FileList !== 'undefined' && value instanceof FileList);
}

function _Json_toElmArray(array)
{
	return A2($elm$core$Array$initialize, array.length, function(i) { return array[i]; });
}

function _Json_expecting(type, value)
{
	return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, 'Expecting ' + type, _Json_wrap(value)));
}


// EQUALITY

function _Json_equality(x, y)
{
	if (x === y)
	{
		return true;
	}

	if (x.$ !== y.$)
	{
		return false;
	}

	switch (x.$)
	{
		case 0:
		case 1:
			return x.a === y.a;

		case 2:
			return x.b === y.b;

		case 5:
			return x.c === y.c;

		case 3:
		case 4:
		case 8:
			return _Json_equality(x.b, y.b);

		case 6:
			return x.d === y.d && _Json_equality(x.b, y.b);

		case 7:
			return x.e === y.e && _Json_equality(x.b, y.b);

		case 9:
			return x.f === y.f && _Json_listEquality(x.g, y.g);

		case 10:
			return x.h === y.h && _Json_equality(x.b, y.b);

		case 11:
			return _Json_listEquality(x.g, y.g);
	}
}

function _Json_listEquality(aDecoders, bDecoders)
{
	var len = aDecoders.length;
	if (len !== bDecoders.length)
	{
		return false;
	}
	for (var i = 0; i < len; i++)
	{
		if (!_Json_equality(aDecoders[i], bDecoders[i]))
		{
			return false;
		}
	}
	return true;
}


// ENCODE

var _Json_encode = F2(function(indentLevel, value)
{
	return JSON.stringify(_Json_unwrap(value), null, indentLevel) + '';
});

function _Json_wrap(value) { return { $: 0, a: value }; }
function _Json_unwrap(value) { return value.a; }

function _Json_wrap_UNUSED(value) { return value; }
function _Json_unwrap_UNUSED(value) { return value; }

function _Json_emptyArray() { return []; }
function _Json_emptyObject() { return {}; }

var _Json_addField = F3(function(key, value, object)
{
	object[key] = _Json_unwrap(value);
	return object;
});

function _Json_addEntry(func)
{
	return F2(function(entry, array)
	{
		array.push(_Json_unwrap(func(entry)));
		return array;
	});
}

var _Json_encodeNull = _Json_wrap(null);



// TASKS

function _Scheduler_succeed(value)
{
	return {
		$: 0,
		a: value
	};
}

function _Scheduler_fail(error)
{
	return {
		$: 1,
		a: error
	};
}

function _Scheduler_binding(callback)
{
	return {
		$: 2,
		b: callback,
		c: null
	};
}

var _Scheduler_andThen = F2(function(callback, task)
{
	return {
		$: 3,
		b: callback,
		d: task
	};
});

var _Scheduler_onError = F2(function(callback, task)
{
	return {
		$: 4,
		b: callback,
		d: task
	};
});

function _Scheduler_receive(callback)
{
	return {
		$: 5,
		b: callback
	};
}


// PROCESSES

var _Scheduler_guid = 0;

function _Scheduler_rawSpawn(task)
{
	var proc = {
		$: 0,
		e: _Scheduler_guid++,
		f: task,
		g: null,
		h: []
	};

	_Scheduler_enqueue(proc);

	return proc;
}

function _Scheduler_spawn(task)
{
	return _Scheduler_binding(function(callback) {
		callback(_Scheduler_succeed(_Scheduler_rawSpawn(task)));
	});
}

function _Scheduler_rawSend(proc, msg)
{
	proc.h.push(msg);
	_Scheduler_enqueue(proc);
}

var _Scheduler_send = F2(function(proc, msg)
{
	return _Scheduler_binding(function(callback) {
		_Scheduler_rawSend(proc, msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});

function _Scheduler_kill(proc)
{
	return _Scheduler_binding(function(callback) {
		var task = proc.f;
		if (task.$ === 2 && task.c)
		{
			task.c();
		}

		proc.f = null;

		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
}


/* STEP PROCESSES

type alias Process =
  { $ : tag
  , id : unique_id
  , root : Task
  , stack : null | { $: SUCCEED | FAIL, a: callback, b: stack }
  , mailbox : [msg]
  }

*/


var _Scheduler_working = false;
var _Scheduler_queue = [];


function _Scheduler_enqueue(proc)
{
	_Scheduler_queue.push(proc);
	if (_Scheduler_working)
	{
		return;
	}
	_Scheduler_working = true;
	while (proc = _Scheduler_queue.shift())
	{
		_Scheduler_step(proc);
	}
	_Scheduler_working = false;
}


function _Scheduler_step(proc)
{
	while (proc.f)
	{
		var rootTag = proc.f.$;
		if (rootTag === 0 || rootTag === 1)
		{
			while (proc.g && proc.g.$ !== rootTag)
			{
				proc.g = proc.g.i;
			}
			if (!proc.g)
			{
				return;
			}
			proc.f = proc.g.b(proc.f.a);
			proc.g = proc.g.i;
		}
		else if (rootTag === 2)
		{
			proc.f.c = proc.f.b(function(newRoot) {
				proc.f = newRoot;
				_Scheduler_enqueue(proc);
			});
			return;
		}
		else if (rootTag === 5)
		{
			if (proc.h.length === 0)
			{
				return;
			}
			proc.f = proc.f.b(proc.h.shift());
		}
		else // if (rootTag === 3 || rootTag === 4)
		{
			proc.g = {
				$: rootTag === 3 ? 0 : 1,
				b: proc.f.b,
				i: proc.g
			};
			proc.f = proc.f.d;
		}
	}
}



function _Process_sleep(time)
{
	return _Scheduler_binding(function(callback) {
		var id = setTimeout(function() {
			callback(_Scheduler_succeed(_Utils_Tuple0));
		}, time);

		return function() { clearTimeout(id); };
	});
}




// PROGRAMS


var _Platform_worker = F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function() { return function() {} }
	);
});



// INITIALIZE A PROGRAM


function _Platform_initialize(flagDecoder, args, init, update, subscriptions, stepperBuilder)
{
	var result = A2(_Json_run, flagDecoder, _Json_wrap(args ? args['flags'] : undefined));
	$elm$core$Result$isOk(result) || _Debug_crash(2 /**/, _Json_errorToString(result.a) /**/);
	var managers = {};
	var initPair = init(result.a);
	var model = initPair.a;
	var stepper = stepperBuilder(sendToApp, model);
	var ports = _Platform_setupEffects(managers, sendToApp);

	function sendToApp(msg, viewMetadata)
	{
		var pair = A2(update, msg, model);
		stepper(model = pair.a, viewMetadata);
		_Platform_enqueueEffects(managers, pair.b, subscriptions(model));
	}

	_Platform_enqueueEffects(managers, initPair.b, subscriptions(model));

	return ports ? { ports: ports } : {};
}



// TRACK PRELOADS
//
// This is used by code in elm/browser and elm/http
// to register any HTTP requests that are triggered by init.
//


var _Platform_preload;


function _Platform_registerPreload(url)
{
	_Platform_preload.add(url);
}



// EFFECT MANAGERS


var _Platform_effectManagers = {};


function _Platform_setupEffects(managers, sendToApp)
{
	var ports;

	// setup all necessary effect managers
	for (var key in _Platform_effectManagers)
	{
		var manager = _Platform_effectManagers[key];

		if (manager.a)
		{
			ports = ports || {};
			ports[key] = manager.a(key, sendToApp);
		}

		managers[key] = _Platform_instantiateManager(manager, sendToApp);
	}

	return ports;
}


function _Platform_createManager(init, onEffects, onSelfMsg, cmdMap, subMap)
{
	return {
		b: init,
		c: onEffects,
		d: onSelfMsg,
		e: cmdMap,
		f: subMap
	};
}


function _Platform_instantiateManager(info, sendToApp)
{
	var router = {
		g: sendToApp,
		h: undefined
	};

	var onEffects = info.c;
	var onSelfMsg = info.d;
	var cmdMap = info.e;
	var subMap = info.f;

	function loop(state)
	{
		return A2(_Scheduler_andThen, loop, _Scheduler_receive(function(msg)
		{
			var value = msg.a;

			if (msg.$ === 0)
			{
				return A3(onSelfMsg, router, value, state);
			}

			return cmdMap && subMap
				? A4(onEffects, router, value.i, value.j, state)
				: A3(onEffects, router, cmdMap ? value.i : value.j, state);
		}));
	}

	return router.h = _Scheduler_rawSpawn(A2(_Scheduler_andThen, loop, info.b));
}



// ROUTING


var _Platform_sendToApp = F2(function(router, msg)
{
	return _Scheduler_binding(function(callback)
	{
		router.g(msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});


var _Platform_sendToSelf = F2(function(router, msg)
{
	return A2(_Scheduler_send, router.h, {
		$: 0,
		a: msg
	});
});



// BAGS


function _Platform_leaf(home)
{
	return function(value)
	{
		return {
			$: 1,
			k: home,
			l: value
		};
	};
}


function _Platform_batch(list)
{
	return {
		$: 2,
		m: list
	};
}


var _Platform_map = F2(function(tagger, bag)
{
	return {
		$: 3,
		n: tagger,
		o: bag
	}
});



// PIPE BAGS INTO EFFECT MANAGERS
//
// Effects must be queued!
//
// Say your init contains a synchronous command, like Time.now or Time.here
//
//   - This will produce a batch of effects (FX_1)
//   - The synchronous task triggers the subsequent `update` call
//   - This will produce a batch of effects (FX_2)
//
// If we just start dispatching FX_2, subscriptions from FX_2 can be processed
// before subscriptions from FX_1. No good! Earlier versions of this code had
// this problem, leading to these reports:
//
//   https://github.com/elm/core/issues/980
//   https://github.com/elm/core/pull/981
//   https://github.com/elm/compiler/issues/1776
//
// The queue is necessary to avoid ordering issues for synchronous commands.


// Why use true/false here? Why not just check the length of the queue?
// The goal is to detect "are we currently dispatching effects?" If we
// are, we need to bail and let the ongoing while loop handle things.
//
// Now say the queue has 1 element. When we dequeue the final element,
// the queue will be empty, but we are still actively dispatching effects.
// So you could get queue jumping in a really tricky category of cases.
//
var _Platform_effectsQueue = [];
var _Platform_effectsActive = false;


function _Platform_enqueueEffects(managers, cmdBag, subBag)
{
	_Platform_effectsQueue.push({ p: managers, q: cmdBag, r: subBag });

	if (_Platform_effectsActive) return;

	_Platform_effectsActive = true;
	for (var fx; fx = _Platform_effectsQueue.shift(); )
	{
		_Platform_dispatchEffects(fx.p, fx.q, fx.r);
	}
	_Platform_effectsActive = false;
}


function _Platform_dispatchEffects(managers, cmdBag, subBag)
{
	var effectsDict = {};
	_Platform_gatherEffects(true, cmdBag, effectsDict, null);
	_Platform_gatherEffects(false, subBag, effectsDict, null);

	for (var home in managers)
	{
		_Scheduler_rawSend(managers[home], {
			$: 'fx',
			a: effectsDict[home] || { i: _List_Nil, j: _List_Nil }
		});
	}
}


function _Platform_gatherEffects(isCmd, bag, effectsDict, taggers)
{
	switch (bag.$)
	{
		case 1:
			var home = bag.k;
			var effect = _Platform_toEffect(isCmd, home, taggers, bag.l);
			effectsDict[home] = _Platform_insert(isCmd, effect, effectsDict[home]);
			return;

		case 2:
			for (var list = bag.m; list.b; list = list.b) // WHILE_CONS
			{
				_Platform_gatherEffects(isCmd, list.a, effectsDict, taggers);
			}
			return;

		case 3:
			_Platform_gatherEffects(isCmd, bag.o, effectsDict, {
				s: bag.n,
				t: taggers
			});
			return;
	}
}


function _Platform_toEffect(isCmd, home, taggers, value)
{
	function applyTaggers(x)
	{
		for (var temp = taggers; temp; temp = temp.t)
		{
			x = temp.s(x);
		}
		return x;
	}

	var map = isCmd
		? _Platform_effectManagers[home].e
		: _Platform_effectManagers[home].f;

	return A2(map, applyTaggers, value)
}


function _Platform_insert(isCmd, newEffect, effects)
{
	effects = effects || { i: _List_Nil, j: _List_Nil };

	isCmd
		? (effects.i = _List_Cons(newEffect, effects.i))
		: (effects.j = _List_Cons(newEffect, effects.j));

	return effects;
}



// PORTS


function _Platform_checkPortName(name)
{
	if (_Platform_effectManagers[name])
	{
		_Debug_crash(3, name)
	}
}



// OUTGOING PORTS


function _Platform_outgoingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		e: _Platform_outgoingPortMap,
		u: converter,
		a: _Platform_setupOutgoingPort
	};
	return _Platform_leaf(name);
}


var _Platform_outgoingPortMap = F2(function(tagger, value) { return value; });


function _Platform_setupOutgoingPort(name)
{
	var subs = [];
	var converter = _Platform_effectManagers[name].u;

	// CREATE MANAGER

	var init = _Process_sleep(0);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, cmdList, state)
	{
		for ( ; cmdList.b; cmdList = cmdList.b) // WHILE_CONS
		{
			// grab a separate reference to subs in case unsubscribe is called
			var currentSubs = subs;
			var value = _Json_unwrap(converter(cmdList.a));
			for (var i = 0; i < currentSubs.length; i++)
			{
				currentSubs[i](value);
			}
		}
		return init;
	});

	// PUBLIC API

	function subscribe(callback)
	{
		subs.push(callback);
	}

	function unsubscribe(callback)
	{
		// copy subs into a new array in case unsubscribe is called within a
		// subscribed callback
		subs = subs.slice();
		var index = subs.indexOf(callback);
		if (index >= 0)
		{
			subs.splice(index, 1);
		}
	}

	return {
		subscribe: subscribe,
		unsubscribe: unsubscribe
	};
}



// INCOMING PORTS


function _Platform_incomingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		f: _Platform_incomingPortMap,
		u: converter,
		a: _Platform_setupIncomingPort
	};
	return _Platform_leaf(name);
}


var _Platform_incomingPortMap = F2(function(tagger, finalTagger)
{
	return function(value)
	{
		return tagger(finalTagger(value));
	};
});


function _Platform_setupIncomingPort(name, sendToApp)
{
	var subs = _List_Nil;
	var converter = _Platform_effectManagers[name].u;

	// CREATE MANAGER

	var init = _Scheduler_succeed(null);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, subList, state)
	{
		subs = subList;
		return init;
	});

	// PUBLIC API

	function send(incomingValue)
	{
		var result = A2(_Json_run, converter, _Json_wrap(incomingValue));

		$elm$core$Result$isOk(result) || _Debug_crash(4, name, result.a);

		var value = result.a;
		for (var temp = subs; temp.b; temp = temp.b) // WHILE_CONS
		{
			sendToApp(temp.a(value));
		}
	}

	return { send: send };
}



// EXPORT ELM MODULES
//
// Have DEBUG and PROD versions so that we can (1) give nicer errors in
// debug mode and (2) not pay for the bits needed for that in prod mode.
//


function _Platform_export_UNUSED(exports)
{
	scope['Elm']
		? _Platform_mergeExportsProd(scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsProd(obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6)
				: _Platform_mergeExportsProd(obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}


function _Platform_export(exports)
{
	scope['Elm']
		? _Platform_mergeExportsDebug('Elm', scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsDebug(moduleName, obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6, moduleName)
				: _Platform_mergeExportsDebug(moduleName + '.' + name, obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}




// HELPERS


var _VirtualDom_divertHrefToApp;

var _VirtualDom_doc = typeof document !== 'undefined' ? document : {};


function _VirtualDom_appendChild(parent, child)
{
	parent.appendChild(child);
}

var _VirtualDom_init = F4(function(virtualNode, flagDecoder, debugMetadata, args)
{
	// NOTE: this function needs _Platform_export available to work

	/**_UNUSED/
	var node = args['node'];
	//*/
	/**/
	var node = args && args['node'] ? args['node'] : _Debug_crash(0);
	//*/

	node.parentNode.replaceChild(
		_VirtualDom_render(virtualNode, function() {}),
		node
	);

	return {};
});



// TEXT


function _VirtualDom_text(string)
{
	return {
		$: 0,
		a: string
	};
}



// NODE


var _VirtualDom_nodeNS = F2(function(namespace, tag)
{
	return F2(function(factList, kidList)
	{
		for (var kids = [], descendantsCount = 0; kidList.b; kidList = kidList.b) // WHILE_CONS
		{
			var kid = kidList.a;
			descendantsCount += (kid.b || 0);
			kids.push(kid);
		}
		descendantsCount += kids.length;

		return {
			$: 1,
			c: tag,
			d: _VirtualDom_organizeFacts(factList),
			e: kids,
			f: namespace,
			b: descendantsCount
		};
	});
});


var _VirtualDom_node = _VirtualDom_nodeNS(undefined);



// KEYED NODE


var _VirtualDom_keyedNodeNS = F2(function(namespace, tag)
{
	return F2(function(factList, kidList)
	{
		for (var kids = [], descendantsCount = 0; kidList.b; kidList = kidList.b) // WHILE_CONS
		{
			var kid = kidList.a;
			descendantsCount += (kid.b.b || 0);
			kids.push(kid);
		}
		descendantsCount += kids.length;

		return {
			$: 2,
			c: tag,
			d: _VirtualDom_organizeFacts(factList),
			e: kids,
			f: namespace,
			b: descendantsCount
		};
	});
});


var _VirtualDom_keyedNode = _VirtualDom_keyedNodeNS(undefined);



// CUSTOM


function _VirtualDom_custom(factList, model, render, diff)
{
	return {
		$: 3,
		d: _VirtualDom_organizeFacts(factList),
		g: model,
		h: render,
		i: diff
	};
}



// MAP


var _VirtualDom_map = F2(function(tagger, node)
{
	return {
		$: 4,
		j: tagger,
		k: node,
		b: 1 + (node.b || 0)
	};
});



// LAZY


function _VirtualDom_thunk(refs, thunk)
{
	return {
		$: 5,
		l: refs,
		m: thunk,
		k: undefined
	};
}

var _VirtualDom_lazy = F2(function(func, a)
{
	return _VirtualDom_thunk([func, a], function() {
		return func(a);
	});
});

var _VirtualDom_lazy2 = F3(function(func, a, b)
{
	return _VirtualDom_thunk([func, a, b], function() {
		return A2(func, a, b);
	});
});

var _VirtualDom_lazy3 = F4(function(func, a, b, c)
{
	return _VirtualDom_thunk([func, a, b, c], function() {
		return A3(func, a, b, c);
	});
});

var _VirtualDom_lazy4 = F5(function(func, a, b, c, d)
{
	return _VirtualDom_thunk([func, a, b, c, d], function() {
		return A4(func, a, b, c, d);
	});
});

var _VirtualDom_lazy5 = F6(function(func, a, b, c, d, e)
{
	return _VirtualDom_thunk([func, a, b, c, d, e], function() {
		return A5(func, a, b, c, d, e);
	});
});

var _VirtualDom_lazy6 = F7(function(func, a, b, c, d, e, f)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f], function() {
		return A6(func, a, b, c, d, e, f);
	});
});

var _VirtualDom_lazy7 = F8(function(func, a, b, c, d, e, f, g)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f, g], function() {
		return A7(func, a, b, c, d, e, f, g);
	});
});

var _VirtualDom_lazy8 = F9(function(func, a, b, c, d, e, f, g, h)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f, g, h], function() {
		return A8(func, a, b, c, d, e, f, g, h);
	});
});



// FACTS


var _VirtualDom_on = F2(function(key, handler)
{
	return {
		$: 'a0',
		n: key,
		o: handler
	};
});
var _VirtualDom_style = F2(function(key, value)
{
	return {
		$: 'a1',
		n: key,
		o: value
	};
});
var _VirtualDom_property = F2(function(key, value)
{
	return {
		$: 'a2',
		n: key,
		o: value
	};
});
var _VirtualDom_attribute = F2(function(key, value)
{
	return {
		$: 'a3',
		n: key,
		o: value
	};
});
var _VirtualDom_attributeNS = F3(function(namespace, key, value)
{
	return {
		$: 'a4',
		n: key,
		o: { f: namespace, o: value }
	};
});



// XSS ATTACK VECTOR CHECKS
//
// For some reason, tabs can appear in href protocols and it still works.
// So '\tjava\tSCRIPT:alert("!!!")' and 'javascript:alert("!!!")' are the same
// in practice. That is why _VirtualDom_RE_js and _VirtualDom_RE_js_html look
// so freaky.
//
// Pulling the regular expressions out to the top level gives a slight speed
// boost in small benchmarks (4-10%) but hoisting values to reduce allocation
// can be unpredictable in large programs where JIT may have a harder time with
// functions are not fully self-contained. The benefit is more that the js and
// js_html ones are so weird that I prefer to see them near each other.


var _VirtualDom_RE_script = /^script$/i;
var _VirtualDom_RE_on_formAction = /^(on|formAction$)/i;
var _VirtualDom_RE_js = /^\s*j\s*a\s*v\s*a\s*s\s*c\s*r\s*i\s*p\s*t\s*:/i;
var _VirtualDom_RE_js_html = /^\s*(j\s*a\s*v\s*a\s*s\s*c\s*r\s*i\s*p\s*t\s*:|d\s*a\s*t\s*a\s*:\s*t\s*e\s*x\s*t\s*\/\s*h\s*t\s*m\s*l\s*(,|;))/i;


function _VirtualDom_noScript(tag)
{
	return _VirtualDom_RE_script.test(tag) ? 'p' : tag;
}

function _VirtualDom_noOnOrFormAction(key)
{
	return _VirtualDom_RE_on_formAction.test(key) ? 'data-' + key : key;
}

function _VirtualDom_noInnerHtmlOrFormAction(key)
{
	return key == 'innerHTML' || key == 'formAction' ? 'data-' + key : key;
}

function _VirtualDom_noJavaScriptUri(value)
{
	return _VirtualDom_RE_js.test(value)
		? /**_UNUSED/''//*//**/'javascript:alert("This is an XSS vector. Please use ports or web components instead.")'//*/
		: value;
}

function _VirtualDom_noJavaScriptOrHtmlUri(value)
{
	return _VirtualDom_RE_js_html.test(value)
		? /**_UNUSED/''//*//**/'javascript:alert("This is an XSS vector. Please use ports or web components instead.")'//*/
		: value;
}

function _VirtualDom_noJavaScriptOrHtmlJson(value)
{
	return (typeof _Json_unwrap(value) === 'string' && _VirtualDom_RE_js_html.test(_Json_unwrap(value)))
		? _Json_wrap(
			/**_UNUSED/''//*//**/'javascript:alert("This is an XSS vector. Please use ports or web components instead.")'//*/
		) : value;
}



// MAP FACTS


var _VirtualDom_mapAttribute = F2(function(func, attr)
{
	return (attr.$ === 'a0')
		? A2(_VirtualDom_on, attr.n, _VirtualDom_mapHandler(func, attr.o))
		: attr;
});

function _VirtualDom_mapHandler(func, handler)
{
	var tag = $elm$virtual_dom$VirtualDom$toHandlerInt(handler);

	// 0 = Normal
	// 1 = MayStopPropagation
	// 2 = MayPreventDefault
	// 3 = Custom

	return {
		$: handler.$,
		a:
			!tag
				? A2($elm$json$Json$Decode$map, func, handler.a)
				:
			A3($elm$json$Json$Decode$map2,
				tag < 3
					? _VirtualDom_mapEventTuple
					: _VirtualDom_mapEventRecord,
				$elm$json$Json$Decode$succeed(func),
				handler.a
			)
	};
}

var _VirtualDom_mapEventTuple = F2(function(func, tuple)
{
	return _Utils_Tuple2(func(tuple.a), tuple.b);
});

var _VirtualDom_mapEventRecord = F2(function(func, record)
{
	return {
		message: func(record.message),
		stopPropagation: record.stopPropagation,
		preventDefault: record.preventDefault
	}
});



// ORGANIZE FACTS


function _VirtualDom_organizeFacts(factList)
{
	for (var facts = {}; factList.b; factList = factList.b) // WHILE_CONS
	{
		var entry = factList.a;

		var tag = entry.$;
		var key = entry.n;
		var value = entry.o;

		if (tag === 'a2')
		{
			(key === 'className')
				? _VirtualDom_addClass(facts, key, _Json_unwrap(value))
				: facts[key] = _Json_unwrap(value);

			continue;
		}

		var subFacts = facts[tag] || (facts[tag] = {});
		(tag === 'a3' && key === 'class')
			? _VirtualDom_addClass(subFacts, key, value)
			: subFacts[key] = value;
	}

	return facts;
}

function _VirtualDom_addClass(object, key, newClass)
{
	var classes = object[key];
	object[key] = classes ? classes + ' ' + newClass : newClass;
}



// RENDER


function _VirtualDom_render(vNode, eventNode)
{
	var tag = vNode.$;

	if (tag === 5)
	{
		return _VirtualDom_render(vNode.k || (vNode.k = vNode.m()), eventNode);
	}

	if (tag === 0)
	{
		return _VirtualDom_doc.createTextNode(vNode.a);
	}

	if (tag === 4)
	{
		var subNode = vNode.k;
		var tagger = vNode.j;

		while (subNode.$ === 4)
		{
			typeof tagger !== 'object'
				? tagger = [tagger, subNode.j]
				: tagger.push(subNode.j);

			subNode = subNode.k;
		}

		var subEventRoot = { j: tagger, p: eventNode };
		var domNode = _VirtualDom_render(subNode, subEventRoot);
		domNode.elm_event_node_ref = subEventRoot;
		return domNode;
	}

	if (tag === 3)
	{
		var domNode = vNode.h(vNode.g);
		_VirtualDom_applyFacts(domNode, eventNode, vNode.d);
		return domNode;
	}

	// at this point `tag` must be 1 or 2

	var domNode = vNode.f
		? _VirtualDom_doc.createElementNS(vNode.f, vNode.c)
		: _VirtualDom_doc.createElement(vNode.c);

	if (_VirtualDom_divertHrefToApp && vNode.c == 'a')
	{
		domNode.addEventListener('click', _VirtualDom_divertHrefToApp(domNode));
	}

	_VirtualDom_applyFacts(domNode, eventNode, vNode.d);

	for (var kids = vNode.e, i = 0; i < kids.length; i++)
	{
		_VirtualDom_appendChild(domNode, _VirtualDom_render(tag === 1 ? kids[i] : kids[i].b, eventNode));
	}

	return domNode;
}



// APPLY FACTS


function _VirtualDom_applyFacts(domNode, eventNode, facts)
{
	for (var key in facts)
	{
		var value = facts[key];

		key === 'a1'
			? _VirtualDom_applyStyles(domNode, value)
			:
		key === 'a0'
			? _VirtualDom_applyEvents(domNode, eventNode, value)
			:
		key === 'a3'
			? _VirtualDom_applyAttrs(domNode, value)
			:
		key === 'a4'
			? _VirtualDom_applyAttrsNS(domNode, value)
			:
		((key !== 'value' && key !== 'checked') || domNode[key] !== value) && (domNode[key] = value);
	}
}



// APPLY STYLES


function _VirtualDom_applyStyles(domNode, styles)
{
	var domNodeStyle = domNode.style;

	for (var key in styles)
	{
		domNodeStyle[key] = styles[key];
	}
}



// APPLY ATTRS


function _VirtualDom_applyAttrs(domNode, attrs)
{
	for (var key in attrs)
	{
		var value = attrs[key];
		typeof value !== 'undefined'
			? domNode.setAttribute(key, value)
			: domNode.removeAttribute(key);
	}
}



// APPLY NAMESPACED ATTRS


function _VirtualDom_applyAttrsNS(domNode, nsAttrs)
{
	for (var key in nsAttrs)
	{
		var pair = nsAttrs[key];
		var namespace = pair.f;
		var value = pair.o;

		typeof value !== 'undefined'
			? domNode.setAttributeNS(namespace, key, value)
			: domNode.removeAttributeNS(namespace, key);
	}
}



// APPLY EVENTS


function _VirtualDom_applyEvents(domNode, eventNode, events)
{
	var allCallbacks = domNode.elmFs || (domNode.elmFs = {});

	for (var key in events)
	{
		var newHandler = events[key];
		var oldCallback = allCallbacks[key];

		if (!newHandler)
		{
			domNode.removeEventListener(key, oldCallback);
			allCallbacks[key] = undefined;
			continue;
		}

		if (oldCallback)
		{
			var oldHandler = oldCallback.q;
			if (oldHandler.$ === newHandler.$)
			{
				oldCallback.q = newHandler;
				continue;
			}
			domNode.removeEventListener(key, oldCallback);
		}

		oldCallback = _VirtualDom_makeCallback(eventNode, newHandler);
		domNode.addEventListener(key, oldCallback,
			_VirtualDom_passiveSupported
			&& { passive: $elm$virtual_dom$VirtualDom$toHandlerInt(newHandler) < 2 }
		);
		allCallbacks[key] = oldCallback;
	}
}



// PASSIVE EVENTS


var _VirtualDom_passiveSupported;

try
{
	window.addEventListener('t', null, Object.defineProperty({}, 'passive', {
		get: function() { _VirtualDom_passiveSupported = true; }
	}));
}
catch(e) {}



// EVENT HANDLERS


function _VirtualDom_makeCallback(eventNode, initialHandler)
{
	function callback(event)
	{
		var handler = callback.q;
		var result = _Json_runHelp(handler.a, event);

		if (!$elm$core$Result$isOk(result))
		{
			return;
		}

		var tag = $elm$virtual_dom$VirtualDom$toHandlerInt(handler);

		// 0 = Normal
		// 1 = MayStopPropagation
		// 2 = MayPreventDefault
		// 3 = Custom

		var value = result.a;
		var message = !tag ? value : tag < 3 ? value.a : value.message;
		var stopPropagation = tag == 1 ? value.b : tag == 3 && value.stopPropagation;
		var currentEventNode = (
			stopPropagation && event.stopPropagation(),
			(tag == 2 ? value.b : tag == 3 && value.preventDefault) && event.preventDefault(),
			eventNode
		);
		var tagger;
		var i;
		while (tagger = currentEventNode.j)
		{
			if (typeof tagger == 'function')
			{
				message = tagger(message);
			}
			else
			{
				for (var i = tagger.length; i--; )
				{
					message = tagger[i](message);
				}
			}
			currentEventNode = currentEventNode.p;
		}
		currentEventNode(message, stopPropagation); // stopPropagation implies isSync
	}

	callback.q = initialHandler;

	return callback;
}

function _VirtualDom_equalEvents(x, y)
{
	return x.$ == y.$ && _Json_equality(x.a, y.a);
}



// DIFF


// TODO: Should we do patches like in iOS?
//
// type Patch
//   = At Int Patch
//   | Batch (List Patch)
//   | Change ...
//
// How could it not be better?
//
function _VirtualDom_diff(x, y)
{
	var patches = [];
	_VirtualDom_diffHelp(x, y, patches, 0);
	return patches;
}


function _VirtualDom_pushPatch(patches, type, index, data)
{
	var patch = {
		$: type,
		r: index,
		s: data,
		t: undefined,
		u: undefined
	};
	patches.push(patch);
	return patch;
}


function _VirtualDom_diffHelp(x, y, patches, index)
{
	if (x === y)
	{
		return;
	}

	var xType = x.$;
	var yType = y.$;

	// Bail if you run into different types of nodes. Implies that the
	// structure has changed significantly and it's not worth a diff.
	if (xType !== yType)
	{
		if (xType === 1 && yType === 2)
		{
			y = _VirtualDom_dekey(y);
			yType = 1;
		}
		else
		{
			_VirtualDom_pushPatch(patches, 0, index, y);
			return;
		}
	}

	// Now we know that both nodes are the same $.
	switch (yType)
	{
		case 5:
			var xRefs = x.l;
			var yRefs = y.l;
			var i = xRefs.length;
			var same = i === yRefs.length;
			while (same && i--)
			{
				same = xRefs[i] === yRefs[i];
			}
			if (same)
			{
				y.k = x.k;
				return;
			}
			y.k = y.m();
			var subPatches = [];
			_VirtualDom_diffHelp(x.k, y.k, subPatches, 0);
			subPatches.length > 0 && _VirtualDom_pushPatch(patches, 1, index, subPatches);
			return;

		case 4:
			// gather nested taggers
			var xTaggers = x.j;
			var yTaggers = y.j;
			var nesting = false;

			var xSubNode = x.k;
			while (xSubNode.$ === 4)
			{
				nesting = true;

				typeof xTaggers !== 'object'
					? xTaggers = [xTaggers, xSubNode.j]
					: xTaggers.push(xSubNode.j);

				xSubNode = xSubNode.k;
			}

			var ySubNode = y.k;
			while (ySubNode.$ === 4)
			{
				nesting = true;

				typeof yTaggers !== 'object'
					? yTaggers = [yTaggers, ySubNode.j]
					: yTaggers.push(ySubNode.j);

				ySubNode = ySubNode.k;
			}

			// Just bail if different numbers of taggers. This implies the
			// structure of the virtual DOM has changed.
			if (nesting && xTaggers.length !== yTaggers.length)
			{
				_VirtualDom_pushPatch(patches, 0, index, y);
				return;
			}

			// check if taggers are "the same"
			if (nesting ? !_VirtualDom_pairwiseRefEqual(xTaggers, yTaggers) : xTaggers !== yTaggers)
			{
				_VirtualDom_pushPatch(patches, 2, index, yTaggers);
			}

			// diff everything below the taggers
			_VirtualDom_diffHelp(xSubNode, ySubNode, patches, index + 1);
			return;

		case 0:
			if (x.a !== y.a)
			{
				_VirtualDom_pushPatch(patches, 3, index, y.a);
			}
			return;

		case 1:
			_VirtualDom_diffNodes(x, y, patches, index, _VirtualDom_diffKids);
			return;

		case 2:
			_VirtualDom_diffNodes(x, y, patches, index, _VirtualDom_diffKeyedKids);
			return;

		case 3:
			if (x.h !== y.h)
			{
				_VirtualDom_pushPatch(patches, 0, index, y);
				return;
			}

			var factsDiff = _VirtualDom_diffFacts(x.d, y.d);
			factsDiff && _VirtualDom_pushPatch(patches, 4, index, factsDiff);

			var patch = y.i(x.g, y.g);
			patch && _VirtualDom_pushPatch(patches, 5, index, patch);

			return;
	}
}

// assumes the incoming arrays are the same length
function _VirtualDom_pairwiseRefEqual(as, bs)
{
	for (var i = 0; i < as.length; i++)
	{
		if (as[i] !== bs[i])
		{
			return false;
		}
	}

	return true;
}

function _VirtualDom_diffNodes(x, y, patches, index, diffKids)
{
	// Bail if obvious indicators have changed. Implies more serious
	// structural changes such that it's not worth it to diff.
	if (x.c !== y.c || x.f !== y.f)
	{
		_VirtualDom_pushPatch(patches, 0, index, y);
		return;
	}

	var factsDiff = _VirtualDom_diffFacts(x.d, y.d);
	factsDiff && _VirtualDom_pushPatch(patches, 4, index, factsDiff);

	diffKids(x, y, patches, index);
}



// DIFF FACTS


// TODO Instead of creating a new diff object, it's possible to just test if
// there *is* a diff. During the actual patch, do the diff again and make the
// modifications directly. This way, there's no new allocations. Worth it?
function _VirtualDom_diffFacts(x, y, category)
{
	var diff;

	// look for changes and removals
	for (var xKey in x)
	{
		if (xKey === 'a1' || xKey === 'a0' || xKey === 'a3' || xKey === 'a4')
		{
			var subDiff = _VirtualDom_diffFacts(x[xKey], y[xKey] || {}, xKey);
			if (subDiff)
			{
				diff = diff || {};
				diff[xKey] = subDiff;
			}
			continue;
		}

		// remove if not in the new facts
		if (!(xKey in y))
		{
			diff = diff || {};
			diff[xKey] =
				!category
					? (typeof x[xKey] === 'string' ? '' : null)
					:
				(category === 'a1')
					? ''
					:
				(category === 'a0' || category === 'a3')
					? undefined
					:
				{ f: x[xKey].f, o: undefined };

			continue;
		}

		var xValue = x[xKey];
		var yValue = y[xKey];

		// reference equal, so don't worry about it
		if (xValue === yValue && xKey !== 'value' && xKey !== 'checked'
			|| category === 'a0' && _VirtualDom_equalEvents(xValue, yValue))
		{
			continue;
		}

		diff = diff || {};
		diff[xKey] = yValue;
	}

	// add new stuff
	for (var yKey in y)
	{
		if (!(yKey in x))
		{
			diff = diff || {};
			diff[yKey] = y[yKey];
		}
	}

	return diff;
}



// DIFF KIDS


function _VirtualDom_diffKids(xParent, yParent, patches, index)
{
	var xKids = xParent.e;
	var yKids = yParent.e;

	var xLen = xKids.length;
	var yLen = yKids.length;

	// FIGURE OUT IF THERE ARE INSERTS OR REMOVALS

	if (xLen > yLen)
	{
		_VirtualDom_pushPatch(patches, 6, index, {
			v: yLen,
			i: xLen - yLen
		});
	}
	else if (xLen < yLen)
	{
		_VirtualDom_pushPatch(patches, 7, index, {
			v: xLen,
			e: yKids
		});
	}

	// PAIRWISE DIFF EVERYTHING ELSE

	for (var minLen = xLen < yLen ? xLen : yLen, i = 0; i < minLen; i++)
	{
		var xKid = xKids[i];
		_VirtualDom_diffHelp(xKid, yKids[i], patches, ++index);
		index += xKid.b || 0;
	}
}



// KEYED DIFF


function _VirtualDom_diffKeyedKids(xParent, yParent, patches, rootIndex)
{
	var localPatches = [];

	var changes = {}; // Dict String Entry
	var inserts = []; // Array { index : Int, entry : Entry }
	// type Entry = { tag : String, vnode : VNode, index : Int, data : _ }

	var xKids = xParent.e;
	var yKids = yParent.e;
	var xLen = xKids.length;
	var yLen = yKids.length;
	var xIndex = 0;
	var yIndex = 0;

	var index = rootIndex;

	while (xIndex < xLen && yIndex < yLen)
	{
		var x = xKids[xIndex];
		var y = yKids[yIndex];

		var xKey = x.a;
		var yKey = y.a;
		var xNode = x.b;
		var yNode = y.b;

		var newMatch = undefined;
		var oldMatch = undefined;

		// check if keys match

		if (xKey === yKey)
		{
			index++;
			_VirtualDom_diffHelp(xNode, yNode, localPatches, index);
			index += xNode.b || 0;

			xIndex++;
			yIndex++;
			continue;
		}

		// look ahead 1 to detect insertions and removals.

		var xNext = xKids[xIndex + 1];
		var yNext = yKids[yIndex + 1];

		if (xNext)
		{
			var xNextKey = xNext.a;
			var xNextNode = xNext.b;
			oldMatch = yKey === xNextKey;
		}

		if (yNext)
		{
			var yNextKey = yNext.a;
			var yNextNode = yNext.b;
			newMatch = xKey === yNextKey;
		}


		// swap x and y
		if (newMatch && oldMatch)
		{
			index++;
			_VirtualDom_diffHelp(xNode, yNextNode, localPatches, index);
			_VirtualDom_insertNode(changes, localPatches, xKey, yNode, yIndex, inserts);
			index += xNode.b || 0;

			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNextNode, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 2;
			continue;
		}

		// insert y
		if (newMatch)
		{
			index++;
			_VirtualDom_insertNode(changes, localPatches, yKey, yNode, yIndex, inserts);
			_VirtualDom_diffHelp(xNode, yNextNode, localPatches, index);
			index += xNode.b || 0;

			xIndex += 1;
			yIndex += 2;
			continue;
		}

		// remove x
		if (oldMatch)
		{
			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNode, index);
			index += xNode.b || 0;

			index++;
			_VirtualDom_diffHelp(xNextNode, yNode, localPatches, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 1;
			continue;
		}

		// remove x, insert y
		if (xNext && xNextKey === yNextKey)
		{
			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNode, index);
			_VirtualDom_insertNode(changes, localPatches, yKey, yNode, yIndex, inserts);
			index += xNode.b || 0;

			index++;
			_VirtualDom_diffHelp(xNextNode, yNextNode, localPatches, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 2;
			continue;
		}

		break;
	}

	// eat up any remaining nodes with removeNode and insertNode

	while (xIndex < xLen)
	{
		index++;
		var x = xKids[xIndex];
		var xNode = x.b;
		_VirtualDom_removeNode(changes, localPatches, x.a, xNode, index);
		index += xNode.b || 0;
		xIndex++;
	}

	while (yIndex < yLen)
	{
		var endInserts = endInserts || [];
		var y = yKids[yIndex];
		_VirtualDom_insertNode(changes, localPatches, y.a, y.b, undefined, endInserts);
		yIndex++;
	}

	if (localPatches.length > 0 || inserts.length > 0 || endInserts)
	{
		_VirtualDom_pushPatch(patches, 8, rootIndex, {
			w: localPatches,
			x: inserts,
			y: endInserts
		});
	}
}



// CHANGES FROM KEYED DIFF


var _VirtualDom_POSTFIX = '_elmW6BL';


function _VirtualDom_insertNode(changes, localPatches, key, vnode, yIndex, inserts)
{
	var entry = changes[key];

	// never seen this key before
	if (!entry)
	{
		entry = {
			c: 0,
			z: vnode,
			r: yIndex,
			s: undefined
		};

		inserts.push({ r: yIndex, A: entry });
		changes[key] = entry;

		return;
	}

	// this key was removed earlier, a match!
	if (entry.c === 1)
	{
		inserts.push({ r: yIndex, A: entry });

		entry.c = 2;
		var subPatches = [];
		_VirtualDom_diffHelp(entry.z, vnode, subPatches, entry.r);
		entry.r = yIndex;
		entry.s.s = {
			w: subPatches,
			A: entry
		};

		return;
	}

	// this key has already been inserted or moved, a duplicate!
	_VirtualDom_insertNode(changes, localPatches, key + _VirtualDom_POSTFIX, vnode, yIndex, inserts);
}


function _VirtualDom_removeNode(changes, localPatches, key, vnode, index)
{
	var entry = changes[key];

	// never seen this key before
	if (!entry)
	{
		var patch = _VirtualDom_pushPatch(localPatches, 9, index, undefined);

		changes[key] = {
			c: 1,
			z: vnode,
			r: index,
			s: patch
		};

		return;
	}

	// this key was inserted earlier, a match!
	if (entry.c === 0)
	{
		entry.c = 2;
		var subPatches = [];
		_VirtualDom_diffHelp(vnode, entry.z, subPatches, index);

		_VirtualDom_pushPatch(localPatches, 9, index, {
			w: subPatches,
			A: entry
		});

		return;
	}

	// this key has already been removed or moved, a duplicate!
	_VirtualDom_removeNode(changes, localPatches, key + _VirtualDom_POSTFIX, vnode, index);
}



// ADD DOM NODES
//
// Each DOM node has an "index" assigned in order of traversal. It is important
// to minimize our crawl over the actual DOM, so these indexes (along with the
// descendantsCount of virtual nodes) let us skip touching entire subtrees of
// the DOM if we know there are no patches there.


function _VirtualDom_addDomNodes(domNode, vNode, patches, eventNode)
{
	_VirtualDom_addDomNodesHelp(domNode, vNode, patches, 0, 0, vNode.b, eventNode);
}


// assumes `patches` is non-empty and indexes increase monotonically.
function _VirtualDom_addDomNodesHelp(domNode, vNode, patches, i, low, high, eventNode)
{
	var patch = patches[i];
	var index = patch.r;

	while (index === low)
	{
		var patchType = patch.$;

		if (patchType === 1)
		{
			_VirtualDom_addDomNodes(domNode, vNode.k, patch.s, eventNode);
		}
		else if (patchType === 8)
		{
			patch.t = domNode;
			patch.u = eventNode;

			var subPatches = patch.s.w;
			if (subPatches.length > 0)
			{
				_VirtualDom_addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
			}
		}
		else if (patchType === 9)
		{
			patch.t = domNode;
			patch.u = eventNode;

			var data = patch.s;
			if (data)
			{
				data.A.s = domNode;
				var subPatches = data.w;
				if (subPatches.length > 0)
				{
					_VirtualDom_addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
				}
			}
		}
		else
		{
			patch.t = domNode;
			patch.u = eventNode;
		}

		i++;

		if (!(patch = patches[i]) || (index = patch.r) > high)
		{
			return i;
		}
	}

	var tag = vNode.$;

	if (tag === 4)
	{
		var subNode = vNode.k;

		while (subNode.$ === 4)
		{
			subNode = subNode.k;
		}

		return _VirtualDom_addDomNodesHelp(domNode, subNode, patches, i, low + 1, high, domNode.elm_event_node_ref);
	}

	// tag must be 1 or 2 at this point

	var vKids = vNode.e;
	var childNodes = domNode.childNodes;
	for (var j = 0; j < vKids.length; j++)
	{
		low++;
		var vKid = tag === 1 ? vKids[j] : vKids[j].b;
		var nextLow = low + (vKid.b || 0);
		if (low <= index && index <= nextLow)
		{
			i = _VirtualDom_addDomNodesHelp(childNodes[j], vKid, patches, i, low, nextLow, eventNode);
			if (!(patch = patches[i]) || (index = patch.r) > high)
			{
				return i;
			}
		}
		low = nextLow;
	}
	return i;
}



// APPLY PATCHES


function _VirtualDom_applyPatches(rootDomNode, oldVirtualNode, patches, eventNode)
{
	if (patches.length === 0)
	{
		return rootDomNode;
	}

	_VirtualDom_addDomNodes(rootDomNode, oldVirtualNode, patches, eventNode);
	return _VirtualDom_applyPatchesHelp(rootDomNode, patches);
}

function _VirtualDom_applyPatchesHelp(rootDomNode, patches)
{
	for (var i = 0; i < patches.length; i++)
	{
		var patch = patches[i];
		var localDomNode = patch.t
		var newNode = _VirtualDom_applyPatch(localDomNode, patch);
		if (localDomNode === rootDomNode)
		{
			rootDomNode = newNode;
		}
	}
	return rootDomNode;
}

function _VirtualDom_applyPatch(domNode, patch)
{
	switch (patch.$)
	{
		case 0:
			return _VirtualDom_applyPatchRedraw(domNode, patch.s, patch.u);

		case 4:
			_VirtualDom_applyFacts(domNode, patch.u, patch.s);
			return domNode;

		case 3:
			domNode.replaceData(0, domNode.length, patch.s);
			return domNode;

		case 1:
			return _VirtualDom_applyPatchesHelp(domNode, patch.s);

		case 2:
			if (domNode.elm_event_node_ref)
			{
				domNode.elm_event_node_ref.j = patch.s;
			}
			else
			{
				domNode.elm_event_node_ref = { j: patch.s, p: patch.u };
			}
			return domNode;

		case 6:
			var data = patch.s;
			for (var i = 0; i < data.i; i++)
			{
				domNode.removeChild(domNode.childNodes[data.v]);
			}
			return domNode;

		case 7:
			var data = patch.s;
			var kids = data.e;
			var i = data.v;
			var theEnd = domNode.childNodes[i];
			for (; i < kids.length; i++)
			{
				domNode.insertBefore(_VirtualDom_render(kids[i], patch.u), theEnd);
			}
			return domNode;

		case 9:
			var data = patch.s;
			if (!data)
			{
				domNode.parentNode.removeChild(domNode);
				return domNode;
			}
			var entry = data.A;
			if (typeof entry.r !== 'undefined')
			{
				domNode.parentNode.removeChild(domNode);
			}
			entry.s = _VirtualDom_applyPatchesHelp(domNode, data.w);
			return domNode;

		case 8:
			return _VirtualDom_applyPatchReorder(domNode, patch);

		case 5:
			return patch.s(domNode);

		default:
			_Debug_crash(10); // 'Ran into an unknown patch!'
	}
}


function _VirtualDom_applyPatchRedraw(domNode, vNode, eventNode)
{
	var parentNode = domNode.parentNode;
	var newNode = _VirtualDom_render(vNode, eventNode);

	if (!newNode.elm_event_node_ref)
	{
		newNode.elm_event_node_ref = domNode.elm_event_node_ref;
	}

	if (parentNode && newNode !== domNode)
	{
		parentNode.replaceChild(newNode, domNode);
	}
	return newNode;
}


function _VirtualDom_applyPatchReorder(domNode, patch)
{
	var data = patch.s;

	// remove end inserts
	var frag = _VirtualDom_applyPatchReorderEndInsertsHelp(data.y, patch);

	// removals
	domNode = _VirtualDom_applyPatchesHelp(domNode, data.w);

	// inserts
	var inserts = data.x;
	for (var i = 0; i < inserts.length; i++)
	{
		var insert = inserts[i];
		var entry = insert.A;
		var node = entry.c === 2
			? entry.s
			: _VirtualDom_render(entry.z, patch.u);
		domNode.insertBefore(node, domNode.childNodes[insert.r]);
	}

	// add end inserts
	if (frag)
	{
		_VirtualDom_appendChild(domNode, frag);
	}

	return domNode;
}


function _VirtualDom_applyPatchReorderEndInsertsHelp(endInserts, patch)
{
	if (!endInserts)
	{
		return;
	}

	var frag = _VirtualDom_doc.createDocumentFragment();
	for (var i = 0; i < endInserts.length; i++)
	{
		var insert = endInserts[i];
		var entry = insert.A;
		_VirtualDom_appendChild(frag, entry.c === 2
			? entry.s
			: _VirtualDom_render(entry.z, patch.u)
		);
	}
	return frag;
}


function _VirtualDom_virtualize(node)
{
	// TEXT NODES

	if (node.nodeType === 3)
	{
		return _VirtualDom_text(node.textContent);
	}


	// WEIRD NODES

	if (node.nodeType !== 1)
	{
		return _VirtualDom_text('');
	}


	// ELEMENT NODES

	var attrList = _List_Nil;
	var attrs = node.attributes;
	for (var i = attrs.length; i--; )
	{
		var attr = attrs[i];
		var name = attr.name;
		var value = attr.value;
		attrList = _List_Cons( A2(_VirtualDom_attribute, name, value), attrList );
	}

	var tag = node.tagName.toLowerCase();
	var kidList = _List_Nil;
	var kids = node.childNodes;

	for (var i = kids.length; i--; )
	{
		kidList = _List_Cons(_VirtualDom_virtualize(kids[i]), kidList);
	}
	return A3(_VirtualDom_node, tag, attrList, kidList);
}

function _VirtualDom_dekey(keyedNode)
{
	var keyedKids = keyedNode.e;
	var len = keyedKids.length;
	var kids = new Array(len);
	for (var i = 0; i < len; i++)
	{
		kids[i] = keyedKids[i].b;
	}

	return {
		$: 1,
		c: keyedNode.c,
		d: keyedNode.d,
		e: kids,
		f: keyedNode.f,
		b: keyedNode.b
	};
}




// ELEMENT


var _Debugger_element;

var _Browser_element = _Debugger_element || F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function(sendToApp, initialModel) {
			var view = impl.view;
			/**_UNUSED/
			var domNode = args['node'];
			//*/
			/**/
			var domNode = args && args['node'] ? args['node'] : _Debug_crash(0);
			//*/
			var currNode = _VirtualDom_virtualize(domNode);

			return _Browser_makeAnimator(initialModel, function(model)
			{
				var nextNode = view(model);
				var patches = _VirtualDom_diff(currNode, nextNode);
				domNode = _VirtualDom_applyPatches(domNode, currNode, patches, sendToApp);
				currNode = nextNode;
			});
		}
	);
});



// DOCUMENT


var _Debugger_document;

var _Browser_document = _Debugger_document || F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function(sendToApp, initialModel) {
			var divertHrefToApp = impl.setup && impl.setup(sendToApp)
			var view = impl.view;
			var title = _VirtualDom_doc.title;
			var bodyNode = _VirtualDom_doc.body;
			var currNode = _VirtualDom_virtualize(bodyNode);
			return _Browser_makeAnimator(initialModel, function(model)
			{
				_VirtualDom_divertHrefToApp = divertHrefToApp;
				var doc = view(model);
				var nextNode = _VirtualDom_node('body')(_List_Nil)(doc.body);
				var patches = _VirtualDom_diff(currNode, nextNode);
				bodyNode = _VirtualDom_applyPatches(bodyNode, currNode, patches, sendToApp);
				currNode = nextNode;
				_VirtualDom_divertHrefToApp = 0;
				(title !== doc.title) && (_VirtualDom_doc.title = title = doc.title);
			});
		}
	);
});



// ANIMATION


var _Browser_cancelAnimationFrame =
	typeof cancelAnimationFrame !== 'undefined'
		? cancelAnimationFrame
		: function(id) { clearTimeout(id); };

var _Browser_requestAnimationFrame =
	typeof requestAnimationFrame !== 'undefined'
		? requestAnimationFrame
		: function(callback) { return setTimeout(callback, 1000 / 60); };


function _Browser_makeAnimator(model, draw)
{
	draw(model);

	var state = 0;

	function updateIfNeeded()
	{
		state = state === 1
			? 0
			: ( _Browser_requestAnimationFrame(updateIfNeeded), draw(model), 1 );
	}

	return function(nextModel, isSync)
	{
		model = nextModel;

		isSync
			? ( draw(model),
				state === 2 && (state = 1)
				)
			: ( state === 0 && _Browser_requestAnimationFrame(updateIfNeeded),
				state = 2
				);
	};
}



// APPLICATION


function _Browser_application(impl)
{
	var onUrlChange = impl.onUrlChange;
	var onUrlRequest = impl.onUrlRequest;
	var key = function() { key.a(onUrlChange(_Browser_getUrl())); };

	return _Browser_document({
		setup: function(sendToApp)
		{
			key.a = sendToApp;
			_Browser_window.addEventListener('popstate', key);
			_Browser_window.navigator.userAgent.indexOf('Trident') < 0 || _Browser_window.addEventListener('hashchange', key);

			return F2(function(domNode, event)
			{
				if (!event.ctrlKey && !event.metaKey && !event.shiftKey && event.button < 1 && !domNode.target && !domNode.hasAttribute('download'))
				{
					event.preventDefault();
					var href = domNode.href;
					var curr = _Browser_getUrl();
					var next = $elm$url$Url$fromString(href).a;
					sendToApp(onUrlRequest(
						(next
							&& curr.protocol === next.protocol
							&& curr.host === next.host
							&& curr.port_.a === next.port_.a
						)
							? $elm$browser$Browser$Internal(next)
							: $elm$browser$Browser$External(href)
					));
				}
			});
		},
		init: function(flags)
		{
			return A3(impl.init, flags, _Browser_getUrl(), key);
		},
		view: impl.view,
		update: impl.update,
		subscriptions: impl.subscriptions
	});
}

function _Browser_getUrl()
{
	return $elm$url$Url$fromString(_VirtualDom_doc.location.href).a || _Debug_crash(1);
}

var _Browser_go = F2(function(key, n)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		n && history.go(n);
		key();
	}));
});

var _Browser_pushUrl = F2(function(key, url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		history.pushState({}, '', url);
		key();
	}));
});

var _Browser_replaceUrl = F2(function(key, url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		history.replaceState({}, '', url);
		key();
	}));
});



// GLOBAL EVENTS


var _Browser_fakeNode = { addEventListener: function() {}, removeEventListener: function() {} };
var _Browser_doc = typeof document !== 'undefined' ? document : _Browser_fakeNode;
var _Browser_window = typeof window !== 'undefined' ? window : _Browser_fakeNode;

var _Browser_on = F3(function(node, eventName, sendToSelf)
{
	return _Scheduler_spawn(_Scheduler_binding(function(callback)
	{
		function handler(event)	{ _Scheduler_rawSpawn(sendToSelf(event)); }
		node.addEventListener(eventName, handler, _VirtualDom_passiveSupported && { passive: true });
		return function() { node.removeEventListener(eventName, handler); };
	}));
});

var _Browser_decodeEvent = F2(function(decoder, event)
{
	var result = _Json_runHelp(decoder, event);
	return $elm$core$Result$isOk(result) ? $elm$core$Maybe$Just(result.a) : $elm$core$Maybe$Nothing;
});



// PAGE VISIBILITY


function _Browser_visibilityInfo()
{
	return (typeof _VirtualDom_doc.hidden !== 'undefined')
		? { hidden: 'hidden', change: 'visibilitychange' }
		:
	(typeof _VirtualDom_doc.mozHidden !== 'undefined')
		? { hidden: 'mozHidden', change: 'mozvisibilitychange' }
		:
	(typeof _VirtualDom_doc.msHidden !== 'undefined')
		? { hidden: 'msHidden', change: 'msvisibilitychange' }
		:
	(typeof _VirtualDom_doc.webkitHidden !== 'undefined')
		? { hidden: 'webkitHidden', change: 'webkitvisibilitychange' }
		: { hidden: 'hidden', change: 'visibilitychange' };
}



// ANIMATION FRAMES


function _Browser_rAF()
{
	return _Scheduler_binding(function(callback)
	{
		var id = _Browser_requestAnimationFrame(function() {
			callback(_Scheduler_succeed(Date.now()));
		});

		return function() {
			_Browser_cancelAnimationFrame(id);
		};
	});
}


function _Browser_now()
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(Date.now()));
	});
}



// DOM STUFF


function _Browser_withNode(id, doStuff)
{
	return _Scheduler_binding(function(callback)
	{
		_Browser_requestAnimationFrame(function() {
			var node = document.getElementById(id);
			callback(node
				? _Scheduler_succeed(doStuff(node))
				: _Scheduler_fail($elm$browser$Browser$Dom$NotFound(id))
			);
		});
	});
}


function _Browser_withWindow(doStuff)
{
	return _Scheduler_binding(function(callback)
	{
		_Browser_requestAnimationFrame(function() {
			callback(_Scheduler_succeed(doStuff()));
		});
	});
}


// FOCUS and BLUR


var _Browser_call = F2(function(functionName, id)
{
	return _Browser_withNode(id, function(node) {
		node[functionName]();
		return _Utils_Tuple0;
	});
});



// WINDOW VIEWPORT


function _Browser_getViewport()
{
	return {
		scene: _Browser_getScene(),
		viewport: {
			x: _Browser_window.pageXOffset,
			y: _Browser_window.pageYOffset,
			width: _Browser_doc.documentElement.clientWidth,
			height: _Browser_doc.documentElement.clientHeight
		}
	};
}

function _Browser_getScene()
{
	var body = _Browser_doc.body;
	var elem = _Browser_doc.documentElement;
	return {
		width: Math.max(body.scrollWidth, body.offsetWidth, elem.scrollWidth, elem.offsetWidth, elem.clientWidth),
		height: Math.max(body.scrollHeight, body.offsetHeight, elem.scrollHeight, elem.offsetHeight, elem.clientHeight)
	};
}

var _Browser_setViewport = F2(function(x, y)
{
	return _Browser_withWindow(function()
	{
		_Browser_window.scroll(x, y);
		return _Utils_Tuple0;
	});
});



// ELEMENT VIEWPORT


function _Browser_getViewportOf(id)
{
	return _Browser_withNode(id, function(node)
	{
		return {
			scene: {
				width: node.scrollWidth,
				height: node.scrollHeight
			},
			viewport: {
				x: node.scrollLeft,
				y: node.scrollTop,
				width: node.clientWidth,
				height: node.clientHeight
			}
		};
	});
}


var _Browser_setViewportOf = F3(function(id, x, y)
{
	return _Browser_withNode(id, function(node)
	{
		node.scrollLeft = x;
		node.scrollTop = y;
		return _Utils_Tuple0;
	});
});



// ELEMENT


function _Browser_getElement(id)
{
	return _Browser_withNode(id, function(node)
	{
		var rect = node.getBoundingClientRect();
		var x = _Browser_window.pageXOffset;
		var y = _Browser_window.pageYOffset;
		return {
			scene: _Browser_getScene(),
			viewport: {
				x: x,
				y: y,
				width: _Browser_doc.documentElement.clientWidth,
				height: _Browser_doc.documentElement.clientHeight
			},
			element: {
				x: x + rect.left,
				y: y + rect.top,
				width: rect.width,
				height: rect.height
			}
		};
	});
}



// LOAD and RELOAD


function _Browser_reload(skipCache)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function(callback)
	{
		_VirtualDom_doc.location.reload(skipCache);
	}));
}

function _Browser_load(url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function(callback)
	{
		try
		{
			_Browser_window.location = url;
		}
		catch(err)
		{
			// Only Firefox can throw a NS_ERROR_MALFORMED_URI exception here.
			// Other browsers reload the page, so let's be consistent about that.
			_VirtualDom_doc.location.reload(false);
		}
	}));
}



// SEND REQUEST

var _Http_toTask = F3(function(router, toTask, request)
{
	return _Scheduler_binding(function(callback)
	{
		function done(response) {
			callback(toTask(request.expect.a(response)));
		}

		var xhr = new XMLHttpRequest();
		xhr.addEventListener('error', function() { done($elm$http$Http$NetworkError_); });
		xhr.addEventListener('timeout', function() { done($elm$http$Http$Timeout_); });
		xhr.addEventListener('load', function() { done(_Http_toResponse(request.expect.b, xhr)); });
		$elm$core$Maybe$isJust(request.tracker) && _Http_track(router, xhr, request.tracker.a);

		try {
			xhr.open(request.method, request.url, true);
		} catch (e) {
			return done($elm$http$Http$BadUrl_(request.url));
		}

		_Http_configureRequest(xhr, request);

		request.body.a && xhr.setRequestHeader('Content-Type', request.body.a);
		xhr.send(request.body.b);

		return function() { xhr.c = true; xhr.abort(); };
	});
});


// CONFIGURE

function _Http_configureRequest(xhr, request)
{
	for (var headers = request.headers; headers.b; headers = headers.b) // WHILE_CONS
	{
		xhr.setRequestHeader(headers.a.a, headers.a.b);
	}
	xhr.timeout = request.timeout.a || 0;
	xhr.responseType = request.expect.d;
	xhr.withCredentials = request.allowCookiesFromOtherDomains;
}


// RESPONSES

function _Http_toResponse(toBody, xhr)
{
	return A2(
		200 <= xhr.status && xhr.status < 300 ? $elm$http$Http$GoodStatus_ : $elm$http$Http$BadStatus_,
		_Http_toMetadata(xhr),
		toBody(xhr.response)
	);
}


// METADATA

function _Http_toMetadata(xhr)
{
	return {
		url: xhr.responseURL,
		statusCode: xhr.status,
		statusText: xhr.statusText,
		headers: _Http_parseHeaders(xhr.getAllResponseHeaders())
	};
}


// HEADERS

function _Http_parseHeaders(rawHeaders)
{
	if (!rawHeaders)
	{
		return $elm$core$Dict$empty;
	}

	var headers = $elm$core$Dict$empty;
	var headerPairs = rawHeaders.split('\r\n');
	for (var i = headerPairs.length; i--; )
	{
		var headerPair = headerPairs[i];
		var index = headerPair.indexOf(': ');
		if (index > 0)
		{
			var key = headerPair.substring(0, index);
			var value = headerPair.substring(index + 2);

			headers = A3($elm$core$Dict$update, key, function(oldValue) {
				return $elm$core$Maybe$Just($elm$core$Maybe$isJust(oldValue)
					? value + ', ' + oldValue.a
					: value
				);
			}, headers);
		}
	}
	return headers;
}


// EXPECT

var _Http_expect = F3(function(type, toBody, toValue)
{
	return {
		$: 0,
		d: type,
		b: toBody,
		a: toValue
	};
});

var _Http_mapExpect = F2(function(func, expect)
{
	return {
		$: 0,
		d: expect.d,
		b: expect.b,
		a: function(x) { return func(expect.a(x)); }
	};
});

function _Http_toDataView(arrayBuffer)
{
	return new DataView(arrayBuffer);
}


// BODY and PARTS

var _Http_emptyBody = { $: 0 };
var _Http_pair = F2(function(a, b) { return { $: 0, a: a, b: b }; });

function _Http_toFormData(parts)
{
	for (var formData = new FormData(); parts.b; parts = parts.b) // WHILE_CONS
	{
		var part = parts.a;
		formData.append(part.a, part.b);
	}
	return formData;
}

var _Http_bytesToBlob = F2(function(mime, bytes)
{
	return new Blob([bytes], { type: mime });
});


// PROGRESS

function _Http_track(router, xhr, tracker)
{
	// TODO check out lengthComputable on loadstart event

	xhr.upload.addEventListener('progress', function(event) {
		if (xhr.c) { return; }
		_Scheduler_rawSpawn(A2($elm$core$Platform$sendToSelf, router, _Utils_Tuple2(tracker, $elm$http$Http$Sending({
			sent: event.loaded,
			size: event.total
		}))));
	});
	xhr.addEventListener('progress', function(event) {
		if (xhr.c) { return; }
		_Scheduler_rawSpawn(A2($elm$core$Platform$sendToSelf, router, _Utils_Tuple2(tracker, $elm$http$Http$Receiving({
			received: event.loaded,
			size: event.lengthComputable ? $elm$core$Maybe$Just(event.total) : $elm$core$Maybe$Nothing
		}))));
	});
}


function _Time_now(millisToPosix)
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(millisToPosix(Date.now())));
	});
}

var _Time_setInterval = F2(function(interval, task)
{
	return _Scheduler_binding(function(callback)
	{
		var id = setInterval(function() { _Scheduler_rawSpawn(task); }, interval);
		return function() { clearInterval(id); };
	});
});

function _Time_here()
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(
			A2($elm$time$Time$customZone, -(new Date().getTimezoneOffset()), _List_Nil)
		));
	});
}


function _Time_getZoneName()
{
	return _Scheduler_binding(function(callback)
	{
		try
		{
			var name = $elm$time$Time$Name(Intl.DateTimeFormat().resolvedOptions().timeZone);
		}
		catch (e)
		{
			var name = $elm$time$Time$Offset(new Date().getTimezoneOffset());
		}
		callback(_Scheduler_succeed(name));
	});
}



var _Bitwise_and = F2(function(a, b)
{
	return a & b;
});

var _Bitwise_or = F2(function(a, b)
{
	return a | b;
});

var _Bitwise_xor = F2(function(a, b)
{
	return a ^ b;
});

function _Bitwise_complement(a)
{
	return ~a;
};

var _Bitwise_shiftLeftBy = F2(function(offset, a)
{
	return a << offset;
});

var _Bitwise_shiftRightBy = F2(function(offset, a)
{
	return a >> offset;
});

var _Bitwise_shiftRightZfBy = F2(function(offset, a)
{
	return a >>> offset;
});
var $elm$core$Basics$EQ = {$: 'EQ'};
var $elm$core$Basics$GT = {$: 'GT'};
var $elm$core$Basics$LT = {$: 'LT'};
var $elm$core$List$cons = _List_cons;
var $elm$core$Dict$foldr = F3(
	function (func, acc, t) {
		foldr:
		while (true) {
			if (t.$ === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var key = t.b;
				var value = t.c;
				var left = t.d;
				var right = t.e;
				var $temp$func = func,
					$temp$acc = A3(
					func,
					key,
					value,
					A3($elm$core$Dict$foldr, func, acc, right)),
					$temp$t = left;
				func = $temp$func;
				acc = $temp$acc;
				t = $temp$t;
				continue foldr;
			}
		}
	});
var $elm$core$Dict$toList = function (dict) {
	return A3(
		$elm$core$Dict$foldr,
		F3(
			function (key, value, list) {
				return A2(
					$elm$core$List$cons,
					_Utils_Tuple2(key, value),
					list);
			}),
		_List_Nil,
		dict);
};
var $elm$core$Dict$keys = function (dict) {
	return A3(
		$elm$core$Dict$foldr,
		F3(
			function (key, value, keyList) {
				return A2($elm$core$List$cons, key, keyList);
			}),
		_List_Nil,
		dict);
};
var $elm$core$Set$toList = function (_v0) {
	var dict = _v0.a;
	return $elm$core$Dict$keys(dict);
};
var $elm$core$Elm$JsArray$foldr = _JsArray_foldr;
var $elm$core$Array$foldr = F3(
	function (func, baseCase, _v0) {
		var tree = _v0.c;
		var tail = _v0.d;
		var helper = F2(
			function (node, acc) {
				if (node.$ === 'SubTree') {
					var subTree = node.a;
					return A3($elm$core$Elm$JsArray$foldr, helper, acc, subTree);
				} else {
					var values = node.a;
					return A3($elm$core$Elm$JsArray$foldr, func, acc, values);
				}
			});
		return A3(
			$elm$core$Elm$JsArray$foldr,
			helper,
			A3($elm$core$Elm$JsArray$foldr, func, baseCase, tail),
			tree);
	});
var $elm$core$Array$toList = function (array) {
	return A3($elm$core$Array$foldr, $elm$core$List$cons, _List_Nil, array);
};
var $elm$core$Result$Err = function (a) {
	return {$: 'Err', a: a};
};
var $elm$json$Json$Decode$Failure = F2(
	function (a, b) {
		return {$: 'Failure', a: a, b: b};
	});
var $elm$json$Json$Decode$Field = F2(
	function (a, b) {
		return {$: 'Field', a: a, b: b};
	});
var $elm$json$Json$Decode$Index = F2(
	function (a, b) {
		return {$: 'Index', a: a, b: b};
	});
var $elm$core$Result$Ok = function (a) {
	return {$: 'Ok', a: a};
};
var $elm$json$Json$Decode$OneOf = function (a) {
	return {$: 'OneOf', a: a};
};
var $elm$core$Basics$False = {$: 'False'};
var $elm$core$Basics$add = _Basics_add;
var $elm$core$Maybe$Just = function (a) {
	return {$: 'Just', a: a};
};
var $elm$core$Maybe$Nothing = {$: 'Nothing'};
var $elm$core$String$all = _String_all;
var $elm$core$Basics$and = _Basics_and;
var $elm$core$Basics$append = _Utils_append;
var $elm$json$Json$Encode$encode = _Json_encode;
var $elm$core$String$fromInt = _String_fromNumber;
var $elm$core$String$join = F2(
	function (sep, chunks) {
		return A2(
			_String_join,
			sep,
			_List_toArray(chunks));
	});
var $elm$core$String$split = F2(
	function (sep, string) {
		return _List_fromArray(
			A2(_String_split, sep, string));
	});
var $elm$json$Json$Decode$indent = function (str) {
	return A2(
		$elm$core$String$join,
		'\n    ',
		A2($elm$core$String$split, '\n', str));
};
var $elm$core$List$foldl = F3(
	function (func, acc, list) {
		foldl:
		while (true) {
			if (!list.b) {
				return acc;
			} else {
				var x = list.a;
				var xs = list.b;
				var $temp$func = func,
					$temp$acc = A2(func, x, acc),
					$temp$list = xs;
				func = $temp$func;
				acc = $temp$acc;
				list = $temp$list;
				continue foldl;
			}
		}
	});
var $elm$core$List$length = function (xs) {
	return A3(
		$elm$core$List$foldl,
		F2(
			function (_v0, i) {
				return i + 1;
			}),
		0,
		xs);
};
var $elm$core$List$map2 = _List_map2;
var $elm$core$Basics$le = _Utils_le;
var $elm$core$Basics$sub = _Basics_sub;
var $elm$core$List$rangeHelp = F3(
	function (lo, hi, list) {
		rangeHelp:
		while (true) {
			if (_Utils_cmp(lo, hi) < 1) {
				var $temp$lo = lo,
					$temp$hi = hi - 1,
					$temp$list = A2($elm$core$List$cons, hi, list);
				lo = $temp$lo;
				hi = $temp$hi;
				list = $temp$list;
				continue rangeHelp;
			} else {
				return list;
			}
		}
	});
var $elm$core$List$range = F2(
	function (lo, hi) {
		return A3($elm$core$List$rangeHelp, lo, hi, _List_Nil);
	});
var $elm$core$List$indexedMap = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$map2,
			f,
			A2(
				$elm$core$List$range,
				0,
				$elm$core$List$length(xs) - 1),
			xs);
	});
var $elm$core$Char$toCode = _Char_toCode;
var $elm$core$Char$isLower = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (97 <= code) && (code <= 122);
};
var $elm$core$Char$isUpper = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (code <= 90) && (65 <= code);
};
var $elm$core$Basics$or = _Basics_or;
var $elm$core$Char$isAlpha = function (_char) {
	return $elm$core$Char$isLower(_char) || $elm$core$Char$isUpper(_char);
};
var $elm$core$Char$isDigit = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (code <= 57) && (48 <= code);
};
var $elm$core$Char$isAlphaNum = function (_char) {
	return $elm$core$Char$isLower(_char) || ($elm$core$Char$isUpper(_char) || $elm$core$Char$isDigit(_char));
};
var $elm$core$List$reverse = function (list) {
	return A3($elm$core$List$foldl, $elm$core$List$cons, _List_Nil, list);
};
var $elm$core$String$uncons = _String_uncons;
var $elm$json$Json$Decode$errorOneOf = F2(
	function (i, error) {
		return '\n\n(' + ($elm$core$String$fromInt(i + 1) + (') ' + $elm$json$Json$Decode$indent(
			$elm$json$Json$Decode$errorToString(error))));
	});
var $elm$json$Json$Decode$errorToString = function (error) {
	return A2($elm$json$Json$Decode$errorToStringHelp, error, _List_Nil);
};
var $elm$json$Json$Decode$errorToStringHelp = F2(
	function (error, context) {
		errorToStringHelp:
		while (true) {
			switch (error.$) {
				case 'Field':
					var f = error.a;
					var err = error.b;
					var isSimple = function () {
						var _v1 = $elm$core$String$uncons(f);
						if (_v1.$ === 'Nothing') {
							return false;
						} else {
							var _v2 = _v1.a;
							var _char = _v2.a;
							var rest = _v2.b;
							return $elm$core$Char$isAlpha(_char) && A2($elm$core$String$all, $elm$core$Char$isAlphaNum, rest);
						}
					}();
					var fieldName = isSimple ? ('.' + f) : ('[\'' + (f + '\']'));
					var $temp$error = err,
						$temp$context = A2($elm$core$List$cons, fieldName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 'Index':
					var i = error.a;
					var err = error.b;
					var indexName = '[' + ($elm$core$String$fromInt(i) + ']');
					var $temp$error = err,
						$temp$context = A2($elm$core$List$cons, indexName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 'OneOf':
					var errors = error.a;
					if (!errors.b) {
						return 'Ran into a Json.Decode.oneOf with no possibilities' + function () {
							if (!context.b) {
								return '!';
							} else {
								return ' at json' + A2(
									$elm$core$String$join,
									'',
									$elm$core$List$reverse(context));
							}
						}();
					} else {
						if (!errors.b.b) {
							var err = errors.a;
							var $temp$error = err,
								$temp$context = context;
							error = $temp$error;
							context = $temp$context;
							continue errorToStringHelp;
						} else {
							var starter = function () {
								if (!context.b) {
									return 'Json.Decode.oneOf';
								} else {
									return 'The Json.Decode.oneOf at json' + A2(
										$elm$core$String$join,
										'',
										$elm$core$List$reverse(context));
								}
							}();
							var introduction = starter + (' failed in the following ' + ($elm$core$String$fromInt(
								$elm$core$List$length(errors)) + ' ways:'));
							return A2(
								$elm$core$String$join,
								'\n\n',
								A2(
									$elm$core$List$cons,
									introduction,
									A2($elm$core$List$indexedMap, $elm$json$Json$Decode$errorOneOf, errors)));
						}
					}
				default:
					var msg = error.a;
					var json = error.b;
					var introduction = function () {
						if (!context.b) {
							return 'Problem with the given value:\n\n';
						} else {
							return 'Problem with the value at json' + (A2(
								$elm$core$String$join,
								'',
								$elm$core$List$reverse(context)) + ':\n\n    ');
						}
					}();
					return introduction + ($elm$json$Json$Decode$indent(
						A2($elm$json$Json$Encode$encode, 4, json)) + ('\n\n' + msg));
			}
		}
	});
var $elm$core$Array$branchFactor = 32;
var $elm$core$Array$Array_elm_builtin = F4(
	function (a, b, c, d) {
		return {$: 'Array_elm_builtin', a: a, b: b, c: c, d: d};
	});
var $elm$core$Elm$JsArray$empty = _JsArray_empty;
var $elm$core$Basics$ceiling = _Basics_ceiling;
var $elm$core$Basics$fdiv = _Basics_fdiv;
var $elm$core$Basics$logBase = F2(
	function (base, number) {
		return _Basics_log(number) / _Basics_log(base);
	});
var $elm$core$Basics$toFloat = _Basics_toFloat;
var $elm$core$Array$shiftStep = $elm$core$Basics$ceiling(
	A2($elm$core$Basics$logBase, 2, $elm$core$Array$branchFactor));
var $elm$core$Array$empty = A4($elm$core$Array$Array_elm_builtin, 0, $elm$core$Array$shiftStep, $elm$core$Elm$JsArray$empty, $elm$core$Elm$JsArray$empty);
var $elm$core$Elm$JsArray$initialize = _JsArray_initialize;
var $elm$core$Array$Leaf = function (a) {
	return {$: 'Leaf', a: a};
};
var $elm$core$Basics$apL = F2(
	function (f, x) {
		return f(x);
	});
var $elm$core$Basics$apR = F2(
	function (x, f) {
		return f(x);
	});
var $elm$core$Basics$eq = _Utils_equal;
var $elm$core$Basics$floor = _Basics_floor;
var $elm$core$Elm$JsArray$length = _JsArray_length;
var $elm$core$Basics$gt = _Utils_gt;
var $elm$core$Basics$max = F2(
	function (x, y) {
		return (_Utils_cmp(x, y) > 0) ? x : y;
	});
var $elm$core$Basics$mul = _Basics_mul;
var $elm$core$Array$SubTree = function (a) {
	return {$: 'SubTree', a: a};
};
var $elm$core$Elm$JsArray$initializeFromList = _JsArray_initializeFromList;
var $elm$core$Array$compressNodes = F2(
	function (nodes, acc) {
		compressNodes:
		while (true) {
			var _v0 = A2($elm$core$Elm$JsArray$initializeFromList, $elm$core$Array$branchFactor, nodes);
			var node = _v0.a;
			var remainingNodes = _v0.b;
			var newAcc = A2(
				$elm$core$List$cons,
				$elm$core$Array$SubTree(node),
				acc);
			if (!remainingNodes.b) {
				return $elm$core$List$reverse(newAcc);
			} else {
				var $temp$nodes = remainingNodes,
					$temp$acc = newAcc;
				nodes = $temp$nodes;
				acc = $temp$acc;
				continue compressNodes;
			}
		}
	});
var $elm$core$Tuple$first = function (_v0) {
	var x = _v0.a;
	return x;
};
var $elm$core$Array$treeFromBuilder = F2(
	function (nodeList, nodeListSize) {
		treeFromBuilder:
		while (true) {
			var newNodeSize = $elm$core$Basics$ceiling(nodeListSize / $elm$core$Array$branchFactor);
			if (newNodeSize === 1) {
				return A2($elm$core$Elm$JsArray$initializeFromList, $elm$core$Array$branchFactor, nodeList).a;
			} else {
				var $temp$nodeList = A2($elm$core$Array$compressNodes, nodeList, _List_Nil),
					$temp$nodeListSize = newNodeSize;
				nodeList = $temp$nodeList;
				nodeListSize = $temp$nodeListSize;
				continue treeFromBuilder;
			}
		}
	});
var $elm$core$Array$builderToArray = F2(
	function (reverseNodeList, builder) {
		if (!builder.nodeListSize) {
			return A4(
				$elm$core$Array$Array_elm_builtin,
				$elm$core$Elm$JsArray$length(builder.tail),
				$elm$core$Array$shiftStep,
				$elm$core$Elm$JsArray$empty,
				builder.tail);
		} else {
			var treeLen = builder.nodeListSize * $elm$core$Array$branchFactor;
			var depth = $elm$core$Basics$floor(
				A2($elm$core$Basics$logBase, $elm$core$Array$branchFactor, treeLen - 1));
			var correctNodeList = reverseNodeList ? $elm$core$List$reverse(builder.nodeList) : builder.nodeList;
			var tree = A2($elm$core$Array$treeFromBuilder, correctNodeList, builder.nodeListSize);
			return A4(
				$elm$core$Array$Array_elm_builtin,
				$elm$core$Elm$JsArray$length(builder.tail) + treeLen,
				A2($elm$core$Basics$max, 5, depth * $elm$core$Array$shiftStep),
				tree,
				builder.tail);
		}
	});
var $elm$core$Basics$idiv = _Basics_idiv;
var $elm$core$Basics$lt = _Utils_lt;
var $elm$core$Array$initializeHelp = F5(
	function (fn, fromIndex, len, nodeList, tail) {
		initializeHelp:
		while (true) {
			if (fromIndex < 0) {
				return A2(
					$elm$core$Array$builderToArray,
					false,
					{nodeList: nodeList, nodeListSize: (len / $elm$core$Array$branchFactor) | 0, tail: tail});
			} else {
				var leaf = $elm$core$Array$Leaf(
					A3($elm$core$Elm$JsArray$initialize, $elm$core$Array$branchFactor, fromIndex, fn));
				var $temp$fn = fn,
					$temp$fromIndex = fromIndex - $elm$core$Array$branchFactor,
					$temp$len = len,
					$temp$nodeList = A2($elm$core$List$cons, leaf, nodeList),
					$temp$tail = tail;
				fn = $temp$fn;
				fromIndex = $temp$fromIndex;
				len = $temp$len;
				nodeList = $temp$nodeList;
				tail = $temp$tail;
				continue initializeHelp;
			}
		}
	});
var $elm$core$Basics$remainderBy = _Basics_remainderBy;
var $elm$core$Array$initialize = F2(
	function (len, fn) {
		if (len <= 0) {
			return $elm$core$Array$empty;
		} else {
			var tailLen = len % $elm$core$Array$branchFactor;
			var tail = A3($elm$core$Elm$JsArray$initialize, tailLen, len - tailLen, fn);
			var initialFromIndex = (len - tailLen) - $elm$core$Array$branchFactor;
			return A5($elm$core$Array$initializeHelp, fn, initialFromIndex, len, _List_Nil, tail);
		}
	});
var $elm$core$Basics$True = {$: 'True'};
var $elm$core$Result$isOk = function (result) {
	if (result.$ === 'Ok') {
		return true;
	} else {
		return false;
	}
};
var $elm$json$Json$Decode$map = _Json_map1;
var $elm$json$Json$Decode$map2 = _Json_map2;
var $elm$json$Json$Decode$succeed = _Json_succeed;
var $elm$virtual_dom$VirtualDom$toHandlerInt = function (handler) {
	switch (handler.$) {
		case 'Normal':
			return 0;
		case 'MayStopPropagation':
			return 1;
		case 'MayPreventDefault':
			return 2;
		default:
			return 3;
	}
};
var $elm$browser$Browser$External = function (a) {
	return {$: 'External', a: a};
};
var $elm$browser$Browser$Internal = function (a) {
	return {$: 'Internal', a: a};
};
var $elm$core$Basics$identity = function (x) {
	return x;
};
var $elm$browser$Browser$Dom$NotFound = function (a) {
	return {$: 'NotFound', a: a};
};
var $elm$url$Url$Http = {$: 'Http'};
var $elm$url$Url$Https = {$: 'Https'};
var $elm$url$Url$Url = F6(
	function (protocol, host, port_, path, query, fragment) {
		return {fragment: fragment, host: host, path: path, port_: port_, protocol: protocol, query: query};
	});
var $elm$core$String$contains = _String_contains;
var $elm$core$String$length = _String_length;
var $elm$core$String$slice = _String_slice;
var $elm$core$String$dropLeft = F2(
	function (n, string) {
		return (n < 1) ? string : A3(
			$elm$core$String$slice,
			n,
			$elm$core$String$length(string),
			string);
	});
var $elm$core$String$indexes = _String_indexes;
var $elm$core$String$isEmpty = function (string) {
	return string === '';
};
var $elm$core$String$left = F2(
	function (n, string) {
		return (n < 1) ? '' : A3($elm$core$String$slice, 0, n, string);
	});
var $elm$core$String$toInt = _String_toInt;
var $elm$url$Url$chompBeforePath = F5(
	function (protocol, path, params, frag, str) {
		if ($elm$core$String$isEmpty(str) || A2($elm$core$String$contains, '@', str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, ':', str);
			if (!_v0.b) {
				return $elm$core$Maybe$Just(
					A6($elm$url$Url$Url, protocol, str, $elm$core$Maybe$Nothing, path, params, frag));
			} else {
				if (!_v0.b.b) {
					var i = _v0.a;
					var _v1 = $elm$core$String$toInt(
						A2($elm$core$String$dropLeft, i + 1, str));
					if (_v1.$ === 'Nothing') {
						return $elm$core$Maybe$Nothing;
					} else {
						var port_ = _v1;
						return $elm$core$Maybe$Just(
							A6(
								$elm$url$Url$Url,
								protocol,
								A2($elm$core$String$left, i, str),
								port_,
								path,
								params,
								frag));
					}
				} else {
					return $elm$core$Maybe$Nothing;
				}
			}
		}
	});
var $elm$url$Url$chompBeforeQuery = F4(
	function (protocol, params, frag, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '/', str);
			if (!_v0.b) {
				return A5($elm$url$Url$chompBeforePath, protocol, '/', params, frag, str);
			} else {
				var i = _v0.a;
				return A5(
					$elm$url$Url$chompBeforePath,
					protocol,
					A2($elm$core$String$dropLeft, i, str),
					params,
					frag,
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$url$Url$chompBeforeFragment = F3(
	function (protocol, frag, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '?', str);
			if (!_v0.b) {
				return A4($elm$url$Url$chompBeforeQuery, protocol, $elm$core$Maybe$Nothing, frag, str);
			} else {
				var i = _v0.a;
				return A4(
					$elm$url$Url$chompBeforeQuery,
					protocol,
					$elm$core$Maybe$Just(
						A2($elm$core$String$dropLeft, i + 1, str)),
					frag,
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$url$Url$chompAfterProtocol = F2(
	function (protocol, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '#', str);
			if (!_v0.b) {
				return A3($elm$url$Url$chompBeforeFragment, protocol, $elm$core$Maybe$Nothing, str);
			} else {
				var i = _v0.a;
				return A3(
					$elm$url$Url$chompBeforeFragment,
					protocol,
					$elm$core$Maybe$Just(
						A2($elm$core$String$dropLeft, i + 1, str)),
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$core$String$startsWith = _String_startsWith;
var $elm$url$Url$fromString = function (str) {
	return A2($elm$core$String$startsWith, 'http://', str) ? A2(
		$elm$url$Url$chompAfterProtocol,
		$elm$url$Url$Http,
		A2($elm$core$String$dropLeft, 7, str)) : (A2($elm$core$String$startsWith, 'https://', str) ? A2(
		$elm$url$Url$chompAfterProtocol,
		$elm$url$Url$Https,
		A2($elm$core$String$dropLeft, 8, str)) : $elm$core$Maybe$Nothing);
};
var $elm$core$Basics$never = function (_v0) {
	never:
	while (true) {
		var nvr = _v0.a;
		var $temp$_v0 = nvr;
		_v0 = $temp$_v0;
		continue never;
	}
};
var $elm$core$Task$Perform = function (a) {
	return {$: 'Perform', a: a};
};
var $elm$core$Task$succeed = _Scheduler_succeed;
var $elm$core$Task$init = $elm$core$Task$succeed(_Utils_Tuple0);
var $elm$core$List$foldrHelper = F4(
	function (fn, acc, ctr, ls) {
		if (!ls.b) {
			return acc;
		} else {
			var a = ls.a;
			var r1 = ls.b;
			if (!r1.b) {
				return A2(fn, a, acc);
			} else {
				var b = r1.a;
				var r2 = r1.b;
				if (!r2.b) {
					return A2(
						fn,
						a,
						A2(fn, b, acc));
				} else {
					var c = r2.a;
					var r3 = r2.b;
					if (!r3.b) {
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(fn, c, acc)));
					} else {
						var d = r3.a;
						var r4 = r3.b;
						var res = (ctr > 500) ? A3(
							$elm$core$List$foldl,
							fn,
							acc,
							$elm$core$List$reverse(r4)) : A4($elm$core$List$foldrHelper, fn, acc, ctr + 1, r4);
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(
									fn,
									c,
									A2(fn, d, res))));
					}
				}
			}
		}
	});
var $elm$core$List$foldr = F3(
	function (fn, acc, ls) {
		return A4($elm$core$List$foldrHelper, fn, acc, 0, ls);
	});
var $elm$core$List$map = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$foldr,
			F2(
				function (x, acc) {
					return A2(
						$elm$core$List$cons,
						f(x),
						acc);
				}),
			_List_Nil,
			xs);
	});
var $elm$core$Task$andThen = _Scheduler_andThen;
var $elm$core$Task$map = F2(
	function (func, taskA) {
		return A2(
			$elm$core$Task$andThen,
			function (a) {
				return $elm$core$Task$succeed(
					func(a));
			},
			taskA);
	});
var $elm$core$Task$map2 = F3(
	function (func, taskA, taskB) {
		return A2(
			$elm$core$Task$andThen,
			function (a) {
				return A2(
					$elm$core$Task$andThen,
					function (b) {
						return $elm$core$Task$succeed(
							A2(func, a, b));
					},
					taskB);
			},
			taskA);
	});
var $elm$core$Task$sequence = function (tasks) {
	return A3(
		$elm$core$List$foldr,
		$elm$core$Task$map2($elm$core$List$cons),
		$elm$core$Task$succeed(_List_Nil),
		tasks);
};
var $elm$core$Platform$sendToApp = _Platform_sendToApp;
var $elm$core$Task$spawnCmd = F2(
	function (router, _v0) {
		var task = _v0.a;
		return _Scheduler_spawn(
			A2(
				$elm$core$Task$andThen,
				$elm$core$Platform$sendToApp(router),
				task));
	});
var $elm$core$Task$onEffects = F3(
	function (router, commands, state) {
		return A2(
			$elm$core$Task$map,
			function (_v0) {
				return _Utils_Tuple0;
			},
			$elm$core$Task$sequence(
				A2(
					$elm$core$List$map,
					$elm$core$Task$spawnCmd(router),
					commands)));
	});
var $elm$core$Task$onSelfMsg = F3(
	function (_v0, _v1, _v2) {
		return $elm$core$Task$succeed(_Utils_Tuple0);
	});
var $elm$core$Task$cmdMap = F2(
	function (tagger, _v0) {
		var task = _v0.a;
		return $elm$core$Task$Perform(
			A2($elm$core$Task$map, tagger, task));
	});
_Platform_effectManagers['Task'] = _Platform_createManager($elm$core$Task$init, $elm$core$Task$onEffects, $elm$core$Task$onSelfMsg, $elm$core$Task$cmdMap);
var $elm$core$Task$command = _Platform_leaf('Task');
var $elm$core$Task$perform = F2(
	function (toMessage, task) {
		return $elm$core$Task$command(
			$elm$core$Task$Perform(
				A2($elm$core$Task$map, toMessage, task)));
	});
var $elm$browser$Browser$element = _Browser_element;
var $author$project$Model$Model = F8(
	function (data, error, csvdata, scatterplotOptions, parallelPlotOption, treeOption, starplotOption, plotVisible) {
		return {csvdata: csvdata, data: data, error: error, parallelPlotOption: parallelPlotOption, plotVisible: plotVisible, scatterplotOptions: scatterplotOptions, starplotOption: starplotOption, treeOption: treeOption};
	});
var $author$project$Main$DataReceived = function (a) {
	return {$: 'DataReceived', a: a};
};
var $elm$http$Http$BadStatus_ = F2(
	function (a, b) {
		return {$: 'BadStatus_', a: a, b: b};
	});
var $elm$http$Http$BadUrl_ = function (a) {
	return {$: 'BadUrl_', a: a};
};
var $elm$http$Http$GoodStatus_ = F2(
	function (a, b) {
		return {$: 'GoodStatus_', a: a, b: b};
	});
var $elm$http$Http$NetworkError_ = {$: 'NetworkError_'};
var $elm$http$Http$Receiving = function (a) {
	return {$: 'Receiving', a: a};
};
var $elm$http$Http$Sending = function (a) {
	return {$: 'Sending', a: a};
};
var $elm$http$Http$Timeout_ = {$: 'Timeout_'};
var $elm$core$Dict$RBEmpty_elm_builtin = {$: 'RBEmpty_elm_builtin'};
var $elm$core$Dict$empty = $elm$core$Dict$RBEmpty_elm_builtin;
var $elm$core$Maybe$isJust = function (maybe) {
	if (maybe.$ === 'Just') {
		return true;
	} else {
		return false;
	}
};
var $elm$core$Platform$sendToSelf = _Platform_sendToSelf;
var $elm$core$Basics$compare = _Utils_compare;
var $elm$core$Dict$get = F2(
	function (targetKey, dict) {
		get:
		while (true) {
			if (dict.$ === 'RBEmpty_elm_builtin') {
				return $elm$core$Maybe$Nothing;
			} else {
				var key = dict.b;
				var value = dict.c;
				var left = dict.d;
				var right = dict.e;
				var _v1 = A2($elm$core$Basics$compare, targetKey, key);
				switch (_v1.$) {
					case 'LT':
						var $temp$targetKey = targetKey,
							$temp$dict = left;
						targetKey = $temp$targetKey;
						dict = $temp$dict;
						continue get;
					case 'EQ':
						return $elm$core$Maybe$Just(value);
					default:
						var $temp$targetKey = targetKey,
							$temp$dict = right;
						targetKey = $temp$targetKey;
						dict = $temp$dict;
						continue get;
				}
			}
		}
	});
var $elm$core$Dict$Black = {$: 'Black'};
var $elm$core$Dict$RBNode_elm_builtin = F5(
	function (a, b, c, d, e) {
		return {$: 'RBNode_elm_builtin', a: a, b: b, c: c, d: d, e: e};
	});
var $elm$core$Dict$Red = {$: 'Red'};
var $elm$core$Dict$balance = F5(
	function (color, key, value, left, right) {
		if ((right.$ === 'RBNode_elm_builtin') && (right.a.$ === 'Red')) {
			var _v1 = right.a;
			var rK = right.b;
			var rV = right.c;
			var rLeft = right.d;
			var rRight = right.e;
			if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) {
				var _v3 = left.a;
				var lK = left.b;
				var lV = left.c;
				var lLeft = left.d;
				var lRight = left.e;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Red,
					key,
					value,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					color,
					rK,
					rV,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, left, rLeft),
					rRight);
			}
		} else {
			if ((((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) && (left.d.$ === 'RBNode_elm_builtin')) && (left.d.a.$ === 'Red')) {
				var _v5 = left.a;
				var lK = left.b;
				var lV = left.c;
				var _v6 = left.d;
				var _v7 = _v6.a;
				var llK = _v6.b;
				var llV = _v6.c;
				var llLeft = _v6.d;
				var llRight = _v6.e;
				var lRight = left.e;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Red,
					lK,
					lV,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, llK, llV, llLeft, llRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, key, value, lRight, right));
			} else {
				return A5($elm$core$Dict$RBNode_elm_builtin, color, key, value, left, right);
			}
		}
	});
var $elm$core$Dict$insertHelp = F3(
	function (key, value, dict) {
		if (dict.$ === 'RBEmpty_elm_builtin') {
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, $elm$core$Dict$RBEmpty_elm_builtin, $elm$core$Dict$RBEmpty_elm_builtin);
		} else {
			var nColor = dict.a;
			var nKey = dict.b;
			var nValue = dict.c;
			var nLeft = dict.d;
			var nRight = dict.e;
			var _v1 = A2($elm$core$Basics$compare, key, nKey);
			switch (_v1.$) {
				case 'LT':
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						A3($elm$core$Dict$insertHelp, key, value, nLeft),
						nRight);
				case 'EQ':
					return A5($elm$core$Dict$RBNode_elm_builtin, nColor, nKey, value, nLeft, nRight);
				default:
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						nLeft,
						A3($elm$core$Dict$insertHelp, key, value, nRight));
			}
		}
	});
var $elm$core$Dict$insert = F3(
	function (key, value, dict) {
		var _v0 = A3($elm$core$Dict$insertHelp, key, value, dict);
		if ((_v0.$ === 'RBNode_elm_builtin') && (_v0.a.$ === 'Red')) {
			var _v1 = _v0.a;
			var k = _v0.b;
			var v = _v0.c;
			var l = _v0.d;
			var r = _v0.e;
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, k, v, l, r);
		} else {
			var x = _v0;
			return x;
		}
	});
var $elm$core$Dict$getMin = function (dict) {
	getMin:
	while (true) {
		if ((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) {
			var left = dict.d;
			var $temp$dict = left;
			dict = $temp$dict;
			continue getMin;
		} else {
			return dict;
		}
	}
};
var $elm$core$Dict$moveRedLeft = function (dict) {
	if (((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) && (dict.e.$ === 'RBNode_elm_builtin')) {
		if ((dict.e.d.$ === 'RBNode_elm_builtin') && (dict.e.d.a.$ === 'Red')) {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v1 = dict.d;
			var lClr = _v1.a;
			var lK = _v1.b;
			var lV = _v1.c;
			var lLeft = _v1.d;
			var lRight = _v1.e;
			var _v2 = dict.e;
			var rClr = _v2.a;
			var rK = _v2.b;
			var rV = _v2.c;
			var rLeft = _v2.d;
			var _v3 = rLeft.a;
			var rlK = rLeft.b;
			var rlV = rLeft.c;
			var rlL = rLeft.d;
			var rlR = rLeft.e;
			var rRight = _v2.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				$elm$core$Dict$Red,
				rlK,
				rlV,
				A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					rlL),
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, rK, rV, rlR, rRight));
		} else {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v4 = dict.d;
			var lClr = _v4.a;
			var lK = _v4.b;
			var lV = _v4.c;
			var lLeft = _v4.d;
			var lRight = _v4.e;
			var _v5 = dict.e;
			var rClr = _v5.a;
			var rK = _v5.b;
			var rV = _v5.c;
			var rLeft = _v5.d;
			var rRight = _v5.e;
			if (clr.$ === 'Black') {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			}
		}
	} else {
		return dict;
	}
};
var $elm$core$Dict$moveRedRight = function (dict) {
	if (((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) && (dict.e.$ === 'RBNode_elm_builtin')) {
		if ((dict.d.d.$ === 'RBNode_elm_builtin') && (dict.d.d.a.$ === 'Red')) {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v1 = dict.d;
			var lClr = _v1.a;
			var lK = _v1.b;
			var lV = _v1.c;
			var _v2 = _v1.d;
			var _v3 = _v2.a;
			var llK = _v2.b;
			var llV = _v2.c;
			var llLeft = _v2.d;
			var llRight = _v2.e;
			var lRight = _v1.e;
			var _v4 = dict.e;
			var rClr = _v4.a;
			var rK = _v4.b;
			var rV = _v4.c;
			var rLeft = _v4.d;
			var rRight = _v4.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				$elm$core$Dict$Red,
				lK,
				lV,
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, llK, llV, llLeft, llRight),
				A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					lRight,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight)));
		} else {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v5 = dict.d;
			var lClr = _v5.a;
			var lK = _v5.b;
			var lV = _v5.c;
			var lLeft = _v5.d;
			var lRight = _v5.e;
			var _v6 = dict.e;
			var rClr = _v6.a;
			var rK = _v6.b;
			var rV = _v6.c;
			var rLeft = _v6.d;
			var rRight = _v6.e;
			if (clr.$ === 'Black') {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			}
		}
	} else {
		return dict;
	}
};
var $elm$core$Dict$removeHelpPrepEQGT = F7(
	function (targetKey, dict, color, key, value, left, right) {
		if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) {
			var _v1 = left.a;
			var lK = left.b;
			var lV = left.c;
			var lLeft = left.d;
			var lRight = left.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				color,
				lK,
				lV,
				lLeft,
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, lRight, right));
		} else {
			_v2$2:
			while (true) {
				if ((right.$ === 'RBNode_elm_builtin') && (right.a.$ === 'Black')) {
					if (right.d.$ === 'RBNode_elm_builtin') {
						if (right.d.a.$ === 'Black') {
							var _v3 = right.a;
							var _v4 = right.d;
							var _v5 = _v4.a;
							return $elm$core$Dict$moveRedRight(dict);
						} else {
							break _v2$2;
						}
					} else {
						var _v6 = right.a;
						var _v7 = right.d;
						return $elm$core$Dict$moveRedRight(dict);
					}
				} else {
					break _v2$2;
				}
			}
			return dict;
		}
	});
var $elm$core$Dict$removeMin = function (dict) {
	if ((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) {
		var color = dict.a;
		var key = dict.b;
		var value = dict.c;
		var left = dict.d;
		var lColor = left.a;
		var lLeft = left.d;
		var right = dict.e;
		if (lColor.$ === 'Black') {
			if ((lLeft.$ === 'RBNode_elm_builtin') && (lLeft.a.$ === 'Red')) {
				var _v3 = lLeft.a;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					color,
					key,
					value,
					$elm$core$Dict$removeMin(left),
					right);
			} else {
				var _v4 = $elm$core$Dict$moveRedLeft(dict);
				if (_v4.$ === 'RBNode_elm_builtin') {
					var nColor = _v4.a;
					var nKey = _v4.b;
					var nValue = _v4.c;
					var nLeft = _v4.d;
					var nRight = _v4.e;
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						$elm$core$Dict$removeMin(nLeft),
						nRight);
				} else {
					return $elm$core$Dict$RBEmpty_elm_builtin;
				}
			}
		} else {
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				color,
				key,
				value,
				$elm$core$Dict$removeMin(left),
				right);
		}
	} else {
		return $elm$core$Dict$RBEmpty_elm_builtin;
	}
};
var $elm$core$Dict$removeHelp = F2(
	function (targetKey, dict) {
		if (dict.$ === 'RBEmpty_elm_builtin') {
			return $elm$core$Dict$RBEmpty_elm_builtin;
		} else {
			var color = dict.a;
			var key = dict.b;
			var value = dict.c;
			var left = dict.d;
			var right = dict.e;
			if (_Utils_cmp(targetKey, key) < 0) {
				if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Black')) {
					var _v4 = left.a;
					var lLeft = left.d;
					if ((lLeft.$ === 'RBNode_elm_builtin') && (lLeft.a.$ === 'Red')) {
						var _v6 = lLeft.a;
						return A5(
							$elm$core$Dict$RBNode_elm_builtin,
							color,
							key,
							value,
							A2($elm$core$Dict$removeHelp, targetKey, left),
							right);
					} else {
						var _v7 = $elm$core$Dict$moveRedLeft(dict);
						if (_v7.$ === 'RBNode_elm_builtin') {
							var nColor = _v7.a;
							var nKey = _v7.b;
							var nValue = _v7.c;
							var nLeft = _v7.d;
							var nRight = _v7.e;
							return A5(
								$elm$core$Dict$balance,
								nColor,
								nKey,
								nValue,
								A2($elm$core$Dict$removeHelp, targetKey, nLeft),
								nRight);
						} else {
							return $elm$core$Dict$RBEmpty_elm_builtin;
						}
					}
				} else {
					return A5(
						$elm$core$Dict$RBNode_elm_builtin,
						color,
						key,
						value,
						A2($elm$core$Dict$removeHelp, targetKey, left),
						right);
				}
			} else {
				return A2(
					$elm$core$Dict$removeHelpEQGT,
					targetKey,
					A7($elm$core$Dict$removeHelpPrepEQGT, targetKey, dict, color, key, value, left, right));
			}
		}
	});
var $elm$core$Dict$removeHelpEQGT = F2(
	function (targetKey, dict) {
		if (dict.$ === 'RBNode_elm_builtin') {
			var color = dict.a;
			var key = dict.b;
			var value = dict.c;
			var left = dict.d;
			var right = dict.e;
			if (_Utils_eq(targetKey, key)) {
				var _v1 = $elm$core$Dict$getMin(right);
				if (_v1.$ === 'RBNode_elm_builtin') {
					var minKey = _v1.b;
					var minValue = _v1.c;
					return A5(
						$elm$core$Dict$balance,
						color,
						minKey,
						minValue,
						left,
						$elm$core$Dict$removeMin(right));
				} else {
					return $elm$core$Dict$RBEmpty_elm_builtin;
				}
			} else {
				return A5(
					$elm$core$Dict$balance,
					color,
					key,
					value,
					left,
					A2($elm$core$Dict$removeHelp, targetKey, right));
			}
		} else {
			return $elm$core$Dict$RBEmpty_elm_builtin;
		}
	});
var $elm$core$Dict$remove = F2(
	function (key, dict) {
		var _v0 = A2($elm$core$Dict$removeHelp, key, dict);
		if ((_v0.$ === 'RBNode_elm_builtin') && (_v0.a.$ === 'Red')) {
			var _v1 = _v0.a;
			var k = _v0.b;
			var v = _v0.c;
			var l = _v0.d;
			var r = _v0.e;
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, k, v, l, r);
		} else {
			var x = _v0;
			return x;
		}
	});
var $elm$core$Dict$update = F3(
	function (targetKey, alter, dictionary) {
		var _v0 = alter(
			A2($elm$core$Dict$get, targetKey, dictionary));
		if (_v0.$ === 'Just') {
			var value = _v0.a;
			return A3($elm$core$Dict$insert, targetKey, value, dictionary);
		} else {
			return A2($elm$core$Dict$remove, targetKey, dictionary);
		}
	});
var $elm$core$Basics$composeR = F3(
	function (f, g, x) {
		return g(
			f(x));
	});
var $elm$http$Http$expectStringResponse = F2(
	function (toMsg, toResult) {
		return A3(
			_Http_expect,
			'',
			$elm$core$Basics$identity,
			A2($elm$core$Basics$composeR, toResult, toMsg));
	});
var $elm$http$Http$BadBody = function (a) {
	return {$: 'BadBody', a: a};
};
var $elm$http$Http$BadStatus = function (a) {
	return {$: 'BadStatus', a: a};
};
var $elm$http$Http$BadUrl = function (a) {
	return {$: 'BadUrl', a: a};
};
var $elm$http$Http$NetworkError = {$: 'NetworkError'};
var $elm$http$Http$Timeout = {$: 'Timeout'};
var $elm$core$Result$mapError = F2(
	function (f, result) {
		if (result.$ === 'Ok') {
			var v = result.a;
			return $elm$core$Result$Ok(v);
		} else {
			var e = result.a;
			return $elm$core$Result$Err(
				f(e));
		}
	});
var $elm$http$Http$resolve = F2(
	function (toResult, response) {
		switch (response.$) {
			case 'BadUrl_':
				var url = response.a;
				return $elm$core$Result$Err(
					$elm$http$Http$BadUrl(url));
			case 'Timeout_':
				return $elm$core$Result$Err($elm$http$Http$Timeout);
			case 'NetworkError_':
				return $elm$core$Result$Err($elm$http$Http$NetworkError);
			case 'BadStatus_':
				var metadata = response.a;
				return $elm$core$Result$Err(
					$elm$http$Http$BadStatus(metadata.statusCode));
			default:
				var body = response.b;
				return A2(
					$elm$core$Result$mapError,
					$elm$http$Http$BadBody,
					toResult(body));
		}
	});
var $elm$http$Http$expectString = function (toMsg) {
	return A2(
		$elm$http$Http$expectStringResponse,
		toMsg,
		$elm$http$Http$resolve($elm$core$Result$Ok));
};
var $elm$http$Http$emptyBody = _Http_emptyBody;
var $elm$http$Http$Request = function (a) {
	return {$: 'Request', a: a};
};
var $elm$http$Http$State = F2(
	function (reqs, subs) {
		return {reqs: reqs, subs: subs};
	});
var $elm$http$Http$init = $elm$core$Task$succeed(
	A2($elm$http$Http$State, $elm$core$Dict$empty, _List_Nil));
var $elm$core$Process$kill = _Scheduler_kill;
var $elm$core$Process$spawn = _Scheduler_spawn;
var $elm$http$Http$updateReqs = F3(
	function (router, cmds, reqs) {
		updateReqs:
		while (true) {
			if (!cmds.b) {
				return $elm$core$Task$succeed(reqs);
			} else {
				var cmd = cmds.a;
				var otherCmds = cmds.b;
				if (cmd.$ === 'Cancel') {
					var tracker = cmd.a;
					var _v2 = A2($elm$core$Dict$get, tracker, reqs);
					if (_v2.$ === 'Nothing') {
						var $temp$router = router,
							$temp$cmds = otherCmds,
							$temp$reqs = reqs;
						router = $temp$router;
						cmds = $temp$cmds;
						reqs = $temp$reqs;
						continue updateReqs;
					} else {
						var pid = _v2.a;
						return A2(
							$elm$core$Task$andThen,
							function (_v3) {
								return A3(
									$elm$http$Http$updateReqs,
									router,
									otherCmds,
									A2($elm$core$Dict$remove, tracker, reqs));
							},
							$elm$core$Process$kill(pid));
					}
				} else {
					var req = cmd.a;
					return A2(
						$elm$core$Task$andThen,
						function (pid) {
							var _v4 = req.tracker;
							if (_v4.$ === 'Nothing') {
								return A3($elm$http$Http$updateReqs, router, otherCmds, reqs);
							} else {
								var tracker = _v4.a;
								return A3(
									$elm$http$Http$updateReqs,
									router,
									otherCmds,
									A3($elm$core$Dict$insert, tracker, pid, reqs));
							}
						},
						$elm$core$Process$spawn(
							A3(
								_Http_toTask,
								router,
								$elm$core$Platform$sendToApp(router),
								req)));
				}
			}
		}
	});
var $elm$http$Http$onEffects = F4(
	function (router, cmds, subs, state) {
		return A2(
			$elm$core$Task$andThen,
			function (reqs) {
				return $elm$core$Task$succeed(
					A2($elm$http$Http$State, reqs, subs));
			},
			A3($elm$http$Http$updateReqs, router, cmds, state.reqs));
	});
var $elm$core$List$maybeCons = F3(
	function (f, mx, xs) {
		var _v0 = f(mx);
		if (_v0.$ === 'Just') {
			var x = _v0.a;
			return A2($elm$core$List$cons, x, xs);
		} else {
			return xs;
		}
	});
var $elm$core$List$filterMap = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$foldr,
			$elm$core$List$maybeCons(f),
			_List_Nil,
			xs);
	});
var $elm$http$Http$maybeSend = F4(
	function (router, desiredTracker, progress, _v0) {
		var actualTracker = _v0.a;
		var toMsg = _v0.b;
		return _Utils_eq(desiredTracker, actualTracker) ? $elm$core$Maybe$Just(
			A2(
				$elm$core$Platform$sendToApp,
				router,
				toMsg(progress))) : $elm$core$Maybe$Nothing;
	});
var $elm$http$Http$onSelfMsg = F3(
	function (router, _v0, state) {
		var tracker = _v0.a;
		var progress = _v0.b;
		return A2(
			$elm$core$Task$andThen,
			function (_v1) {
				return $elm$core$Task$succeed(state);
			},
			$elm$core$Task$sequence(
				A2(
					$elm$core$List$filterMap,
					A3($elm$http$Http$maybeSend, router, tracker, progress),
					state.subs)));
	});
var $elm$http$Http$Cancel = function (a) {
	return {$: 'Cancel', a: a};
};
var $elm$http$Http$cmdMap = F2(
	function (func, cmd) {
		if (cmd.$ === 'Cancel') {
			var tracker = cmd.a;
			return $elm$http$Http$Cancel(tracker);
		} else {
			var r = cmd.a;
			return $elm$http$Http$Request(
				{
					allowCookiesFromOtherDomains: r.allowCookiesFromOtherDomains,
					body: r.body,
					expect: A2(_Http_mapExpect, func, r.expect),
					headers: r.headers,
					method: r.method,
					timeout: r.timeout,
					tracker: r.tracker,
					url: r.url
				});
		}
	});
var $elm$http$Http$MySub = F2(
	function (a, b) {
		return {$: 'MySub', a: a, b: b};
	});
var $elm$http$Http$subMap = F2(
	function (func, _v0) {
		var tracker = _v0.a;
		var toMsg = _v0.b;
		return A2(
			$elm$http$Http$MySub,
			tracker,
			A2($elm$core$Basics$composeR, toMsg, func));
	});
_Platform_effectManagers['Http'] = _Platform_createManager($elm$http$Http$init, $elm$http$Http$onEffects, $elm$http$Http$onSelfMsg, $elm$http$Http$cmdMap, $elm$http$Http$subMap);
var $elm$http$Http$command = _Platform_leaf('Http');
var $elm$http$Http$subscription = _Platform_leaf('Http');
var $elm$http$Http$request = function (r) {
	return $elm$http$Http$command(
		$elm$http$Http$Request(
			{allowCookiesFromOtherDomains: false, body: r.body, expect: r.expect, headers: r.headers, method: r.method, timeout: r.timeout, tracker: r.tracker, url: r.url}));
};
var $elm$http$Http$get = function (r) {
	return $elm$http$Http$request(
		{body: $elm$http$Http$emptyBody, expect: r.expect, headers: _List_Nil, method: 'GET', timeout: $elm$core$Maybe$Nothing, tracker: $elm$core$Maybe$Nothing, url: r.url});
};
var $author$project$Main$fetchData = $elm$http$Http$get(
	{
		expect: $elm$http$Http$expectString($author$project$Main$DataReceived),
		url: './csv/smartphone_dataset.csv'
	});
var $author$project$TreeView$h = 450;
var $gampleman$elm_visualization$Zoom$NoTouches = {$: 'NoTouches'};
var $gampleman$elm_visualization$Zoom$Zoom = function (a) {
	return {$: 'Zoom', a: a};
};
var $gampleman$elm_visualization$Zoom$Transform$Transform = F3(
	function (k, x, y) {
		return {k: k, x: x, y: y};
	});
var $gampleman$elm_visualization$Zoom$Transform$identity = A3($gampleman$elm_visualization$Zoom$Transform$Transform, 1.0, 0.0, 0.0);
var $gampleman$elm_visualization$Zoom$infinity = 1 / 0;
var $elm$core$Basics$negate = function (n) {
	return -n;
};
var $gampleman$elm_visualization$Zoom$init = function (_v0) {
	var width = _v0.width;
	var height = _v0.height;
	return $gampleman$elm_visualization$Zoom$Zoom(
		{
			drag: $elm$core$Maybe$Nothing,
			extent: _Utils_Tuple2(
				_Utils_Tuple2(0, 0),
				_Utils_Tuple2(width, height)),
			gestureLastScale: 0,
			scaleExtent: _Utils_Tuple2(0, $gampleman$elm_visualization$Zoom$infinity),
			touchStarted: false,
			touches: $gampleman$elm_visualization$Zoom$NoTouches,
			transform: $gampleman$elm_visualization$Zoom$Transform$identity,
			transition: $elm$core$Maybe$Nothing,
			translateExtent: _Utils_Tuple2(
				_Utils_Tuple2(-$gampleman$elm_visualization$Zoom$infinity, -$gampleman$elm_visualization$Zoom$infinity),
				_Utils_Tuple2($gampleman$elm_visualization$Zoom$infinity, $gampleman$elm_visualization$Zoom$infinity))
		});
};
var $gampleman$elm_visualization$Zoom$scaleExtent = F3(
	function (mn, mx, _v0) {
		var zoom = _v0.a;
		return $gampleman$elm_visualization$Zoom$Zoom(
			_Utils_update(
				zoom,
				{
					scaleExtent: _Utils_Tuple2(mn, mx)
				}));
	});
var $gampleman$elm_visualization$Zoom$translateExtent = F2(
	function (extent, _v0) {
		var zoom = _v0.a;
		return $gampleman$elm_visualization$Zoom$Zoom(
			_Utils_update(
				zoom,
				{translateExtent: extent}));
	});
var $author$project$TreeView$w = 990;
var $author$project$Main$init = function (_v0) {
	return _Utils_Tuple2(
		A8(
			$author$project$Model$Model,
			_List_Nil,
			$elm$core$Maybe$Nothing,
			'',
			{att1List: _List_Nil, att2List: _List_Nil, attribute1: 'Price', attribute2: 'Rating', unit1: 'EUR', unit2: '%'},
			{
				orderedLabels: _List_fromArray(
					['Price', 'Rating', 'NumCores', 'Processor Speed', 'Battery', 'Fast Charging', 'Memory', 'RAM', 'Screen Size', 'Refresh Rate']),
				orderedList: _List_fromArray(
					[
						function ($) {
						return $.price;
					},
						function ($) {
						return $.rating;
					},
						function ($) {
						return $.num_cores;
					},
						function ($) {
						return $.processor_speed;
					},
						function ($) {
						return $.battery;
					},
						function ($) {
						return $.fast_charging;
					},
						function ($) {
						return $.memory;
					},
						function ($) {
						return $.ram;
					},
						function ($) {
						return $.screen_size;
					},
						function ($) {
						return $.refresh_rate;
					}
					]),
				orderedUnitLabels: _List_fromArray(
					['EUR', '%', '', 'GHz', 'mAh', '', 'GB', 'GB', 'inches', 'Hz']),
				selectedFilter: {brand: 'all', g5: 'all', ir_blaster: 'all', nfc: 'all'}
			},
			{
				dropCount: 0,
				inputDropCount: '',
				selectedFilter: {brand: 'all', g5: 'true', ir_blaster: 'false', nfc: 'false'},
				zoomOption: A2(
					$gampleman$elm_visualization$Zoom$translateExtent,
					_Utils_Tuple2(
						_Utils_Tuple2(0, 0),
						_Utils_Tuple2($author$project$TreeView$w, $author$project$TreeView$h)),
					A3(
						$gampleman$elm_visualization$Zoom$scaleExtent,
						1,
						100,
						$gampleman$elm_visualization$Zoom$init(
							{height: $author$project$TreeView$h, width: $author$project$TreeView$w})))
			},
			{input1: '', input2: '', modelID1: '0', modelID2: '1019', nextChange: 2},
			{parallelCoordinatesPlot: false, scatterPlot: true, starPlot: false, treeView: false}),
		$author$project$Main$fetchData);
};
var $author$project$Main$ZooomMsg = function (a) {
	return {$: 'ZooomMsg', a: a};
};
var $gampleman$elm_visualization$Zoom$MouseMove = function (a) {
	return {$: 'MouseMove', a: a};
};
var $gampleman$elm_visualization$Zoom$MouseUp = {$: 'MouseUp'};
var $gampleman$elm_visualization$Zoom$Tick = function (a) {
	return {$: 'Tick', a: a};
};
var $gampleman$elm_visualization$Zoom$TouchStartedExpired = {$: 'TouchStartedExpired'};
var $elm$core$Basics$always = F2(
	function (a, _v0) {
		return a;
	});
var $elm$core$Platform$Sub$batch = _Platform_batch;
var $elm$time$Time$Every = F2(
	function (a, b) {
		return {$: 'Every', a: a, b: b};
	});
var $elm$time$Time$State = F2(
	function (taggers, processes) {
		return {processes: processes, taggers: taggers};
	});
var $elm$time$Time$init = $elm$core$Task$succeed(
	A2($elm$time$Time$State, $elm$core$Dict$empty, $elm$core$Dict$empty));
var $elm$time$Time$addMySub = F2(
	function (_v0, state) {
		var interval = _v0.a;
		var tagger = _v0.b;
		var _v1 = A2($elm$core$Dict$get, interval, state);
		if (_v1.$ === 'Nothing') {
			return A3(
				$elm$core$Dict$insert,
				interval,
				_List_fromArray(
					[tagger]),
				state);
		} else {
			var taggers = _v1.a;
			return A3(
				$elm$core$Dict$insert,
				interval,
				A2($elm$core$List$cons, tagger, taggers),
				state);
		}
	});
var $elm$core$Dict$foldl = F3(
	function (func, acc, dict) {
		foldl:
		while (true) {
			if (dict.$ === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var key = dict.b;
				var value = dict.c;
				var left = dict.d;
				var right = dict.e;
				var $temp$func = func,
					$temp$acc = A3(
					func,
					key,
					value,
					A3($elm$core$Dict$foldl, func, acc, left)),
					$temp$dict = right;
				func = $temp$func;
				acc = $temp$acc;
				dict = $temp$dict;
				continue foldl;
			}
		}
	});
var $elm$core$Dict$merge = F6(
	function (leftStep, bothStep, rightStep, leftDict, rightDict, initialResult) {
		var stepState = F3(
			function (rKey, rValue, _v0) {
				stepState:
				while (true) {
					var list = _v0.a;
					var result = _v0.b;
					if (!list.b) {
						return _Utils_Tuple2(
							list,
							A3(rightStep, rKey, rValue, result));
					} else {
						var _v2 = list.a;
						var lKey = _v2.a;
						var lValue = _v2.b;
						var rest = list.b;
						if (_Utils_cmp(lKey, rKey) < 0) {
							var $temp$rKey = rKey,
								$temp$rValue = rValue,
								$temp$_v0 = _Utils_Tuple2(
								rest,
								A3(leftStep, lKey, lValue, result));
							rKey = $temp$rKey;
							rValue = $temp$rValue;
							_v0 = $temp$_v0;
							continue stepState;
						} else {
							if (_Utils_cmp(lKey, rKey) > 0) {
								return _Utils_Tuple2(
									list,
									A3(rightStep, rKey, rValue, result));
							} else {
								return _Utils_Tuple2(
									rest,
									A4(bothStep, lKey, lValue, rValue, result));
							}
						}
					}
				}
			});
		var _v3 = A3(
			$elm$core$Dict$foldl,
			stepState,
			_Utils_Tuple2(
				$elm$core$Dict$toList(leftDict),
				initialResult),
			rightDict);
		var leftovers = _v3.a;
		var intermediateResult = _v3.b;
		return A3(
			$elm$core$List$foldl,
			F2(
				function (_v4, result) {
					var k = _v4.a;
					var v = _v4.b;
					return A3(leftStep, k, v, result);
				}),
			intermediateResult,
			leftovers);
	});
var $elm$time$Time$Name = function (a) {
	return {$: 'Name', a: a};
};
var $elm$time$Time$Offset = function (a) {
	return {$: 'Offset', a: a};
};
var $elm$time$Time$Zone = F2(
	function (a, b) {
		return {$: 'Zone', a: a, b: b};
	});
var $elm$time$Time$customZone = $elm$time$Time$Zone;
var $elm$time$Time$setInterval = _Time_setInterval;
var $elm$time$Time$spawnHelp = F3(
	function (router, intervals, processes) {
		if (!intervals.b) {
			return $elm$core$Task$succeed(processes);
		} else {
			var interval = intervals.a;
			var rest = intervals.b;
			var spawnTimer = $elm$core$Process$spawn(
				A2(
					$elm$time$Time$setInterval,
					interval,
					A2($elm$core$Platform$sendToSelf, router, interval)));
			var spawnRest = function (id) {
				return A3(
					$elm$time$Time$spawnHelp,
					router,
					rest,
					A3($elm$core$Dict$insert, interval, id, processes));
			};
			return A2($elm$core$Task$andThen, spawnRest, spawnTimer);
		}
	});
var $elm$time$Time$onEffects = F3(
	function (router, subs, _v0) {
		var processes = _v0.processes;
		var rightStep = F3(
			function (_v6, id, _v7) {
				var spawns = _v7.a;
				var existing = _v7.b;
				var kills = _v7.c;
				return _Utils_Tuple3(
					spawns,
					existing,
					A2(
						$elm$core$Task$andThen,
						function (_v5) {
							return kills;
						},
						$elm$core$Process$kill(id)));
			});
		var newTaggers = A3($elm$core$List$foldl, $elm$time$Time$addMySub, $elm$core$Dict$empty, subs);
		var leftStep = F3(
			function (interval, taggers, _v4) {
				var spawns = _v4.a;
				var existing = _v4.b;
				var kills = _v4.c;
				return _Utils_Tuple3(
					A2($elm$core$List$cons, interval, spawns),
					existing,
					kills);
			});
		var bothStep = F4(
			function (interval, taggers, id, _v3) {
				var spawns = _v3.a;
				var existing = _v3.b;
				var kills = _v3.c;
				return _Utils_Tuple3(
					spawns,
					A3($elm$core$Dict$insert, interval, id, existing),
					kills);
			});
		var _v1 = A6(
			$elm$core$Dict$merge,
			leftStep,
			bothStep,
			rightStep,
			newTaggers,
			processes,
			_Utils_Tuple3(
				_List_Nil,
				$elm$core$Dict$empty,
				$elm$core$Task$succeed(_Utils_Tuple0)));
		var spawnList = _v1.a;
		var existingDict = _v1.b;
		var killTask = _v1.c;
		return A2(
			$elm$core$Task$andThen,
			function (newProcesses) {
				return $elm$core$Task$succeed(
					A2($elm$time$Time$State, newTaggers, newProcesses));
			},
			A2(
				$elm$core$Task$andThen,
				function (_v2) {
					return A3($elm$time$Time$spawnHelp, router, spawnList, existingDict);
				},
				killTask));
	});
var $elm$time$Time$Posix = function (a) {
	return {$: 'Posix', a: a};
};
var $elm$time$Time$millisToPosix = $elm$time$Time$Posix;
var $elm$time$Time$now = _Time_now($elm$time$Time$millisToPosix);
var $elm$time$Time$onSelfMsg = F3(
	function (router, interval, state) {
		var _v0 = A2($elm$core$Dict$get, interval, state.taggers);
		if (_v0.$ === 'Nothing') {
			return $elm$core$Task$succeed(state);
		} else {
			var taggers = _v0.a;
			var tellTaggers = function (time) {
				return $elm$core$Task$sequence(
					A2(
						$elm$core$List$map,
						function (tagger) {
							return A2(
								$elm$core$Platform$sendToApp,
								router,
								tagger(time));
						},
						taggers));
			};
			return A2(
				$elm$core$Task$andThen,
				function (_v1) {
					return $elm$core$Task$succeed(state);
				},
				A2($elm$core$Task$andThen, tellTaggers, $elm$time$Time$now));
		}
	});
var $elm$core$Basics$composeL = F3(
	function (g, f, x) {
		return g(
			f(x));
	});
var $elm$time$Time$subMap = F2(
	function (f, _v0) {
		var interval = _v0.a;
		var tagger = _v0.b;
		return A2(
			$elm$time$Time$Every,
			interval,
			A2($elm$core$Basics$composeL, f, tagger));
	});
_Platform_effectManagers['Time'] = _Platform_createManager($elm$time$Time$init, $elm$time$Time$onEffects, $elm$time$Time$onSelfMsg, 0, $elm$time$Time$subMap);
var $elm$time$Time$subscription = _Platform_leaf('Time');
var $elm$time$Time$every = F2(
	function (interval, tagger) {
		return $elm$time$Time$subscription(
			A2($elm$time$Time$Every, interval, tagger));
	});
var $elm$json$Json$Decode$field = _Json_decodeField;
var $elm$json$Json$Decode$float = _Json_decodeFloat;
var $elm$core$Maybe$map = F2(
	function (f, maybe) {
		if (maybe.$ === 'Just') {
			var value = maybe.a;
			return $elm$core$Maybe$Just(
				f(value));
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $elm$core$Platform$Sub$none = $elm$core$Platform$Sub$batch(_List_Nil);
var $elm$browser$Browser$AnimationManager$Delta = function (a) {
	return {$: 'Delta', a: a};
};
var $elm$browser$Browser$AnimationManager$State = F3(
	function (subs, request, oldTime) {
		return {oldTime: oldTime, request: request, subs: subs};
	});
var $elm$browser$Browser$AnimationManager$init = $elm$core$Task$succeed(
	A3($elm$browser$Browser$AnimationManager$State, _List_Nil, $elm$core$Maybe$Nothing, 0));
var $elm$browser$Browser$AnimationManager$now = _Browser_now(_Utils_Tuple0);
var $elm$browser$Browser$AnimationManager$rAF = _Browser_rAF(_Utils_Tuple0);
var $elm$browser$Browser$AnimationManager$onEffects = F3(
	function (router, subs, _v0) {
		var request = _v0.request;
		var oldTime = _v0.oldTime;
		var _v1 = _Utils_Tuple2(request, subs);
		if (_v1.a.$ === 'Nothing') {
			if (!_v1.b.b) {
				var _v2 = _v1.a;
				return $elm$browser$Browser$AnimationManager$init;
			} else {
				var _v4 = _v1.a;
				return A2(
					$elm$core$Task$andThen,
					function (pid) {
						return A2(
							$elm$core$Task$andThen,
							function (time) {
								return $elm$core$Task$succeed(
									A3(
										$elm$browser$Browser$AnimationManager$State,
										subs,
										$elm$core$Maybe$Just(pid),
										time));
							},
							$elm$browser$Browser$AnimationManager$now);
					},
					$elm$core$Process$spawn(
						A2(
							$elm$core$Task$andThen,
							$elm$core$Platform$sendToSelf(router),
							$elm$browser$Browser$AnimationManager$rAF)));
			}
		} else {
			if (!_v1.b.b) {
				var pid = _v1.a.a;
				return A2(
					$elm$core$Task$andThen,
					function (_v3) {
						return $elm$browser$Browser$AnimationManager$init;
					},
					$elm$core$Process$kill(pid));
			} else {
				return $elm$core$Task$succeed(
					A3($elm$browser$Browser$AnimationManager$State, subs, request, oldTime));
			}
		}
	});
var $elm$browser$Browser$AnimationManager$onSelfMsg = F3(
	function (router, newTime, _v0) {
		var subs = _v0.subs;
		var oldTime = _v0.oldTime;
		var send = function (sub) {
			if (sub.$ === 'Time') {
				var tagger = sub.a;
				return A2(
					$elm$core$Platform$sendToApp,
					router,
					tagger(
						$elm$time$Time$millisToPosix(newTime)));
			} else {
				var tagger = sub.a;
				return A2(
					$elm$core$Platform$sendToApp,
					router,
					tagger(newTime - oldTime));
			}
		};
		return A2(
			$elm$core$Task$andThen,
			function (pid) {
				return A2(
					$elm$core$Task$andThen,
					function (_v1) {
						return $elm$core$Task$succeed(
							A3(
								$elm$browser$Browser$AnimationManager$State,
								subs,
								$elm$core$Maybe$Just(pid),
								newTime));
					},
					$elm$core$Task$sequence(
						A2($elm$core$List$map, send, subs)));
			},
			$elm$core$Process$spawn(
				A2(
					$elm$core$Task$andThen,
					$elm$core$Platform$sendToSelf(router),
					$elm$browser$Browser$AnimationManager$rAF)));
	});
var $elm$browser$Browser$AnimationManager$Time = function (a) {
	return {$: 'Time', a: a};
};
var $elm$browser$Browser$AnimationManager$subMap = F2(
	function (func, sub) {
		if (sub.$ === 'Time') {
			var tagger = sub.a;
			return $elm$browser$Browser$AnimationManager$Time(
				A2($elm$core$Basics$composeL, func, tagger));
		} else {
			var tagger = sub.a;
			return $elm$browser$Browser$AnimationManager$Delta(
				A2($elm$core$Basics$composeL, func, tagger));
		}
	});
_Platform_effectManagers['Browser.AnimationManager'] = _Platform_createManager($elm$browser$Browser$AnimationManager$init, $elm$browser$Browser$AnimationManager$onEffects, $elm$browser$Browser$AnimationManager$onSelfMsg, 0, $elm$browser$Browser$AnimationManager$subMap);
var $elm$browser$Browser$AnimationManager$subscription = _Platform_leaf('Browser.AnimationManager');
var $elm$browser$Browser$AnimationManager$onAnimationFrameDelta = function (tagger) {
	return $elm$browser$Browser$AnimationManager$subscription(
		$elm$browser$Browser$AnimationManager$Delta(tagger));
};
var $elm$browser$Browser$Events$onAnimationFrameDelta = $elm$browser$Browser$AnimationManager$onAnimationFrameDelta;
var $elm$browser$Browser$Events$Document = {$: 'Document'};
var $elm$browser$Browser$Events$MySub = F3(
	function (a, b, c) {
		return {$: 'MySub', a: a, b: b, c: c};
	});
var $elm$browser$Browser$Events$State = F2(
	function (subs, pids) {
		return {pids: pids, subs: subs};
	});
var $elm$browser$Browser$Events$init = $elm$core$Task$succeed(
	A2($elm$browser$Browser$Events$State, _List_Nil, $elm$core$Dict$empty));
var $elm$browser$Browser$Events$nodeToKey = function (node) {
	if (node.$ === 'Document') {
		return 'd_';
	} else {
		return 'w_';
	}
};
var $elm$browser$Browser$Events$addKey = function (sub) {
	var node = sub.a;
	var name = sub.b;
	return _Utils_Tuple2(
		_Utils_ap(
			$elm$browser$Browser$Events$nodeToKey(node),
			name),
		sub);
};
var $elm$core$Dict$fromList = function (assocs) {
	return A3(
		$elm$core$List$foldl,
		F2(
			function (_v0, dict) {
				var key = _v0.a;
				var value = _v0.b;
				return A3($elm$core$Dict$insert, key, value, dict);
			}),
		$elm$core$Dict$empty,
		assocs);
};
var $elm$browser$Browser$Events$Event = F2(
	function (key, event) {
		return {event: event, key: key};
	});
var $elm$browser$Browser$Events$spawn = F3(
	function (router, key, _v0) {
		var node = _v0.a;
		var name = _v0.b;
		var actualNode = function () {
			if (node.$ === 'Document') {
				return _Browser_doc;
			} else {
				return _Browser_window;
			}
		}();
		return A2(
			$elm$core$Task$map,
			function (value) {
				return _Utils_Tuple2(key, value);
			},
			A3(
				_Browser_on,
				actualNode,
				name,
				function (event) {
					return A2(
						$elm$core$Platform$sendToSelf,
						router,
						A2($elm$browser$Browser$Events$Event, key, event));
				}));
	});
var $elm$core$Dict$union = F2(
	function (t1, t2) {
		return A3($elm$core$Dict$foldl, $elm$core$Dict$insert, t2, t1);
	});
var $elm$browser$Browser$Events$onEffects = F3(
	function (router, subs, state) {
		var stepRight = F3(
			function (key, sub, _v6) {
				var deads = _v6.a;
				var lives = _v6.b;
				var news = _v6.c;
				return _Utils_Tuple3(
					deads,
					lives,
					A2(
						$elm$core$List$cons,
						A3($elm$browser$Browser$Events$spawn, router, key, sub),
						news));
			});
		var stepLeft = F3(
			function (_v4, pid, _v5) {
				var deads = _v5.a;
				var lives = _v5.b;
				var news = _v5.c;
				return _Utils_Tuple3(
					A2($elm$core$List$cons, pid, deads),
					lives,
					news);
			});
		var stepBoth = F4(
			function (key, pid, _v2, _v3) {
				var deads = _v3.a;
				var lives = _v3.b;
				var news = _v3.c;
				return _Utils_Tuple3(
					deads,
					A3($elm$core$Dict$insert, key, pid, lives),
					news);
			});
		var newSubs = A2($elm$core$List$map, $elm$browser$Browser$Events$addKey, subs);
		var _v0 = A6(
			$elm$core$Dict$merge,
			stepLeft,
			stepBoth,
			stepRight,
			state.pids,
			$elm$core$Dict$fromList(newSubs),
			_Utils_Tuple3(_List_Nil, $elm$core$Dict$empty, _List_Nil));
		var deadPids = _v0.a;
		var livePids = _v0.b;
		var makeNewPids = _v0.c;
		return A2(
			$elm$core$Task$andThen,
			function (pids) {
				return $elm$core$Task$succeed(
					A2(
						$elm$browser$Browser$Events$State,
						newSubs,
						A2(
							$elm$core$Dict$union,
							livePids,
							$elm$core$Dict$fromList(pids))));
			},
			A2(
				$elm$core$Task$andThen,
				function (_v1) {
					return $elm$core$Task$sequence(makeNewPids);
				},
				$elm$core$Task$sequence(
					A2($elm$core$List$map, $elm$core$Process$kill, deadPids))));
	});
var $elm$browser$Browser$Events$onSelfMsg = F3(
	function (router, _v0, state) {
		var key = _v0.key;
		var event = _v0.event;
		var toMessage = function (_v2) {
			var subKey = _v2.a;
			var _v3 = _v2.b;
			var node = _v3.a;
			var name = _v3.b;
			var decoder = _v3.c;
			return _Utils_eq(subKey, key) ? A2(_Browser_decodeEvent, decoder, event) : $elm$core$Maybe$Nothing;
		};
		var messages = A2($elm$core$List$filterMap, toMessage, state.subs);
		return A2(
			$elm$core$Task$andThen,
			function (_v1) {
				return $elm$core$Task$succeed(state);
			},
			$elm$core$Task$sequence(
				A2(
					$elm$core$List$map,
					$elm$core$Platform$sendToApp(router),
					messages)));
	});
var $elm$browser$Browser$Events$subMap = F2(
	function (func, _v0) {
		var node = _v0.a;
		var name = _v0.b;
		var decoder = _v0.c;
		return A3(
			$elm$browser$Browser$Events$MySub,
			node,
			name,
			A2($elm$json$Json$Decode$map, func, decoder));
	});
_Platform_effectManagers['Browser.Events'] = _Platform_createManager($elm$browser$Browser$Events$init, $elm$browser$Browser$Events$onEffects, $elm$browser$Browser$Events$onSelfMsg, 0, $elm$browser$Browser$Events$subMap);
var $elm$browser$Browser$Events$subscription = _Platform_leaf('Browser.Events');
var $elm$browser$Browser$Events$on = F3(
	function (node, name, decoder) {
		return $elm$browser$Browser$Events$subscription(
			A3($elm$browser$Browser$Events$MySub, node, name, decoder));
	});
var $elm$browser$Browser$Events$onMouseMove = A2($elm$browser$Browser$Events$on, $elm$browser$Browser$Events$Document, 'mousemove');
var $elm$browser$Browser$Events$onMouseUp = A2($elm$browser$Browser$Events$on, $elm$browser$Browser$Events$Document, 'mouseup');
var $gampleman$elm_visualization$Zoom$touchDelay = 500;
var $elm$core$Maybe$withDefault = F2(
	function (_default, maybe) {
		if (maybe.$ === 'Just') {
			var value = maybe.a;
			return value;
		} else {
			return _default;
		}
	});
var $gampleman$elm_visualization$Zoom$subscriptions = F2(
	function (_v0, tagger) {
		var zoom = _v0.a;
		return $elm$core$Platform$Sub$batch(
			_List_fromArray(
				[
					function () {
					var _v1 = zoom.drag;
					if (_v1.$ === 'Just') {
						return $elm$core$Platform$Sub$batch(
							_List_fromArray(
								[
									$elm$browser$Browser$Events$onMouseMove(
									A3(
										$elm$json$Json$Decode$map2,
										F2(
											function (x, y) {
												return tagger(
													$gampleman$elm_visualization$Zoom$MouseMove(
														_Utils_Tuple2(x, y)));
											}),
										A2($elm$json$Json$Decode$field, 'clientX', $elm$json$Json$Decode$float),
										A2($elm$json$Json$Decode$field, 'clientY', $elm$json$Json$Decode$float))),
									$elm$browser$Browser$Events$onMouseUp(
									$elm$json$Json$Decode$succeed(
										tagger($gampleman$elm_visualization$Zoom$MouseUp)))
								]));
					} else {
						return $elm$core$Platform$Sub$none;
					}
				}(),
					zoom.touchStarted ? A2(
					$elm$time$Time$every,
					$gampleman$elm_visualization$Zoom$touchDelay,
					A2(
						$elm$core$Basics$composeR,
						$elm$core$Basics$always($gampleman$elm_visualization$Zoom$TouchStartedExpired),
						tagger)) : $elm$core$Platform$Sub$none,
					A2(
					$elm$core$Maybe$withDefault,
					$elm$core$Platform$Sub$none,
					A2(
						$elm$core$Maybe$map,
						$elm$core$Basics$always(
							$elm$browser$Browser$Events$onAnimationFrameDelta(
								A2($elm$core$Basics$composeR, $gampleman$elm_visualization$Zoom$Tick, tagger))),
						zoom.transition))
				]));
	});
var $author$project$Main$subscriptions = function (model) {
	return A2($gampleman$elm_visualization$Zoom$subscriptions, model.treeOption.zoomOption, $author$project$Main$ZooomMsg);
};
var $author$project$Main$createAttList = F2(
	function (model, att) {
		return (att === 'Price') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.price;
				},
				model.data),
			'EUR') : ((att === 'Rating') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.rating;
				},
				model.data),
			'%') : ((att === 'NumCores') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.num_cores;
				},
				model.data),
			'') : ((att === 'Processor Speed') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.processor_speed;
				},
				model.data),
			'GHz') : ((att === 'Battery') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.battery;
				},
				model.data),
			'mAh') : ((att === 'Fast Charging') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.fast_charging;
				},
				model.data),
			'') : ((att === 'Memory') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.memory;
				},
				model.data),
			'GB') : ((att === 'RAM') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.ram;
				},
				model.data),
			'GB') : ((att === 'Screen Size') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.screen_size;
				},
				model.data),
			'inches') : ((att === 'Refresh Rate') ? _Utils_Tuple2(
			A2(
				$elm$core$List$map,
				function ($) {
					return $.refresh_rate;
				},
				model.data),
			'Hz') : _Utils_Tuple2(_List_Nil, ''))))))))));
	});
var $elm$core$Platform$Cmd$batch = _Platform_batch;
var $elm$core$Platform$Cmd$none = $elm$core$Platform$Cmd$batch(_List_Nil);
var $BrianHicks$elm_csv$Csv$Decode$FieldNamesFromFirstRow = {$: 'FieldNamesFromFirstRow'};
var $BrianHicks$elm_csv$Csv$Decode$ParsingError = function (a) {
	return {$: 'ParsingError', a: a};
};
var $elm$core$Result$andThen = F2(
	function (callback, result) {
		if (result.$ === 'Ok') {
			var value = result.a;
			return callback(value);
		} else {
			var msg = result.a;
			return $elm$core$Result$Err(msg);
		}
	});
var $BrianHicks$elm_csv$Csv$Decode$DecodingErrors = function (a) {
	return {$: 'DecodingErrors', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$OnlyColumn_ = {$: 'OnlyColumn_'};
var $elm$core$List$append = F2(
	function (xs, ys) {
		if (!ys.b) {
			return xs;
		} else {
			return A3($elm$core$List$foldr, $elm$core$List$cons, ys, xs);
		}
	});
var $elm$core$List$concat = function (lists) {
	return A3($elm$core$List$foldr, $elm$core$List$append, _List_Nil, lists);
};
var $BrianHicks$elm_csv$Csv$Decode$NoFieldNamesOnFirstRow = {$: 'NoFieldNamesOnFirstRow'};
var $elm$core$String$trim = _String_trim;
var $BrianHicks$elm_csv$Csv$Decode$getFieldNames = F2(
	function (headers, rows) {
		var fromList = function (names) {
			return A3(
				$elm$core$List$foldl,
				F2(
					function (name, _v2) {
						var soFar = _v2.a;
						var i = _v2.b;
						return _Utils_Tuple2(
							A3($elm$core$Dict$insert, name, i, soFar),
							i + 1);
					}),
				_Utils_Tuple2($elm$core$Dict$empty, 0),
				names).a;
		};
		switch (headers.$) {
			case 'NoFieldNames':
				return $elm$core$Result$Ok(
					_Utils_Tuple3(
						{available: false, names: $elm$core$Dict$empty},
						0,
						rows));
			case 'CustomFieldNames':
				var names = headers.a;
				return $elm$core$Result$Ok(
					_Utils_Tuple3(
						{
							available: true,
							names: fromList(names)
						},
						0,
						rows));
			default:
				if (!rows.b) {
					return $elm$core$Result$Err($BrianHicks$elm_csv$Csv$Decode$NoFieldNamesOnFirstRow);
				} else {
					var first = rows.a;
					var rest = rows.b;
					return $elm$core$Result$Ok(
						_Utils_Tuple3(
							{
								available: true,
								names: fromList(
									A2($elm$core$List$map, $elm$core$String$trim, first))
							},
							1,
							rest));
				}
		}
	});
var $elm$core$Result$map = F2(
	function (func, ra) {
		if (ra.$ === 'Ok') {
			var a = ra.a;
			return $elm$core$Result$Ok(
				func(a));
		} else {
			var e = ra.a;
			return $elm$core$Result$Err(e);
		}
	});
var $BrianHicks$elm_csv$Csv$Decode$applyDecoder = F3(
	function (fieldNames, _v0, allRows) {
		var decode = _v0.a;
		var defaultLocation = $BrianHicks$elm_csv$Csv$Decode$OnlyColumn_;
		return A2(
			$elm$core$Result$andThen,
			function (_v1) {
				var resolvedNames = _v1.a;
				var firstRowNumber = _v1.b;
				var rows = _v1.c;
				return A2(
					$elm$core$Result$mapError,
					A2(
						$elm$core$Basics$composeL,
						A2($elm$core$Basics$composeL, $BrianHicks$elm_csv$Csv$Decode$DecodingErrors, $elm$core$List$concat),
						$elm$core$List$reverse),
					A2(
						$elm$core$Result$map,
						$elm$core$List$reverse,
						A3(
							$elm$core$List$foldl,
							F2(
								function (row, _v2) {
									var soFar = _v2.a;
									var rowNum = _v2.b;
									return _Utils_Tuple2(
										function () {
											var _v3 = A4(decode, defaultLocation, resolvedNames, rowNum, row);
											if (_v3.$ === 'Ok') {
												var val = _v3.a;
												if (soFar.$ === 'Ok') {
													var values = soFar.a;
													return $elm$core$Result$Ok(
														A2($elm$core$List$cons, val, values));
												} else {
													var errs = soFar.a;
													return $elm$core$Result$Err(errs);
												}
											} else {
												var err = _v3.a;
												if (soFar.$ === 'Ok') {
													return $elm$core$Result$Err(
														_List_fromArray(
															[err]));
												} else {
													var errs = soFar.a;
													return $elm$core$Result$Err(
														A2($elm$core$List$cons, err, errs));
												}
											}
										}(),
										rowNum + 1);
								}),
							_Utils_Tuple2(
								$elm$core$Result$Ok(_List_Nil),
								firstRowNumber),
							rows).a));
			},
			A2($BrianHicks$elm_csv$Csv$Decode$getFieldNames, fieldNames, allRows));
	});
var $BrianHicks$elm_csv$Csv$Parser$AdditionalCharactersAfterClosingQuote = function (a) {
	return {$: 'AdditionalCharactersAfterClosingQuote', a: a};
};
var $BrianHicks$elm_csv$Csv$Parser$SourceEndedWithoutClosingQuote = function (a) {
	return {$: 'SourceEndedWithoutClosingQuote', a: a};
};
var $elm$core$String$cons = _String_cons;
var $elm$core$String$fromChar = function (_char) {
	return A2($elm$core$String$cons, _char, '');
};
var $elm$core$Basics$ge = _Utils_ge;
var $BrianHicks$elm_csv$Csv$Parser$parse = F2(
	function (config, source) {
		var finalLength = $elm$core$String$length(source);
		var parseQuotedField = F4(
			function (isFieldSeparator, soFar, startOffset, endOffset) {
				parseQuotedField:
				while (true) {
					if ((endOffset - finalLength) >= 0) {
						return $elm$core$Result$Err($BrianHicks$elm_csv$Csv$Parser$SourceEndedWithoutClosingQuote);
					} else {
						if (A3($elm$core$String$slice, endOffset, endOffset + 1, source) === '\"') {
							var segment = A3($elm$core$String$slice, startOffset, endOffset, source);
							if (((endOffset + 1) - finalLength) >= 0) {
								return $elm$core$Result$Ok(
									_Utils_Tuple3(
										_Utils_ap(soFar, segment),
										endOffset + 1,
										false));
							} else {
								var next = A3($elm$core$String$slice, endOffset + 1, endOffset + 2, source);
								if (next === '\"') {
									var newPos = endOffset + 2;
									var $temp$isFieldSeparator = isFieldSeparator,
										$temp$soFar = soFar + (segment + '\"'),
										$temp$startOffset = newPos,
										$temp$endOffset = newPos;
									isFieldSeparator = $temp$isFieldSeparator;
									soFar = $temp$soFar;
									startOffset = $temp$startOffset;
									endOffset = $temp$endOffset;
									continue parseQuotedField;
								} else {
									if (isFieldSeparator(next)) {
										return $elm$core$Result$Ok(
											_Utils_Tuple3(
												_Utils_ap(soFar, segment),
												endOffset + 2,
												false));
									} else {
										if (next === '\n') {
											return $elm$core$Result$Ok(
												_Utils_Tuple3(
													_Utils_ap(soFar, segment),
													endOffset + 2,
													true));
										} else {
											if ((next === '\u000D') && (A3($elm$core$String$slice, endOffset + 2, endOffset + 3, source) === '\n')) {
												return $elm$core$Result$Ok(
													_Utils_Tuple3(
														_Utils_ap(soFar, segment),
														endOffset + 3,
														true));
											} else {
												return $elm$core$Result$Err($BrianHicks$elm_csv$Csv$Parser$AdditionalCharactersAfterClosingQuote);
											}
										}
									}
								}
							}
						} else {
							var $temp$isFieldSeparator = isFieldSeparator,
								$temp$soFar = soFar,
								$temp$startOffset = startOffset,
								$temp$endOffset = endOffset + 1;
							isFieldSeparator = $temp$isFieldSeparator;
							soFar = $temp$soFar;
							startOffset = $temp$startOffset;
							endOffset = $temp$endOffset;
							continue parseQuotedField;
						}
					}
				}
			});
		var parseComma = F4(
			function (row, rows, startOffset, endOffset) {
				parseComma:
				while (true) {
					if ((endOffset - finalLength) >= 0) {
						var finalField = A3($elm$core$String$slice, startOffset, endOffset, source);
						return ((finalField === '') && _Utils_eq(row, _List_Nil)) ? $elm$core$Result$Ok(
							$elm$core$List$reverse(rows)) : $elm$core$Result$Ok(
							$elm$core$List$reverse(
								A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2($elm$core$List$cons, finalField, row)),
									rows)));
					} else {
						var first = A3($elm$core$String$slice, endOffset, endOffset + 1, source);
						if (first === ',') {
							var newPos = endOffset + 1;
							var $temp$row = A2(
								$elm$core$List$cons,
								A3($elm$core$String$slice, startOffset, endOffset, source),
								row),
								$temp$rows = rows,
								$temp$startOffset = newPos,
								$temp$endOffset = newPos;
							row = $temp$row;
							rows = $temp$rows;
							startOffset = $temp$startOffset;
							endOffset = $temp$endOffset;
							continue parseComma;
						} else {
							if (first === '\n') {
								var newPos = endOffset + 1;
								var $temp$row = _List_Nil,
									$temp$rows = A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2(
											$elm$core$List$cons,
											A3($elm$core$String$slice, startOffset, endOffset, source),
											row)),
									rows),
									$temp$startOffset = newPos,
									$temp$endOffset = newPos;
								row = $temp$row;
								rows = $temp$rows;
								startOffset = $temp$startOffset;
								endOffset = $temp$endOffset;
								continue parseComma;
							} else {
								if ((first === '\u000D') && (A3($elm$core$String$slice, endOffset + 1, endOffset + 2, source) === '\n')) {
									var newPos = endOffset + 2;
									var $temp$row = _List_Nil,
										$temp$rows = A2(
										$elm$core$List$cons,
										$elm$core$List$reverse(
											A2(
												$elm$core$List$cons,
												A3($elm$core$String$slice, startOffset, endOffset, source),
												row)),
										rows),
										$temp$startOffset = newPos,
										$temp$endOffset = newPos;
									row = $temp$row;
									rows = $temp$rows;
									startOffset = $temp$startOffset;
									endOffset = $temp$endOffset;
									continue parseComma;
								} else {
									if (first === '\"') {
										var newPos = endOffset + 1;
										var _v0 = A4(
											parseQuotedField,
											function (c) {
												return c === ',';
											},
											'',
											newPos,
											newPos);
										if (_v0.$ === 'Ok') {
											var _v1 = _v0.a;
											var value = _v1.a;
											var afterQuotedField = _v1.b;
											var rowEnded = _v1.c;
											if (_Utils_cmp(afterQuotedField, finalLength) > -1) {
												return $elm$core$Result$Ok(
													$elm$core$List$reverse(
														A2(
															$elm$core$List$cons,
															$elm$core$List$reverse(
																A2($elm$core$List$cons, value, row)),
															rows)));
											} else {
												if (rowEnded) {
													var $temp$row = _List_Nil,
														$temp$rows = A2(
														$elm$core$List$cons,
														$elm$core$List$reverse(
															A2($elm$core$List$cons, value, row)),
														rows),
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseComma;
												} else {
													var $temp$row = A2($elm$core$List$cons, value, row),
														$temp$rows = rows,
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseComma;
												}
											}
										} else {
											var problem = _v0.a;
											return $elm$core$Result$Err(
												problem(
													$elm$core$List$length(rows) + 1));
										}
									} else {
										var $temp$row = row,
											$temp$rows = rows,
											$temp$startOffset = startOffset,
											$temp$endOffset = endOffset + 1;
										row = $temp$row;
										rows = $temp$rows;
										startOffset = $temp$startOffset;
										endOffset = $temp$endOffset;
										continue parseComma;
									}
								}
							}
						}
					}
				}
			});
		var parseHelp = F5(
			function (isFieldSeparator, row, rows, startOffset, endOffset) {
				parseHelp:
				while (true) {
					if ((endOffset - finalLength) >= 0) {
						var finalField = A3($elm$core$String$slice, startOffset, endOffset, source);
						return ((finalField === '') && _Utils_eq(row, _List_Nil)) ? $elm$core$Result$Ok(
							$elm$core$List$reverse(rows)) : $elm$core$Result$Ok(
							$elm$core$List$reverse(
								A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2($elm$core$List$cons, finalField, row)),
									rows)));
					} else {
						var first = A3($elm$core$String$slice, endOffset, endOffset + 1, source);
						if (isFieldSeparator(first)) {
							var newPos = endOffset + 1;
							var $temp$isFieldSeparator = isFieldSeparator,
								$temp$row = A2(
								$elm$core$List$cons,
								A3($elm$core$String$slice, startOffset, endOffset, source),
								row),
								$temp$rows = rows,
								$temp$startOffset = newPos,
								$temp$endOffset = newPos;
							isFieldSeparator = $temp$isFieldSeparator;
							row = $temp$row;
							rows = $temp$rows;
							startOffset = $temp$startOffset;
							endOffset = $temp$endOffset;
							continue parseHelp;
						} else {
							if (first === '\n') {
								var newPos = endOffset + 1;
								var $temp$isFieldSeparator = isFieldSeparator,
									$temp$row = _List_Nil,
									$temp$rows = A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2(
											$elm$core$List$cons,
											A3($elm$core$String$slice, startOffset, endOffset, source),
											row)),
									rows),
									$temp$startOffset = newPos,
									$temp$endOffset = newPos;
								isFieldSeparator = $temp$isFieldSeparator;
								row = $temp$row;
								rows = $temp$rows;
								startOffset = $temp$startOffset;
								endOffset = $temp$endOffset;
								continue parseHelp;
							} else {
								if ((first === '\u000D') && (A3($elm$core$String$slice, endOffset + 1, endOffset + 2, source) === '\n')) {
									var newPos = endOffset + 2;
									var $temp$isFieldSeparator = isFieldSeparator,
										$temp$row = _List_Nil,
										$temp$rows = A2(
										$elm$core$List$cons,
										$elm$core$List$reverse(
											A2(
												$elm$core$List$cons,
												A3($elm$core$String$slice, startOffset, endOffset, source),
												row)),
										rows),
										$temp$startOffset = newPos,
										$temp$endOffset = newPos;
									isFieldSeparator = $temp$isFieldSeparator;
									row = $temp$row;
									rows = $temp$rows;
									startOffset = $temp$startOffset;
									endOffset = $temp$endOffset;
									continue parseHelp;
								} else {
									if (first === '\"') {
										var newPos = endOffset + 1;
										var _v2 = A4(parseQuotedField, isFieldSeparator, '', newPos, newPos);
										if (_v2.$ === 'Ok') {
											var _v3 = _v2.a;
											var value = _v3.a;
											var afterQuotedField = _v3.b;
											var rowEnded = _v3.c;
											if (_Utils_cmp(afterQuotedField, finalLength) > -1) {
												return $elm$core$Result$Ok(
													$elm$core$List$reverse(
														A2(
															$elm$core$List$cons,
															$elm$core$List$reverse(
																A2($elm$core$List$cons, value, row)),
															rows)));
											} else {
												if (rowEnded) {
													var $temp$isFieldSeparator = isFieldSeparator,
														$temp$row = _List_Nil,
														$temp$rows = A2(
														$elm$core$List$cons,
														$elm$core$List$reverse(
															A2($elm$core$List$cons, value, row)),
														rows),
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													isFieldSeparator = $temp$isFieldSeparator;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseHelp;
												} else {
													var $temp$isFieldSeparator = isFieldSeparator,
														$temp$row = A2($elm$core$List$cons, value, row),
														$temp$rows = rows,
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													isFieldSeparator = $temp$isFieldSeparator;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseHelp;
												}
											}
										} else {
											var problem = _v2.a;
											return $elm$core$Result$Err(
												problem(
													$elm$core$List$length(rows) + 1));
										}
									} else {
										var $temp$isFieldSeparator = isFieldSeparator,
											$temp$row = row,
											$temp$rows = rows,
											$temp$startOffset = startOffset,
											$temp$endOffset = endOffset + 1;
										isFieldSeparator = $temp$isFieldSeparator;
										row = $temp$row;
										rows = $temp$rows;
										startOffset = $temp$startOffset;
										endOffset = $temp$endOffset;
										continue parseHelp;
									}
								}
							}
						}
					}
				}
			});
		var parseSemicolon = F4(
			function (row, rows, startOffset, endOffset) {
				parseSemicolon:
				while (true) {
					if ((endOffset - finalLength) >= 0) {
						var finalField = A3($elm$core$String$slice, startOffset, endOffset, source);
						return ((finalField === '') && _Utils_eq(row, _List_Nil)) ? $elm$core$Result$Ok(
							$elm$core$List$reverse(rows)) : $elm$core$Result$Ok(
							$elm$core$List$reverse(
								A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2($elm$core$List$cons, finalField, row)),
									rows)));
					} else {
						var first = A3($elm$core$String$slice, endOffset, endOffset + 1, source);
						if (first === ';') {
							var newPos = endOffset + 1;
							var $temp$row = A2(
								$elm$core$List$cons,
								A3($elm$core$String$slice, startOffset, endOffset, source),
								row),
								$temp$rows = rows,
								$temp$startOffset = newPos,
								$temp$endOffset = newPos;
							row = $temp$row;
							rows = $temp$rows;
							startOffset = $temp$startOffset;
							endOffset = $temp$endOffset;
							continue parseSemicolon;
						} else {
							if (first === '\n') {
								var newPos = endOffset + 1;
								var $temp$row = _List_Nil,
									$temp$rows = A2(
									$elm$core$List$cons,
									$elm$core$List$reverse(
										A2(
											$elm$core$List$cons,
											A3($elm$core$String$slice, startOffset, endOffset, source),
											row)),
									rows),
									$temp$startOffset = newPos,
									$temp$endOffset = newPos;
								row = $temp$row;
								rows = $temp$rows;
								startOffset = $temp$startOffset;
								endOffset = $temp$endOffset;
								continue parseSemicolon;
							} else {
								if ((first === '\u000D') && (A3($elm$core$String$slice, endOffset + 1, endOffset + 2, source) === '\n')) {
									var newPos = endOffset + 2;
									var $temp$row = _List_Nil,
										$temp$rows = A2(
										$elm$core$List$cons,
										$elm$core$List$reverse(
											A2(
												$elm$core$List$cons,
												A3($elm$core$String$slice, startOffset, endOffset, source),
												row)),
										rows),
										$temp$startOffset = newPos,
										$temp$endOffset = newPos;
									row = $temp$row;
									rows = $temp$rows;
									startOffset = $temp$startOffset;
									endOffset = $temp$endOffset;
									continue parseSemicolon;
								} else {
									if (first === '\"') {
										var newPos = endOffset + 1;
										var _v4 = A4(
											parseQuotedField,
											function (c) {
												return c === ';';
											},
											'',
											newPos,
											newPos);
										if (_v4.$ === 'Ok') {
											var _v5 = _v4.a;
											var value = _v5.a;
											var afterQuotedField = _v5.b;
											var rowEnded = _v5.c;
											if (_Utils_cmp(afterQuotedField, finalLength) > -1) {
												return $elm$core$Result$Ok(
													$elm$core$List$reverse(
														A2(
															$elm$core$List$cons,
															$elm$core$List$reverse(
																A2($elm$core$List$cons, value, row)),
															rows)));
											} else {
												if (rowEnded) {
													var $temp$row = _List_Nil,
														$temp$rows = A2(
														$elm$core$List$cons,
														$elm$core$List$reverse(
															A2($elm$core$List$cons, value, row)),
														rows),
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseSemicolon;
												} else {
													var $temp$row = A2($elm$core$List$cons, value, row),
														$temp$rows = rows,
														$temp$startOffset = afterQuotedField,
														$temp$endOffset = afterQuotedField;
													row = $temp$row;
													rows = $temp$rows;
													startOffset = $temp$startOffset;
													endOffset = $temp$endOffset;
													continue parseSemicolon;
												}
											}
										} else {
											var problem = _v4.a;
											return $elm$core$Result$Err(
												problem(
													$elm$core$List$length(rows) + 1));
										}
									} else {
										var $temp$row = row,
											$temp$rows = rows,
											$temp$startOffset = startOffset,
											$temp$endOffset = endOffset + 1;
										row = $temp$row;
										rows = $temp$rows;
										startOffset = $temp$startOffset;
										endOffset = $temp$endOffset;
										continue parseSemicolon;
									}
								}
							}
						}
					}
				}
			});
		var fieldSeparator = $elm$core$String$fromChar(config.fieldSeparator);
		return $elm$core$String$isEmpty(source) ? $elm$core$Result$Ok(_List_Nil) : (_Utils_eq(
			config.fieldSeparator,
			_Utils_chr(',')) ? A4(parseComma, _List_Nil, _List_Nil, 0, 0) : (_Utils_eq(
			config.fieldSeparator,
			_Utils_chr(';')) ? A4(parseSemicolon, _List_Nil, _List_Nil, 0, 0) : A5(
			parseHelp,
			function (s) {
				return _Utils_eq(s, fieldSeparator);
			},
			_List_Nil,
			_List_Nil,
			0,
			0)));
	});
var $BrianHicks$elm_csv$Csv$Decode$decodeCustom = F4(
	function (config, fieldNames, decoder, source) {
		return A2(
			$elm$core$Result$andThen,
			A2($BrianHicks$elm_csv$Csv$Decode$applyDecoder, fieldNames, decoder),
			A2(
				$elm$core$Result$mapError,
				$BrianHicks$elm_csv$Csv$Decode$ParsingError,
				A2($BrianHicks$elm_csv$Csv$Parser$parse, config, source)));
	});
var $BrianHicks$elm_csv$Csv$Decode$decodeCsv = $BrianHicks$elm_csv$Csv$Decode$decodeCustom(
	{
		fieldSeparator: _Utils_chr(',')
	});
var $author$project$SmartPhoneType$Smartphone = function (id) {
	return function (brand) {
		return function (model) {
			return function (price) {
				return function (rating) {
					return function (g5) {
						return function (nfc) {
							return function (ir_blaster) {
								return function (processor_name) {
									return function (processor_brand) {
										return function (num_cores) {
											return function (processor_speed) {
												return function (battery) {
													return function (fast_charging) {
														return function (memory) {
															return function (ram) {
																return function (screen_size) {
																	return function (resolution) {
																		return function (refresh_rate) {
																			return function (camera) {
																				return function (card) {
																					return function (os) {
																						return {battery: battery, brand: brand, camera: camera, card: card, fast_charging: fast_charging, g5: g5, id: id, ir_blaster: ir_blaster, memory: memory, model: model, nfc: nfc, num_cores: num_cores, os: os, price: price, processor_brand: processor_brand, processor_name: processor_name, processor_speed: processor_speed, ram: ram, rating: rating, refresh_rate: refresh_rate, resolution: resolution, screen_size: screen_size};
																					};
																				};
																			};
																		};
																	};
																};
															};
														};
													};
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $BrianHicks$elm_csv$Csv$Decode$Decoder = function (a) {
	return {$: 'Decoder', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$andThen = F2(
	function (next, _v0) {
		var first = _v0.a;
		return $BrianHicks$elm_csv$Csv$Decode$Decoder(
			F4(
				function (location, fieldNames, rowNum, row) {
					return A2(
						$elm$core$Result$andThen,
						function (nextValue) {
							var _v1 = next(nextValue);
							var _final = _v1.a;
							return A4(_final, location, fieldNames, rowNum, row);
						},
						A4(first, location, fieldNames, rowNum, row));
				}));
	});
var $BrianHicks$elm_csv$Csv$Decode$map = F2(
	function (transform, _v0) {
		var decoder = _v0.a;
		return $BrianHicks$elm_csv$Csv$Decode$Decoder(
			F4(
				function (location, fieldNames, rowNum, row) {
					return A2(
						$elm$core$Result$map,
						transform,
						A4(decoder, location, fieldNames, rowNum, row));
				}));
	});
var $BrianHicks$elm_csv$Csv$Decode$ColumnNotFound = function (a) {
	return {$: 'ColumnNotFound', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$ExpectedOneColumn = function (a) {
	return {$: 'ExpectedOneColumn', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$FieldDecodingError = function (a) {
	return {$: 'FieldDecodingError', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$FieldNotFound = function (a) {
	return {$: 'FieldNotFound', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$FieldNotProvided = function (a) {
	return {$: 'FieldNotProvided', a: a};
};
var $elm$core$List$drop = F2(
	function (n, list) {
		drop:
		while (true) {
			if (n <= 0) {
				return list;
			} else {
				if (!list.b) {
					return list;
				} else {
					var x = list.a;
					var xs = list.b;
					var $temp$n = n - 1,
						$temp$list = xs;
					n = $temp$n;
					list = $temp$list;
					continue drop;
				}
			}
		}
	});
var $elm$core$List$head = function (list) {
	if (list.b) {
		var x = list.a;
		var xs = list.b;
		return $elm$core$Maybe$Just(x);
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $BrianHicks$elm_csv$Csv$Decode$Column = function (a) {
	return {$: 'Column', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$Field = F2(
	function (a, b) {
		return {$: 'Field', a: a, b: b};
	});
var $BrianHicks$elm_csv$Csv$Decode$OnlyColumn = {$: 'OnlyColumn'};
var $BrianHicks$elm_csv$Csv$Decode$locationToColumn = F2(
	function (fieldNames, location) {
		switch (location.$) {
			case 'Column_':
				var i = location.a;
				return $BrianHicks$elm_csv$Csv$Decode$Column(i);
			case 'Field_':
				var name = location.a;
				return A2(
					$BrianHicks$elm_csv$Csv$Decode$Field,
					name,
					A2($elm$core$Dict$get, name, fieldNames));
			default:
				return $BrianHicks$elm_csv$Csv$Decode$OnlyColumn;
		}
	});
var $BrianHicks$elm_csv$Csv$Decode$fromString = function (convert) {
	return $BrianHicks$elm_csv$Csv$Decode$Decoder(
		F4(
			function (location, _v0, rowNum, row) {
				var names = _v0.names;
				var error = function (problem) {
					return $elm$core$Result$Err(
						_List_fromArray(
							[
								$BrianHicks$elm_csv$Csv$Decode$FieldDecodingError(
								{
									column: A2($BrianHicks$elm_csv$Csv$Decode$locationToColumn, names, location),
									problem: problem,
									row: rowNum
								})
							]));
				};
				switch (location.$) {
					case 'Column_':
						var colNum = location.a;
						var _v2 = $elm$core$List$head(
							A2($elm$core$List$drop, colNum, row));
						if (_v2.$ === 'Just') {
							var value = _v2.a;
							var _v3 = convert(value);
							if (_v3.$ === 'Ok') {
								var converted = _v3.a;
								return $elm$core$Result$Ok(converted);
							} else {
								var problem = _v3.a;
								return error(problem);
							}
						} else {
							return error(
								$BrianHicks$elm_csv$Csv$Decode$ColumnNotFound(colNum));
						}
					case 'Field_':
						var name = location.a;
						var _v4 = A2($elm$core$Dict$get, name, names);
						if (_v4.$ === 'Just') {
							var colNum = _v4.a;
							var _v5 = $elm$core$List$head(
								A2($elm$core$List$drop, colNum, row));
							if (_v5.$ === 'Just') {
								var value = _v5.a;
								var _v6 = convert(value);
								if (_v6.$ === 'Ok') {
									var converted = _v6.a;
									return $elm$core$Result$Ok(converted);
								} else {
									var problem = _v6.a;
									return error(problem);
								}
							} else {
								return error(
									$BrianHicks$elm_csv$Csv$Decode$FieldNotFound(name));
							}
						} else {
							return $elm$core$Result$Err(
								_List_fromArray(
									[
										$BrianHicks$elm_csv$Csv$Decode$FieldNotProvided(name)
									]));
						}
					default:
						if (!row.b) {
							return error(
								$BrianHicks$elm_csv$Csv$Decode$ColumnNotFound(0));
						} else {
							if (!row.b.b) {
								var only = row.a;
								var _v8 = convert(only);
								if (_v8.$ === 'Ok') {
									var converted = _v8.a;
									return $elm$core$Result$Ok(converted);
								} else {
									var problem = _v8.a;
									return error(problem);
								}
							} else {
								return error(
									$BrianHicks$elm_csv$Csv$Decode$ExpectedOneColumn(
										$elm$core$List$length(row)));
							}
						}
				}
			}));
};
var $BrianHicks$elm_csv$Csv$Decode$string = $BrianHicks$elm_csv$Csv$Decode$fromString($elm$core$Result$Ok);
var $BrianHicks$elm_csv$Csv$Decode$succeed = function (value) {
	return $BrianHicks$elm_csv$Csv$Decode$Decoder(
		F4(
			function (_v0, _v1, _v2, _v3) {
				return $elm$core$Result$Ok(value);
			}));
};
var $BrianHicks$elm_csv$Csv$Decode$blank = function (decoder) {
	return A2(
		$BrianHicks$elm_csv$Csv$Decode$andThen,
		function (maybeBlank) {
			return $elm$core$String$isEmpty(
				$elm$core$String$trim(maybeBlank)) ? $BrianHicks$elm_csv$Csv$Decode$succeed($elm$core$Maybe$Nothing) : A2($BrianHicks$elm_csv$Csv$Decode$map, $elm$core$Maybe$Just, decoder);
		},
		$BrianHicks$elm_csv$Csv$Decode$string);
};
var $BrianHicks$elm_csv$Csv$Decode$Field_ = function (a) {
	return {$: 'Field_', a: a};
};
var $BrianHicks$elm_csv$Csv$Decode$field = F2(
	function (name, _v0) {
		var decoder = _v0.a;
		return $BrianHicks$elm_csv$Csv$Decode$Decoder(
			F3(
				function (_v1, fieldNames, row) {
					return A3(
						decoder,
						$BrianHicks$elm_csv$Csv$Decode$Field_(name),
						fieldNames,
						row);
				}));
	});
var $BrianHicks$elm_csv$Csv$Decode$ExpectedFloat = function (a) {
	return {$: 'ExpectedFloat', a: a};
};
var $elm$core$String$toFloat = _String_toFloat;
var $BrianHicks$elm_csv$Csv$Decode$float = $BrianHicks$elm_csv$Csv$Decode$fromString(
	function (value) {
		var _v0 = $elm$core$String$toFloat(
			$elm$core$String$trim(value));
		if (_v0.$ === 'Just') {
			var parsed = _v0.a;
			return $elm$core$Result$Ok(parsed);
		} else {
			return $elm$core$Result$Err(
				$BrianHicks$elm_csv$Csv$Decode$ExpectedFloat(value));
		}
	});
var $BrianHicks$elm_csv$Csv$Decode$into = $BrianHicks$elm_csv$Csv$Decode$succeed;
var $BrianHicks$elm_csv$Csv$Decode$map2 = F3(
	function (transform, _v0, _v1) {
		var decodeA = _v0.a;
		var decodeB = _v1.a;
		return $BrianHicks$elm_csv$Csv$Decode$Decoder(
			F4(
				function (location, fieldNames, rowNum, row) {
					var _v2 = _Utils_Tuple2(
						A4(decodeA, location, fieldNames, rowNum, row),
						A4(decodeB, location, fieldNames, rowNum, row));
					if (_v2.a.$ === 'Ok') {
						if (_v2.b.$ === 'Ok') {
							var a = _v2.a.a;
							var b = _v2.b.a;
							return $elm$core$Result$Ok(
								A2(transform, a, b));
						} else {
							var b = _v2.b.a;
							return $elm$core$Result$Err(b);
						}
					} else {
						if (_v2.b.$ === 'Err') {
							var a = _v2.a.a;
							var b = _v2.b.a;
							return $elm$core$Result$Err(
								_Utils_ap(a, b));
						} else {
							var a = _v2.a.a;
							return $elm$core$Result$Err(a);
						}
					}
				}));
	});
var $BrianHicks$elm_csv$Csv$Decode$pipeline = $BrianHicks$elm_csv$Csv$Decode$map2(
	F2(
		function (value, fn) {
			return fn(value);
		}));
var $author$project$Main$toBool = function (str) {
	_v0$2:
	while (true) {
		if (str.$ === 'Just') {
			switch (str.a) {
				case 'True':
					return $elm$core$Maybe$Just(true);
				case 'False':
					return $elm$core$Maybe$Just(false);
				default:
					break _v0$2;
			}
		} else {
			break _v0$2;
		}
	}
	return $elm$core$Maybe$Nothing;
};
var $author$project$Main$toCores = function (str) {
	_v0$4:
	while (true) {
		if (str.$ === 'Just') {
			switch (str.a) {
				case 'dual core':
					return $elm$core$Maybe$Just(2);
				case 'quad core':
					return $elm$core$Maybe$Just(4);
				case 'hexa core':
					return $elm$core$Maybe$Just(6);
				case 'octa core':
					return $elm$core$Maybe$Just(8);
				default:
					break _v0$4;
			}
		} else {
			break _v0$4;
		}
	}
	return $elm$core$Maybe$Nothing;
};
var $elm$core$Basics$not = _Basics_not;
var $elm$core$Basics$abs = function (n) {
	return (n < 0) ? (-n) : n;
};
var $elm$core$List$any = F2(
	function (isOkay, list) {
		any:
		while (true) {
			if (!list.b) {
				return false;
			} else {
				var x = list.a;
				var xs = list.b;
				if (isOkay(x)) {
					return true;
				} else {
					var $temp$isOkay = isOkay,
						$temp$list = xs;
					isOkay = $temp$isOkay;
					list = $temp$list;
					continue any;
				}
			}
		}
	});
var $elm$core$Basics$neq = _Utils_notEqual;
var $elm$core$String$foldr = _String_foldr;
var $elm$core$String$toList = function (string) {
	return A3($elm$core$String$foldr, $elm$core$List$cons, _List_Nil, string);
};
var $myrho$elm_round$Round$addSign = F2(
	function (signed, str) {
		var isNotZero = A2(
			$elm$core$List$any,
			function (c) {
				return (!_Utils_eq(
					c,
					_Utils_chr('0'))) && (!_Utils_eq(
					c,
					_Utils_chr('.')));
			},
			$elm$core$String$toList(str));
		return _Utils_ap(
			(signed && isNotZero) ? '-' : '',
			str);
	});
var $elm$core$String$fromFloat = _String_fromNumber;
var $elm$core$Char$fromCode = _Char_fromCode;
var $myrho$elm_round$Round$increaseNum = function (_v0) {
	var head = _v0.a;
	var tail = _v0.b;
	if (_Utils_eq(
		head,
		_Utils_chr('9'))) {
		var _v1 = $elm$core$String$uncons(tail);
		if (_v1.$ === 'Nothing') {
			return '01';
		} else {
			var headtail = _v1.a;
			return A2(
				$elm$core$String$cons,
				_Utils_chr('0'),
				$myrho$elm_round$Round$increaseNum(headtail));
		}
	} else {
		var c = $elm$core$Char$toCode(head);
		return ((c >= 48) && (c < 57)) ? A2(
			$elm$core$String$cons,
			$elm$core$Char$fromCode(c + 1),
			tail) : '0';
	}
};
var $elm$core$Basics$isInfinite = _Basics_isInfinite;
var $elm$core$Basics$isNaN = _Basics_isNaN;
var $elm$core$Bitwise$and = _Bitwise_and;
var $elm$core$Bitwise$shiftRightBy = _Bitwise_shiftRightBy;
var $elm$core$String$repeatHelp = F3(
	function (n, chunk, result) {
		return (n <= 0) ? result : A3(
			$elm$core$String$repeatHelp,
			n >> 1,
			_Utils_ap(chunk, chunk),
			(!(n & 1)) ? result : _Utils_ap(result, chunk));
	});
var $elm$core$String$repeat = F2(
	function (n, chunk) {
		return A3($elm$core$String$repeatHelp, n, chunk, '');
	});
var $elm$core$String$padRight = F3(
	function (n, _char, string) {
		return _Utils_ap(
			string,
			A2(
				$elm$core$String$repeat,
				n - $elm$core$String$length(string),
				$elm$core$String$fromChar(_char)));
	});
var $elm$core$String$reverse = _String_reverse;
var $myrho$elm_round$Round$splitComma = function (str) {
	var _v0 = A2($elm$core$String$split, '.', str);
	if (_v0.b) {
		if (_v0.b.b) {
			var before = _v0.a;
			var _v1 = _v0.b;
			var after = _v1.a;
			return _Utils_Tuple2(before, after);
		} else {
			var before = _v0.a;
			return _Utils_Tuple2(before, '0');
		}
	} else {
		return _Utils_Tuple2('0', '0');
	}
};
var $elm$core$Tuple$mapFirst = F2(
	function (func, _v0) {
		var x = _v0.a;
		var y = _v0.b;
		return _Utils_Tuple2(
			func(x),
			y);
	});
var $myrho$elm_round$Round$toDecimal = function (fl) {
	var _v0 = A2(
		$elm$core$String$split,
		'e',
		$elm$core$String$fromFloat(
			$elm$core$Basics$abs(fl)));
	if (_v0.b) {
		if (_v0.b.b) {
			var num = _v0.a;
			var _v1 = _v0.b;
			var exp = _v1.a;
			var e = A2(
				$elm$core$Maybe$withDefault,
				0,
				$elm$core$String$toInt(
					A2($elm$core$String$startsWith, '+', exp) ? A2($elm$core$String$dropLeft, 1, exp) : exp));
			var _v2 = $myrho$elm_round$Round$splitComma(num);
			var before = _v2.a;
			var after = _v2.b;
			var total = _Utils_ap(before, after);
			var zeroed = (e < 0) ? A2(
				$elm$core$Maybe$withDefault,
				'0',
				A2(
					$elm$core$Maybe$map,
					function (_v3) {
						var a = _v3.a;
						var b = _v3.b;
						return a + ('.' + b);
					},
					A2(
						$elm$core$Maybe$map,
						$elm$core$Tuple$mapFirst($elm$core$String$fromChar),
						$elm$core$String$uncons(
							_Utils_ap(
								A2(
									$elm$core$String$repeat,
									$elm$core$Basics$abs(e),
									'0'),
								total))))) : A3(
				$elm$core$String$padRight,
				e + 1,
				_Utils_chr('0'),
				total);
			return _Utils_ap(
				(fl < 0) ? '-' : '',
				zeroed);
		} else {
			var num = _v0.a;
			return _Utils_ap(
				(fl < 0) ? '-' : '',
				num);
		}
	} else {
		return '';
	}
};
var $myrho$elm_round$Round$roundFun = F3(
	function (functor, s, fl) {
		if ($elm$core$Basics$isInfinite(fl) || $elm$core$Basics$isNaN(fl)) {
			return $elm$core$String$fromFloat(fl);
		} else {
			var signed = fl < 0;
			var _v0 = $myrho$elm_round$Round$splitComma(
				$myrho$elm_round$Round$toDecimal(
					$elm$core$Basics$abs(fl)));
			var before = _v0.a;
			var after = _v0.b;
			var r = $elm$core$String$length(before) + s;
			var normalized = _Utils_ap(
				A2($elm$core$String$repeat, (-r) + 1, '0'),
				A3(
					$elm$core$String$padRight,
					r,
					_Utils_chr('0'),
					_Utils_ap(before, after)));
			var totalLen = $elm$core$String$length(normalized);
			var roundDigitIndex = A2($elm$core$Basics$max, 1, r);
			var increase = A2(
				functor,
				signed,
				A3($elm$core$String$slice, roundDigitIndex, totalLen, normalized));
			var remains = A3($elm$core$String$slice, 0, roundDigitIndex, normalized);
			var num = increase ? $elm$core$String$reverse(
				A2(
					$elm$core$Maybe$withDefault,
					'1',
					A2(
						$elm$core$Maybe$map,
						$myrho$elm_round$Round$increaseNum,
						$elm$core$String$uncons(
							$elm$core$String$reverse(remains))))) : remains;
			var numLen = $elm$core$String$length(num);
			var numZeroed = (num === '0') ? num : ((s <= 0) ? _Utils_ap(
				num,
				A2(
					$elm$core$String$repeat,
					$elm$core$Basics$abs(s),
					'0')) : ((_Utils_cmp(
				s,
				$elm$core$String$length(after)) < 0) ? (A3($elm$core$String$slice, 0, numLen - s, num) + ('.' + A3($elm$core$String$slice, numLen - s, numLen, num))) : _Utils_ap(
				before + '.',
				A3(
					$elm$core$String$padRight,
					s,
					_Utils_chr('0'),
					after))));
			return A2($myrho$elm_round$Round$addSign, signed, numZeroed);
		}
	});
var $myrho$elm_round$Round$round = $myrho$elm_round$Round$roundFun(
	F2(
		function (signed, str) {
			var _v0 = $elm$core$String$uncons(str);
			if (_v0.$ === 'Nothing') {
				return false;
			} else {
				if ('5' === _v0.a.a.valueOf()) {
					if (_v0.a.b === '') {
						var _v1 = _v0.a;
						return !signed;
					} else {
						var _v2 = _v0.a;
						return true;
					}
				} else {
					var _v3 = _v0.a;
					var _int = _v3.a;
					return function (i) {
						return ((i > 53) && signed) || ((i >= 53) && (!signed));
					}(
						$elm$core$Char$toCode(_int));
				}
			}
		}));
var $author$project$Main$toEuro = function (str) {
	if (str.$ === 'Just') {
		var price = str.a;
		return $elm$core$String$toFloat(
			A2($myrho$elm_round$Round$round, 2, price * 0.011));
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $elm$core$String$replace = F3(
	function (before, after, string) {
		return A2(
			$elm$core$String$join,
			after,
			A2($elm$core$String$split, before, string));
	});
var $author$project$Main$toGB = function (str) {
	return $elm$core$String$toFloat(
		$elm$core$String$trim(
			A3(
				$elm$core$String$replace,
				'GB inbuilt',
				'',
				A2($elm$core$Maybe$withDefault, '', str))));
};
var $author$project$Main$toGHz = function (str) {
	return $elm$core$String$toFloat(
		$elm$core$String$trim(
			A3(
				$elm$core$String$replace,
				'GHz Processor',
				'',
				A2($elm$core$Maybe$withDefault, '', str))));
};
var $author$project$Main$toInche = function (str) {
	return $elm$core$String$toFloat(
		$elm$core$String$trim(
			A3(
				$elm$core$String$replace,
				'inches',
				'',
				A2($elm$core$Maybe$withDefault, '', str))));
};
var $author$project$Main$decoder = A2(
	$BrianHicks$elm_csv$Csv$Decode$pipeline,
	A2(
		$BrianHicks$elm_csv$Csv$Decode$field,
		'os',
		$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
	A2(
		$BrianHicks$elm_csv$Csv$Decode$pipeline,
		A2(
			$BrianHicks$elm_csv$Csv$Decode$field,
			'card',
			$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
		A2(
			$BrianHicks$elm_csv$Csv$Decode$pipeline,
			A2(
				$BrianHicks$elm_csv$Csv$Decode$field,
				'camera',
				$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
			A2(
				$BrianHicks$elm_csv$Csv$Decode$pipeline,
				A2(
					$BrianHicks$elm_csv$Csv$Decode$field,
					'refresh_rate',
					$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float)),
				A2(
					$BrianHicks$elm_csv$Csv$Decode$pipeline,
					A2(
						$BrianHicks$elm_csv$Csv$Decode$field,
						'resolution',
						$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
					A2(
						$BrianHicks$elm_csv$Csv$Decode$pipeline,
						A2(
							$BrianHicks$elm_csv$Csv$Decode$field,
							'screen_size',
							A2(
								$BrianHicks$elm_csv$Csv$Decode$map,
								$author$project$Main$toInche,
								$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
						A2(
							$BrianHicks$elm_csv$Csv$Decode$pipeline,
							A2(
								$BrianHicks$elm_csv$Csv$Decode$field,
								'RAM',
								$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float)),
							A2(
								$BrianHicks$elm_csv$Csv$Decode$pipeline,
								A2(
									$BrianHicks$elm_csv$Csv$Decode$field,
									'Internal_mem',
									A2(
										$BrianHicks$elm_csv$Csv$Decode$map,
										$author$project$Main$toGB,
										$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
								A2(
									$BrianHicks$elm_csv$Csv$Decode$pipeline,
									A2(
										$BrianHicks$elm_csv$Csv$Decode$field,
										'fast_charging',
										$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float)),
									A2(
										$BrianHicks$elm_csv$Csv$Decode$pipeline,
										A2(
											$BrianHicks$elm_csv$Csv$Decode$field,
											'Battery',
											$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float)),
										A2(
											$BrianHicks$elm_csv$Csv$Decode$pipeline,
											A2(
												$BrianHicks$elm_csv$Csv$Decode$field,
												'processor_speed',
												A2(
													$BrianHicks$elm_csv$Csv$Decode$map,
													$author$project$Main$toGHz,
													$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
											A2(
												$BrianHicks$elm_csv$Csv$Decode$pipeline,
												A2(
													$BrianHicks$elm_csv$Csv$Decode$field,
													'num_cores',
													A2(
														$BrianHicks$elm_csv$Csv$Decode$map,
														$author$project$Main$toCores,
														$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
												A2(
													$BrianHicks$elm_csv$Csv$Decode$pipeline,
													A2(
														$BrianHicks$elm_csv$Csv$Decode$field,
														'processor_brand',
														$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
													A2(
														$BrianHicks$elm_csv$Csv$Decode$pipeline,
														A2(
															$BrianHicks$elm_csv$Csv$Decode$field,
															'processor_name',
															$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
														A2(
															$BrianHicks$elm_csv$Csv$Decode$pipeline,
															A2(
																$BrianHicks$elm_csv$Csv$Decode$field,
																'IR_blaster',
																A2(
																	$BrianHicks$elm_csv$Csv$Decode$map,
																	$author$project$Main$toBool,
																	$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
															A2(
																$BrianHicks$elm_csv$Csv$Decode$pipeline,
																A2(
																	$BrianHicks$elm_csv$Csv$Decode$field,
																	'NFC',
																	A2(
																		$BrianHicks$elm_csv$Csv$Decode$map,
																		$author$project$Main$toBool,
																		$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
																A2(
																	$BrianHicks$elm_csv$Csv$Decode$pipeline,
																	A2(
																		$BrianHicks$elm_csv$Csv$Decode$field,
																		'5G',
																		A2(
																			$BrianHicks$elm_csv$Csv$Decode$map,
																			$author$project$Main$toBool,
																			$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string))),
																	A2(
																		$BrianHicks$elm_csv$Csv$Decode$pipeline,
																		A2(
																			$BrianHicks$elm_csv$Csv$Decode$field,
																			'rating',
																			$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float)),
																		A2(
																			$BrianHicks$elm_csv$Csv$Decode$pipeline,
																			A2(
																				$BrianHicks$elm_csv$Csv$Decode$field,
																				'price',
																				A2(
																					$BrianHicks$elm_csv$Csv$Decode$map,
																					$author$project$Main$toEuro,
																					$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$float))),
																			A2(
																				$BrianHicks$elm_csv$Csv$Decode$pipeline,
																				A2(
																					$BrianHicks$elm_csv$Csv$Decode$field,
																					'model',
																					$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
																				A2(
																					$BrianHicks$elm_csv$Csv$Decode$pipeline,
																					A2(
																						$BrianHicks$elm_csv$Csv$Decode$field,
																						'brand',
																						$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
																					A2(
																						$BrianHicks$elm_csv$Csv$Decode$pipeline,
																						A2(
																							$BrianHicks$elm_csv$Csv$Decode$field,
																							'id',
																							$BrianHicks$elm_csv$Csv$Decode$blank($BrianHicks$elm_csv$Csv$Decode$string)),
																						$BrianHicks$elm_csv$Csv$Decode$into($author$project$SmartPhoneType$Smartphone)))))))))))))))))))))));
var $author$project$Main$parseCSV = function (csv) {
	return A3($BrianHicks$elm_csv$Csv$Decode$decodeCsv, $BrianHicks$elm_csv$Csv$Decode$FieldNamesFromFirstRow, $author$project$Main$decoder, csv);
};
var $gampleman$elm_visualization$Zoom$WithAnimation = function (a) {
	return {$: 'WithAnimation', a: a};
};
var $gampleman$elm_visualization$Zoom$animatedAround = $gampleman$elm_visualization$Zoom$WithAnimation;
var $elm$core$Basics$min = F2(
	function (x, y) {
		return (_Utils_cmp(x, y) < 0) ? x : y;
	});
var $author$project$TreeView$padding = 30;
var $elm$core$Basics$e = _Basics_e;
var $elm$core$Basics$pow = _Basics_pow;
var $gampleman$elm_visualization$Zoom$Interpolation$exp = function (x) {
	return A2($elm$core$Basics$pow, $elm$core$Basics$e, x);
};
var $gampleman$elm_visualization$Zoom$Interpolation$cosh = function (x) {
	var x_ = $gampleman$elm_visualization$Zoom$Interpolation$exp(x);
	return (x_ + (1 / x_)) / 2;
};
var $gampleman$elm_visualization$Zoom$Interpolation$epsilon2 = 1.0e-12;
var $gampleman$elm_visualization$Zoom$Interpolation$log = $elm$core$Basics$logBase($elm$core$Basics$e);
var $elm$core$Basics$sqrt = _Basics_sqrt;
var $gampleman$elm_visualization$Zoom$Interpolation$rho = $elm$core$Basics$sqrt(2);
var $gampleman$elm_visualization$Zoom$Interpolation$sinh = function (x) {
	var x_ = $gampleman$elm_visualization$Zoom$Interpolation$exp(x);
	return (x_ - (1 / x_)) / 2;
};
var $gampleman$elm_visualization$Zoom$Interpolation$tanh = function (x) {
	var x_ = $gampleman$elm_visualization$Zoom$Interpolation$exp(2 * x);
	return (x_ - 1) / (x_ + 1);
};
var $gampleman$elm_visualization$Zoom$Interpolation$interpolate = F2(
	function (a, b) {
		var dy = b.cy - a.cy;
		var dx = b.cx - a.cx;
		var d2 = A2($elm$core$Basics$pow, dx, 2) + A2($elm$core$Basics$pow, dy, 2);
		if (_Utils_cmp(d2, $gampleman$elm_visualization$Zoom$Interpolation$epsilon2) < 0) {
			var s = $gampleman$elm_visualization$Zoom$Interpolation$log(b.size / a.size) / $gampleman$elm_visualization$Zoom$Interpolation$rho;
			return _Utils_Tuple2(
				$elm$core$Basics$abs(s) * 1000,
				function (t) {
					return {
						cx: a.cx + (t * dx),
						cy: a.cy + (t * dy),
						size: a.size * $gampleman$elm_visualization$Zoom$Interpolation$exp(($gampleman$elm_visualization$Zoom$Interpolation$rho * t) * s)
					};
				});
		} else {
			var d1 = $elm$core$Basics$sqrt(d2);
			var b1 = ((A2($elm$core$Basics$pow, b.size, 2) - A2($elm$core$Basics$pow, a.size, 2)) - (A2($elm$core$Basics$pow, $gampleman$elm_visualization$Zoom$Interpolation$rho, 4) * d2)) / (((2 * b.size) * A2($elm$core$Basics$pow, $gampleman$elm_visualization$Zoom$Interpolation$rho, 2)) * d1);
			var r1 = $gampleman$elm_visualization$Zoom$Interpolation$log(
				$elm$core$Basics$sqrt(
					A2($elm$core$Basics$pow, b1, 2) + 1) - b1);
			var b0 = ((A2($elm$core$Basics$pow, b.size, 2) - A2($elm$core$Basics$pow, a.size, 2)) + (A2($elm$core$Basics$pow, $gampleman$elm_visualization$Zoom$Interpolation$rho, 4) * d2)) / (((2 * a.size) * A2($elm$core$Basics$pow, $gampleman$elm_visualization$Zoom$Interpolation$rho, 2)) * d1);
			var r0 = $gampleman$elm_visualization$Zoom$Interpolation$log(
				$elm$core$Basics$sqrt(
					A2($elm$core$Basics$pow, b0, 2) + 1) - b0);
			var s_ = (r1 - r0) / $gampleman$elm_visualization$Zoom$Interpolation$rho;
			return _Utils_Tuple2(
				s_ * 1000,
				function (t) {
					var s = t * s_;
					var coshr0 = $gampleman$elm_visualization$Zoom$Interpolation$cosh(r0);
					var u = (a.size / (A2($elm$core$Basics$pow, $gampleman$elm_visualization$Zoom$Interpolation$rho, 2) * d1)) * ((coshr0 * $gampleman$elm_visualization$Zoom$Interpolation$tanh(($gampleman$elm_visualization$Zoom$Interpolation$rho * s) + r0)) - $gampleman$elm_visualization$Zoom$Interpolation$sinh(r0));
					return {
						cx: a.cx + (u * dx),
						cy: a.cy + (u * dy),
						size: (a.size * coshr0) / $gampleman$elm_visualization$Zoom$Interpolation$cosh(($gampleman$elm_visualization$Zoom$Interpolation$rho * s) + r0)
					};
				});
		}
	});
var $gampleman$elm_visualization$Zoom$Transform$invert = F2(
	function (_v0, _v1) {
		var locX = _v0.a;
		var locY = _v0.b;
		var k = _v1.k;
		var x = _v1.x;
		var y = _v1.y;
		return _Utils_Tuple2((locX - x) / k, (locY - y) / k);
	});
var $elm$core$Tuple$second = function (_v0) {
	var y = _v0.b;
	return y;
};
var $gampleman$elm_visualization$Zoom$schedule = F3(
	function (btransform, center, _v0) {
		var model = _v0.a;
		var atransform = model.transform;
		var _v1 = model.extent;
		var _v2 = _v1.a;
		var top = _v2.a;
		var left = _v2.b;
		var _v3 = _v1.b;
		var bottom = _v3.a;
		var right = _v3.b;
		var w = A2($elm$core$Basics$max, bottom - top, right - left);
		var _v4 = A2($gampleman$elm_visualization$Zoom$Transform$invert, center, btransform);
		var bx = _v4.a;
		var by = _v4.b;
		var _v5 = A2($gampleman$elm_visualization$Zoom$Transform$invert, center, atransform);
		var ax = _v5.a;
		var ay = _v5.b;
		var _v6 = A2(
			$gampleman$elm_visualization$Zoom$Interpolation$interpolate,
			{cx: ax, cy: ay, size: w / atransform.k},
			{cx: bx, cy: by, size: w / btransform.k});
		var dur = _v6.a;
		var interp = _v6.b;
		return $gampleman$elm_visualization$Zoom$Zoom(
			_Utils_update(
				model,
				{
					transition: $elm$core$Maybe$Just(
						{
							duration: dur,
							elapsed: 0,
							interpolation: function (t) {
								if (t === 1) {
									return btransform;
								} else {
									var l = interp(t);
									var k = w / l.size;
									return {k: k, x: center.a - (l.cx * k), y: center.b - (l.cy * k)};
								}
							}
						})
				}));
	});
var $gampleman$elm_visualization$Zoom$setTransform = F3(
	function (transition, trfm, _v0) {
		var model = _v0.a;
		var internalTransform = {k: trfm.scale, x: trfm.translate.x, y: trfm.translate.y};
		if (transition.$ === 'WithAnimation') {
			var point = transition.a;
			return A3(
				$gampleman$elm_visualization$Zoom$schedule,
				internalTransform,
				point,
				$gampleman$elm_visualization$Zoom$Zoom(model));
		} else {
			return $gampleman$elm_visualization$Zoom$Zoom(
				_Utils_update(
					model,
					{transform: internalTransform, transition: $elm$core$Maybe$Nothing}));
		}
	});
var $author$project$TreeView$performZoom = function (t) {
	var yScale = ($author$project$TreeView$h - (2 * $author$project$TreeView$padding)) / t.bbox.height;
	var xScale = ($author$project$TreeView$w - (2 * $author$project$TreeView$padding)) / t.bbox.width;
	var scale = A2($elm$core$Basics$min, xScale, yScale);
	var tx = ($author$project$TreeView$padding + t.bbox.x) * (-scale);
	var ty = ($author$project$TreeView$padding + t.bbox.y) * (-scale);
	var translate = (_Utils_cmp(xScale, yScale) > 0) ? {x: (($author$project$TreeView$w / 2) - ((scale * t.bbox.width) / 2)) + tx, y: $author$project$TreeView$padding + ty} : {x: $author$project$TreeView$padding + tx, y: (($author$project$TreeView$h / 2) - ((scale * t.bbox.height) / 2)) + ty};
	var p = _Utils_Tuple2(t.x + (t.width / 2), t.y + (t.height / 2));
	return A2(
		$gampleman$elm_visualization$Zoom$setTransform,
		$gampleman$elm_visualization$Zoom$animatedAround(p),
		{scale: scale, translate: translate});
};
var $elm$core$List$takeReverse = F3(
	function (n, list, kept) {
		takeReverse:
		while (true) {
			if (n <= 0) {
				return kept;
			} else {
				if (!list.b) {
					return kept;
				} else {
					var x = list.a;
					var xs = list.b;
					var $temp$n = n - 1,
						$temp$list = xs,
						$temp$kept = A2($elm$core$List$cons, x, kept);
					n = $temp$n;
					list = $temp$list;
					kept = $temp$kept;
					continue takeReverse;
				}
			}
		}
	});
var $elm$core$List$takeTailRec = F2(
	function (n, list) {
		return $elm$core$List$reverse(
			A3($elm$core$List$takeReverse, n, list, _List_Nil));
	});
var $elm$core$List$takeFast = F3(
	function (ctr, n, list) {
		if (n <= 0) {
			return _List_Nil;
		} else {
			var _v0 = _Utils_Tuple2(n, list);
			_v0$1:
			while (true) {
				_v0$5:
				while (true) {
					if (!_v0.b.b) {
						return list;
					} else {
						if (_v0.b.b.b) {
							switch (_v0.a) {
								case 1:
									break _v0$1;
								case 2:
									var _v2 = _v0.b;
									var x = _v2.a;
									var _v3 = _v2.b;
									var y = _v3.a;
									return _List_fromArray(
										[x, y]);
								case 3:
									if (_v0.b.b.b.b) {
										var _v4 = _v0.b;
										var x = _v4.a;
										var _v5 = _v4.b;
										var y = _v5.a;
										var _v6 = _v5.b;
										var z = _v6.a;
										return _List_fromArray(
											[x, y, z]);
									} else {
										break _v0$5;
									}
								default:
									if (_v0.b.b.b.b && _v0.b.b.b.b.b) {
										var _v7 = _v0.b;
										var x = _v7.a;
										var _v8 = _v7.b;
										var y = _v8.a;
										var _v9 = _v8.b;
										var z = _v9.a;
										var _v10 = _v9.b;
										var w = _v10.a;
										var tl = _v10.b;
										return (ctr > 1000) ? A2(
											$elm$core$List$cons,
											x,
											A2(
												$elm$core$List$cons,
												y,
												A2(
													$elm$core$List$cons,
													z,
													A2(
														$elm$core$List$cons,
														w,
														A2($elm$core$List$takeTailRec, n - 4, tl))))) : A2(
											$elm$core$List$cons,
											x,
											A2(
												$elm$core$List$cons,
												y,
												A2(
													$elm$core$List$cons,
													z,
													A2(
														$elm$core$List$cons,
														w,
														A3($elm$core$List$takeFast, ctr + 1, n - 4, tl)))));
									} else {
										break _v0$5;
									}
							}
						} else {
							if (_v0.a === 1) {
								break _v0$1;
							} else {
								break _v0$5;
							}
						}
					}
				}
				return list;
			}
			var _v1 = _v0.b;
			var x = _v1.a;
			return _List_fromArray(
				[x]);
		}
	});
var $elm$core$List$take = F2(
	function (n, list) {
		return A3($elm$core$List$takeFast, 0, n, list);
	});
var $elm_community$list_extra$List$Extra$splitAt = F2(
	function (n, xs) {
		return _Utils_Tuple2(
			A2($elm$core$List$take, n, xs),
			A2($elm$core$List$drop, n, xs));
	});
var $elm_community$list_extra$List$Extra$uncons = function (list) {
	if (!list.b) {
		return $elm$core$Maybe$Nothing;
	} else {
		var first = list.a;
		var rest = list.b;
		return $elm$core$Maybe$Just(
			_Utils_Tuple2(first, rest));
	}
};
var $elm_community$list_extra$List$Extra$swapAt = F3(
	function (index1, index2, l) {
		swapAt:
		while (true) {
			if (_Utils_eq(index1, index2) || (index1 < 0)) {
				return l;
			} else {
				if (_Utils_cmp(index1, index2) > 0) {
					var $temp$index1 = index2,
						$temp$index2 = index1,
						$temp$l = l;
					index1 = $temp$index1;
					index2 = $temp$index2;
					l = $temp$l;
					continue swapAt;
				} else {
					var _v0 = A2($elm_community$list_extra$List$Extra$splitAt, index1, l);
					var part1 = _v0.a;
					var tail1 = _v0.b;
					var _v1 = A2($elm_community$list_extra$List$Extra$splitAt, index2 - index1, tail1);
					var head2 = _v1.a;
					var tail2 = _v1.b;
					var _v2 = _Utils_Tuple2(
						$elm_community$list_extra$List$Extra$uncons(head2),
						$elm_community$list_extra$List$Extra$uncons(tail2));
					if ((_v2.a.$ === 'Just') && (_v2.b.$ === 'Just')) {
						var _v3 = _v2.a.a;
						var value1 = _v3.a;
						var part2 = _v3.b;
						var _v4 = _v2.b.a;
						var value2 = _v4.a;
						var part3 = _v4.b;
						return $elm$core$List$concat(
							_List_fromArray(
								[
									part1,
									A2($elm$core$List$cons, value2, part2),
									A2($elm$core$List$cons, value1, part3)
								]));
					} else {
						return l;
					}
				}
			}
		}
	});
var $gampleman$elm_visualization$Zoom$OneFinger = function (a) {
	return {$: 'OneFinger', a: a};
};
var $gampleman$elm_visualization$Zoom$TwoFingers = F2(
	function (a, b) {
		return {$: 'TwoFingers', a: a, b: b};
	});
var $elm$core$Basics$clamp = F3(
	function (low, high, number) {
		return (_Utils_cmp(number, low) < 0) ? low : ((_Utils_cmp(number, high) > 0) ? high : number);
	});
var $gampleman$elm_visualization$Zoom$Transform$translate = F2(
	function (_v0, _v1) {
		var locX = _v0.a;
		var locY = _v0.b;
		var k = _v1.k;
		var x = _v1.x;
		var y = _v1.y;
		return A3($gampleman$elm_visualization$Zoom$Transform$Transform, k, x + (k * locX), y + (k * locY));
	});
var $gampleman$elm_visualization$Zoom$constrain = F3(
	function (_v0, _v1, tsfm) {
		var extentT = _v0.a;
		var extentB = _v0.b;
		var translateExtentT = _v1.a;
		var translateExtentB = _v1.b;
		var minus = F2(
			function (_v5, _v6) {
				var a = _v5.a;
				var b = _v5.b;
				var c = _v6.a;
				var d = _v6.b;
				return _Utils_Tuple2(c - a, d - b);
			});
		var _v2 = A2(
			minus,
			translateExtentB,
			A2($gampleman$elm_visualization$Zoom$Transform$invert, extentB, tsfm));
		var dx1 = _v2.a;
		var dy1 = _v2.b;
		var _v3 = A2(
			minus,
			translateExtentT,
			A2($gampleman$elm_visualization$Zoom$Transform$invert, extentT, tsfm));
		var dx0 = _v3.a;
		var dy0 = _v3.b;
		var _v4 = _Utils_Tuple2(
			A2($elm$core$Basics$min, 0, dx0),
			A2($elm$core$Basics$min, 0, dy0));
		var minDX = _v4.a;
		var minDY = _v4.b;
		return A2(
			$gampleman$elm_visualization$Zoom$Transform$translate,
			_Utils_Tuple2(
				(_Utils_cmp(dx1, dx0) > 0) ? ((dx0 + dx1) / 2) : ((!minDX) ? A2($elm$core$Basics$max, 0, dx1) : minDX),
				(_Utils_cmp(dy1, dy0) > 0) ? ((dy0 + dy1) / 2) : ((!minDY) ? A2($elm$core$Basics$max, 0, dy1) : minDY)),
			tsfm);
	});
var $gampleman$elm_visualization$Zoom$dist2 = F2(
	function (_v0, _v1) {
		var x1 = _v0.a;
		var y1 = _v0.b;
		var x2 = _v1.a;
		var y2 = _v1.b;
		return A2($elm$core$Basics$pow, x2 - x1, 2) + A2($elm$core$Basics$pow, y2 - y1, 2);
	});
var $gampleman$elm_visualization$Zoom$easingInOutCubic = function (t) {
	return (t < 0.5) ? (A2($elm$core$Basics$pow, t * 2, 3) / 2) : (1 - (0.5 * A2($elm$core$Basics$pow, ((-2) * t) + 2, 3)));
};
var $elm$core$List$filter = F2(
	function (isGood, list) {
		return A3(
			$elm$core$List$foldr,
			F2(
				function (x, xs) {
					return isGood(x) ? A2($elm$core$List$cons, x, xs) : xs;
				}),
			_List_Nil,
			list);
	});
var $gampleman$elm_visualization$Zoom$findAssociatedTouch = function (_v0) {
	var identifier = _v0.identifier;
	return A2(
		$elm$core$Basics$composeR,
		$elm$core$List$filter(
			function (t) {
				return _Utils_eq(t.identifier, identifier);
			}),
		$elm$core$List$head);
};
var $gampleman$elm_visualization$Zoom$midpoint = F2(
	function (_v0, _v1) {
		var x1 = _v0.a;
		var y1 = _v0.b;
		var x2 = _v1.a;
		var y2 = _v1.b;
		return _Utils_Tuple2((x1 + x2) / 2, (y1 + y2) / 2);
	});
var $gampleman$elm_visualization$Zoom$Matrix$transform = F2(
	function (_v0, _v1) {
		var x = _v0.a;
		var y = _v0.b;
		var _v2 = _v1.a;
		var a11 = _v2.a;
		var a12 = _v2.b;
		var a13 = _v2.c;
		var _v3 = _v1.b;
		var a21 = _v3.a;
		var a22 = _v3.b;
		var a23 = _v3.c;
		return _Utils_Tuple2(((a11 * x) + (a12 * y)) + a13, ((a21 * x) + (a22 * y)) + a23);
	});
var $gampleman$elm_visualization$Events$normalizePointerPosition = F2(
	function (position, maybeMatrix) {
		if (maybeMatrix.$ === 'Just') {
			var matrix = maybeMatrix.a;
			return A2($gampleman$elm_visualization$Zoom$Matrix$transform, position, matrix);
		} else {
			return position;
		}
	});
var $gampleman$elm_visualization$Zoom$scale = F3(
	function (_v0, k, trfm) {
		var mi = _v0.a;
		var mx = _v0.b;
		return _Utils_update(
			trfm,
			{
				k: A3($elm$core$Basics$clamp, mi, mx, k)
			});
	});
var $gampleman$elm_visualization$Zoom$Transform$scale = F2(
	function (k_, _v0) {
		var k = _v0.k;
		var x = _v0.x;
		var y = _v0.y;
		return A3($gampleman$elm_visualization$Zoom$Transform$Transform, k * k_, x, y);
	});
var $gampleman$elm_visualization$Zoom$translate = F3(
	function (_v0, _v1, trfm) {
		var position0x = _v0.a;
		var position0y = _v0.b;
		var position1x = _v1.a;
		var position1y = _v1.b;
		return _Utils_update(
			trfm,
			{x: position0x - (position1x * trfm.k), y: position0y - (position1y * trfm.k)});
	});
var $gampleman$elm_visualization$Zoom$update = F2(
	function (msg, _v0) {
		var model = _v0.a;
		switch (msg.$) {
			case 'DoubleClicked':
				var shiftKey = msg.a;
				var position0 = msg.b;
				var position1 = A2($gampleman$elm_visualization$Zoom$Transform$invert, position0, model.transform);
				var k = model.transform.k * (shiftKey ? 0.5 : 2);
				var newTransform = A3(
					$gampleman$elm_visualization$Zoom$constrain,
					model.extent,
					model.translateExtent,
					A3(
						$gampleman$elm_visualization$Zoom$translate,
						position0,
						position1,
						A3($gampleman$elm_visualization$Zoom$scale, model.scaleExtent, k, model.transform)));
				return A3(
					$gampleman$elm_visualization$Zoom$schedule,
					newTransform,
					position0,
					$gampleman$elm_visualization$Zoom$Zoom(
						_Utils_update(
							model,
							{touchStarted: false})));
			case 'MouseDown':
				var position = msg.a;
				var matrix = msg.b;
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{
							drag: $elm$core$Maybe$Just(
								{
									current: A2(
										$gampleman$elm_visualization$Zoom$Transform$invert,
										A2($gampleman$elm_visualization$Events$normalizePointerPosition, position, matrix),
										model.transform),
									matrix: matrix
								}),
							transition: $elm$core$Maybe$Nothing
						}));
			case 'MouseMove':
				var position_ = msg.a;
				var _v2 = model.drag;
				if (_v2.$ === 'Just') {
					var drag = _v2.a;
					var position = A2($gampleman$elm_visualization$Events$normalizePointerPosition, position_, drag.matrix);
					var trasform_ = A3($gampleman$elm_visualization$Zoom$translate, position, drag.current, model.transform);
					return $gampleman$elm_visualization$Zoom$Zoom(
						_Utils_update(
							model,
							{
								drag: $elm$core$Maybe$Just(
									_Utils_update(
										drag,
										{
											current: A2($gampleman$elm_visualization$Zoom$Transform$invert, position, trasform_)
										})),
								transform: A3($gampleman$elm_visualization$Zoom$constrain, model.extent, model.translateExtent, trasform_),
								transition: $elm$core$Maybe$Nothing
							}));
				} else {
					return $gampleman$elm_visualization$Zoom$Zoom(model);
				}
			case 'MouseUp':
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{drag: $elm$core$Maybe$Nothing}));
			case 'Wheeled':
				var delta = msg.a;
				var position0 = msg.b;
				var position1 = A2($gampleman$elm_visualization$Zoom$Transform$invert, position0, model.transform);
				var k = model.transform.k * A2($elm$core$Basics$pow, 2, delta);
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{
							transform: A3(
								$gampleman$elm_visualization$Zoom$constrain,
								model.extent,
								model.translateExtent,
								A3(
									$gampleman$elm_visualization$Zoom$translate,
									position0,
									position1,
									A3($gampleman$elm_visualization$Zoom$scale, model.scaleExtent, k, model.transform))),
							transition: $elm$core$Maybe$Nothing
						}));
			case 'GestureStarted':
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{gestureLastScale: 1}));
			case 'Gestured':
				var scl = msg.a;
				var position0 = msg.b;
				var position1 = A2($gampleman$elm_visualization$Zoom$Transform$invert, position0, model.transform);
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{
							gestureLastScale: scl,
							transform: A3(
								$gampleman$elm_visualization$Zoom$constrain,
								model.extent,
								model.translateExtent,
								A3(
									$gampleman$elm_visualization$Zoom$translate,
									position0,
									position1,
									A2($gampleman$elm_visualization$Zoom$Transform$scale, scl / model.gestureLastScale, model.transform))),
							transition: $elm$core$Maybe$Nothing
						}));
			case 'TouchStartedExpired':
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{touchStarted: false}));
			case 'TouchStarted':
				var touches = msg.a;
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{
							touchStarted: true,
							touches: function () {
								var _v3 = _Utils_Tuple2(model.touches, touches);
								_v3$3:
								while (true) {
									if (_v3.b.b) {
										switch (_v3.a.$) {
											case 'NoTouches':
												if (!_v3.b.b.b) {
													var _v4 = _v3.a;
													var _v5 = _v3.b;
													var single = _v5.a;
													return $gampleman$elm_visualization$Zoom$OneFinger(
														{
															identifier: single.identifier,
															position: single.position,
															previous: A2($gampleman$elm_visualization$Zoom$Transform$invert, single.position, model.transform)
														});
												} else {
													var _v6 = _v3.a;
													var _v7 = _v3.b;
													var one = _v7.a;
													var _v8 = _v7.b;
													var two = _v8.a;
													return A2(
														$gampleman$elm_visualization$Zoom$TwoFingers,
														{
															identifier: one.identifier,
															position: one.position,
															previous: A2($gampleman$elm_visualization$Zoom$Transform$invert, one.position, model.transform)
														},
														{
															identifier: two.identifier,
															position: two.position,
															previous: A2($gampleman$elm_visualization$Zoom$Transform$invert, two.position, model.transform)
														});
												}
											case 'OneFinger':
												var id1 = _v3.a.a;
												var _v9 = _v3.b;
												var one = _v9.a;
												return A2(
													$gampleman$elm_visualization$Zoom$TwoFingers,
													id1,
													{
														identifier: one.identifier,
														position: one.position,
														previous: A2($gampleman$elm_visualization$Zoom$Transform$invert, one.position, model.transform)
													});
											default:
												break _v3$3;
										}
									} else {
										break _v3$3;
									}
								}
								return model.touches;
							}(),
							transition: $elm$core$Maybe$Nothing
						}));
			case 'TouchMoved':
				var touches = msg.a;
				return $gampleman$elm_visualization$Zoom$Zoom(
					function () {
						var _v10 = model.touches;
						switch (_v10.$) {
							case 'OneFinger':
								var before = _v10.a;
								var _v11 = A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, before, touches);
								if (_v11.$ === 'Just') {
									var after = _v11.a;
									return _Utils_update(
										model,
										{
											touchStarted: false,
											touches: $gampleman$elm_visualization$Zoom$OneFinger(
												_Utils_update(
													before,
													{position: after.position})),
											transform: A3(
												$gampleman$elm_visualization$Zoom$constrain,
												model.extent,
												model.translateExtent,
												A3($gampleman$elm_visualization$Zoom$translate, after.position, before.previous, model.transform)),
											transition: $elm$core$Maybe$Nothing
										});
								} else {
									return model;
								}
							case 'TwoFingers':
								var beforeTouch1 = _v10.a;
								var beforeTouch2 = _v10.b;
								var t = model.transform;
								var before2 = beforeTouch2.previous;
								var before1 = beforeTouch1.previous;
								var distBefore = A2($gampleman$elm_visualization$Zoom$dist2, before1, before2);
								var after2 = A2(
									$elm$core$Maybe$withDefault,
									beforeTouch2.position,
									A2(
										$elm$core$Maybe$map,
										function ($) {
											return $.position;
										},
										A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, beforeTouch2, touches)));
								var after1 = A2(
									$elm$core$Maybe$withDefault,
									beforeTouch1.position,
									A2(
										$elm$core$Maybe$map,
										function ($) {
											return $.position;
										},
										A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, beforeTouch1, touches)));
								var distAfter = A2($gampleman$elm_visualization$Zoom$dist2, after1, after2);
								return _Utils_update(
									model,
									{
										touchStarted: false,
										touches: A2(
											$gampleman$elm_visualization$Zoom$TwoFingers,
											_Utils_update(
												beforeTouch1,
												{position: after1}),
											_Utils_update(
												beforeTouch2,
												{position: after2})),
										transform: A3(
											$gampleman$elm_visualization$Zoom$constrain,
											model.extent,
											model.translateExtent,
											A3(
												$gampleman$elm_visualization$Zoom$translate,
												A2($gampleman$elm_visualization$Zoom$midpoint, after1, after2),
												A2($gampleman$elm_visualization$Zoom$midpoint, before1, before2),
												A3(
													$gampleman$elm_visualization$Zoom$scale,
													model.scaleExtent,
													$elm$core$Basics$sqrt(distAfter / distBefore),
													t))),
										transition: $elm$core$Maybe$Nothing
									});
							default:
								return model;
						}
					}());
			case 'TouchEnded':
				var touches = msg.a;
				return $gampleman$elm_visualization$Zoom$Zoom(
					_Utils_update(
						model,
						{
							touches: function () {
								var _v12 = model.touches;
								switch (_v12.$) {
									case 'NoTouches':
										return $gampleman$elm_visualization$Zoom$NoTouches;
									case 'OneFinger':
										var touch1 = _v12.a;
										var _v13 = A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, touch1, touches);
										if (_v13.$ === 'Just') {
											return $gampleman$elm_visualization$Zoom$NoTouches;
										} else {
											return model.touches;
										}
									default:
										var before1 = _v12.a;
										var before2 = _v12.b;
										var _v14 = _Utils_Tuple2(
											A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, before1, touches),
											A2($gampleman$elm_visualization$Zoom$findAssociatedTouch, before2, touches));
										if (_v14.a.$ === 'Just') {
											if (_v14.b.$ === 'Just') {
												return $gampleman$elm_visualization$Zoom$NoTouches;
											} else {
												var _v15 = _v14.b;
												return $gampleman$elm_visualization$Zoom$OneFinger(before2);
											}
										} else {
											if (_v14.b.$ === 'Just') {
												var _v16 = _v14.a;
												return $gampleman$elm_visualization$Zoom$OneFinger(before1);
											} else {
												var _v17 = _v14.a;
												var _v18 = _v14.b;
												return model.touches;
											}
										}
								}
							}()
						}));
			default:
				var delta = msg.a;
				var _v19 = model.transition;
				if (_v19.$ === 'Just') {
					var transition = _v19.a;
					var duration = transition.duration;
					var elapsed = transition.elapsed;
					var interpolation = transition.interpolation;
					return $gampleman$elm_visualization$Zoom$Zoom(
						_Utils_update(
							model,
							{
								transform: interpolation(
									$gampleman$elm_visualization$Zoom$easingInOutCubic(
										A3($elm$core$Basics$clamp, 0, 1, (elapsed + delta) / duration))),
								transition: (_Utils_cmp(elapsed + delta, duration) > -1) ? $elm$core$Maybe$Nothing : $elm$core$Maybe$Just(
									_Utils_update(
										transition,
										{elapsed: elapsed + delta}))
							}));
				} else {
					return $gampleman$elm_visualization$Zoom$Zoom(model);
				}
		}
	});
var $author$project$Main$update = F2(
	function (msg, model) {
		switch (msg.$) {
			case 'FetchData':
				return _Utils_Tuple2(model, $author$project$Main$fetchData);
			case 'DataReceived':
				if (msg.a.$ === 'Ok') {
					var csvData = msg.a.a;
					var parsedData = $author$project$Main$parseCSV(csvData);
					if (parsedData.$ === 'Ok') {
						var data = parsedData.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{csvdata: csvData, data: data, error: $elm$core$Maybe$Nothing}),
							$elm$core$Platform$Cmd$none);
					} else {
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									error: $elm$core$Maybe$Just('Failed to parse CSV data')
								}),
							$elm$core$Platform$Cmd$none);
					}
				} else {
					return _Utils_Tuple2(
						_Utils_update(
							model,
							{
								error: $elm$core$Maybe$Just('Failed to load data')
							}),
						$elm$core$Platform$Cmd$none);
				}
			case 'ScatterplotMsg':
				switch (msg.a.$) {
					case 'ChangeAttribute1':
						var value = msg.a.a;
						var attList = A2($author$project$Main$createAttList, model, value);
						var unit = attList.b;
						var values = attList.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									scatterplotOptions: {att1List: values, att2List: model.scatterplotOptions.att2List, attribute1: value, attribute2: model.scatterplotOptions.attribute2, unit1: unit, unit2: model.scatterplotOptions.unit2}
								}),
							$elm$core$Platform$Cmd$none);
					case 'ChangeAttribute2':
						var value = msg.a.a;
						var attList = A2($author$project$Main$createAttList, model, value);
						var unit = attList.b;
						var values = attList.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									scatterplotOptions: {att1List: model.scatterplotOptions.att1List, att2List: values, attribute1: model.scatterplotOptions.attribute1, attribute2: value, unit1: model.scatterplotOptions.unit1, unit2: unit}
								}),
							$elm$core$Platform$Cmd$none);
					default:
						var id = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									plotVisible: {parallelCoordinatesPlot: false, scatterPlot: false, starPlot: true, treeView: false},
									starplotOption: {
										input1: model.starplotOption.input1,
										input2: model.starplotOption.input2,
										modelID1: (model.starplotOption.nextChange === 1) ? id : model.starplotOption.modelID1,
										modelID2: (model.starplotOption.nextChange === 2) ? id : model.starplotOption.modelID2,
										nextChange: (model.starplotOption.nextChange === 1) ? 2 : 1
									}
								}),
							$elm$core$Platform$Cmd$none);
				}
			case 'ParallelCoordinatesMsg':
				switch (msg.a.$) {
					case 'ChangeOrder':
						var _v2 = msg.a;
						var pos1 = _v2.a;
						var pos2 = _v2.b;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									parallelPlotOption: {
										orderedLabels: A3($elm_community$list_extra$List$Extra$swapAt, pos1, pos2, model.parallelPlotOption.orderedLabels),
										orderedList: A3($elm_community$list_extra$List$Extra$swapAt, pos1, pos2, model.parallelPlotOption.orderedList),
										orderedUnitLabels: A3($elm_community$list_extra$List$Extra$swapAt, pos1, pos2, model.parallelPlotOption.orderedUnitLabels),
										selectedFilter: model.parallelPlotOption.selectedFilter
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetScatterPlotFromParallelPlot':
						var _v3 = msg.a;
						var att1 = _v3.a;
						var att2 = _v3.b;
						var attList2 = A2($author$project$Main$createAttList, model, att2);
						var unit2 = attList2.b;
						var values2 = attList2.a;
						var attList1 = A2($author$project$Main$createAttList, model, att1);
						var unit1 = attList1.b;
						var values1 = attList1.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									plotVisible: {parallelCoordinatesPlot: false, scatterPlot: true, starPlot: false, treeView: false},
									scatterplotOptions: {att1List: values1, att2List: values2, attribute1: att1, attribute2: att2, unit1: unit1, unit2: unit2}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetBrandParallel':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									parallelPlotOption: {
										orderedLabels: model.parallelPlotOption.orderedLabels,
										orderedList: model.parallelPlotOption.orderedList,
										orderedUnitLabels: model.parallelPlotOption.orderedUnitLabels,
										selectedFilter: {brand: value, g5: model.parallelPlotOption.selectedFilter.g5, ir_blaster: model.parallelPlotOption.selectedFilter.ir_blaster, nfc: model.parallelPlotOption.selectedFilter.nfc}
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'Set5GParallel':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									parallelPlotOption: {
										orderedLabels: model.parallelPlotOption.orderedLabels,
										orderedList: model.parallelPlotOption.orderedList,
										orderedUnitLabels: model.parallelPlotOption.orderedUnitLabels,
										selectedFilter: {brand: model.parallelPlotOption.selectedFilter.brand, g5: value, ir_blaster: model.parallelPlotOption.selectedFilter.ir_blaster, nfc: model.parallelPlotOption.selectedFilter.nfc}
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetNFCParallel':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									parallelPlotOption: {
										orderedLabels: model.parallelPlotOption.orderedLabels,
										orderedList: model.parallelPlotOption.orderedList,
										orderedUnitLabels: model.parallelPlotOption.orderedUnitLabels,
										selectedFilter: {brand: model.parallelPlotOption.selectedFilter.brand, g5: model.parallelPlotOption.selectedFilter.g5, ir_blaster: model.parallelPlotOption.selectedFilter.ir_blaster, nfc: value}
									}
								}),
							$elm$core$Platform$Cmd$none);
					default:
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									parallelPlotOption: {
										orderedLabels: model.parallelPlotOption.orderedLabels,
										orderedList: model.parallelPlotOption.orderedList,
										orderedUnitLabels: model.parallelPlotOption.orderedUnitLabels,
										selectedFilter: {brand: model.parallelPlotOption.selectedFilter.brand, g5: model.parallelPlotOption.selectedFilter.g5, ir_blaster: value, nfc: model.parallelPlotOption.selectedFilter.nfc}
									}
								}),
							$elm$core$Platform$Cmd$none);
				}
			case 'TreeViewMsg':
				switch (msg.a.$) {
					case 'ZoomMsg':
						var m = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: model.treeOption.selectedFilter,
										zoomOption: A2($gampleman$elm_visualization$Zoom$update, m, model.treeOption.zoomOption)
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'Click':
						var t = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: model.treeOption.selectedFilter,
										zoomOption: A2($author$project$TreeView$performZoom, t, model.treeOption.zoomOption)
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetStarPlotFromTree':
						var id = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									plotVisible: {parallelCoordinatesPlot: false, scatterPlot: false, starPlot: true, treeView: false},
									starplotOption: {
										input1: model.starplotOption.input1,
										input2: model.starplotOption.input2,
										modelID1: (model.starplotOption.nextChange === 1) ? id : model.starplotOption.modelID1,
										modelID2: (model.starplotOption.nextChange === 2) ? id : model.starplotOption.modelID2,
										nextChange: (model.starplotOption.nextChange === 1) ? 2 : 1
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetDropCountInput':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {dropCount: model.treeOption.dropCount, inputDropCount: value, selectedFilter: model.treeOption.selectedFilter, zoomOption: model.treeOption.zoomOption}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetDropCount':
						var _v4 = msg.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: A2(
											$elm$core$Maybe$withDefault,
											0,
											$elm$core$String$toInt(model.treeOption.inputDropCount)),
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: model.treeOption.selectedFilter,
										zoomOption: model.treeOption.zoomOption
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetBrandTree':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: {brand: value, g5: model.treeOption.selectedFilter.g5, ir_blaster: model.treeOption.selectedFilter.ir_blaster, nfc: model.treeOption.selectedFilter.nfc},
										zoomOption: model.treeOption.zoomOption
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'Set5GTree':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: {brand: model.treeOption.selectedFilter.brand, g5: value, ir_blaster: model.treeOption.selectedFilter.ir_blaster, nfc: model.treeOption.selectedFilter.nfc},
										zoomOption: model.treeOption.zoomOption
									}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SetNFCTree':
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: {brand: model.treeOption.selectedFilter.brand, g5: model.treeOption.selectedFilter.g5, ir_blaster: model.treeOption.selectedFilter.ir_blaster, nfc: value},
										zoomOption: model.treeOption.zoomOption
									}
								}),
							$elm$core$Platform$Cmd$none);
					default:
						var value = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									treeOption: {
										dropCount: model.treeOption.dropCount,
										inputDropCount: model.treeOption.inputDropCount,
										selectedFilter: {brand: model.treeOption.selectedFilter.brand, g5: model.treeOption.selectedFilter.g5, ir_blaster: value, nfc: model.treeOption.selectedFilter.nfc},
										zoomOption: model.treeOption.zoomOption
									}
								}),
							$elm$core$Platform$Cmd$none);
				}
			case 'ZooomMsg':
				var m = msg.a;
				return _Utils_Tuple2(
					_Utils_update(
						model,
						{
							treeOption: {
								dropCount: model.treeOption.dropCount,
								inputDropCount: model.treeOption.inputDropCount,
								selectedFilter: model.treeOption.selectedFilter,
								zoomOption: A2($gampleman$elm_visualization$Zoom$update, m, model.treeOption.zoomOption)
							}
						}),
					$elm$core$Platform$Cmd$none);
			case 'StarplotMsg':
				switch (msg.a.$) {
					case 'InputChange1':
						var id = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									starplotOption: {input1: id, input2: model.starplotOption.input2, modelID1: model.starplotOption.modelID1, modelID2: model.starplotOption.modelID2, nextChange: model.starplotOption.nextChange}
								}),
							$elm$core$Platform$Cmd$none);
					case 'InputChange2':
						var id = msg.a.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									starplotOption: {input1: model.starplotOption.input1, input2: id, modelID1: model.starplotOption.modelID1, modelID2: model.starplotOption.modelID2, nextChange: model.starplotOption.nextChange}
								}),
							$elm$core$Platform$Cmd$none);
					case 'SubmitNumber1':
						var _v5 = msg.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									starplotOption: {
										input1: model.starplotOption.input1,
										input2: model.starplotOption.input2,
										modelID1: function () {
											var _v6 = $elm$core$String$toInt(model.starplotOption.input1);
											if (_v6.$ === 'Just') {
												return model.starplotOption.input1;
											} else {
												return model.starplotOption.modelID1;
											}
										}(),
										modelID2: model.starplotOption.modelID2,
										nextChange: (model.starplotOption.nextChange === 1) ? 2 : 1
									}
								}),
							$elm$core$Platform$Cmd$none);
					default:
						var _v7 = msg.a;
						return _Utils_Tuple2(
							_Utils_update(
								model,
								{
									starplotOption: {
										input1: model.starplotOption.input1,
										input2: model.starplotOption.input2,
										modelID1: model.starplotOption.modelID1,
										modelID2: function () {
											var _v8 = $elm$core$String$toInt(model.starplotOption.input2);
											if (_v8.$ === 'Just') {
												return model.starplotOption.input2;
											} else {
												return model.starplotOption.modelID2;
											}
										}(),
										nextChange: (model.starplotOption.nextChange === 1) ? 2 : 1
									}
								}),
							$elm$core$Platform$Cmd$none);
				}
			case 'SetViewScatterplot':
				return _Utils_Tuple2(
					_Utils_update(
						model,
						{
							plotVisible: {parallelCoordinatesPlot: false, scatterPlot: true, starPlot: false, treeView: false}
						}),
					$elm$core$Platform$Cmd$none);
			case 'SetViewParallelCoordesPlot':
				return _Utils_Tuple2(
					_Utils_update(
						model,
						{
							plotVisible: {parallelCoordinatesPlot: true, scatterPlot: false, starPlot: false, treeView: false}
						}),
					$elm$core$Platform$Cmd$none);
			case 'SetViewTree':
				return _Utils_Tuple2(
					_Utils_update(
						model,
						{
							plotVisible: {parallelCoordinatesPlot: false, scatterPlot: false, starPlot: false, treeView: true}
						}),
					$elm$core$Platform$Cmd$none);
			default:
				return _Utils_Tuple2(
					_Utils_update(
						model,
						{
							plotVisible: {parallelCoordinatesPlot: false, scatterPlot: false, starPlot: true, treeView: false}
						}),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Main$ParallelCoordinatesMsg = function (a) {
	return {$: 'ParallelCoordinatesMsg', a: a};
};
var $author$project$Main$ScatterplotMsg = function (a) {
	return {$: 'ScatterplotMsg', a: a};
};
var $author$project$Main$SetViewParallelCoordesPlot = {$: 'SetViewParallelCoordesPlot'};
var $author$project$Main$SetViewScatterplot = {$: 'SetViewScatterplot'};
var $author$project$Main$SetViewStarPlot = {$: 'SetViewStarPlot'};
var $author$project$Main$SetViewTree = {$: 'SetViewTree'};
var $author$project$Main$StarplotMsg = function (a) {
	return {$: 'StarplotMsg', a: a};
};
var $author$project$Main$TreeViewMsg = function (a) {
	return {$: 'TreeViewMsg', a: a};
};
var $elm$json$Json$Encode$string = _Json_wrap;
var $elm$html$Html$Attributes$stringProperty = F2(
	function (key, string) {
		return A2(
			_VirtualDom_property,
			key,
			$elm$json$Json$Encode$string(string));
	});
var $elm$html$Html$Attributes$align = $elm$html$Html$Attributes$stringProperty('align');
var $elm$html$Html$b = _VirtualDom_node('b');
var $elm$html$Html$button = _VirtualDom_node('button');
var $elm$virtual_dom$VirtualDom$attribute = F2(
	function (key, value) {
		return A2(
			_VirtualDom_attribute,
			_VirtualDom_noOnOrFormAction(key),
			_VirtualDom_noJavaScriptOrHtmlUri(value));
	});
var $elm_community$typed_svg$TypedSvg$Core$attribute = $elm$virtual_dom$VirtualDom$attribute;
var $elm_community$typed_svg$TypedSvg$Attributes$class = function (names) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'class',
		A2($elm$core$String$join, ' ', names));
};
var $elm$html$Html$div = _VirtualDom_node('div');
var $elm$virtual_dom$VirtualDom$map = _VirtualDom_map;
var $elm$html$Html$map = $elm$virtual_dom$VirtualDom$map;
var $elm$virtual_dom$VirtualDom$Normal = function (a) {
	return {$: 'Normal', a: a};
};
var $elm$virtual_dom$VirtualDom$on = _VirtualDom_on;
var $elm$html$Html$Events$on = F2(
	function (event, decoder) {
		return A2(
			$elm$virtual_dom$VirtualDom$on,
			event,
			$elm$virtual_dom$VirtualDom$Normal(decoder));
	});
var $elm$html$Html$Events$onClick = function (msg) {
	return A2(
		$elm$html$Html$Events$on,
		'click',
		$elm$json$Json$Decode$succeed(msg));
};
var $elm$virtual_dom$VirtualDom$text = _VirtualDom_text;
var $elm$html$Html$text = $elm$virtual_dom$VirtualDom$text;
var $author$project$ParallelCoordinates$Set5GParallel = function (a) {
	return {$: 'Set5GParallel', a: a};
};
var $author$project$ParallelCoordinates$SetBrandParallel = function (a) {
	return {$: 'SetBrandParallel', a: a};
};
var $author$project$ParallelCoordinates$SetIRBlasterParallel = function (a) {
	return {$: 'SetIRBlasterParallel', a: a};
};
var $author$project$ParallelCoordinates$SetNFCParallel = function (a) {
	return {$: 'SetNFCParallel', a: a};
};
var $elm$html$Html$br = _VirtualDom_node('br');
var $elm$html$Html$option = _VirtualDom_node('option');
var $elm$json$Json$Encode$bool = _Json_wrap;
var $elm$html$Html$Attributes$boolProperty = F2(
	function (key, bool) {
		return A2(
			_VirtualDom_property,
			key,
			$elm$json$Json$Encode$bool(bool));
	});
var $elm$html$Html$Attributes$selected = $elm$html$Html$Attributes$boolProperty('selected');
var $elm$html$Html$Attributes$value = $elm$html$Html$Attributes$stringProperty('value');
var $author$project$ParallelCoordinates$createSelectorOptions = F2(
	function (select, valueOption) {
		return _Utils_eq(select, valueOption) ? A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(valueOption),
					$elm$html$Html$Attributes$selected(true)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(valueOption)
				])) : A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(valueOption)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(valueOption)
				]));
	});
var $author$project$ParallelCoordinates$fromBrand = F2(
	function (model, smartphone) {
		return (_Utils_eq(
			model.parallelPlotOption.selectedFilter.brand,
			A2($elm$core$Maybe$withDefault, '', smartphone.brand)) || (model.parallelPlotOption.selectedFilter.brand === 'all')) ? true : false;
	});
var $author$project$ParallelCoordinates$has5G = F2(
	function (model, smartphone) {
		return (((model.parallelPlotOption.selectedFilter.g5 === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.g5)) || (model.parallelPlotOption.selectedFilter.g5 === 'all')) ? true : (((model.parallelPlotOption.selectedFilter.g5 === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.g5))) ? true : false);
	});
var $author$project$ParallelCoordinates$hasIRBlaster = F2(
	function (model, smartphone) {
		return (((model.parallelPlotOption.selectedFilter.ir_blaster === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.ir_blaster)) || (model.parallelPlotOption.selectedFilter.ir_blaster === 'all')) ? true : (((model.parallelPlotOption.selectedFilter.ir_blaster === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.ir_blaster))) ? true : false);
	});
var $author$project$ParallelCoordinates$hasNFC = F2(
	function (model, smartphone) {
		return (((model.parallelPlotOption.selectedFilter.nfc === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.nfc)) || (model.parallelPlotOption.selectedFilter.nfc === 'all')) ? true : (((model.parallelPlotOption.selectedFilter.nfc === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.nfc))) ? true : false);
	});
var $elm$core$Maybe$andThen = F2(
	function (callback, maybeValue) {
		if (maybeValue.$ === 'Just') {
			var value = maybeValue.a;
			return callback(value);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$ExtendedFunctions$map10 = function (func) {
	return function (maybe1) {
		return function (maybe2) {
			return function (maybe3) {
				return function (maybe4) {
					return function (maybe5) {
						return function (maybe6) {
							return function (maybe7) {
								return function (maybe8) {
									return function (maybe9) {
										return function (maybe10) {
											return A2(
												$elm$core$Maybe$andThen,
												function (value1) {
													return A2(
														$elm$core$Maybe$andThen,
														function (value2) {
															return A2(
																$elm$core$Maybe$andThen,
																function (value3) {
																	return A2(
																		$elm$core$Maybe$andThen,
																		function (value4) {
																			return A2(
																				$elm$core$Maybe$andThen,
																				function (value5) {
																					return A2(
																						$elm$core$Maybe$andThen,
																						function (value6) {
																							return A2(
																								$elm$core$Maybe$andThen,
																								function (value7) {
																									return A2(
																										$elm$core$Maybe$andThen,
																										function (value8) {
																											return A2(
																												$elm$core$Maybe$andThen,
																												function (value9) {
																													return A2(
																														$elm$core$Maybe$map,
																														function (value10) {
																															return func(value1)(value2)(value3)(value4)(value5)(value6)(value7)(value8)(value9)(value10);
																														},
																														maybe10);
																												},
																												maybe9);
																										},
																										maybe8);
																								},
																								maybe7);
																						},
																						maybe6);
																				},
																				maybe5);
																		},
																		maybe4);
																},
																maybe3);
														},
														maybe2);
												},
												maybe1);
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$ParallelCoordinates$mapToSPData = function (smartphone) {
	return $author$project$ExtendedFunctions$map10(
		function (price) {
			return function (rating) {
				return function (num_cores) {
					return function (processor_speed) {
						return function (battery) {
							return function (fast_charging) {
								return function (memory) {
									return function (ram) {
										return function (screen_size) {
											return function (refresh_rate) {
												return {
													battery: $elm$core$Maybe$Just(battery),
													brand: smartphone.brand,
													camera: smartphone.camera,
													card: smartphone.card,
													fast_charging: $elm$core$Maybe$Just(fast_charging),
													g5: smartphone.g5,
													id: smartphone.id,
													ir_blaster: smartphone.ir_blaster,
													memory: $elm$core$Maybe$Just(memory),
													model: smartphone.model,
													nfc: smartphone.nfc,
													num_cores: $elm$core$Maybe$Just(num_cores),
													os: smartphone.os,
													price: $elm$core$Maybe$Just(price),
													processor_brand: smartphone.processor_brand,
													processor_name: smartphone.processor_name,
													processor_speed: $elm$core$Maybe$Just(processor_speed),
													ram: $elm$core$Maybe$Just(ram),
													rating: $elm$core$Maybe$Just(rating),
													refresh_rate: $elm$core$Maybe$Just(refresh_rate),
													resolution: smartphone.resolution,
													screen_size: $elm$core$Maybe$Just(screen_size)
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		})(smartphone.price)(smartphone.rating)(smartphone.num_cores)(smartphone.processor_speed)(smartphone.battery)(smartphone.fast_charging)(smartphone.memory)(smartphone.ram)(smartphone.screen_size)(smartphone.refresh_rate);
};
var $author$project$ParallelCoordinates$filterSPData = F2(
	function (smartphone, model) {
		var smartphoneList = A2(
			$elm$core$List$filter,
			$author$project$ParallelCoordinates$hasIRBlaster(model),
			A2(
				$elm$core$List$filter,
				$author$project$ParallelCoordinates$hasNFC(model),
				A2(
					$elm$core$List$filter,
					$author$project$ParallelCoordinates$has5G(model),
					A2(
						$elm$core$List$filter,
						$author$project$ParallelCoordinates$fromBrand(model),
						A2($elm$core$List$filterMap, $author$project$ParallelCoordinates$mapToSPData, smartphone)))));
		return smartphoneList;
	});
var $elm$core$Set$Set_elm_builtin = function (a) {
	return {$: 'Set_elm_builtin', a: a};
};
var $elm$core$Set$empty = $elm$core$Set$Set_elm_builtin($elm$core$Dict$empty);
var $elm$core$Set$insert = F2(
	function (key, _v0) {
		var dict = _v0.a;
		return $elm$core$Set$Set_elm_builtin(
			A3($elm$core$Dict$insert, key, _Utils_Tuple0, dict));
	});
var $elm$core$Set$fromList = function (list) {
	return A3($elm$core$List$foldl, $elm$core$Set$insert, $elm$core$Set$empty, list);
};
var $elm$html$Html$Events$alwaysStop = function (x) {
	return _Utils_Tuple2(x, true);
};
var $elm$virtual_dom$VirtualDom$MayStopPropagation = function (a) {
	return {$: 'MayStopPropagation', a: a};
};
var $elm$html$Html$Events$stopPropagationOn = F2(
	function (event, decoder) {
		return A2(
			$elm$virtual_dom$VirtualDom$on,
			event,
			$elm$virtual_dom$VirtualDom$MayStopPropagation(decoder));
	});
var $elm$json$Json$Decode$at = F2(
	function (fields, decoder) {
		return A3($elm$core$List$foldr, $elm$json$Json$Decode$field, decoder, fields);
	});
var $elm$json$Json$Decode$string = _Json_decodeString;
var $elm$html$Html$Events$targetValue = A2(
	$elm$json$Json$Decode$at,
	_List_fromArray(
		['target', 'value']),
	$elm$json$Json$Decode$string);
var $elm$html$Html$Events$onInput = function (tagger) {
	return A2(
		$elm$html$Html$Events$stopPropagationOn,
		'input',
		A2(
			$elm$json$Json$Decode$map,
			$elm$html$Html$Events$alwaysStop,
			A2($elm$json$Json$Decode$map, tagger, $elm$html$Html$Events$targetValue)));
};
var $elm_community$typed_svg$TypedSvg$Types$Percent = function (a) {
	return {$: 'Percent', a: a};
};
var $author$project$ParallelCoordinates$axisPaddig = 40;
var $gampleman$elm_visualization$Scale$convert = F2(
	function (_v0, value) {
		var scale = _v0.a;
		return A3(scale.convert, scale.domain, scale.range, value);
	});
var $elm_community$typed_svg$TypedSvg$Types$Paint = function (a) {
	return {$: 'Paint', a: a};
};
var $elm_community$typed_svg$TypedSvg$Types$PaintNone = {$: 'PaintNone'};
var $elm_community$typed_svg$TypedSvg$Types$Px = function (a) {
	return {$: 'Px', a: a};
};
var $avh4$elm_color$Color$RgbaSpace = F4(
	function (a, b, c, d) {
		return {$: 'RgbaSpace', a: a, b: b, c: c, d: d};
	});
var $avh4$elm_color$Color$darkBlue = A4($avh4$elm_color$Color$RgbaSpace, 32 / 255, 74 / 255, 135 / 255, 1.0);
var $elm$svg$Svg$Attributes$d = _VirtualDom_attribute('d');
var $elm$svg$Svg$trustedNode = _VirtualDom_nodeNS('http://www.w3.org/2000/svg');
var $elm$svg$Svg$path = $elm$svg$Svg$trustedNode('path');
var $folkertdev$one_true_path_experiment$SubPath$Empty = {$: 'Empty'};
var $folkertdev$one_true_path_experiment$SubPath$SubPath = function (a) {
	return {$: 'SubPath', a: a};
};
var $folkertdev$elm_deque$Deque$Deque = function (a) {
	return {$: 'Deque', a: a};
};
var $folkertdev$elm_deque$Internal$empty = {front: _List_Nil, rear: _List_Nil, sizeF: 0, sizeR: 0};
var $folkertdev$elm_deque$Deque$empty = $folkertdev$elm_deque$Deque$Deque($folkertdev$elm_deque$Internal$empty);
var $folkertdev$elm_deque$Internal$rebalance = function (deque) {
	var sizeF = deque.sizeF;
	var sizeR = deque.sizeR;
	var front = deque.front;
	var rear = deque.rear;
	var size1 = ((sizeF + sizeR) / 2) | 0;
	var size2 = (sizeF + sizeR) - size1;
	var balanceConstant = 4;
	if ((sizeF + sizeR) < 2) {
		return deque;
	} else {
		if (_Utils_cmp(sizeF, (balanceConstant * sizeR) + 1) > 0) {
			var newRear = _Utils_ap(
				rear,
				$elm$core$List$reverse(
					A2($elm$core$List$drop, size1, front)));
			var newFront = A2($elm$core$List$take, size1, front);
			return {front: newFront, rear: newRear, sizeF: size1, sizeR: size2};
		} else {
			if (_Utils_cmp(sizeR, (balanceConstant * sizeF) + 1) > 0) {
				var newRear = A2($elm$core$List$take, size1, rear);
				var newFront = _Utils_ap(
					front,
					$elm$core$List$reverse(
						A2($elm$core$List$drop, size1, rear)));
				return {front: newFront, rear: newRear, sizeF: size1, sizeR: size2};
			} else {
				return deque;
			}
		}
	}
};
var $folkertdev$elm_deque$Internal$fromList = function (list) {
	return $folkertdev$elm_deque$Internal$rebalance(
		{
			front: list,
			rear: _List_Nil,
			sizeF: $elm$core$List$length(list),
			sizeR: 0
		});
};
var $folkertdev$elm_deque$Deque$fromList = A2($elm$core$Basics$composeL, $folkertdev$elm_deque$Deque$Deque, $folkertdev$elm_deque$Internal$fromList);
var $folkertdev$one_true_path_experiment$LowLevel$Command$ClosePath = {$: 'ClosePath'};
var $folkertdev$one_true_path_experiment$LowLevel$Command$CurveTo = function (a) {
	return {$: 'CurveTo', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$EllipticalArc = function (a) {
	return {$: 'EllipticalArc', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$LineTo = function (a) {
	return {$: 'LineTo', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$QuadraticBezierCurveTo = function (a) {
	return {$: 'QuadraticBezierCurveTo', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$merge = F2(
	function (instruction1, instruction2) {
		var _v0 = _Utils_Tuple2(instruction1, instruction2);
		_v0$5:
		while (true) {
			switch (_v0.a.$) {
				case 'LineTo':
					if (_v0.b.$ === 'LineTo') {
						var p1 = _v0.a.a;
						var p2 = _v0.b.a;
						return $elm$core$Result$Ok(
							$folkertdev$one_true_path_experiment$LowLevel$Command$LineTo(
								_Utils_ap(p1, p2)));
					} else {
						break _v0$5;
					}
				case 'CurveTo':
					if (_v0.b.$ === 'CurveTo') {
						var p1 = _v0.a.a;
						var p2 = _v0.b.a;
						return $elm$core$Result$Ok(
							$folkertdev$one_true_path_experiment$LowLevel$Command$CurveTo(
								_Utils_ap(p1, p2)));
					} else {
						break _v0$5;
					}
				case 'QuadraticBezierCurveTo':
					if (_v0.b.$ === 'QuadraticBezierCurveTo') {
						var p1 = _v0.a.a;
						var p2 = _v0.b.a;
						return $elm$core$Result$Ok(
							$folkertdev$one_true_path_experiment$LowLevel$Command$QuadraticBezierCurveTo(
								_Utils_ap(p1, p2)));
					} else {
						break _v0$5;
					}
				case 'EllipticalArc':
					if (_v0.b.$ === 'EllipticalArc') {
						var p1 = _v0.a.a;
						var p2 = _v0.b.a;
						return $elm$core$Result$Ok(
							$folkertdev$one_true_path_experiment$LowLevel$Command$EllipticalArc(
								_Utils_ap(p1, p2)));
					} else {
						break _v0$5;
					}
				default:
					if (_v0.b.$ === 'ClosePath') {
						var _v1 = _v0.a;
						var _v2 = _v0.b;
						return $elm$core$Result$Ok($folkertdev$one_true_path_experiment$LowLevel$Command$ClosePath);
					} else {
						break _v0$5;
					}
			}
		}
		return $elm$core$Result$Err(
			_Utils_Tuple2(instruction1, instruction2));
	});
var $folkertdev$elm_deque$Internal$toList = function (deque) {
	return _Utils_ap(
		deque.front,
		$elm$core$List$reverse(deque.rear));
};
var $folkertdev$elm_deque$Deque$unwrap = function (_v0) {
	var boundedDeque = _v0.a;
	return boundedDeque;
};
var $folkertdev$elm_deque$Deque$toList = A2($elm$core$Basics$composeL, $folkertdev$elm_deque$Internal$toList, $folkertdev$elm_deque$Deque$unwrap);
var $folkertdev$one_true_path_experiment$SubPath$compressHelper = function (drawtos) {
	var folder = F2(
		function (instruction, _v3) {
			var previous = _v3.a;
			var accum = _v3.b;
			var _v2 = A2($folkertdev$one_true_path_experiment$LowLevel$Command$merge, previous, instruction);
			if (_v2.$ === 'Ok') {
				var merged = _v2.a;
				return _Utils_Tuple2(merged, accum);
			} else {
				return _Utils_Tuple2(
					instruction,
					A2($elm$core$List$cons, previous, accum));
			}
		});
	var _v0 = $folkertdev$elm_deque$Deque$toList(drawtos);
	if (!_v0.b) {
		return $folkertdev$elm_deque$Deque$empty;
	} else {
		var first = _v0.a;
		var rest = _v0.b;
		return $folkertdev$elm_deque$Deque$fromList(
			$elm$core$List$reverse(
				function (_v1) {
					var a = _v1.a;
					var b = _v1.b;
					return A2($elm$core$List$cons, a, b);
				}(
					A3(
						$elm$core$List$foldl,
						folder,
						_Utils_Tuple2(first, _List_Nil),
						rest))));
	}
};
var $folkertdev$one_true_path_experiment$SubPath$compress = function (subpath) {
	if (subpath.$ === 'Empty') {
		return $folkertdev$one_true_path_experiment$SubPath$Empty;
	} else {
		var data = subpath.a;
		return $folkertdev$one_true_path_experiment$SubPath$SubPath(
			_Utils_update(
				data,
				{
					drawtos: $folkertdev$one_true_path_experiment$SubPath$compressHelper(data.drawtos)
				}));
	}
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$DecimalPlaces = function (a) {
	return {$: 'DecimalPlaces', a: a};
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$decimalPlaces = $folkertdev$svg_path_lowlevel$Path$LowLevel$DecimalPlaces;
var $folkertdev$one_true_path_experiment$SubPath$defaultConfig = {decimalPlaces: $elm$core$Maybe$Nothing, mergeAdjacent: false};
var $folkertdev$one_true_path_experiment$SubPath$optionFolder = F2(
	function (option, config) {
		if (option.$ === 'DecimalPlaces') {
			var n = option.a;
			return _Utils_update(
				config,
				{
					decimalPlaces: $elm$core$Maybe$Just(n)
				});
		} else {
			return _Utils_update(
				config,
				{mergeAdjacent: true});
		}
	});
var $elm$core$List$singleton = function (value) {
	return _List_fromArray(
		[value]);
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute = {$: 'Absolute'};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$ClosePath = {$: 'ClosePath'};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$CurveTo = F2(
	function (a, b) {
		return {$: 'CurveTo', a: a, b: b};
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$EllipticalArc = F2(
	function (a, b) {
		return {$: 'EllipticalArc', a: a, b: b};
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$LineTo = F2(
	function (a, b) {
		return {$: 'LineTo', a: a, b: b};
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$QuadraticBezierCurveTo = F2(
	function (a, b) {
		return {$: 'QuadraticBezierCurveTo', a: a, b: b};
	});
var $folkertdev$one_true_path_experiment$LowLevel$Command$toLowLevelDrawTo = function (drawto) {
	switch (drawto.$) {
		case 'LineTo':
			var coordinates = drawto.a;
			return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$LineTo, $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute, coordinates);
		case 'CurveTo':
			var coordinates = drawto.a;
			return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$CurveTo, $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute, coordinates);
		case 'QuadraticBezierCurveTo':
			var coordinates = drawto.a;
			return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$QuadraticBezierCurveTo, $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute, coordinates);
		case 'EllipticalArc':
			var _arguments = drawto.a;
			return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$EllipticalArc, $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute, _arguments);
		default:
			return $folkertdev$svg_path_lowlevel$Path$LowLevel$ClosePath;
	}
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$MoveTo = F2(
	function (a, b) {
		return {$: 'MoveTo', a: a, b: b};
	});
var $folkertdev$one_true_path_experiment$LowLevel$Command$toLowLevelMoveTo = function (_v0) {
	var target = _v0.a;
	return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$MoveTo, $folkertdev$svg_path_lowlevel$Path$LowLevel$Absolute, target);
};
var $folkertdev$one_true_path_experiment$SubPath$toLowLevel = function (subpath) {
	if (subpath.$ === 'Empty') {
		return $elm$core$Maybe$Nothing;
	} else {
		var moveto = subpath.a.moveto;
		var drawtos = subpath.a.drawtos;
		return $elm$core$Maybe$Just(
			{
				drawtos: A2(
					$elm$core$List$map,
					$folkertdev$one_true_path_experiment$LowLevel$Command$toLowLevelDrawTo,
					$folkertdev$elm_deque$Deque$toList(drawtos)),
				moveto: $folkertdev$one_true_path_experiment$LowLevel$Command$toLowLevelMoveTo(moveto)
			});
	}
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$defaultConfig = {floatFormatter: $elm$core$String$fromFloat};
var $elm$core$Basics$round = _Basics_round;
var $folkertdev$svg_path_lowlevel$Path$LowLevel$roundTo = F2(
	function (n, value) {
		if (!n) {
			return $elm$core$String$fromInt(
				$elm$core$Basics$round(value));
		} else {
			var sign = (value < 0.0) ? '-' : '';
			var exp = A2($elm$core$Basics$pow, 10, n);
			var raised = $elm$core$Basics$abs(
				$elm$core$Basics$round(value * exp));
			var decimals = raised % exp;
			return (!decimals) ? _Utils_ap(
				sign,
				$elm$core$String$fromInt((raised / exp) | 0)) : (sign + ($elm$core$String$fromInt((raised / exp) | 0) + ('.' + $elm$core$String$fromInt(decimals))));
		}
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$optionFolder = F2(
	function (option, config) {
		var n = option.a;
		return _Utils_update(
			config,
			{
				floatFormatter: $folkertdev$svg_path_lowlevel$Path$LowLevel$roundTo(n)
			});
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$accumulateOptions = A2($elm$core$List$foldl, $folkertdev$svg_path_lowlevel$Path$LowLevel$optionFolder, $folkertdev$svg_path_lowlevel$Path$LowLevel$defaultConfig);
var $elm$core$List$isEmpty = function (xs) {
	if (!xs.b) {
		return true;
	} else {
		return false;
	}
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$isEmpty = function (command) {
	switch (command.$) {
		case 'LineTo':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'Horizontal':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'Vertical':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'CurveTo':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'SmoothCurveTo':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'QuadraticBezierCurveTo':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'SmoothQuadraticBezierCurveTo':
			var mode = command.a;
			var coordinates = command.b;
			return $elm$core$List$isEmpty(coordinates);
		case 'EllipticalArc':
			var mode = command.a;
			var _arguments = command.b;
			return $elm$core$List$isEmpty(_arguments);
		default:
			return false;
	}
};
var $elm$core$Char$toLower = _Char_toLower;
var $elm$core$Char$toUpper = _Char_toUpper;
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter = F2(
	function (mode, character) {
		if (mode.$ === 'Absolute') {
			return $elm$core$String$fromChar(
				$elm$core$Char$toUpper(character));
		} else {
			return $elm$core$String$fromChar(
				$elm$core$Char$toLower(character));
		}
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate = F2(
	function (config, _v0) {
		var x = _v0.a;
		var y = _v0.b;
		return config.floatFormatter(x) + (',' + config.floatFormatter(y));
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate2 = F2(
	function (config, _v0) {
		var c1 = _v0.a;
		var c2 = _v0.b;
		return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, c1) + (' ' + A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, c2));
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate3 = F2(
	function (config, _v0) {
		var c1 = _v0.a;
		var c2 = _v0.b;
		var c3 = _v0.c;
		return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, c1) + (' ' + (A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, c2) + (' ' + A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, c3))));
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$encodeFlags = function (_v0) {
	var arcFlag = _v0.a;
	var direction = _v0.b;
	var _v1 = _Utils_Tuple2(arcFlag, direction);
	if (_v1.a.$ === 'LargestArc') {
		if (_v1.b.$ === 'Clockwise') {
			var _v2 = _v1.a;
			var _v3 = _v1.b;
			return _Utils_Tuple2(1, 0);
		} else {
			var _v6 = _v1.a;
			var _v7 = _v1.b;
			return _Utils_Tuple2(1, 1);
		}
	} else {
		if (_v1.b.$ === 'Clockwise') {
			var _v4 = _v1.a;
			var _v5 = _v1.b;
			return _Utils_Tuple2(0, 0);
		} else {
			var _v8 = _v1.a;
			var _v9 = _v1.b;
			return _Utils_Tuple2(0, 1);
		}
	}
};
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyEllipticalArcArgument = F2(
	function (config, _v0) {
		var radii = _v0.radii;
		var xAxisRotate = _v0.xAxisRotate;
		var arcFlag = _v0.arcFlag;
		var direction = _v0.direction;
		var target = _v0.target;
		var _v1 = $folkertdev$svg_path_lowlevel$Path$LowLevel$encodeFlags(
			_Utils_Tuple2(arcFlag, direction));
		var arc = _v1.a;
		var sweep = _v1.b;
		return A2(
			$elm$core$String$join,
			' ',
			_List_fromArray(
				[
					A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, radii),
					$elm$core$String$fromFloat(xAxisRotate),
					$elm$core$String$fromInt(arc),
					$elm$core$String$fromInt(sweep),
					A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, target)
				]));
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyDrawTo = F2(
	function (config, command) {
		if ($folkertdev$svg_path_lowlevel$Path$LowLevel$isEmpty(command)) {
			return '';
		} else {
			switch (command.$) {
				case 'LineTo':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('L')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate(config),
								coordinates)));
				case 'Horizontal':
					var mode = command.a;
					var coordinates = command.b;
					return $elm$core$List$isEmpty(coordinates) ? '' : _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('H')),
						A2(
							$elm$core$String$join,
							' ',
							A2($elm$core$List$map, $elm$core$String$fromFloat, coordinates)));
				case 'Vertical':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('V')),
						A2(
							$elm$core$String$join,
							' ',
							A2($elm$core$List$map, $elm$core$String$fromFloat, coordinates)));
				case 'CurveTo':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('C')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate3(config),
								coordinates)));
				case 'SmoothCurveTo':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('S')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate2(config),
								coordinates)));
				case 'QuadraticBezierCurveTo':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('Q')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate2(config),
								coordinates)));
				case 'SmoothQuadraticBezierCurveTo':
					var mode = command.a;
					var coordinates = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('T')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate(config),
								coordinates)));
				case 'EllipticalArc':
					var mode = command.a;
					var _arguments = command.b;
					return _Utils_ap(
						A2(
							$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCharacter,
							mode,
							_Utils_chr('A')),
						A2(
							$elm$core$String$join,
							' ',
							A2(
								$elm$core$List$map,
								$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyEllipticalArcArgument(config),
								_arguments)));
				default:
					return 'Z';
			}
		}
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyMoveTo = F2(
	function (config, _v0) {
		var mode = _v0.a;
		var coordinate = _v0.b;
		if (mode.$ === 'Absolute') {
			return 'M' + A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, coordinate);
		} else {
			return 'm' + A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyCoordinate, config, coordinate);
		}
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$toStringSubPath = F2(
	function (config, _v0) {
		var moveto = _v0.moveto;
		var drawtos = _v0.drawtos;
		return A2($folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyMoveTo, config, moveto) + (' ' + A2(
			$elm$core$String$join,
			' ',
			A2(
				$elm$core$List$map,
				$folkertdev$svg_path_lowlevel$Path$LowLevel$stringifyDrawTo(config),
				drawtos)));
	});
var $folkertdev$svg_path_lowlevel$Path$LowLevel$toStringWith = F2(
	function (options, subpaths) {
		var config = $folkertdev$svg_path_lowlevel$Path$LowLevel$accumulateOptions(options);
		return A2(
			$elm$core$String$join,
			' ',
			A2(
				$elm$core$List$map,
				$folkertdev$svg_path_lowlevel$Path$LowLevel$toStringSubPath(config),
				subpaths));
	});
var $folkertdev$one_true_path_experiment$SubPath$toStringWith = F2(
	function (options, subpath) {
		var config = A3($elm$core$List$foldl, $folkertdev$one_true_path_experiment$SubPath$optionFolder, $folkertdev$one_true_path_experiment$SubPath$defaultConfig, options);
		var lowLevelOptions = function () {
			var _v0 = config.decimalPlaces;
			if (_v0.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var n = _v0.a;
				return _List_fromArray(
					[
						$folkertdev$svg_path_lowlevel$Path$LowLevel$decimalPlaces(n)
					]);
			}
		}();
		return A2(
			$elm$core$Maybe$withDefault,
			'',
			A2(
				$elm$core$Maybe$map,
				A2(
					$elm$core$Basics$composeL,
					$folkertdev$svg_path_lowlevel$Path$LowLevel$toStringWith(lowLevelOptions),
					$elm$core$List$singleton),
				$folkertdev$one_true_path_experiment$SubPath$toLowLevel(
					(config.mergeAdjacent ? $folkertdev$one_true_path_experiment$SubPath$compress : $elm$core$Basics$identity)(subpath))));
	});
var $folkertdev$one_true_path_experiment$SubPath$toString = function (subpath) {
	return A2($folkertdev$one_true_path_experiment$SubPath$toStringWith, _List_Nil, subpath);
};
var $folkertdev$one_true_path_experiment$Path$toString = A2(
	$elm$core$Basics$composeL,
	$elm$core$String$join(' '),
	$elm$core$List$map($folkertdev$one_true_path_experiment$SubPath$toString));
var $folkertdev$one_true_path_experiment$Path$element = F2(
	function (path, attributes) {
		return A2(
			$elm$svg$Svg$path,
			A2(
				$elm$core$List$cons,
				$elm$svg$Svg$Attributes$d(
					$folkertdev$one_true_path_experiment$Path$toString(path)),
				attributes),
			_List_Nil);
	});
var $elm$core$String$concat = function (strings) {
	return A2($elm$core$String$join, '', strings);
};
var $avh4$elm_color$Color$toCssString = function (_v0) {
	var r = _v0.a;
	var g = _v0.b;
	var b = _v0.c;
	var a = _v0.d;
	var roundTo = function (x) {
		return $elm$core$Basics$round(x * 1000) / 1000;
	};
	var pct = function (x) {
		return $elm$core$Basics$round(x * 10000) / 100;
	};
	return $elm$core$String$concat(
		_List_fromArray(
			[
				'rgba(',
				$elm$core$String$fromFloat(
				pct(r)),
				'%,',
				$elm$core$String$fromFloat(
				pct(g)),
				'%,',
				$elm$core$String$fromFloat(
				pct(b)),
				'%,',
				$elm$core$String$fromFloat(
				roundTo(a)),
				')'
			]));
};
var $elm_community$typed_svg$TypedSvg$TypesToStrings$paintToString = function (paint) {
	switch (paint.$) {
		case 'Paint':
			var color = paint.a;
			return $avh4$elm_color$Color$toCssString(color);
		case 'CSSVariable':
			var string = paint.a;
			return $elm$core$String$concat(
				_List_fromArray(
					['var(' + (string + ')')]));
		case 'Reference':
			var string = paint.a;
			return $elm$core$String$concat(
				_List_fromArray(
					['url(#', string, ')']));
		case 'ContextFill':
			return 'context-fill';
		case 'ContextStroke':
			return 'context-stroke';
		default:
			return 'none';
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$fill = A2(
	$elm$core$Basics$composeL,
	$elm_community$typed_svg$TypedSvg$Core$attribute('fill'),
	$elm_community$typed_svg$TypedSvg$TypesToStrings$paintToString);
var $elm$virtual_dom$VirtualDom$nodeNS = F2(
	function (namespace, tag) {
		return A2(
			_VirtualDom_nodeNS,
			namespace,
			_VirtualDom_noScript(tag));
	});
var $elm_community$typed_svg$TypedSvg$Core$node = $elm$virtual_dom$VirtualDom$nodeNS('http://www.w3.org/2000/svg');
var $elm_community$typed_svg$TypedSvg$g = $elm_community$typed_svg$TypedSvg$Core$node('g');
var $elm_community$typed_svg$TypedSvg$Attributes$stroke = A2(
	$elm$core$Basics$composeL,
	$elm_community$typed_svg$TypedSvg$Core$attribute('stroke'),
	$elm_community$typed_svg$TypedSvg$TypesToStrings$paintToString);
var $elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString = function (length) {
	switch (length.$) {
		case 'Cm':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'cm';
		case 'Em':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'em';
		case 'Ex':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'ex';
		case 'In':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'in';
		case 'Mm':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'mm';
		case 'Num':
			var x = length.a;
			return $elm$core$String$fromFloat(x);
		case 'Pc':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'pc';
		case 'Percent':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + '%';
		case 'Pt':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'pt';
		case 'Px':
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'px';
		default:
			var x = length.a;
			return $elm$core$String$fromFloat(x) + 'rem';
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$strokeWidth = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'stroke-width',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $author$project$ParallelCoordinates$createLine = function (path) {
	return A2(
		$elm_community$typed_svg$TypedSvg$g,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$folkertdev$one_true_path_experiment$Path$element,
				path,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$stroke(
						$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$darkBlue)),
						$elm_community$typed_svg$TypedSvg$Attributes$strokeWidth(
						$elm_community$typed_svg$TypedSvg$Types$Px(0.5)),
						$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone)
					]))
			]));
};
var $elm_community$typed_svg$TypedSvg$Types$AnchorEnd = {$: 'AnchorEnd'};
var $elm_community$typed_svg$TypedSvg$Types$AnchorMiddle = {$: 'AnchorMiddle'};
var $elm_community$typed_svg$TypedSvg$Types$AnchorStart = {$: 'AnchorStart'};
var $author$project$ParallelCoordinates$ChangeOrder = F2(
	function (a, b) {
		return {$: 'ChangeOrder', a: a, b: b};
	});
var $author$project$ParallelCoordinates$SetScatterPlotFromParallelPlot = F2(
	function (a, b) {
		return {$: 'SetScatterPlotFromParallelPlot', a: a, b: b};
	});
var $elm_community$typed_svg$TypedSvg$Types$Translate = F2(
	function (a, b) {
		return {$: 'Translate', a: a, b: b};
	});
var $elm_community$typed_svg$TypedSvg$Attributes$fontSize = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'font-size',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$TypesToStrings$anchorAlignmentToString = function (anchorAlignment) {
	switch (anchorAlignment.$) {
		case 'AnchorInherit':
			return 'inherit';
		case 'AnchorStart':
			return 'start';
		case 'AnchorMiddle':
			return 'middle';
		default:
			return 'end';
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$textAnchor = function (anchorAlignment) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'text-anchor',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$anchorAlignmentToString(anchorAlignment));
};
var $elm_community$typed_svg$TypedSvg$text_ = $elm_community$typed_svg$TypedSvg$Core$node('text');
var $elm_community$typed_svg$TypedSvg$TypesToStrings$transformToString = function (xform) {
	var tr = F2(
		function (name, args) {
			return $elm$core$String$concat(
				_List_fromArray(
					[
						name,
						'(',
						A2(
						$elm$core$String$join,
						' ',
						A2($elm$core$List$map, $elm$core$String$fromFloat, args)),
						')'
					]));
		});
	switch (xform.$) {
		case 'Matrix':
			var a = xform.a;
			var b = xform.b;
			var c = xform.c;
			var d = xform.d;
			var e = xform.e;
			var f = xform.f;
			return A2(
				tr,
				'matrix',
				_List_fromArray(
					[a, b, c, d, e, f]));
		case 'Rotate':
			var a = xform.a;
			var x = xform.b;
			var y = xform.c;
			return A2(
				tr,
				'rotate',
				_List_fromArray(
					[a, x, y]));
		case 'Scale':
			var x = xform.a;
			var y = xform.b;
			return A2(
				tr,
				'scale',
				_List_fromArray(
					[x, y]));
		case 'SkewX':
			var x = xform.a;
			return A2(
				tr,
				'skewX',
				_List_fromArray(
					[x]));
		case 'SkewY':
			var y = xform.a;
			return A2(
				tr,
				'skewY',
				_List_fromArray(
					[y]));
		default:
			var x = xform.a;
			var y = xform.b;
			return A2(
				tr,
				'translate',
				_List_fromArray(
					[x, y]));
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$transform = function (transforms) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'transform',
		A2(
			$elm$core$String$join,
			' ',
			A2($elm$core$List$map, $elm_community$typed_svg$TypedSvg$TypesToStrings$transformToString, transforms)));
};
var $elm_community$typed_svg$TypedSvg$Types$px = $elm_community$typed_svg$TypedSvg$Types$Px;
var $elm_community$typed_svg$TypedSvg$Attributes$x = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'x',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$x = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$x(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $elm_community$typed_svg$TypedSvg$Attributes$y = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'y',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$y = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$y(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $elm$svg$Svg$Attributes$class = _VirtualDom_attribute('class');
var $gampleman$elm_visualization$Scale$tickFormat = function (_v0) {
	var opts = _v0.a;
	return opts.tickFormat(opts.domain);
};
var $gampleman$elm_visualization$Scale$ticks = F2(
	function (_v0, count) {
		var scale = _v0.a;
		return A2(scale.ticks, scale.domain, count);
	});
var $gampleman$elm_visualization$Axis$computeOptions = F2(
	function (attrs, scale) {
		var _v0 = A3(
			$elm$core$List$foldl,
			F2(
				function (attr, _v1) {
					var babyOpts = _v1.a;
					var post = _v1.b;
					switch (attr.$) {
						case 'TickCount':
							var val = attr.a;
							return _Utils_Tuple2(
								_Utils_update(
									babyOpts,
									{tickCount: val}),
								post);
						case 'TickSizeInner':
							var val = attr.a;
							return _Utils_Tuple2(
								_Utils_update(
									babyOpts,
									{tickSizeInner: val}),
								post);
						case 'TickSizeOuter':
							var val = attr.a;
							return _Utils_Tuple2(
								_Utils_update(
									babyOpts,
									{tickSizeOuter: val}),
								post);
						case 'TickPadding':
							var val = attr.a;
							return _Utils_Tuple2(
								_Utils_update(
									babyOpts,
									{tickPadding: val}),
								post);
						default:
							return _Utils_Tuple2(
								babyOpts,
								A2($elm$core$List$cons, attr, post));
					}
				}),
			_Utils_Tuple2(
				{tickCount: 10, tickPadding: 3, tickSizeInner: 6, tickSizeOuter: 6},
				_List_Nil),
			attrs);
		var opts = _v0.a;
		var postList = _v0.b;
		return A3(
			$elm$core$List$foldl,
			F2(
				function (attr, options) {
					switch (attr.$) {
						case 'Ticks':
							var val = attr.a;
							return _Utils_update(
								options,
								{ticks: val});
						case 'TickFormat':
							var val = attr.a;
							return _Utils_update(
								options,
								{tickFormat: val});
						default:
							return options;
					}
				}),
			{
				tickCount: opts.tickCount,
				tickFormat: A2($gampleman$elm_visualization$Scale$tickFormat, scale, opts.tickCount),
				tickPadding: opts.tickPadding,
				tickSizeInner: opts.tickSizeInner,
				tickSizeOuter: opts.tickSizeOuter,
				ticks: A2($gampleman$elm_visualization$Scale$ticks, scale, opts.tickCount)
			},
			postList);
	});
var $elm$svg$Svg$Attributes$dy = _VirtualDom_attribute('dy');
var $elm$svg$Svg$Attributes$fill = _VirtualDom_attribute('fill');
var $elm$svg$Svg$Attributes$fontFamily = _VirtualDom_attribute('font-family');
var $elm$svg$Svg$Attributes$fontSize = _VirtualDom_attribute('font-size');
var $elm$svg$Svg$g = $elm$svg$Svg$trustedNode('g');
var $elm$svg$Svg$line = $elm$svg$Svg$trustedNode('line');
var $gampleman$elm_visualization$Scale$rangeExtent = function (_v0) {
	var options = _v0.a;
	return A2(options.rangeExtent, options.domain, options.range);
};
var $elm$svg$Svg$Attributes$stroke = _VirtualDom_attribute('stroke');
var $elm$svg$Svg$text = $elm$virtual_dom$VirtualDom$text;
var $elm$svg$Svg$Attributes$textAnchor = _VirtualDom_attribute('text-anchor');
var $elm$svg$Svg$text_ = $elm$svg$Svg$trustedNode('text');
var $elm$svg$Svg$Attributes$transform = _VirtualDom_attribute('transform');
var $gampleman$elm_visualization$Axis$element = F4(
	function (_v0, k, displacement, textAnchorPosition) {
		var x = _v0.x;
		var y = _v0.y;
		var x2 = _v0.x2;
		var y1 = _v0.y1;
		var y2 = _v0.y2;
		var translate = _v0.translate;
		var horizontal = _v0.horizontal;
		return F2(
			function (attrs, scale) {
				var rangeExtent = $gampleman$elm_visualization$Scale$rangeExtent(scale);
				var range1 = rangeExtent.b + 0.5;
				var range0 = rangeExtent.a + 0.5;
				var position = $gampleman$elm_visualization$Scale$convert(scale);
				var opts = A2($gampleman$elm_visualization$Axis$computeOptions, attrs, scale);
				var spacing = A2($elm$core$Basics$max, opts.tickSizeInner, 0) + opts.tickPadding;
				var drawTick = function (tick) {
					return A2(
						$elm$svg$Svg$g,
						_List_fromArray(
							[
								$elm$svg$Svg$Attributes$class('tick'),
								$elm$svg$Svg$Attributes$transform(
								translate(
									position(tick)))
							]),
						_List_fromArray(
							[
								A2(
								$elm$svg$Svg$line,
								_List_fromArray(
									[
										$elm$svg$Svg$Attributes$stroke('#000'),
										x2(k * opts.tickSizeInner),
										y1(0.5),
										y2(0.5)
									]),
								_List_Nil),
								A2(
								$elm$svg$Svg$text_,
								_List_fromArray(
									[
										$elm$svg$Svg$Attributes$fill('#000'),
										x(k * spacing),
										y(0.5),
										$elm$svg$Svg$Attributes$dy(displacement)
									]),
								_List_fromArray(
									[
										$elm$svg$Svg$text(
										opts.tickFormat(tick))
									]))
							]));
				};
				var domainLine = horizontal ? ('M' + ($elm$core$String$fromFloat(k * opts.tickSizeOuter) + (',' + ($elm$core$String$fromFloat(range0) + ('H0.5V' + ($elm$core$String$fromFloat(range1) + ('H' + $elm$core$String$fromFloat(k * opts.tickSizeOuter)))))))) : ('M' + ($elm$core$String$fromFloat(range0) + (',' + ($elm$core$String$fromFloat(k * opts.tickSizeOuter) + ('V0.5H' + ($elm$core$String$fromFloat(range1) + ('V' + $elm$core$String$fromFloat(k * opts.tickSizeOuter))))))));
				return A2(
					$elm$svg$Svg$g,
					_List_fromArray(
						[
							$elm$svg$Svg$Attributes$fill('none'),
							$elm$svg$Svg$Attributes$fontSize('10'),
							$elm$svg$Svg$Attributes$fontFamily('sans-serif'),
							$elm$svg$Svg$Attributes$textAnchor(textAnchorPosition)
						]),
					A2(
						$elm$core$List$cons,
						A2(
							$elm$svg$Svg$path,
							_List_fromArray(
								[
									$elm$svg$Svg$Attributes$class('domain'),
									$elm$svg$Svg$Attributes$stroke('#000'),
									$elm$svg$Svg$Attributes$d(domainLine)
								]),
							_List_Nil),
						A2($elm$core$List$map, drawTick, opts.ticks)));
			});
	});
var $elm$svg$Svg$Attributes$x = _VirtualDom_attribute('x');
var $elm$svg$Svg$Attributes$x1 = _VirtualDom_attribute('x1');
var $elm$svg$Svg$Attributes$x2 = _VirtualDom_attribute('x2');
var $elm$svg$Svg$Attributes$y = _VirtualDom_attribute('y');
var $elm$svg$Svg$Attributes$y1 = _VirtualDom_attribute('y1');
var $elm$svg$Svg$Attributes$y2 = _VirtualDom_attribute('y2');
var $gampleman$elm_visualization$Axis$horizontalAttrs = {
	horizontal: true,
	translate: function (y) {
		return 'translate(0, ' + ($elm$core$String$fromFloat(y) + ')');
	},
	x: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x, $elm$core$String$fromFloat),
	x1: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x1, $elm$core$String$fromFloat),
	x2: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x2, $elm$core$String$fromFloat),
	y: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y, $elm$core$String$fromFloat),
	y1: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y1, $elm$core$String$fromFloat),
	y2: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y2, $elm$core$String$fromFloat)
};
var $gampleman$elm_visualization$Axis$left = A4($gampleman$elm_visualization$Axis$element, $gampleman$elm_visualization$Axis$horizontalAttrs, -1, '0.32em', 'end');
var $author$project$ParallelCoordinates$yAxis = function (scale) {
	return A2($gampleman$elm_visualization$Axis$left, _List_Nil, scale);
};
var $author$project$ParallelCoordinates$createYAxis = F5(
	function (scaleX, model, scaleY, text, unit) {
		var index = scaleY.a;
		var indexF = index;
		var indexafter = (index === 9) ? 0 : (index + 1);
		var indexbefore = (!index) ? 9 : (index - 1);
		var att2 = A2(
			$elm$core$Maybe$withDefault,
			'Price',
			$elm$core$List$head(
				A2($elm$core$List$drop, indexafter, model.parallelPlotOption.orderedLabels)));
		var att1 = A2(
			$elm$core$Maybe$withDefault,
			'Price',
			$elm$core$List$head(
				A2($elm$core$List$drop, index, model.parallelPlotOption.orderedLabels)));
		return A2(
			$elm_community$typed_svg$TypedSvg$g,
			_List_fromArray(
				[
					$elm_community$typed_svg$TypedSvg$Attributes$transform(
					_List_fromArray(
						[
							A2(
							$elm_community$typed_svg$TypedSvg$Types$Translate,
							A2($gampleman$elm_visualization$Scale$convert, scaleX, indexF),
							$author$project$ParallelCoordinates$axisPaddig)
						])),
					$elm_community$typed_svg$TypedSvg$Attributes$class(
					_List_fromArray(
						['axis']))
				]),
			_List_fromArray(
				[
					A2(
					$elm_community$typed_svg$TypedSvg$g,
					_List_Nil,
					_List_fromArray(
						[
							$author$project$ParallelCoordinates$yAxis(scaleY.b)
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(-10),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(-30),
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorEnd),
							$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
							$elm_community$typed_svg$TypedSvg$Types$Px(10)),
							$elm$html$Html$Events$onClick(
							A2($author$project$ParallelCoordinates$ChangeOrder, index, indexbefore))
						]),
					_List_fromArray(
						[
							$elm$html$Html$text('<<< ')
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(10),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(-30),
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorStart),
							$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
							$elm_community$typed_svg$TypedSvg$Types$Px(10)),
							$elm$html$Html$Events$onClick(
							A2($author$project$ParallelCoordinates$ChangeOrder, index, indexafter))
						]),
					_List_fromArray(
						[
							$elm$html$Html$text('>>>')
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(-14),
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle),
							$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
							$elm_community$typed_svg$TypedSvg$Types$Px(14)),
							$elm$html$Html$Events$onClick(
							A2($author$project$ParallelCoordinates$SetScatterPlotFromParallelPlot, att1, att2))
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(text)
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(-5),
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle),
							$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
							$elm_community$typed_svg$TypedSvg$Types$Px(8)),
							$elm$html$Html$Events$onClick(
							A2($author$project$ParallelCoordinates$SetScatterPlotFromParallelPlot, att1, att2))
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(unit)
						]))
				]));
	});
var $author$project$ParallelCoordinates$h = 430;
var $elm_community$typed_svg$TypedSvg$Attributes$height = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'height',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $gampleman$elm_visualization$Shape$Generators$line = F2(
	function (curve, data) {
		var makeCurves = F2(
			function (datum, _v3) {
				var prev = _v3.a;
				var list = _v3.b;
				var _v0 = _Utils_Tuple3(prev, datum, list);
				if (_v0.b.$ === 'Nothing') {
					var _v1 = _v0.b;
					var l = _v0.c;
					return _Utils_Tuple2(false, l);
				} else {
					if (!_v0.a) {
						var point = _v0.b.a;
						var l = _v0.c;
						return _Utils_Tuple2(
							true,
							A2(
								$elm$core$List$cons,
								_List_fromArray(
									[point]),
								l));
					} else {
						if (_v0.c.b) {
							var p1 = _v0.b.a;
							var _v2 = _v0.c;
							var ps = _v2.a;
							var l = _v2.b;
							return _Utils_Tuple2(
								true,
								A2(
									$elm$core$List$cons,
									A2($elm$core$List$cons, p1, ps),
									l));
						} else {
							var p1 = _v0.b.a;
							var l = _v0.c;
							return _Utils_Tuple2(
								true,
								A2(
									$elm$core$List$cons,
									_List_fromArray(
										[p1]),
									l));
						}
					}
				}
			});
		return A2(
			$elm$core$List$map,
			curve,
			A3(
				$elm$core$List$foldr,
				makeCurves,
				_Utils_Tuple2(false, _List_Nil),
				data).b);
	});
var $gampleman$elm_visualization$Shape$line = $gampleman$elm_visualization$Shape$Generators$line;
var $folkertdev$one_true_path_experiment$SubPath$empty = $folkertdev$one_true_path_experiment$SubPath$Empty;
var $folkertdev$one_true_path_experiment$LowLevel$Command$lineTo = $folkertdev$one_true_path_experiment$LowLevel$Command$LineTo;
var $folkertdev$one_true_path_experiment$LowLevel$Command$MoveTo = function (a) {
	return {$: 'MoveTo', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$moveTo = $folkertdev$one_true_path_experiment$LowLevel$Command$MoveTo;
var $folkertdev$one_true_path_experiment$SubPath$with = F2(
	function (moveto, drawtos) {
		return $folkertdev$one_true_path_experiment$SubPath$SubPath(
			{
				drawtos: $folkertdev$elm_deque$Deque$fromList(drawtos),
				moveto: moveto
			});
	});
var $folkertdev$one_true_path_experiment$Curve$linear = function (points) {
	if (!points.b) {
		return $folkertdev$one_true_path_experiment$SubPath$empty;
	} else {
		var x = points.a;
		var xs = points.b;
		return A2(
			$folkertdev$one_true_path_experiment$SubPath$with,
			$folkertdev$one_true_path_experiment$LowLevel$Command$moveTo(x),
			_List_fromArray(
				[
					$folkertdev$one_true_path_experiment$LowLevel$Command$lineTo(xs)
				]));
	}
};
var $gampleman$elm_visualization$Shape$linearCurve = $folkertdev$one_true_path_experiment$Curve$linear;
var $author$project$ExtendedFunctions$listmap10 = function (f) {
	return function (la) {
		return function (lb) {
			return function (lc) {
				return function (ld) {
					return function (le) {
						return function (lf) {
							return function (lg) {
								return function (lh) {
									return function (li) {
										return function (lj) {
											var go = function (xs) {
												return function (ys) {
													return function (zs) {
														return function (ws) {
															return function (vs) {
																return function (as1) {
																	return function (bs) {
																		return function (cs) {
																			return function (ds) {
																				return function (es) {
																					return function (acc) {
																						go:
																						while (true) {
																							var _v0 = _Utils_Tuple3(xs, ys, zs);
																							if ((_v0.a.b && _v0.b.b) && _v0.c.b) {
																								var _v1 = _v0.a;
																								var x = _v1.a;
																								var xr = _v1.b;
																								var _v2 = _v0.b;
																								var y = _v2.a;
																								var yr = _v2.b;
																								var _v3 = _v0.c;
																								var z = _v3.a;
																								var zr = _v3.b;
																								var _v4 = _Utils_Tuple3(ws, vs, as1);
																								if ((_v4.a.b && _v4.b.b) && _v4.c.b) {
																									var _v5 = _v4.a;
																									var w1 = _v5.a;
																									var wr = _v5.b;
																									var _v6 = _v4.b;
																									var v = _v6.a;
																									var vr = _v6.b;
																									var _v7 = _v4.c;
																									var a = _v7.a;
																									var ar = _v7.b;
																									var _v8 = _Utils_Tuple3(bs, cs, ds);
																									if ((_v8.a.b && _v8.b.b) && _v8.c.b) {
																										var _v9 = _v8.a;
																										var b = _v9.a;
																										var br = _v9.b;
																										var _v10 = _v8.b;
																										var c = _v10.a;
																										var cr = _v10.b;
																										var _v11 = _v8.c;
																										var d = _v11.a;
																										var dr = _v11.b;
																										if (es.b) {
																											var e = es.a;
																											var er = es.b;
																											var $temp$xs = xr,
																												$temp$ys = yr,
																												$temp$zs = zr,
																												$temp$ws = wr,
																												$temp$vs = vr,
																												$temp$as1 = ar,
																												$temp$bs = br,
																												$temp$cs = cr,
																												$temp$ds = dr,
																												$temp$es = er,
																												$temp$acc = A2(
																												$elm$core$List$cons,
																												f(x)(y)(z)(w1)(v)(a)(b)(c)(d)(e),
																												acc);
																											xs = $temp$xs;
																											ys = $temp$ys;
																											zs = $temp$zs;
																											ws = $temp$ws;
																											vs = $temp$vs;
																											as1 = $temp$as1;
																											bs = $temp$bs;
																											cs = $temp$cs;
																											ds = $temp$ds;
																											es = $temp$es;
																											acc = $temp$acc;
																											continue go;
																										} else {
																											return $elm$core$List$reverse(acc);
																										}
																									} else {
																										return $elm$core$List$reverse(acc);
																									}
																								} else {
																									return $elm$core$List$reverse(acc);
																								}
																							} else {
																								return $elm$core$List$reverse(acc);
																							}
																						}
																					};
																				};
																			};
																		};
																	};
																};
															};
														};
													};
												};
											};
											return go(la)(lb)(lc)(ld)(le)(lf)(lg)(lh)(li)(lj)(_List_Nil);
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $elm$core$List$map3 = _List_map3;
var $elm$core$Tuple$pair = F2(
	function (a, b) {
		return _Utils_Tuple2(a, b);
	});
var $elm_community$typed_svg$TypedSvg$style = $elm_community$typed_svg$TypedSvg$Core$node('style');
var $elm_community$typed_svg$TypedSvg$svg = $elm_community$typed_svg$TypedSvg$Core$node('svg');
var $elm_community$typed_svg$TypedSvg$Core$text = $elm$virtual_dom$VirtualDom$text;
var $elm_community$typed_svg$TypedSvg$Attributes$viewBox = F4(
	function (minX, minY, vWidth, vHeight) {
		return A2(
			$elm_community$typed_svg$TypedSvg$Core$attribute,
			'viewBox',
			A2(
				$elm$core$String$join,
				' ',
				A2(
					$elm$core$List$map,
					$elm$core$String$fromFloat,
					_List_fromArray(
						[minX, minY, vWidth, vHeight]))));
	});
var $author$project$ParallelCoordinates$w = 900;
var $elm_community$typed_svg$TypedSvg$Attributes$width = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'width',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $gampleman$elm_visualization$Scale$Scale = function (a) {
	return {$: 'Scale', a: a};
};
var $gampleman$elm_visualization$Scale$Continuous$normalize = F2(
	function (a, b) {
		var c = b - a;
		return (!c) ? $elm$core$Basics$always(0.5) : ($elm$core$Basics$isNaN(c) ? $elm$core$Basics$always(0 / 0) : function (x) {
			return (x - a) / c;
		});
	});
var $gampleman$elm_visualization$Scale$Continuous$bimap = F3(
	function (_v0, _v1, interpolate) {
		var d0 = _v0.a;
		var d1 = _v0.b;
		var r0 = _v1.a;
		var r1 = _v1.b;
		var _v2 = (_Utils_cmp(d1, d0) < 0) ? _Utils_Tuple2(
			A2($gampleman$elm_visualization$Scale$Continuous$normalize, d1, d0),
			A2(interpolate, r1, r0)) : _Utils_Tuple2(
			A2($gampleman$elm_visualization$Scale$Continuous$normalize, d0, d1),
			A2(interpolate, r0, r1));
		var de = _v2.a;
		var re = _v2.b;
		return A2($elm$core$Basics$composeL, re, de);
	});
var $gampleman$elm_visualization$Scale$Continuous$convertTransform = F4(
	function (transform, interpolate, _v0, range) {
		var d0 = _v0.a;
		var d1 = _v0.b;
		return A2(
			$elm$core$Basics$composeR,
			transform,
			A3(
				$gampleman$elm_visualization$Scale$Continuous$bimap,
				_Utils_Tuple2(
					transform(d0),
					transform(d1)),
				range,
				interpolate));
	});
var $gampleman$elm_visualization$Interpolation$float = F2(
	function (a, to) {
		var b = to - a;
		return function (t) {
			return a + (b * t);
		};
	});
var $gampleman$elm_visualization$Scale$Continuous$invertTransform = F4(
	function (transform, untransform, _v0, range) {
		var d0 = _v0.a;
		var d1 = _v0.b;
		return A2(
			$elm$core$Basics$composeR,
			A3(
				$gampleman$elm_visualization$Scale$Continuous$bimap,
				range,
				_Utils_Tuple2(
					transform(d0),
					transform(d1)),
				$gampleman$elm_visualization$Interpolation$float),
			untransform);
	});
var $gampleman$elm_visualization$Scale$Continuous$fixPoint = F3(
	function (maxIterations, initialInput, fn) {
		var helper = F2(
			function (iters, _v0) {
				helper:
				while (true) {
					var a = _v0.a;
					var b = _v0.b;
					if (_Utils_cmp(iters + 1, maxIterations) > -1) {
						return b;
					} else {
						var _v1 = fn(b);
						var outA = _v1.a;
						var outB = _v1.b;
						if (_Utils_eq(outA, a)) {
							return b;
						} else {
							if (!outA) {
								return b;
							} else {
								var $temp$iters = iters + 1,
									$temp$_v0 = _Utils_Tuple2(outA, outB);
								iters = $temp$iters;
								_v0 = $temp$_v0;
								continue helper;
							}
						}
					}
				}
			});
		return A2(
			helper,
			1,
			fn(initialInput));
	});
var $gampleman$elm_visualization$Scale$Continuous$e10 = $elm$core$Basics$sqrt(50);
var $gampleman$elm_visualization$Scale$Continuous$e2 = $elm$core$Basics$sqrt(2);
var $gampleman$elm_visualization$Scale$Continuous$e5 = $elm$core$Basics$sqrt(10);
var $gampleman$elm_visualization$Scale$Continuous$ln10 = A2($elm$core$Basics$logBase, $elm$core$Basics$e, 10);
var $gampleman$elm_visualization$Scale$Continuous$tickIncrement = F3(
	function (start, stop, count) {
		var step = (stop - start) / A2($elm$core$Basics$max, 0, count);
		var powr = $elm$core$Basics$floor(
			A2($elm$core$Basics$logBase, $elm$core$Basics$e, step) / $gampleman$elm_visualization$Scale$Continuous$ln10);
		var error = step / A2($elm$core$Basics$pow, 10, powr);
		var order = (_Utils_cmp(error, $gampleman$elm_visualization$Scale$Continuous$e10) > -1) ? 10 : ((_Utils_cmp(error, $gampleman$elm_visualization$Scale$Continuous$e5) > -1) ? 5 : ((_Utils_cmp(error, $gampleman$elm_visualization$Scale$Continuous$e2) > -1) ? 2 : 1));
		return (powr >= 0) ? (order * A2($elm$core$Basics$pow, 10, powr)) : ((-A2($elm$core$Basics$pow, 10, -powr)) / order);
	});
var $gampleman$elm_visualization$Scale$Continuous$withNormalizedDomain = F2(
	function (fn, _v0) {
		var a = _v0.a;
		var b = _v0.b;
		if (_Utils_cmp(a, b) < 0) {
			return fn(
				_Utils_Tuple2(a, b));
		} else {
			var _v1 = fn(
				_Utils_Tuple2(b, a));
			var d = _v1.a;
			var c = _v1.b;
			return _Utils_Tuple2(c, d);
		}
	});
var $gampleman$elm_visualization$Scale$Continuous$nice = F2(
	function (domain, count) {
		var computation = function (_v0) {
			var start = _v0.a;
			var stop = _v0.b;
			var step = A3($gampleman$elm_visualization$Scale$Continuous$tickIncrement, start, stop, count);
			return _Utils_Tuple2(
				step,
				(step > 0) ? _Utils_Tuple2(
					$elm$core$Basics$floor(start / step) * step,
					$elm$core$Basics$ceiling(stop / step) * step) : ((step < 0) ? _Utils_Tuple2(
					$elm$core$Basics$ceiling(start * step) / step,
					$elm$core$Basics$floor(stop * step) / step) : _Utils_Tuple2(start, stop)));
		};
		return A2(
			$gampleman$elm_visualization$Scale$Continuous$withNormalizedDomain,
			function (dmn) {
				return A3($gampleman$elm_visualization$Scale$Continuous$fixPoint, 10, dmn, computation);
			},
			domain);
	});
var $gampleman$elm_visualization$Scale$Continuous$exponent = function (num) {
	var helper = F2(
		function (soFar, x) {
			helper:
			while (true) {
				if (!x) {
					return soFar;
				} else {
					if (x < 1) {
						var $temp$soFar = 1 + soFar,
							$temp$x = x * 10;
						soFar = $temp$soFar;
						x = $temp$x;
						continue helper;
					} else {
						return soFar;
					}
				}
			}
		});
	return A2(helper, 0, num);
};
var $gampleman$elm_visualization$Scale$Continuous$precisionFixed = function (step) {
	return A2(
		$elm$core$Basics$max,
		0,
		$gampleman$elm_visualization$Scale$Continuous$exponent(
			$elm$core$Basics$abs(step)));
};
var $gampleman$elm_visualization$Statistics$tickStep = F3(
	function (start, stop, count) {
		var step0 = $elm$core$Basics$abs(stop - start) / A2($elm$core$Basics$max, 0, count);
		var step1 = A2(
			$elm$core$Basics$pow,
			10,
			$elm$core$Basics$floor(
				A2($elm$core$Basics$logBase, $elm$core$Basics$e, step0) / A2($elm$core$Basics$logBase, $elm$core$Basics$e, 10)));
		var error = step0 / step1;
		var step2 = (_Utils_cmp(
			error,
			$elm$core$Basics$sqrt(50)) > -1) ? (step1 * 10) : ((_Utils_cmp(
			error,
			$elm$core$Basics$sqrt(10)) > -1) ? (step1 * 5) : ((_Utils_cmp(
			error,
			$elm$core$Basics$sqrt(2)) > -1) ? (step1 * 2) : step1));
		return (_Utils_cmp(stop, start) < 0) ? (-step2) : step2;
	});
var $gampleman$elm_visualization$Scale$Continuous$toFixed = F2(
	function (precision, value) {
		var power_ = A2($elm$core$Basics$pow, 10, precision);
		var pad = function (num) {
			_v0$2:
			while (true) {
				if (num.b) {
					if (num.b.b) {
						if (!num.b.b.b) {
							var x = num.a;
							var _v1 = num.b;
							var y = _v1.a;
							return _List_fromArray(
								[
									x,
									A3(
									$elm$core$String$padRight,
									precision,
									_Utils_chr('0'),
									y)
								]);
						} else {
							break _v0$2;
						}
					} else {
						var val = num.a;
						return (precision > 0) ? _List_fromArray(
							[
								val,
								A3(
								$elm$core$String$padRight,
								precision,
								_Utils_chr('0'),
								'')
							]) : _List_fromArray(
							[val]);
					}
				} else {
					break _v0$2;
				}
			}
			var val = num;
			return val;
		};
		return A2(
			$elm$core$String$join,
			'.',
			pad(
				A2(
					$elm$core$String$split,
					'.',
					$elm$core$String$fromFloat(
						$elm$core$Basics$round(value * power_) / power_))));
	});
var $gampleman$elm_visualization$Scale$Continuous$tickFormat = F2(
	function (_v0, count) {
		var start = _v0.a;
		var stop = _v0.b;
		return $gampleman$elm_visualization$Scale$Continuous$toFixed(
			$gampleman$elm_visualization$Scale$Continuous$precisionFixed(
				A3($gampleman$elm_visualization$Statistics$tickStep, start, stop, count)));
	});
var $elmcraft$core_extra$Float$Extra$range = F3(
	function (start, stop, step) {
		if (!step) {
			return _List_Nil;
		} else {
			var n = A2(
				$elm$core$Basics$max,
				0,
				$elm$core$Basics$ceiling((stop - start) / step));
			var helper = F2(
				function (i, list) {
					helper:
					while (true) {
						if (i >= 0) {
							var $temp$i = i - 1,
								$temp$list = A2($elm$core$List$cons, start + (step * i), list);
							i = $temp$i;
							list = $temp$list;
							continue helper;
						} else {
							return list;
						}
					}
				});
			return A2(helper, n - 1, _List_Nil);
		}
	});
var $gampleman$elm_visualization$Statistics$range = $elmcraft$core_extra$Float$Extra$range;
var $gampleman$elm_visualization$Statistics$ticks = F3(
	function (start, stop, count) {
		var step = A3($gampleman$elm_visualization$Statistics$tickStep, start, stop, count);
		var end = ($elm$core$Basics$floor(stop / step) * step) + (step / 2);
		var beg = $elm$core$Basics$ceiling(start / step) * step;
		return A3($gampleman$elm_visualization$Statistics$range, beg, end, step);
	});
var $gampleman$elm_visualization$Scale$Continuous$ticks = F2(
	function (_v0, count) {
		var start = _v0.a;
		var end = _v0.b;
		return A3($gampleman$elm_visualization$Statistics$ticks, start, end, count);
	});
var $gampleman$elm_visualization$Scale$Continuous$scaleWithTransform = F4(
	function (transform, untransform, range_, domain_) {
		return {
			convert: A2($gampleman$elm_visualization$Scale$Continuous$convertTransform, transform, $gampleman$elm_visualization$Interpolation$float),
			domain: domain_,
			invert: A2($gampleman$elm_visualization$Scale$Continuous$invertTransform, transform, untransform),
			nice: $gampleman$elm_visualization$Scale$Continuous$nice,
			range: range_,
			rangeExtent: F2(
				function (_v0, r) {
					return r;
				}),
			tickFormat: $gampleman$elm_visualization$Scale$Continuous$tickFormat,
			ticks: $gampleman$elm_visualization$Scale$Continuous$ticks
		};
	});
var $gampleman$elm_visualization$Scale$Continuous$linear = A2($gampleman$elm_visualization$Scale$Continuous$scaleWithTransform, $elm$core$Basics$identity, $elm$core$Basics$identity);
var $gampleman$elm_visualization$Scale$linear = F2(
	function (range_, domain_) {
		return $gampleman$elm_visualization$Scale$Scale(
			A2($gampleman$elm_visualization$Scale$Continuous$linear, range_, domain_));
	});
var $author$project$ParallelCoordinates$padding = 60;
var $author$project$ParallelCoordinates$defaultExtent = _Utils_Tuple2(0, 200000);
var $gampleman$elm_visualization$Statistics$extentBy = F2(
	function (fn, list) {
		var min = F2(
			function (a, b) {
				return (_Utils_cmp(
					fn(a),
					fn(b)) < 0) ? a : b;
			});
		var max = F2(
			function (a, b) {
				return (_Utils_cmp(
					fn(a),
					fn(b)) > 0) ? a : b;
			});
		var helper = F2(
			function (l, _v0) {
				helper:
				while (true) {
					var mini = _v0.a;
					var maxi = _v0.b;
					if (!l.b) {
						return _Utils_Tuple2(mini, maxi);
					} else {
						var x = l.a;
						var xs = l.b;
						var $temp$l = xs,
							$temp$_v0 = _Utils_Tuple2(
							A2(min, mini, x),
							A2(max, maxi, x));
						l = $temp$l;
						_v0 = $temp$_v0;
						continue helper;
					}
				}
			});
		if (!list.b) {
			return $elm$core$Maybe$Nothing;
		} else {
			var x = list.a;
			var xs = list.b;
			return $elm$core$Maybe$Just(
				A2(
					helper,
					xs,
					_Utils_Tuple2(x, x)));
		}
	});
var $gampleman$elm_visualization$Statistics$extent = $gampleman$elm_visualization$Statistics$extentBy($elm$core$Basics$identity);
var $author$project$ParallelCoordinates$wideExtent = function (values) {
	return A2(
		$elm$core$Maybe$withDefault,
		$author$project$ParallelCoordinates$defaultExtent,
		$gampleman$elm_visualization$Statistics$extent(values));
};
var $author$project$ParallelCoordinates$xScale = function (values) {
	return A2(
		$gampleman$elm_visualization$Scale$linear,
		_Utils_Tuple2($author$project$ParallelCoordinates$padding, $author$project$ParallelCoordinates$w),
		$author$project$ParallelCoordinates$wideExtent(values));
};
var $author$project$ParallelCoordinates$yScale = function (values) {
	return A2(
		$gampleman$elm_visualization$Scale$linear,
		_Utils_Tuple2($author$project$ParallelCoordinates$h, 0),
		$author$project$ParallelCoordinates$wideExtent(values));
};
var $author$project$ParallelCoordinates$parallelCoordinatesPlot = F2(
	function (model, smartphonesList) {
		var multidimStrings = model.parallelPlotOption.orderedLabels;
		var getAttributeList = F2(
			function (attribute, smartphones) {
				return A2($elm$core$List$map, attribute, smartphones);
			});
		var convertMaybeList = F2(
			function (maybeList, defaultValue) {
				return A2(
					$elm$core$List$map,
					$elm$core$Maybe$withDefault(defaultValue),
					maybeList);
			});
		var getAllAttributeLists = F2(
			function (attributes, smartphones) {
				return A2(
					$elm$core$List$map,
					function (attribute) {
						return A2(
							convertMaybeList,
							A2(getAttributeList, attribute, smartphones),
							0.0);
					},
					attributes);
			});
		var multiDimValues = A2(getAllAttributeLists, model.parallelPlotOption.orderedList, smartphonesList);
		var dimLen = $elm$core$List$length(multiDimValues) - 1;
		var xScaleLocal = $author$project$ParallelCoordinates$xScale(
			A2(
				$elm$core$List$map,
				$elm$core$Basics$toFloat,
				A2($elm$core$List$range, 0, dimLen)));
		var yValues = multiDimValues;
		var yScaleLocals = A2($elm$core$List$map, $author$project$ParallelCoordinates$yScale, yValues);
		var pathGenerator = function (y1) {
			return function (y2) {
				return function (y3) {
					return function (y4) {
						return function (y5) {
							return function (y6) {
								return function (y7) {
									return function (y8) {
										return function (y9) {
											return function (y10) {
												var yPoints = _List_fromArray(
													[y1, y2, y3, y4, y5, y6, y7, y8, y9, y10]);
												var xPoints = _List_fromArray(
													[0, 1, 2, 3, 4, 5, 6, 7, 8, 9]);
												var yPointsScaled = A4(
													$elm$core$List$map3,
													F3(
														function (yS, y, x) {
															return $elm$core$Maybe$Just(
																_Utils_Tuple2(
																	A2($gampleman$elm_visualization$Scale$convert, xScaleLocal, x),
																	A2($gampleman$elm_visualization$Scale$convert, yS, y) + $author$project$ParallelCoordinates$axisPaddig));
														}),
													yScaleLocals,
													yPoints,
													xPoints);
												return A2($gampleman$elm_visualization$Shape$line, $gampleman$elm_visualization$Shape$linearCurve, yPointsScaled);
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
		var yScaleLocalsWithIndex = A2(
			$elm$core$List$indexedMap,
			$elm$core$Tuple$pair,
			A2($elm$core$List$map, $author$project$ParallelCoordinates$yScale, yValues));
		var yaxis = A4(
			$elm$core$List$map3,
			A2($author$project$ParallelCoordinates$createYAxis, xScaleLocal, model),
			yScaleLocalsWithIndex,
			multidimStrings,
			model.parallelPlotOption.orderedUnitLabels);
		var yValue1 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(yValues));
		var yValue10 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 9, yValues)));
		var yValue2 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 1, yValues)));
		var yValue3 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 2, yValues)));
		var yValue4 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 3, yValues)));
		var yValue5 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 4, yValues)));
		var yValue6 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 5, yValues)));
		var yValue7 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 6, yValues)));
		var yValue8 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 7, yValues)));
		var yValue9 = A2(
			$elm$core$Maybe$withDefault,
			_List_Nil,
			$elm$core$List$head(
				A2($elm$core$List$drop, 8, yValues)));
		var paths = $author$project$ExtendedFunctions$listmap10(pathGenerator)(yValue1)(yValue2)(yValue3)(yValue4)(yValue5)(yValue6)(yValue7)(yValue8)(yValue9)(yValue10);
		var lines = A2($elm$core$List$map, $author$project$ParallelCoordinates$createLine, paths);
		return A2(
			$elm_community$typed_svg$TypedSvg$svg,
			_List_fromArray(
				[
					A4($elm_community$typed_svg$TypedSvg$Attributes$viewBox, 0, 0, $author$project$ParallelCoordinates$w + 60, $author$project$ParallelCoordinates$h + 60),
					$elm_community$typed_svg$TypedSvg$Attributes$width(
					$elm_community$typed_svg$TypedSvg$Types$Percent(100)),
					$elm_community$typed_svg$TypedSvg$Attributes$height(
					$elm_community$typed_svg$TypedSvg$Types$Percent(100))
				]),
			_Utils_ap(
				_List_fromArray(
					[
						A2(
						$elm_community$typed_svg$TypedSvg$style,
						_List_Nil,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Core$text('\r\n            .axis .tick text { display: none; font-size:13px }\r\n            .axis:hover .tick text { display: inline; }\r\n            ')
							])),
						A2($elm_community$typed_svg$TypedSvg$g, _List_Nil, _List_Nil)
					]),
				_Utils_ap(lines, yaxis)));
	});
var $elm$html$Html$select = _VirtualDom_node('select');
var $elm$html$Html$span = _VirtualDom_node('span');
var $author$project$ParallelCoordinates$viewParallelCoordinates = function (model) {
	var otherFilterValues = _List_fromArray(
		['all', 'true', 'false']);
	var filteredSmartphoneData = A2($author$project$ParallelCoordinates$filterSPData, model.data, model);
	var brandList = $elm$core$Set$toList(
		$elm$core$Set$fromList(
			A2(
				$elm$core$List$filterMap,
				function ($) {
					return $.brand;
				},
				model.data)));
	var brandFilterValues = A2($elm$core$List$cons, 'all', brandList);
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['description'])),
						$elm$html$Html$Attributes$align('center')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Hints: By clicking on a axis label, you switch to the scatterplot with clicked axis label as x-value and the following label as y-value. By hovering over an axis, the axis values are displayed. By clicking on the <<< or >>> you can switch the axis backward or forward. You can select different filters to bound the result.')
							]))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' Brand: ')
							]))
					])),
				A2(
				$elm$html$Html$select,
				_List_fromArray(
					[
						$elm$html$Html$Events$onInput($author$project$ParallelCoordinates$SetBrandParallel)
					]),
				A2(
					$elm$core$List$map,
					$author$project$ParallelCoordinates$createSelectorOptions(model.parallelPlotOption.selectedFilter.brand),
					brandFilterValues)),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' 5G: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$ParallelCoordinates$Set5GParallel)
							]),
						A2(
							$elm$core$List$map,
							$author$project$ParallelCoordinates$createSelectorOptions(model.parallelPlotOption.selectedFilter.g5),
							otherFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' NFC: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$ParallelCoordinates$SetNFCParallel)
							]),
						A2(
							$elm$core$List$map,
							$author$project$ParallelCoordinates$createSelectorOptions(model.parallelPlotOption.selectedFilter.nfc),
							otherFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' IR-Blaster: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$ParallelCoordinates$SetIRBlasterParallel)
							]),
						A2(
							$elm$core$List$map,
							$author$project$ParallelCoordinates$createSelectorOptions(model.parallelPlotOption.selectedFilter.ir_blaster),
							otherFilterValues))
					])),
				A2($elm$html$Html$br, _List_Nil, _List_Nil),
				A2($elm$html$Html$br, _List_Nil, _List_Nil),
				A2($author$project$ParallelCoordinates$parallelCoordinatesPlot, model, filteredSmartphoneData)
			]));
};
var $author$project$Scatterplot$ChangeAttribute1 = function (a) {
	return {$: 'ChangeAttribute1', a: a};
};
var $author$project$Scatterplot$ChangeAttribute2 = function (a) {
	return {$: 'ChangeAttribute2', a: a};
};
var $author$project$Scatterplot$createSelectorOptions = F2(
	function (select, att) {
		return _Utils_eq(select, att) ? A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(att),
					$elm$html$Html$Attributes$selected(true)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(att)
				])) : A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(att)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(att)
				]));
	});
var $author$project$Scatterplot$attributeSelector = F2(
	function (attNr, model) {
		var attributes = _List_fromArray(
			['Price', 'Rating', 'NumCores', 'Processor Speed', 'Battery', 'Fast Charging', 'Memory', 'RAM', 'Screen Size', 'Refresh Rate']);
		var att2 = model.scatterplotOptions.attribute2;
		var att1 = model.scatterplotOptions.attribute1;
		return A2(
			$elm$html$Html$select,
			_List_fromArray(
				[
					$elm$html$Html$Events$onInput(
					(attNr === 1) ? $author$project$Scatterplot$ChangeAttribute1 : $author$project$Scatterplot$ChangeAttribute2)
				]),
			(attNr === 1) ? A2(
				$elm$core$List$map,
				$author$project$Scatterplot$createSelectorOptions(att1),
				attributes) : A2(
				$elm$core$List$map,
				$author$project$Scatterplot$createSelectorOptions(att2),
				attributes));
	});
var $author$project$Scatterplot$XyData = F5(
	function (xDescription, yDescription, unitX, unitY, data) {
		return {data: data, unitX: unitX, unitY: unitY, xDescription: xDescription, yDescription: yDescription};
	});
var $elm$core$List$map4 = _List_map4;
var $elm$core$Maybe$map4 = F5(
	function (func, ma, mb, mc, md) {
		if (ma.$ === 'Nothing') {
			return $elm$core$Maybe$Nothing;
		} else {
			var a = ma.a;
			if (mb.$ === 'Nothing') {
				return $elm$core$Maybe$Nothing;
			} else {
				var b = mb.a;
				if (mc.$ === 'Nothing') {
					return $elm$core$Maybe$Nothing;
				} else {
					var c = mc.a;
					if (md.$ === 'Nothing') {
						return $elm$core$Maybe$Nothing;
					} else {
						var d = md.a;
						return $elm$core$Maybe$Just(
							A4(func, a, b, c, d));
					}
				}
			}
		}
	});
var $author$project$Scatterplot$mapToPoint = function (smartphoneData) {
	return A5(
		$elm$core$Maybe$map4,
		F4(
			function (att1, att2, name, index) {
				return {
					id: index,
					pointName: name + (' (' + ($elm$core$String$fromFloat(att1) + (',' + ($elm$core$String$fromFloat(att2) + ')')))),
					x: att1,
					y: att2
				};
			}),
		smartphoneData.att1,
		smartphoneData.att2,
		smartphoneData.name,
		smartphoneData.id);
};
var $author$project$Scatterplot$filterSmartphonesXY = F3(
	function (model, att1List, att2List) {
		var modelList = A2(
			$elm$core$List$map,
			function ($) {
				return $.model;
			},
			model.data);
		var idList = A2(
			$elm$core$List$map,
			function ($) {
				return $.id;
			},
			model.data);
		var smartphoneDataList = A5(
			$elm$core$List$map4,
			F4(
				function (a1, a2, mn, i) {
					return {att1: a1, att2: a2, id: i, name: mn};
				}),
			att1List,
			att2List,
			modelList,
			idList);
		var filteredSmartphones = A2($elm$core$List$filterMap, $author$project$Scatterplot$mapToPoint, smartphoneDataList);
		return A5($author$project$Scatterplot$XyData, model.scatterplotOptions.attribute1, model.scatterplotOptions.attribute2, model.scatterplotOptions.unit1, model.scatterplotOptions.unit2, filteredSmartphones);
	});
var $author$project$Scatterplot$h = 430;
var $author$project$Scatterplot$padding = 50;
var $author$project$Scatterplot$SetStarPlot = function (a) {
	return {$: 'SetStarPlot', a: a};
};
var $elm_community$typed_svg$TypedSvg$circle = $elm_community$typed_svg$TypedSvg$Core$node('circle');
var $elm_community$typed_svg$TypedSvg$Attributes$cx = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'cx',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$cx = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$cx(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $elm_community$typed_svg$TypedSvg$Attributes$cy = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'cy',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$cy = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$cy(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $elm_community$typed_svg$TypedSvg$Attributes$fontFamily = function (families) {
	if (!families.b) {
		return A2($elm_community$typed_svg$TypedSvg$Core$attribute, 'font-family', 'inherit');
	} else {
		return A2(
			$elm_community$typed_svg$TypedSvg$Core$attribute,
			'font-family',
			A2($elm$core$String$join, ', ', families));
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$r = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'r',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$r = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$r(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $author$project$Scatterplot$radius = 2.0;
var $author$project$Scatterplot$point = F3(
	function (scaleX, scaleY, xyPoint) {
		return A2(
			$elm_community$typed_svg$TypedSvg$g,
			_List_fromArray(
				[
					$elm_community$typed_svg$TypedSvg$Attributes$class(
					_List_fromArray(
						['point'])),
					$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
					$elm_community$typed_svg$TypedSvg$Types$Px(10.0)),
					$elm_community$typed_svg$TypedSvg$Attributes$fontFamily(
					_List_fromArray(
						['sans-serif'])),
					$elm$html$Html$Events$onClick(
					$author$project$Scatterplot$SetStarPlot(xyPoint.id))
				]),
			_List_fromArray(
				[
					A2(
					$elm_community$typed_svg$TypedSvg$circle,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$cx(
							A2($gampleman$elm_visualization$Scale$convert, scaleX, xyPoint.x)),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$cy(
							A2($gampleman$elm_visualization$Scale$convert, scaleY, xyPoint.y)),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$r($author$project$Scatterplot$radius)
						]),
					_List_Nil),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(
							A2($gampleman$elm_visualization$Scale$convert, scaleX, xyPoint.x)),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(
							A2($gampleman$elm_visualization$Scale$convert, scaleY, xyPoint.y)),
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text('ID:' + (xyPoint.id + (' | ' + xyPoint.pointName)))
						]))
				]));
	});
var $author$project$Scatterplot$w = 900;
var $author$project$Scatterplot$defaultExtent = _Utils_Tuple2(0, 200000);
var $author$project$Scatterplot$tickCount = 5;
var $author$project$Scatterplot$wideExtent = function (values) {
	var tup = A2(
		$elm$core$Maybe$withDefault,
		$author$project$Scatterplot$defaultExtent,
		$gampleman$elm_visualization$Statistics$extent(values));
	var minValue = ((tup.a - (tup.b / ($author$project$Scatterplot$tickCount * 2))) <= 0) ? 0 : (tup.a - (tup.b / ($author$project$Scatterplot$tickCount * 2)));
	var maxValue = tup.b + (tup.b / ($author$project$Scatterplot$tickCount * 2));
	return _Utils_Tuple2(minValue, maxValue);
};
var $gampleman$elm_visualization$Axis$verticalAttrs = {
	horizontal: false,
	translate: function (x) {
		return 'translate(' + ($elm$core$String$fromFloat(x) + ', 0)');
	},
	x: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y, $elm$core$String$fromFloat),
	x1: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y1, $elm$core$String$fromFloat),
	x2: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$y2, $elm$core$String$fromFloat),
	y: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x, $elm$core$String$fromFloat),
	y1: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x1, $elm$core$String$fromFloat),
	y2: A2($elm$core$Basics$composeL, $elm$svg$Svg$Attributes$x2, $elm$core$String$fromFloat)
};
var $gampleman$elm_visualization$Axis$bottom = A4($gampleman$elm_visualization$Axis$element, $gampleman$elm_visualization$Axis$verticalAttrs, 1, '0.71em', 'middle');
var $gampleman$elm_visualization$Axis$TickCount = function (a) {
	return {$: 'TickCount', a: a};
};
var $gampleman$elm_visualization$Axis$tickCount = $gampleman$elm_visualization$Axis$TickCount;
var $author$project$Scatterplot$xScale = function (values) {
	return A2(
		$gampleman$elm_visualization$Scale$linear,
		_Utils_Tuple2(0, $author$project$Scatterplot$w - (2 * $author$project$Scatterplot$padding)),
		$author$project$Scatterplot$wideExtent(values));
};
var $author$project$Scatterplot$xAxis = function (values) {
	return A2(
		$gampleman$elm_visualization$Axis$bottom,
		_List_fromArray(
			[
				$gampleman$elm_visualization$Axis$tickCount($author$project$Scatterplot$tickCount)
			]),
		$author$project$Scatterplot$xScale(values));
};
var $author$project$Scatterplot$yScale = function (values) {
	return A2(
		$gampleman$elm_visualization$Scale$linear,
		_Utils_Tuple2($author$project$Scatterplot$h - (2 * $author$project$Scatterplot$padding), 0),
		$author$project$Scatterplot$wideExtent(values));
};
var $author$project$Scatterplot$yAxis = function (values) {
	return A2(
		$gampleman$elm_visualization$Axis$left,
		_List_fromArray(
			[
				$gampleman$elm_visualization$Axis$tickCount($author$project$Scatterplot$tickCount)
			]),
		$author$project$Scatterplot$yScale(values));
};
var $author$project$Scatterplot$scatterplot = function (model) {
	var yValues = A2(
		$elm$core$List$map,
		function ($) {
			return $.y;
		},
		model.data);
	var yScaleLocal = $author$project$Scatterplot$yScale(yValues);
	var xValues = A2(
		$elm$core$List$map,
		function ($) {
			return $.x;
		},
		model.data);
	var xScaleLocal = $author$project$Scatterplot$xScale(xValues);
	var labelPositions = {
		x: $author$project$Scatterplot$wideExtent(xValues).b,
		y: $author$project$Scatterplot$wideExtent(yValues).b
	};
	return A2(
		$elm_community$typed_svg$TypedSvg$svg,
		_List_fromArray(
			[
				A4($elm_community$typed_svg$TypedSvg$Attributes$viewBox, 0, 0, $author$project$Scatterplot$w, $author$project$Scatterplot$h),
				$elm_community$typed_svg$TypedSvg$Attributes$width(
				$elm_community$typed_svg$TypedSvg$Types$Percent(100)),
				$elm_community$typed_svg$TypedSvg$Attributes$height(
				$elm_community$typed_svg$TypedSvg$Types$Percent(100))
			]),
		_List_fromArray(
			[
				A2(
				$elm_community$typed_svg$TypedSvg$style,
				_List_Nil,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Core$text('\r\n            .point circle { stroke: rgba(0, 0, 0,0.4); fill: rgba(255, 255, 255,0.3); }\r\n            .point text { display: none; }\r\n            .point:hover circle { stroke: rgba(0, 0, 0,1.0); fill: rgb(118, 214, 78); }\r\n            .point:hover text { display: inline; }\r\n          ')
					])),
				A2(
				$elm_community$typed_svg$TypedSvg$g,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$transform(
						_List_fromArray(
							[
								A2($elm_community$typed_svg$TypedSvg$Types$Translate, $author$project$Scatterplot$padding - 1, ($author$project$Scatterplot$h - $author$project$Scatterplot$padding) - 1)
							]))
					]),
				_List_fromArray(
					[
						$author$project$Scatterplot$xAxis(xValues),
						A2(
						$elm_community$typed_svg$TypedSvg$text_,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(
								A2($gampleman$elm_visualization$Scale$convert, xScaleLocal, labelPositions.x) - 20),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(30),
								$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle),
								$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
								$elm_community$typed_svg$TypedSvg$Types$Px(14))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(
								_Utils_ap(
									model.xDescription,
									_Utils_ap(
										($elm$core$String$length(model.unitX) > 0) ? ' in ' : '',
										model.unitX)))
							]))
					])),
				A2(
				$elm_community$typed_svg$TypedSvg$g,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$transform(
						_List_fromArray(
							[
								A2($elm_community$typed_svg$TypedSvg$Types$Translate, $author$project$Scatterplot$padding - 1, $author$project$Scatterplot$padding - 1)
							]))
					]),
				_List_fromArray(
					[
						$author$project$Scatterplot$yAxis(yValues),
						A2(
						$elm_community$typed_svg$TypedSvg$text_,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(20),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(
								A2($gampleman$elm_visualization$Scale$convert, yScaleLocal, labelPositions.y) - 10),
								$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle),
								$elm_community$typed_svg$TypedSvg$Attributes$fontSize(
								$elm_community$typed_svg$TypedSvg$Types$Px(14))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(
								_Utils_ap(
									model.yDescription,
									_Utils_ap(
										($elm$core$String$length(model.unitY) > 0) ? ' in ' : '',
										model.unitY)))
							]))
					])),
				A2(
				$elm_community$typed_svg$TypedSvg$g,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$transform(
						_List_fromArray(
							[
								A2($elm_community$typed_svg$TypedSvg$Types$Translate, $author$project$Scatterplot$padding, $author$project$Scatterplot$padding)
							]))
					]),
				A2(
					$elm$core$List$map,
					A2($author$project$Scatterplot$point, xScaleLocal, yScaleLocal),
					model.data))
			]));
};
var $author$project$Scatterplot$viewScatterplot = function (model) {
	var att2List = _Utils_eq(model.scatterplotOptions.att2List, _List_Nil) ? A2(
		$elm$core$List$map,
		function ($) {
			return $.rating;
		},
		model.data) : model.scatterplotOptions.att2List;
	var att1List = _Utils_eq(model.scatterplotOptions.att1List, _List_Nil) ? A2(
		$elm$core$List$map,
		function ($) {
			return $.price;
		},
		model.data) : model.scatterplotOptions.att1List;
	var filteredSmartphoneData = A3($author$project$Scatterplot$filterSmartphonesXY, model, att1List, att2List);
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['description'])),
						$elm$html$Html$Attributes$align('center')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Hints: By clicking on a point, the plot switch to the star plot and show the point data. By hovering over a point, you get the model name, ID und the exactly x and y values.')
							]))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('x-Axis: ')
							])),
						A2($author$project$Scatterplot$attributeSelector, 1, model)
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' y-Axis: ')
							])),
						A2($author$project$Scatterplot$attributeSelector, 2, model)
					])),
				$author$project$Scatterplot$scatterplot(filteredSmartphoneData)
			]));
};
var $author$project$Starplot$InputChange1 = function (a) {
	return {$: 'InputChange1', a: a};
};
var $author$project$Starplot$InputChange2 = function (a) {
	return {$: 'InputChange2', a: a};
};
var $author$project$Starplot$SubmitNumber1 = {$: 'SubmitNumber1'};
var $author$project$Starplot$SubmitNumber2 = {$: 'SubmitNumber2'};
var $author$project$Starplot$starlength = 300;
var $author$project$Starplot$calculateStarValue = F3(
	function (smartphone, max, func) {
		if (smartphone.$ === 'Just') {
			var sp = smartphone.a;
			var _v1 = func(sp);
			if (_v1.$ === 'Just') {
				var sV = _v1.a;
				if (max.$ === 'Just') {
					var m = max.a;
					return (sV / m) * $author$project$Starplot$starlength;
				} else {
					return -1;
				}
			} else {
				return -1;
			}
		} else {
			return -1;
		}
	});
var $elm$core$List$maximum = function (list) {
	if (list.b) {
		var x = list.a;
		var xs = list.b;
		return $elm$core$Maybe$Just(
			A3($elm$core$List$foldl, $elm$core$Basics$max, x, xs));
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$Starplot$findMaxValue = F2(
	function (model, func) {
		return $elm$core$List$maximum(
			A2($elm$core$List$filterMap, func, model.data));
	});
var $author$project$Starplot$checkID = F2(
	function (modelID, smartphone) {
		return _Utils_eq(
			A2($elm$core$Maybe$withDefault, 'NaN', smartphone.id),
			modelID);
	});
var $author$project$Starplot$findSmartphoneById = F2(
	function (model, id) {
		return $elm$core$List$head(
			A2(
				$elm$core$List$filter,
				$author$project$Starplot$checkID(id),
				model.data));
	});
var $elm$html$Html$input = _VirtualDom_node('input');
var $elm$html$Html$Attributes$placeholder = $elm$html$Html$Attributes$stringProperty('placeholder');
var $avh4$elm_color$Color$black = A4($avh4$elm_color$Color$RgbaSpace, 0 / 255, 0 / 255, 0 / 255, 1.0);
var $author$project$Starplot$midX = 450;
var $author$project$Starplot$midY = 360;
var $author$project$Starplot$createAxis = function (axisPoint) {
	return A2(
		$gampleman$elm_visualization$Shape$line,
		$gampleman$elm_visualization$Shape$linearCurve,
		_List_fromArray(
			[
				$elm$core$Maybe$Just(
				_Utils_Tuple2($author$project$Starplot$midX, $author$project$Starplot$midY)),
				$elm$core$Maybe$Just(
				_Utils_Tuple2($author$project$Starplot$midX + (axisPoint.a * $author$project$Starplot$starlength), $author$project$Starplot$midY + (axisPoint.b * $author$project$Starplot$starlength)))
			]));
};
var $elm$core$Debug$toString = _Debug_toString;
var $author$project$Starplot$createLabels = F4(
	function (label, vlabel, unit, labelPoint) {
		return A2(
			$elm_community$typed_svg$TypedSvg$g,
			_List_fromArray(
				[
					$elm_community$typed_svg$TypedSvg$Attributes$class(
					_List_fromArray(
						['label']))
				]),
			_List_fromArray(
				[
					A2(
					$elm_community$typed_svg$TypedSvg$g,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$class(
							_List_fromArray(
								['starLabel']))
						]),
					_List_fromArray(
						[
							A2(
							$elm_community$typed_svg$TypedSvg$text_,
							_List_fromArray(
								[
									$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(($author$project$Starplot$midX + (labelPoint.a * $author$project$Starplot$starlength)) - 20),
									$elm_community$typed_svg$TypedSvg$Attributes$InPx$y($author$project$Starplot$midY + (labelPoint.b * $author$project$Starplot$starlength))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(label)
								]))
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$g,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$class(
							_List_fromArray(
								['valueLabel']))
						]),
					_List_fromArray(
						[
							A2(
							$elm_community$typed_svg$TypedSvg$text_,
							_List_fromArray(
								[
									$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(($author$project$Starplot$midX + (labelPoint.a * $author$project$Starplot$starlength)) - 20),
									$elm_community$typed_svg$TypedSvg$Attributes$InPx$y($author$project$Starplot$midY + (labelPoint.b * $author$project$Starplot$starlength))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(
									(vlabel < 0) ? 'NaN' : ($elm$core$Debug$toString(vlabel) + (' ' + unit)))
								]))
						]))
				]));
	});
var $avh4$elm_color$Color$darkGray = A4($avh4$elm_color$Color$RgbaSpace, 186 / 255, 189 / 255, 182 / 255, 1.0);
var $author$project$Starplot$h = 700;
var $avh4$elm_color$Color$red = A4($avh4$elm_color$Color$RgbaSpace, 204 / 255, 0 / 255, 0 / 255, 1.0);
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$strokeWidth(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $author$project$Starplot$w = 990;
var $author$project$Starplot$starplot = F5(
	function (smartphone, starValues, labels, unit, func) {
		var valueLabel = A2(
			$elm$core$List$map,
			function (f) {
				var _v3 = f(smartphone);
				if (_v3.$ === 'Just') {
					var value = _v3.a;
					return value;
				} else {
					return -1;
				}
			},
			func);
		var starLabel = A5(
			$elm$core$List$map4,
			$author$project$Starplot$createLabels,
			labels,
			valueLabel,
			unit,
			_List_fromArray(
				[
					_Utils_Tuple2(0, -1.1),
					_Utils_Tuple2(0.7, -0.95),
					_Utils_Tuple2(0.95, -0.45),
					_Utils_Tuple2(0.95, 0.45),
					_Utils_Tuple2(0.7, 0.95),
					_Utils_Tuple2(0, 1.1),
					_Utils_Tuple2(-0.7, 0.95),
					_Utils_Tuple2(-0.95, 0.45),
					_Utils_Tuple2(-1.1, -0.45),
					_Utils_Tuple2(-0.7, -0.95)
				]));
		var axisMultiplikator = _List_fromArray(
			[
				_Utils_Tuple2(0, -0.9),
				_Utils_Tuple2(0.5, -0.75),
				_Utils_Tuple2(0.75, -0.25),
				_Utils_Tuple2(0.75, 0.25),
				_Utils_Tuple2(0.5, 0.75),
				_Utils_Tuple2(0, 0.9),
				_Utils_Tuple2(-0.5, 0.75),
				_Utils_Tuple2(-0.75, 0.25),
				_Utils_Tuple2(-0.75, -0.25),
				_Utils_Tuple2(-0.5, -0.75)
			]);
		var axisMultiplikatorHalf = A2(
			$elm$core$List$map,
			function (_v2) {
				var x = _v2.a;
				var y = _v2.b;
				return _Utils_Tuple2(x / 2, y / 2);
			},
			axisMultiplikator);
		var pathCircleHalf = A2(
			$gampleman$elm_visualization$Shape$line,
			$gampleman$elm_visualization$Shape$linearCurve,
			_Utils_ap(
				A2(
					$elm$core$List$map,
					function (_v1) {
						var x = _v1.a;
						var y = _v1.b;
						return $elm$core$Maybe$Just(
							_Utils_Tuple2($author$project$Starplot$midX + (x * $author$project$Starplot$starlength), $author$project$Starplot$midY + (y * $author$project$Starplot$starlength)));
					},
					axisMultiplikatorHalf),
				_List_fromArray(
					[
						$elm$core$Maybe$Just(
						_Utils_Tuple2(
							$author$project$Starplot$midX + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikatorHalf)).a * $author$project$Starplot$starlength),
							$author$project$Starplot$midY + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikatorHalf)).b * $author$project$Starplot$starlength)))
					])));
		var pathCircleMax = A2(
			$gampleman$elm_visualization$Shape$line,
			$gampleman$elm_visualization$Shape$linearCurve,
			_Utils_ap(
				A2(
					$elm$core$List$map,
					function (_v0) {
						var x = _v0.a;
						var y = _v0.b;
						return $elm$core$Maybe$Just(
							_Utils_Tuple2($author$project$Starplot$midX + (x * $author$project$Starplot$starlength), $author$project$Starplot$midY + (y * $author$project$Starplot$starlength)));
					},
					axisMultiplikator),
				_List_fromArray(
					[
						$elm$core$Maybe$Just(
						_Utils_Tuple2(
							$author$project$Starplot$midX + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikator)).a * $author$project$Starplot$starlength),
							$author$project$Starplot$midY + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikator)).b * $author$project$Starplot$starlength)))
					])));
		var pathCircleSmartphone = A2(
			$gampleman$elm_visualization$Shape$line,
			$gampleman$elm_visualization$Shape$linearCurve,
			_Utils_ap(
				A3(
					$elm$core$List$map2,
					F2(
						function (axisM, starV) {
							return $elm$core$Maybe$Just(
								_Utils_Tuple2($author$project$Starplot$midX + (axisM.a * starV), $author$project$Starplot$midY + (axisM.b * starV)));
						}),
					axisMultiplikator,
					starValues),
				_List_fromArray(
					[
						$elm$core$Maybe$Just(
						_Utils_Tuple2(
							$author$project$Starplot$midX + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikator)).a * A2(
								$elm$core$Maybe$withDefault,
								0,
								$elm$core$List$head(starValues))),
							$author$project$Starplot$midY + (A2(
								$elm$core$Maybe$withDefault,
								_Utils_Tuple2(0, 0.9),
								$elm$core$List$head(axisMultiplikator)).b * A2(
								$elm$core$Maybe$withDefault,
								0,
								$elm$core$List$head(starValues)))))
					])));
		var starAxisMax = A2($elm$core$List$map, $author$project$Starplot$createAxis, axisMultiplikator);
		return A2(
			$elm_community$typed_svg$TypedSvg$svg,
			_List_fromArray(
				[
					A4($elm_community$typed_svg$TypedSvg$Attributes$viewBox, 0, 0, $author$project$Starplot$w, $author$project$Starplot$h),
					$elm_community$typed_svg$TypedSvg$Attributes$width(
					$elm_community$typed_svg$TypedSvg$Types$Percent(50)),
					$elm_community$typed_svg$TypedSvg$Attributes$height(
					$elm_community$typed_svg$TypedSvg$Types$Percent(100))
				]),
			_Utils_ap(
				_List_fromArray(
					[
						A2(
						$elm_community$typed_svg$TypedSvg$style,
						_List_Nil,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Core$text('\r\n            .valueLabel { display: none }\r\n            .starLabel {font-size:30px;}\r\n            .valueLabel {font-size:30px;}\r\n            .label:hover .valueLabel { display: inline; }\r\n            .label:hover .starLabel { display: none; }\r\n            ')
							])),
						A2(
						$elm_community$typed_svg$TypedSvg$circle,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$cx($author$project$Starplot$midX),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$cy($author$project$Starplot$midY),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$r(1),
								$elm_community$typed_svg$TypedSvg$Attributes$stroke(
								$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$black)),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(1)
							]),
						_List_Nil),
						A2(
						$folkertdev$one_true_path_experiment$Path$element,
						pathCircleMax,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$stroke(
								$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$darkGray)),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(0.8),
								$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone)
							])),
						A2(
						$folkertdev$one_true_path_experiment$Path$element,
						pathCircleHalf,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$stroke(
								$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$darkGray)),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(0.5),
								$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone)
							])),
						A2(
						$folkertdev$one_true_path_experiment$Path$element,
						pathCircleSmartphone,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$stroke(
								$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$red)),
								$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(2),
								$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone)
							]))
					]),
				_Utils_ap(
					starLabel,
					A2(
						$elm$core$List$map,
						function (p) {
							return A2(
								$folkertdev$one_true_path_experiment$Path$element,
								p,
								_List_fromArray(
									[
										$elm_community$typed_svg$TypedSvg$Attributes$stroke(
										$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$black)),
										$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(0.5),
										$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone)
									]));
						},
						starAxisMax))));
	});
var $author$project$Starplot$viewStarplot = function (model) {
	var unit = _List_fromArray(
		['EUR', '%', '', 'GHz', 'mAh', '', 'GB', 'GB', 'inches', 'Hz']);
	var starplotViewHead = F2(
		function (spd1, spd2) {
			return A2(
				$elm$html$Html$div,
				_List_Nil,
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['description'])),
								$elm$html$Html$Attributes$align('center')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text('Hints: You can compare two smartphones at the same time. Each of the two starplots has an input field where an ID from a smartphone can be entered to display it in the starplot. By hovering over a plot label, you can see the exactly value for the label.')
									]))
							])),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotStarInfo']))
							]),
						_List_fromArray(
							[
								function () {
								if (spd1.$ === 'Just') {
									var spd = spd1.a;
									return A2(
										$elm$html$Html$span,
										_List_Nil,
										_List_fromArray(
											[
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(
														('Starplot1 | ID:' + A2($elm$core$Maybe$withDefault, 'NaN', spd.id)) + (' | ' + A2($elm$core$Maybe$withDefault, 'NaN', spd.model)))
													])),
												A2($elm$html$Html$br, _List_Nil, _List_Nil),
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text('Select ID1: ')
													])),
												A2(
												$elm$html$Html$input,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$placeholder('Enter a number'),
														$elm$html$Html$Events$onInput($author$project$Starplot$InputChange1)
													]),
												_List_Nil),
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Events$onClick($author$project$Starplot$SubmitNumber1)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text('Submit for SP1')
													]))
											]));
								} else {
									return A2(
										$elm$html$Html$span,
										_List_Nil,
										_List_fromArray(
											[
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(('Starplot1 | ID:' + 'NaN') + (' | ' + 'NaN'))
													])),
												A2($elm$html$Html$br, _List_Nil, _List_Nil),
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text('Select ID1: ')
													])),
												A2(
												$elm$html$Html$input,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$placeholder('Enter a number'),
														$elm$html$Html$Events$onInput($author$project$Starplot$InputChange1)
													]),
												_List_Nil),
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Events$onClick($author$project$Starplot$SubmitNumber1)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text('Submit for SP1')
													]))
											]));
								}
							}(),
								function () {
								if (spd2.$ === 'Just') {
									var spd = spd2.a;
									return A2(
										$elm$html$Html$span,
										_List_Nil,
										_List_fromArray(
											[
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(
														('Starplot2 | ID:' + A2($elm$core$Maybe$withDefault, 'NaN', spd.id)) + (' | ' + A2($elm$core$Maybe$withDefault, 'NaN', spd.model)))
													])),
												A2($elm$html$Html$br, _List_Nil, _List_Nil),
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(' Select ID2: ')
													])),
												A2(
												$elm$html$Html$input,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$placeholder('Enter a number'),
														$elm$html$Html$Events$onInput($author$project$Starplot$InputChange2)
													]),
												_List_Nil),
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Events$onClick($author$project$Starplot$SubmitNumber2)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text('Submit for SP2')
													]))
											]));
								} else {
									return A2(
										$elm$html$Html$span,
										_List_Nil,
										_List_fromArray(
											[
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(('Starplot2 | ID:' + 'NaN') + (' | ' + 'NaN'))
													])),
												A2($elm$html$Html$br, _List_Nil, _List_Nil),
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(' Select ID2: ')
													])),
												A2(
												$elm$html$Html$input,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$placeholder('Enter a number'),
														$elm$html$Html$Events$onInput($author$project$Starplot$InputChange2)
													]),
												_List_Nil),
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Events$onClick($author$project$Starplot$SubmitNumber2)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text('Submit for SP2')
													]))
											]));
								}
							}()
							]))
					]));
		});
	var starplotData2 = A2($author$project$Starplot$findSmartphoneById, model, model.starplotOption.modelID2);
	var starplotData1 = A2($author$project$Starplot$findSmartphoneById, model, model.starplotOption.modelID1);
	var smartphoneFunctions = _List_fromArray(
		[
			function ($) {
			return $.price;
		},
			function ($) {
			return $.rating;
		},
			function ($) {
			return $.num_cores;
		},
			function ($) {
			return $.processor_speed;
		},
			function ($) {
			return $.battery;
		},
			function ($) {
			return $.fast_charging;
		},
			function ($) {
			return $.memory;
		},
			function ($) {
			return $.ram;
		},
			function ($) {
			return $.screen_size;
		},
			function ($) {
			return $.refresh_rate;
		}
		]);
	var maxValues = A2(
		$elm$core$List$map,
		$author$project$Starplot$findMaxValue(model),
		smartphoneFunctions);
	var starValues1 = A3(
		$elm$core$List$map2,
		$author$project$Starplot$calculateStarValue(starplotData1),
		maxValues,
		smartphoneFunctions);
	var starValues2 = A3(
		$elm$core$List$map2,
		$author$project$Starplot$calculateStarValue(starplotData2),
		maxValues,
		smartphoneFunctions);
	var labels = _List_fromArray(
		['Price', 'Rating', 'NumCores', 'Processor Speed', 'Battery', 'Fast Charging', 'Memory', 'RAM', 'Screen Size', 'Refresh Rate']);
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(starplotViewHead, starplotData1, starplotData2),
				function () {
				if (starplotData1.$ === 'Just') {
					var spd1 = starplotData1.a;
					return A5($author$project$Starplot$starplot, spd1, starValues1, labels, unit, smartphoneFunctions);
				} else {
					return A2(
						$elm$html$Html$div,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Error: Starplot1 kann nicht dargestellt werden, da zu dieser ID (' + (model.starplotOption.modelID1 + ') keine Data vorliegen Probiere Sie eine andere ID aus. Die ID muss eine Nummer sein.'))
							]));
				}
			}(),
				function () {
				if (starplotData2.$ === 'Just') {
					var spd2 = starplotData2.a;
					return A5($author$project$Starplot$starplot, spd2, starValues2, labels, unit, smartphoneFunctions);
				} else {
					return A2(
						$elm$html$Html$div,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Error: Starplot2 kann nicht dargestellt werden, da zu dieser ID (' + (model.starplotOption.modelID2 + ') keine Data vorliegen Probiere Sie eine andere ID aus. Die ID muss eine Nummer sein.'))
							]));
				}
			}()
			]));
};
var $author$project$TreeView$Set5GTree = function (a) {
	return {$: 'Set5GTree', a: a};
};
var $author$project$TreeView$SetBrandTree = function (a) {
	return {$: 'SetBrandTree', a: a};
};
var $author$project$TreeView$SetDropCount = {$: 'SetDropCount'};
var $author$project$TreeView$SetDropCountInput = function (a) {
	return {$: 'SetDropCountInput', a: a};
};
var $author$project$TreeView$SetIRBlasterTree = function (a) {
	return {$: 'SetIRBlasterTree', a: a};
};
var $author$project$TreeView$SetNFCTree = function (a) {
	return {$: 'SetNFCTree', a: a};
};
var $author$project$TreeView$createSelectorOptions = F2(
	function (select, valueOption) {
		return _Utils_eq(select, valueOption) ? A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(valueOption),
					$elm$html$Html$Attributes$selected(true)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(valueOption)
				])) : A2(
			$elm$html$Html$option,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$value(valueOption)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(valueOption)
				]));
	});
var $author$project$TreeView$ZoomMsg = function (a) {
	return {$: 'ZoomMsg', a: a};
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$cubicCurveTo = $folkertdev$one_true_path_experiment$LowLevel$Command$CurveTo;
var $gampleman$elm_visualization$Shape$Bump$bumpYCurve = function (points) {
	if (!points.b) {
		return $folkertdev$one_true_path_experiment$SubPath$empty;
	} else {
		var first = points.a;
		var rest = points.b;
		return A2(
			$folkertdev$one_true_path_experiment$SubPath$with,
			$folkertdev$one_true_path_experiment$LowLevel$Command$moveTo(first),
			_List_fromArray(
				[
					$folkertdev$one_true_path_experiment$LowLevel$Command$cubicCurveTo(
					$elm$core$List$reverse(
						A3(
							$elm$core$List$foldl,
							F2(
								function (_v1, _v2) {
									var x = _v1.a;
									var y = _v1.b;
									var _v3 = _v2.a;
									var x0 = _v3.a;
									var y0 = _v3.b;
									var soFar = _v2.b;
									var y1 = (y0 + y) / 2;
									return _Utils_Tuple2(
										_Utils_Tuple2(x, y),
										A2(
											$elm$core$List$cons,
											_Utils_Tuple3(
												_Utils_Tuple2(x0, y1),
												_Utils_Tuple2(x, y1),
												_Utils_Tuple2(x, y)),
											soFar));
								}),
							_Utils_Tuple2(first, _List_Nil),
							rest).b))
				]));
	}
};
var $gampleman$elm_visualization$Shape$bumpYCurve = $gampleman$elm_visualization$Shape$Bump$bumpYCurve;
var $gampleman$elm_visualization$Zoom$DoubleClicked = F2(
	function (a, b) {
		return {$: 'DoubleClicked', a: a, b: b};
	});
var $elm$json$Json$Decode$bool = _Json_decodeBool;
var $elm$virtual_dom$VirtualDom$Custom = function (a) {
	return {$: 'Custom', a: a};
};
var $elm$html$Html$Events$custom = F2(
	function (event, decoder) {
		return A2(
			$elm$virtual_dom$VirtualDom$on,
			event,
			$elm$virtual_dom$VirtualDom$Custom(decoder));
	});
var $elm$svg$Svg$Events$custom = $elm$html$Html$Events$custom;
var $gampleman$elm_visualization$Events$Rect = F4(
	function (x, y, width, height) {
		return {height: height, width: width, x: x, y: y};
	});
var $elm$json$Json$Decode$map4 = _Json_map4;
var $gampleman$elm_visualization$Events$decodeRect = A5(
	$elm$json$Json$Decode$map4,
	$gampleman$elm_visualization$Events$Rect,
	A2($elm$json$Json$Decode$field, 'x', $elm$json$Json$Decode$float),
	A2($elm$json$Json$Decode$field, 'y', $elm$json$Json$Decode$float),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$float),
	A2($elm$json$Json$Decode$field, 'height', $elm$json$Json$Decode$float));
var $elm$json$Json$Decode$map3 = _Json_map3;
var $elm$json$Json$Decode$oneOf = _Json_oneOf;
var $gampleman$elm_visualization$Events$decodeSVGTransformMatrix = $elm$json$Json$Decode$oneOf(
	_List_fromArray(
		[
			A4(
			$elm$json$Json$Decode$map3,
			F3(
				function (viewBox, width, height) {
					return $elm$core$Maybe$Just(
						_Utils_Tuple2(
							_Utils_Tuple3(viewBox.width / width, 0, 0),
							_Utils_Tuple3(0, viewBox.height / height, 0)));
				}),
			A2(
				$elm$json$Json$Decode$at,
				_List_fromArray(
					['currentTarget', 'viewBox', 'baseVal']),
				$gampleman$elm_visualization$Events$decodeRect),
			A2(
				$elm$json$Json$Decode$at,
				_List_fromArray(
					['currentTarget', 'width', 'baseVal', 'value']),
				$elm$json$Json$Decode$float),
			A2(
				$elm$json$Json$Decode$at,
				_List_fromArray(
					['currentTarget', 'height', 'baseVal', 'value']),
				$elm$json$Json$Decode$float)),
			$elm$json$Json$Decode$succeed($elm$core$Maybe$Nothing)
		]));
var $gampleman$elm_visualization$Events$decodeMousePosition = A4(
	$elm$json$Json$Decode$map3,
	F3(
		function (maybeMatrix, x, y) {
			return A2(
				$gampleman$elm_visualization$Events$normalizePointerPosition,
				_Utils_Tuple2(x, y),
				maybeMatrix);
		}),
	$gampleman$elm_visualization$Events$decodeSVGTransformMatrix,
	$elm$json$Json$Decode$oneOf(
		_List_fromArray(
			[
				A2($elm$json$Json$Decode$field, 'offsetX', $elm$json$Json$Decode$float),
				A2($elm$json$Json$Decode$field, 'clientX', $elm$json$Json$Decode$float)
			])),
	$elm$json$Json$Decode$oneOf(
		_List_fromArray(
			[
				A2($elm$json$Json$Decode$field, 'offsetY', $elm$json$Json$Decode$float),
				A2($elm$json$Json$Decode$field, 'clientY', $elm$json$Json$Decode$float)
			])));
var $gampleman$elm_visualization$Zoom$onDoubleClick = F2(
	function (_v0, tagger) {
		return A2(
			$elm$svg$Svg$Events$custom,
			'dblclick',
			A3(
				$elm$json$Json$Decode$map2,
				F2(
					function (shiftDown, position) {
						return {
							message: tagger(
								A2($gampleman$elm_visualization$Zoom$DoubleClicked, shiftDown, position)),
							preventDefault: true,
							stopPropagation: true
						};
					}),
				A2($elm$json$Json$Decode$field, 'shiftKey', $elm$json$Json$Decode$bool),
				$gampleman$elm_visualization$Events$decodeMousePosition));
	});
var $gampleman$elm_visualization$Zoom$MouseDown = F2(
	function (a, b) {
		return {$: 'MouseDown', a: a, b: b};
	});
var $gampleman$elm_visualization$Zoom$onDrag = F2(
	function (_v0, tagger) {
		var drag = _v0.a.drag;
		if (drag.$ === 'Nothing') {
			return _List_fromArray(
				[
					A2(
					$elm$svg$Svg$Events$custom,
					'mousedown',
					A4(
						$elm$json$Json$Decode$map3,
						F3(
							function (x, y, matrix) {
								return {
									message: tagger(
										A2(
											$gampleman$elm_visualization$Zoom$MouseDown,
											_Utils_Tuple2(x, y),
											matrix)),
									preventDefault: false,
									stopPropagation: true
								};
							}),
						A2($elm$json$Json$Decode$field, 'clientX', $elm$json$Json$Decode$float),
						A2($elm$json$Json$Decode$field, 'clientY', $elm$json$Json$Decode$float),
						$gampleman$elm_visualization$Events$decodeSVGTransformMatrix))
				]);
		} else {
			return _List_Nil;
		}
	});
var $gampleman$elm_visualization$Zoom$GestureStarted = {$: 'GestureStarted'};
var $gampleman$elm_visualization$Zoom$Gestured = F2(
	function (a, b) {
		return {$: 'Gestured', a: a, b: b};
	});
var $gampleman$elm_visualization$Zoom$onGesture = F2(
	function (_v0, tagger) {
		return _List_fromArray(
			[
				A2(
				$elm$svg$Svg$Events$custom,
				'gesturestart',
				$elm$json$Json$Decode$succeed(
					{
						message: tagger($gampleman$elm_visualization$Zoom$GestureStarted),
						preventDefault: true,
						stopPropagation: true
					})),
				A2(
				$elm$svg$Svg$Events$custom,
				'gesturechange',
				A3(
					$elm$json$Json$Decode$map2,
					F2(
						function (scl, position) {
							return {
								message: tagger(
									A2($gampleman$elm_visualization$Zoom$Gestured, scl, position)),
								preventDefault: true,
								stopPropagation: true
							};
						}),
					A2($elm$json$Json$Decode$field, 'scale', $elm$json$Json$Decode$float),
					$gampleman$elm_visualization$Events$decodeMousePosition))
			]);
	});
var $gampleman$elm_visualization$Zoom$TouchEnded = function (a) {
	return {$: 'TouchEnded', a: a};
};
var $gampleman$elm_visualization$Zoom$TouchMoved = function (a) {
	return {$: 'TouchMoved', a: a};
};
var $gampleman$elm_visualization$Zoom$TouchStarted = function (a) {
	return {$: 'TouchStarted', a: a};
};
var $elm$json$Json$Decode$andThen = _Json_andThen;
var $elm$json$Json$Decode$int = _Json_decodeInt;
var $gampleman$elm_visualization$Events$listLike = function (itemDecoder) {
	var decodeOne = function (n) {
		return A2(
			$elm$json$Json$Decode$field,
			$elm$core$String$fromInt(n),
			itemDecoder);
	};
	var decodeN = function (n) {
		return A3(
			$elm$core$List$foldr,
			$elm$json$Json$Decode$map2($elm$core$List$cons),
			$elm$json$Json$Decode$succeed(_List_Nil),
			A2(
				$elm$core$List$map,
				decodeOne,
				A2($elm$core$List$range, 0, n - 1)));
	};
	return A2(
		$elm$json$Json$Decode$andThen,
		decodeN,
		A2($elm$json$Json$Decode$field, 'length', $elm$json$Json$Decode$int));
};
var $gampleman$elm_visualization$Events$decodeTouches = A2(
	$elm$json$Json$Decode$andThen,
	function (maybeMatrix) {
		return A2(
			$elm$json$Json$Decode$field,
			'changedTouches',
			$gampleman$elm_visualization$Events$listLike(
				A4(
					$elm$json$Json$Decode$map3,
					F3(
						function (x, y, identifier) {
							return {
								identifier: identifier,
								position: A2(
									$gampleman$elm_visualization$Events$normalizePointerPosition,
									_Utils_Tuple2(x, y),
									maybeMatrix)
							};
						}),
					A2($elm$json$Json$Decode$field, 'clientX', $elm$json$Json$Decode$float),
					A2($elm$json$Json$Decode$field, 'clientY', $elm$json$Json$Decode$float),
					A2($elm$json$Json$Decode$field, 'identifier', $elm$json$Json$Decode$int))));
	},
	$gampleman$elm_visualization$Events$decodeSVGTransformMatrix);
var $elm$virtual_dom$VirtualDom$style = _VirtualDom_style;
var $elm$html$Html$Attributes$style = $elm$virtual_dom$VirtualDom$style;
var $gampleman$elm_visualization$Zoom$onTouch = F2(
	function (_v0, tagger) {
		var zoom = _v0.a;
		return _List_fromArray(
			[
				A2(
				$elm$svg$Svg$Events$custom,
				'touchstart',
				A2(
					$elm$json$Json$Decode$map,
					function (touches) {
						var _v1 = _Utils_Tuple3(zoom.touchStarted, touches, zoom.touches);
						if (((_v1.a && _v1.b.b) && (!_v1.b.b.b)) && (_v1.c.$ === 'NoTouches')) {
							var _v2 = _v1.b;
							var touch0 = _v2.a;
							var _v3 = _v1.c;
							return {
								message: tagger(
									A2($gampleman$elm_visualization$Zoom$DoubleClicked, false, touch0.position)),
								preventDefault: true,
								stopPropagation: true
							};
						} else {
							return {
								message: tagger(
									$gampleman$elm_visualization$Zoom$TouchStarted(touches)),
								preventDefault: false,
								stopPropagation: true
							};
						}
					},
					$gampleman$elm_visualization$Events$decodeTouches)),
				A2(
				$elm$svg$Svg$Events$custom,
				'touchmove',
				A2(
					$elm$json$Json$Decode$map,
					function (touches) {
						return {
							message: tagger(
								$gampleman$elm_visualization$Zoom$TouchMoved(touches)),
							preventDefault: true,
							stopPropagation: true
						};
					},
					$gampleman$elm_visualization$Events$decodeTouches)),
				A2(
				$elm$svg$Svg$Events$custom,
				'touchend',
				A2(
					$elm$json$Json$Decode$map,
					function (touches) {
						return {
							message: tagger(
								$gampleman$elm_visualization$Zoom$TouchEnded(touches)),
							preventDefault: false,
							stopPropagation: true
						};
					},
					$gampleman$elm_visualization$Events$decodeTouches)),
				A2(
				$elm$svg$Svg$Events$custom,
				'touchcancel',
				A2(
					$elm$json$Json$Decode$map,
					function (touches) {
						return {
							message: tagger(
								$gampleman$elm_visualization$Zoom$TouchEnded(touches)),
							preventDefault: false,
							stopPropagation: true
						};
					},
					$gampleman$elm_visualization$Events$decodeTouches)),
				A2($elm$html$Html$Attributes$style, 'touch-action', 'none'),
				A2($elm$html$Html$Attributes$style, '-webkit-tap-highlight-color', 'rgba(0,0,0,0)')
			]);
	});
var $gampleman$elm_visualization$Zoom$Wheeled = F2(
	function (a, b) {
		return {$: 'Wheeled', a: a, b: b};
	});
var $gampleman$elm_visualization$Zoom$onWheel = F2(
	function (_v0, tagger) {
		return A2(
			$elm$svg$Svg$Events$custom,
			'wheel',
			A4(
				$elm$json$Json$Decode$map3,
				F3(
					function (deltaY, deltaMode, position) {
						return {
							message: tagger(
								A2(
									$gampleman$elm_visualization$Zoom$Wheeled,
									(-deltaY) * ((!deltaMode) ? 0.002 : ((deltaMode === 1) ? 0.05 : 1)),
									position)),
							preventDefault: true,
							stopPropagation: true
						};
					}),
				A2($elm$json$Json$Decode$field, 'deltaY', $elm$json$Json$Decode$float),
				A2($elm$json$Json$Decode$field, 'deltaMode', $elm$json$Json$Decode$int),
				$gampleman$elm_visualization$Events$decodeMousePosition));
	});
var $gampleman$elm_visualization$Zoom$events = F2(
	function (zoom, tagger) {
		return A2(
			$elm$core$List$cons,
			A2($gampleman$elm_visualization$Zoom$onDoubleClick, zoom, tagger),
			A2(
				$elm$core$List$cons,
				A2($gampleman$elm_visualization$Zoom$onWheel, zoom, tagger),
				_Utils_ap(
					A2($gampleman$elm_visualization$Zoom$onDrag, zoom, tagger),
					_Utils_ap(
						A2($gampleman$elm_visualization$Zoom$onGesture, zoom, tagger),
						A2($gampleman$elm_visualization$Zoom$onTouch, zoom, tagger)))));
	});
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$height = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$height(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $author$project$TreeView$Click = function (a) {
	return {$: 'Click', a: a};
};
var $elm_community$typed_svg$TypedSvg$Types$ClipPathFunc = function (a) {
	return {$: 'ClipPathFunc', a: a};
};
var $author$project$TreeView$SetStarPlotFromTree = function (a) {
	return {$: 'SetStarPlotFromTree', a: a};
};
var $elm_community$typed_svg$TypedSvg$clipPath = $elm_community$typed_svg$TypedSvg$Core$node('clipPath');
var $elm_community$typed_svg$TypedSvg$TypesToStrings$clipPathToString = function (clipPath) {
	switch (clipPath.$) {
		case 'ClipPathNone':
			return 'none';
		case 'ClipPathInherit':
			return 'inherit';
		default:
			var value = clipPath.a;
			return value;
	}
};
var $elm_community$typed_svg$TypedSvg$Attributes$clipPath = function (cPath) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'clip-path',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$clipPathToString(cPath));
};
var $elm_community$typed_svg$TypedSvg$Attributes$dy = function (length) {
	return A2(
		$elm_community$typed_svg$TypedSvg$Core$attribute,
		'dy',
		$elm_community$typed_svg$TypedSvg$TypesToStrings$lengthToString(length));
};
var $elm_community$typed_svg$TypedSvg$Types$Em = function (a) {
	return {$: 'Em', a: a};
};
var $elm_community$typed_svg$TypedSvg$Types$em = $elm_community$typed_svg$TypedSvg$Types$Em;
var $elm$core$String$foldl = _String_foldl;
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$fontSize = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$fontSize(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $elm$core$String$fromList = _String_fromList;
var $elm_community$typed_svg$TypedSvg$Attributes$href = $elm_community$typed_svg$TypedSvg$Core$attribute('href');
var $elm_community$typed_svg$TypedSvg$Attributes$id = $elm_community$typed_svg$TypedSvg$Core$attribute('id');
var $elm_community$list_extra$List$Extra$last = function (items) {
	last:
	while (true) {
		if (!items.b) {
			return $elm$core$Maybe$Nothing;
		} else {
			if (!items.b.b) {
				var x = items.a;
				return $elm$core$Maybe$Just(x);
			} else {
				var rest = items.b;
				var $temp$items = rest;
				items = $temp$items;
				continue last;
			}
		}
	}
};
var $folkertdev$one_true_path_experiment$LowLevel$Command$closePath = $folkertdev$one_true_path_experiment$LowLevel$Command$ClosePath;
var $folkertdev$one_true_path_experiment$Curve$linearClosed = function (points) {
	if (!points.b) {
		return $folkertdev$one_true_path_experiment$SubPath$empty;
	} else {
		var x = points.a;
		var xs = points.b;
		return A2(
			$folkertdev$one_true_path_experiment$SubPath$with,
			$folkertdev$one_true_path_experiment$LowLevel$Command$moveTo(x),
			_List_fromArray(
				[
					$folkertdev$one_true_path_experiment$LowLevel$Command$lineTo(xs),
					$folkertdev$one_true_path_experiment$LowLevel$Command$closePath
				]));
	}
};
var $elm_community$typed_svg$TypedSvg$Events$on = $elm$virtual_dom$VirtualDom$on;
var $elm_community$typed_svg$TypedSvg$Events$simpleOn = function (name) {
	return function (msg) {
		return A2(
			$elm_community$typed_svg$TypedSvg$Events$on,
			name,
			$elm$virtual_dom$VirtualDom$Normal(
				$elm$json$Json$Decode$succeed(msg)));
	};
};
var $elm_community$typed_svg$TypedSvg$Events$onClick = $elm_community$typed_svg$TypedSvg$Events$simpleOn('click');
var $elm_community$typed_svg$TypedSvg$Attributes$pointerEvents = $elm_community$typed_svg$TypedSvg$Core$attribute('pointer-events');
var $avh4$elm_color$Color$rgb = F3(
	function (r, g, b) {
		return A4($avh4$elm_color$Color$RgbaSpace, r, g, b, 1.0);
	});
var $elm_community$typed_svg$TypedSvg$Attributes$style = function (value) {
	return A2($elm_community$typed_svg$TypedSvg$Core$attribute, 'style', value);
};
var $elm_community$typed_svg$TypedSvg$title = $elm_community$typed_svg$TypedSvg$Core$node('title');
var $elm_community$typed_svg$TypedSvg$tspan = $elm_community$typed_svg$TypedSvg$Core$node('tspan');
var $elm_community$typed_svg$TypedSvg$use = $elm_community$typed_svg$TypedSvg$Core$node('use');
var $author$project$TreeView$label = function (item) {
	var _v0 = item.node.kind;
	if (_v0.$ === 'Leaf') {
		return A2(
			$elm_community$typed_svg$TypedSvg$g,
			_List_fromArray(
				[
					$elm_community$typed_svg$TypedSvg$Attributes$transform(
					_List_fromArray(
						[
							A2($elm_community$typed_svg$TypedSvg$Types$Translate, item.x, item.y)
						])),
					$elm$html$Html$Events$onClick(
					$author$project$TreeView$SetStarPlotFromTree(item.node.id))
				]),
			_List_fromArray(
				[
					A2(
					$folkertdev$one_true_path_experiment$Path$element,
					_List_fromArray(
						[
							$folkertdev$one_true_path_experiment$Curve$linearClosed(
							_List_fromArray(
								[
									_Utils_Tuple2(0, item.height),
									_Utils_Tuple2(0, 0),
									_Utils_Tuple2(item.width, 0),
									_Utils_Tuple2(item.width, item.height)
								]))
						]),
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$fill(
							$elm_community$typed_svg$TypedSvg$Types$Paint(
								A3($avh4$elm_color$Color$rgb, 1, 1, 0.8))),
							$elm_community$typed_svg$TypedSvg$Attributes$stroke(
							$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$black)),
							$elm_community$typed_svg$TypedSvg$Attributes$style('vector-effect: non-scaling-stroke'),
							$elm_community$typed_svg$TypedSvg$Attributes$id('path-' + item.node.name)
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$title,
					_List_Nil,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Core$text(
							item.node.name + (' - ' + ($elm$core$String$fromFloat(item.node.size) + ' loc')))
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$clipPath,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$id('clip-' + item.node.name)
						]),
					_List_fromArray(
						[
							A2(
							$elm_community$typed_svg$TypedSvg$use,
							_List_fromArray(
								[
									$elm_community$typed_svg$TypedSvg$Attributes$href('#path-' + item.node.name)
								]),
							_List_Nil)
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$fontSize(
							$elm$core$Basics$sqrt(item.node.size) / 130),
							$elm_community$typed_svg$TypedSvg$Attributes$pointerEvents('none'),
							$elm_community$typed_svg$TypedSvg$Attributes$clipPath(
							$elm_community$typed_svg$TypedSvg$Types$ClipPathFunc('url(#clip-' + (item.node.name + ')')))
						]),
					A2(
						$elm$core$List$indexedMap,
						F2(
							function (i, st) {
								return A2(
									$elm_community$typed_svg$TypedSvg$tspan,
									_List_fromArray(
										[
											$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(item.width * 0.05),
											$elm_community$typed_svg$TypedSvg$Attributes$y(
											$elm_community$typed_svg$TypedSvg$Types$em(2 + (i * 0.9)))
										]),
									_List_fromArray(
										[
											$elm_community$typed_svg$TypedSvg$Core$text(st)
										]));
							}),
						$elm$core$List$reverse(
							function (_v3) {
								var word = _v3.a;
								var soFar = _v3.b;
								return A2(
									$elm$core$List$cons,
									$elm$core$String$fromList(
										$elm$core$List$reverse(word)),
									soFar);
							}(
								A3(
									$elm$core$String$foldl,
									F2(
										function (c, _v1) {
											var word = _v1.a;
											var soFar = _v1.b;
											return ($elm$core$Char$toCode(c) === 32) ? _Utils_Tuple2(
												_List_fromArray(
													[c]),
												function () {
													if (!word.b) {
														return soFar;
													} else {
														return A2(
															$elm$core$List$cons,
															$elm$core$String$fromList(
																$elm$core$List$reverse(word)),
															soFar);
													}
												}()) : _Utils_Tuple2(
												A2($elm$core$List$cons, c, word),
												soFar);
										}),
									_Utils_Tuple2(_List_Nil, _List_Nil),
									A2(
										$elm$core$Maybe$withDefault,
										item.node.name,
										$elm$core$List$head(
											$elm$core$List$reverse(
												A2($elm$core$String$split, '.', item.node.name)))))))))
				]));
	} else {
		return A2(
			$elm_community$typed_svg$TypedSvg$g,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$folkertdev$one_true_path_experiment$Path$element,
					_List_fromArray(
						[
							$folkertdev$one_true_path_experiment$Curve$linearClosed(
							_List_fromArray(
								[
									_Utils_Tuple2(item.x, item.y + item.height),
									_Utils_Tuple2(item.x, item.y + (item.height * 0.1)),
									_Utils_Tuple2(item.x + (item.width * 0.45), item.y + (item.height * 0.1)),
									_Utils_Tuple2(item.x + item.width, item.y + (item.height * 0.1)),
									_Utils_Tuple2(item.x + item.width, item.y + item.height)
								]))
						]),
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$fill(
							$elm_community$typed_svg$TypedSvg$Types$Paint(
								A3($avh4$elm_color$Color$rgb, 0.8, 0.9, 1))),
							$elm_community$typed_svg$TypedSvg$Attributes$stroke(
							$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$black)),
							$elm_community$typed_svg$TypedSvg$Attributes$style('vector-effect: non-scaling-stroke'),
							$elm_community$typed_svg$TypedSvg$Events$onClick(
							$author$project$TreeView$Click(item))
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$title,
					_List_Nil,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Core$text(
							item.node.name + (' - ' + ($elm$core$String$fromFloat(item.node.size) + ' loc')))
						])),
					A2(
					$elm_community$typed_svg$TypedSvg$text_,
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Attributes$textAnchor($elm_community$typed_svg$TypedSvg$Types$AnchorMiddle),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$fontSize(
							$elm$core$Basics$sqrt(item.node.size) / 110),
							$elm_community$typed_svg$TypedSvg$Attributes$pointerEvents('none'),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$x(item.x + (item.width / 2)),
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$y(item.y + (item.height / 2)),
							$elm_community$typed_svg$TypedSvg$Attributes$dy(
							$elm_community$typed_svg$TypedSvg$Types$em(0.3))
						]),
					_List_fromArray(
						[
							$elm_community$typed_svg$TypedSvg$Core$text(
							A2(
								$elm$core$Maybe$withDefault,
								'',
								$elm_community$list_extra$List$Extra$last(
									A2($elm$core$String$split, '.', item.node.name))))
						]))
				]));
	}
};
var $author$project$TreeView$maxBBoxes = F2(
	function (a, b) {
		var y = A2($elm$core$Basics$min, a.y, b.y);
		var x = A2($elm$core$Basics$min, a.x, b.x);
		return {
			height: A2($elm$core$Basics$max, a.y + a.height, b.y + b.height) - y,
			width: A2($elm$core$Basics$max, a.x + a.width, b.x + b.width) - x,
			x: x,
			y: y
		};
	});
var $gampleman$elm_visualization$Hierarchy$NodeSize = function (a) {
	return {$: 'NodeSize', a: a};
};
var $gampleman$elm_visualization$Hierarchy$nodeSize = $gampleman$elm_visualization$Hierarchy$NodeSize;
var $gampleman$elm_visualization$Hierarchy$ParentChildMargin = function (a) {
	return {$: 'ParentChildMargin', a: a};
};
var $gampleman$elm_visualization$Hierarchy$parentChildMargin = $gampleman$elm_visualization$Hierarchy$ParentChildMargin;
var $gampleman$elm_visualization$Hierarchy$PeerMargin = function (a) {
	return {$: 'PeerMargin', a: a};
};
var $gampleman$elm_visualization$Hierarchy$peerMargin = $gampleman$elm_visualization$Hierarchy$PeerMargin;
var $gampleman$elm_visualization$Hierarchy$Size = F2(
	function (a, b) {
		return {$: 'Size', a: a, b: b};
	});
var $gampleman$elm_visualization$Hierarchy$size = $gampleman$elm_visualization$Hierarchy$Size;
var $gampleman$elm_rosetree$Tree$defaultTopDown = F4(
	function (s, _v0, l, c) {
		return _Utils_Tuple3(s, l, c);
	});
var $gampleman$elm_rosetree$Tree$depthFirstTraversalHelp = F5(
	function (fLabel, fTree, state, acc, stack) {
		depthFirstTraversalHelp:
		while (true) {
			var _v0 = acc.todo;
			if (!_v0.b) {
				var _v1 = A4(
					fTree,
					state,
					A2(
						$elm$core$List$map,
						function ($) {
							return $.label;
						},
						stack),
					acc.label,
					$elm$core$List$reverse(acc.done));
				var state_ = _v1.a;
				var node = _v1.b;
				if (!stack.b) {
					return _Utils_Tuple2(state_, node);
				} else {
					var top = stack.a;
					var rest = stack.b;
					var $temp$fLabel = fLabel,
						$temp$fTree = fTree,
						$temp$state = state_,
						$temp$acc = _Utils_update(
						top,
						{
							done: A2($elm$core$List$cons, node, top.done)
						}),
						$temp$stack = rest;
					fLabel = $temp$fLabel;
					fTree = $temp$fTree;
					state = $temp$state;
					acc = $temp$acc;
					stack = $temp$stack;
					continue depthFirstTraversalHelp;
				}
			} else {
				var _v3 = _v0.a;
				var l = _v3.a;
				var chs = _v3.b;
				var rest = _v0.b;
				var ancestors = A2(
					$elm$core$List$cons,
					acc.label,
					A2(
						$elm$core$List$map,
						function ($) {
							return $.label;
						},
						stack));
				var _v4 = A4(fLabel, state, ancestors, l, chs);
				var state0 = _v4.a;
				var label_ = _v4.b;
				var children_ = _v4.c;
				if (!children_.b) {
					var _v6 = A4(fTree, state0, ancestors, label_, _List_Nil);
					var state_ = _v6.a;
					var newTree = _v6.b;
					var $temp$fLabel = fLabel,
						$temp$fTree = fTree,
						$temp$state = state_,
						$temp$acc = _Utils_update(
						acc,
						{
							done: A2($elm$core$List$cons, newTree, acc.done),
							todo: rest
						}),
						$temp$stack = stack;
					fLabel = $temp$fLabel;
					fTree = $temp$fTree;
					state = $temp$state;
					acc = $temp$acc;
					stack = $temp$stack;
					continue depthFirstTraversalHelp;
				} else {
					var cs = children_;
					var $temp$fLabel = fLabel,
						$temp$fTree = fTree,
						$temp$state = state0,
						$temp$acc = {done: _List_Nil, label: label_, todo: cs},
						$temp$stack = A2(
						$elm$core$List$cons,
						_Utils_update(
							acc,
							{todo: rest}),
						stack);
					fLabel = $temp$fLabel;
					fTree = $temp$fTree;
					state = $temp$state;
					acc = $temp$acc;
					stack = $temp$stack;
					continue depthFirstTraversalHelp;
				}
			}
		}
	});
var $gampleman$elm_rosetree$Tree$depthFirstTraversal = F4(
	function (convertLabel, convertTree, s, _v0) {
		var l = _v0.a;
		var c = _v0.b;
		var _v1 = A4(convertLabel, s, _List_Nil, l, c);
		var state_ = _v1.a;
		var label_ = _v1.b;
		var children_ = _v1.c;
		return A5(
			$gampleman$elm_rosetree$Tree$depthFirstTraversalHelp,
			convertLabel,
			convertTree,
			state_,
			{done: _List_Nil, label: label_, todo: children_},
			_List_Nil);
	});
var $gampleman$elm_rosetree$Tree$label = function (_v0) {
	var v = _v0.a;
	return v;
};
var $gampleman$elm_rosetree$Tree$Tree = F2(
	function (a, b) {
		return {$: 'Tree', a: a, b: b};
	});
var $gampleman$elm_rosetree$Tree$singleton = function (v) {
	return A2($gampleman$elm_rosetree$Tree$Tree, v, _List_Nil);
};
var $gampleman$elm_rosetree$Tree$tree = $gampleman$elm_rosetree$Tree$Tree;
var $gampleman$elm_rosetree$Tree$sumUp = F3(
	function (leaf, branch, t) {
		return A4(
			$gampleman$elm_rosetree$Tree$depthFirstTraversal,
			$gampleman$elm_rosetree$Tree$defaultTopDown,
			F4(
				function (s, _v0, l, c) {
					return _Utils_Tuple2(
						s,
						function () {
							if (!c.b) {
								return $gampleman$elm_rosetree$Tree$singleton(
									leaf(l));
							} else {
								return A2(
									$gampleman$elm_rosetree$Tree$tree,
									A2(
										branch,
										l,
										A2($elm$core$List$map, $gampleman$elm_rosetree$Tree$label, c)),
									c);
							}
						}());
				}),
			_Utils_Tuple0,
			t).b;
	});
var $gampleman$elm_rosetree$Tree$Continue = function (a) {
	return {$: 'Continue', a: a};
};
var $gampleman$elm_rosetree$Tree$depthFirstFoldHelp = F5(
	function (f, acc, parents, trees, nextSets) {
		depthFirstFoldHelp:
		while (true) {
			if (!trees.b) {
				if (nextSets.b) {
					var _v2 = nextSets.a;
					var p = _v2.a;
					var set = _v2.b;
					var sets = nextSets.b;
					var $temp$f = f,
						$temp$acc = acc,
						$temp$parents = p,
						$temp$trees = set,
						$temp$nextSets = sets;
					f = $temp$f;
					acc = $temp$acc;
					parents = $temp$parents;
					trees = $temp$trees;
					nextSets = $temp$nextSets;
					continue depthFirstFoldHelp;
				} else {
					return acc;
				}
			} else {
				var _v3 = trees.a;
				var d = _v3.a;
				var ch = _v3.b;
				var rest = trees.b;
				var _v4 = A4(f, acc, parents, d, ch);
				if (_v4.$ === 'Continue') {
					var a = _v4.a;
					if (!ch.b) {
						var $temp$f = f,
							$temp$acc = a,
							$temp$parents = parents,
							$temp$trees = rest,
							$temp$nextSets = nextSets;
						f = $temp$f;
						acc = $temp$acc;
						parents = $temp$parents;
						trees = $temp$trees;
						nextSets = $temp$nextSets;
						continue depthFirstFoldHelp;
					} else {
						var xs = ch;
						var $temp$f = f,
							$temp$acc = a,
							$temp$parents = A2($elm$core$List$cons, d, parents),
							$temp$trees = xs,
							$temp$nextSets = A2(
							$elm$core$List$cons,
							_Utils_Tuple2(parents, rest),
							nextSets);
						f = $temp$f;
						acc = $temp$acc;
						parents = $temp$parents;
						trees = $temp$trees;
						nextSets = $temp$nextSets;
						continue depthFirstFoldHelp;
					}
				} else {
					var a = _v4.a;
					return a;
				}
			}
		}
	});
var $gampleman$elm_rosetree$Tree$depthFirstFold = F3(
	function (f, acc, t) {
		return A5(
			$gampleman$elm_rosetree$Tree$depthFirstFoldHelp,
			f,
			acc,
			_List_Nil,
			_List_fromArray(
				[t]),
			_List_Nil);
	});
var $gampleman$elm_rosetree$Tree$foldl = F3(
	function (f, acc, t) {
		return A3(
			$gampleman$elm_rosetree$Tree$depthFirstFold,
			F4(
				function (s, _v0, l, _v1) {
					return $gampleman$elm_rosetree$Tree$Continue(
						A2(f, l, s));
				}),
			acc,
			t);
	});
var $elm$core$Bitwise$shiftRightZfBy = _Bitwise_shiftRightZfBy;
var $elm$core$Array$bitMask = 4294967295 >>> (32 - $elm$core$Array$shiftStep);
var $elm$core$Elm$JsArray$unsafeGet = _JsArray_unsafeGet;
var $elm$core$Array$getHelp = F3(
	function (shift, index, tree) {
		getHelp:
		while (true) {
			var pos = $elm$core$Array$bitMask & (index >>> shift);
			var _v0 = A2($elm$core$Elm$JsArray$unsafeGet, pos, tree);
			if (_v0.$ === 'SubTree') {
				var subTree = _v0.a;
				var $temp$shift = shift - $elm$core$Array$shiftStep,
					$temp$index = index,
					$temp$tree = subTree;
				shift = $temp$shift;
				index = $temp$index;
				tree = $temp$tree;
				continue getHelp;
			} else {
				var values = _v0.a;
				return A2($elm$core$Elm$JsArray$unsafeGet, $elm$core$Array$bitMask & index, values);
			}
		}
	});
var $elm$core$Bitwise$shiftLeftBy = _Bitwise_shiftLeftBy;
var $elm$core$Array$tailIndex = function (len) {
	return (len >>> 5) << 5;
};
var $elm$core$Array$get = F2(
	function (index, _v0) {
		var len = _v0.a;
		var startShift = _v0.b;
		var tree = _v0.c;
		var tail = _v0.d;
		return ((index < 0) || (_Utils_cmp(index, len) > -1)) ? $elm$core$Maybe$Nothing : ((_Utils_cmp(
			index,
			$elm$core$Array$tailIndex(len)) > -1) ? $elm$core$Maybe$Just(
			A2($elm$core$Elm$JsArray$unsafeGet, $elm$core$Array$bitMask & index, tail)) : $elm$core$Maybe$Just(
			A3($elm$core$Array$getHelp, startShift, index, tree)));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData = F2(
	function (l, id) {
		return A2($elm$core$Array$get, id, l);
	});
var $elm$core$Elm$JsArray$foldl = _JsArray_foldl;
var $elm$core$Array$foldl = F3(
	function (func, baseCase, _v0) {
		var tree = _v0.c;
		var tail = _v0.d;
		var helper = F2(
			function (node, acc) {
				if (node.$ === 'SubTree') {
					var subTree = node.a;
					return A3($elm$core$Elm$JsArray$foldl, helper, acc, subTree);
				} else {
					var values = node.a;
					return A3($elm$core$Elm$JsArray$foldl, func, acc, values);
				}
			});
		return A3(
			$elm$core$Elm$JsArray$foldl,
			func,
			A3($elm$core$Elm$JsArray$foldl, helper, baseCase, tree),
			tail);
	});
var $elm$core$Elm$JsArray$unsafeSet = _JsArray_unsafeSet;
var $elm$core$Array$setHelp = F4(
	function (shift, index, value, tree) {
		var pos = $elm$core$Array$bitMask & (index >>> shift);
		var _v0 = A2($elm$core$Elm$JsArray$unsafeGet, pos, tree);
		if (_v0.$ === 'SubTree') {
			var subTree = _v0.a;
			var newSub = A4($elm$core$Array$setHelp, shift - $elm$core$Array$shiftStep, index, value, subTree);
			return A3(
				$elm$core$Elm$JsArray$unsafeSet,
				pos,
				$elm$core$Array$SubTree(newSub),
				tree);
		} else {
			var values = _v0.a;
			var newLeaf = A3($elm$core$Elm$JsArray$unsafeSet, $elm$core$Array$bitMask & index, value, values);
			return A3(
				$elm$core$Elm$JsArray$unsafeSet,
				pos,
				$elm$core$Array$Leaf(newLeaf),
				tree);
		}
	});
var $elm$core$Array$set = F3(
	function (index, value, array) {
		var len = array.a;
		var startShift = array.b;
		var tree = array.c;
		var tail = array.d;
		return ((index < 0) || (_Utils_cmp(index, len) > -1)) ? array : ((_Utils_cmp(
			index,
			$elm$core$Array$tailIndex(len)) > -1) ? A4(
			$elm$core$Array$Array_elm_builtin,
			len,
			startShift,
			tree,
			A3($elm$core$Elm$JsArray$unsafeSet, $elm$core$Array$bitMask & index, value, tail)) : A4(
			$elm$core$Array$Array_elm_builtin,
			len,
			startShift,
			A4($elm$core$Array$setHelp, startShift, index, value, tree),
			tail));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData = F3(
	function (fn, id, l) {
		var _v0 = A2($elm$core$Array$get, id, l);
		if (_v0.$ === 'Just') {
			var td = _v0.a;
			return A3(
				$elm$core$Array$set,
				id,
				fn(td),
				l);
		} else {
			return l;
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$addChildSpacing = F2(
	function (children, layout_) {
		return function (_v2) {
			var a = _v2.a;
			return a;
		}(
			A3(
				$elm$core$Array$foldl,
				F2(
					function (idx, _v0) {
						var lay = _v0.a;
						var speed = _v0.b;
						var delta = _v0.c;
						var _v1 = A2(
							$elm$core$Maybe$withDefault,
							_Utils_Tuple2(0, 0),
							A2(
								$elm$core$Maybe$map,
								function (c) {
									return _Utils_Tuple2(c.shiftAcceleration, c.shiftChange);
								},
								A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, idx)));
						var childShiftAcceleration = _v1.a;
						var shiftChange = _v1.b;
						return _Utils_Tuple3(
							A3(
								$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
								function (child) {
									return _Utils_update(
										child,
										{modifierToSubtree: (((child.modifierToSubtree + speed) + childShiftAcceleration) + delta) + shiftChange, shiftAcceleration: 0, shiftChange: 0});
								},
								idx,
								lay),
							speed + childShiftAcceleration,
							((delta + speed) + childShiftAcceleration) + shiftChange);
					}),
				_Utils_Tuple3(layout_, 0, 0),
				children));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$derefBottom = F2(
	function (id, l) {
		return A2(
			$elm$core$Maybe$withDefault,
			0,
			A2(
				$elm$core$Maybe$map,
				function (_v0) {
					var height = _v0.height;
					var y = _v0.y;
					return height + y;
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, l, id)));
	});
var $elm$core$Array$fromListHelp = F3(
	function (list, nodeList, nodeListSize) {
		fromListHelp:
		while (true) {
			var _v0 = A2($elm$core$Elm$JsArray$initializeFromList, $elm$core$Array$branchFactor, list);
			var jsArray = _v0.a;
			var remainingItems = _v0.b;
			if (_Utils_cmp(
				$elm$core$Elm$JsArray$length(jsArray),
				$elm$core$Array$branchFactor) < 0) {
				return A2(
					$elm$core$Array$builderToArray,
					true,
					{nodeList: nodeList, nodeListSize: nodeListSize, tail: jsArray});
			} else {
				var $temp$list = remainingItems,
					$temp$nodeList = A2(
					$elm$core$List$cons,
					$elm$core$Array$Leaf(jsArray),
					nodeList),
					$temp$nodeListSize = nodeListSize + 1;
				list = $temp$list;
				nodeList = $temp$nodeList;
				nodeListSize = $temp$nodeListSize;
				continue fromListHelp;
			}
		}
	});
var $elm$core$Array$fromList = function (list) {
	if (!list.b) {
		return $elm$core$Array$empty;
	} else {
		return A3($elm$core$Array$fromListHelp, list, _List_Nil, 0);
	}
};
var $gampleman$elm_rosetree$Tree$defaultBottomUp = F4(
	function (s, _v0, l, c) {
		return _Utils_Tuple2(
			s,
			A2($gampleman$elm_rosetree$Tree$tree, l, c));
	});
var $gampleman$elm_rosetree$Tree$mapAccumulate = F3(
	function (f, state, t) {
		return A4(
			$gampleman$elm_rosetree$Tree$depthFirstTraversal,
			F4(
				function (s, _v0, l, c) {
					var _v1 = A2(f, s, l);
					var s_ = _v1.a;
					var l_ = _v1.b;
					return _Utils_Tuple3(s_, l_, c);
				}),
			$gampleman$elm_rosetree$Tree$defaultBottomUp,
			state,
			t);
	});
var $gampleman$elm_rosetree$Tree$indexedMap = F2(
	function (f, t) {
		return A3(
			$gampleman$elm_rosetree$Tree$mapAccumulate,
			F2(
				function (idx, elem) {
					return _Utils_Tuple2(
						idx + 1,
						A2(f, idx, elem));
				}),
			0,
			t).b;
	});
var $elm$core$List$sortBy = _List_sortBy;
var $gampleman$elm_visualization$Hierarchy$Tidy$initialize = F2(
	function (nodeSize, tree) {
		return $elm$core$Array$fromList(
			A2(
				$elm$core$List$sortBy,
				function ($) {
					return $.id;
				},
				A3(
					$gampleman$elm_rosetree$Tree$depthFirstFold,
					F4(
						function (lst, _v0, node, children) {
							var _v1 = nodeSize(node.b);
							var w = _v1.a;
							var h = _v1.b;
							return $gampleman$elm_rosetree$Tree$Continue(
								A2(
									$elm$core$List$cons,
									{
										children: $elm$core$Array$fromList(
											A2(
												$elm$core$List$map,
												A2($elm$core$Basics$composeR, $gampleman$elm_rosetree$Tree$label, $elm$core$Tuple$first),
												children)),
										extremeLeft: -1,
										extremeRight: -1,
										height: h,
										id: node.a,
										modifierExtremeLeft: 0,
										modifierExtremeRight: 0,
										modifierThreadLeft: 0,
										modifierThreadRight: 0,
										modifierToSubtree: 0,
										relativeX: 0,
										relativeY: 0,
										shiftAcceleration: 0,
										shiftChange: 0,
										threadLeft: -1,
										threadRight: -1,
										value: node.b,
										width: w,
										x: 0,
										y: 0
									},
									lst));
						}),
					_List_Nil,
					A2($gampleman$elm_rosetree$Tree$indexedMap, $elm$core$Tuple$pair, tree))));
	});
var $elm$core$Elm$JsArray$map = _JsArray_map;
var $elm$core$Array$map = F2(
	function (func, _v0) {
		var len = _v0.a;
		var startShift = _v0.b;
		var tree = _v0.c;
		var tail = _v0.d;
		var helper = function (node) {
			if (node.$ === 'SubTree') {
				var subTree = node.a;
				return $elm$core$Array$SubTree(
					A2($elm$core$Elm$JsArray$map, helper, subTree));
			} else {
				var values = node.a;
				return $elm$core$Array$Leaf(
					A2($elm$core$Elm$JsArray$map, func, values));
			}
		};
		return A4(
			$elm$core$Array$Array_elm_builtin,
			len,
			startShift,
			A2($elm$core$Elm$JsArray$map, helper, tree),
			A2($elm$core$Elm$JsArray$map, func, tail));
	});
var $elm$core$Array$length = function (_v0) {
	var len = _v0.a;
	return len;
};
var $elm$core$Maybe$map2 = F3(
	function (func, ma, mb) {
		if (ma.$ === 'Nothing') {
			return $elm$core$Maybe$Nothing;
		} else {
			var a = ma.a;
			if (mb.$ === 'Nothing') {
				return $elm$core$Maybe$Nothing;
			} else {
				var b = mb.a;
				return $elm$core$Maybe$Just(
					A2(func, a, b));
			}
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$positionRoot = F2(
	function (nodeId, lay) {
		var _v0 = A2(
			$elm$core$Maybe$andThen,
			function (c) {
				return A3(
					$elm$core$Maybe$map2,
					$elm$core$Tuple$pair,
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2($elm$core$Array$get, 0, c)),
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2(
							$elm$core$Array$get,
							$elm$core$Array$length(c) - 1,
							c)));
			},
			A2(
				$elm$core$Maybe$map,
				function ($) {
					return $.children;
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, nodeId)));
		if (_v0.$ === 'Just') {
			var _v1 = _v0.a;
			var first = _v1.a;
			var last = _v1.b;
			var relativeX = (((first.relativeX + first.modifierToSubtree) + last.relativeX) + last.modifierToSubtree) / 2;
			return A3(
				$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
				function (self) {
					return _Utils_update(
						self,
						{modifierToSubtree: -relativeX, relativeX: relativeX});
				},
				nodeId,
				lay);
		} else {
			return lay;
		}
	});
var $elm$core$Array$isEmpty = function (_v0) {
	var len = _v0.a;
	return !len;
};
var $gampleman$elm_visualization$Hierarchy$Tidy$refToMaybe = F2(
	function (ref, lay) {
		return ((ref >= 0) && (_Utils_cmp(
			ref,
			$elm$core$Array$length(lay)) < 0)) ? $elm$core$Maybe$Just(ref) : $elm$core$Maybe$Nothing;
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$contourNext = F2(
	function (lay, contour) {
		var node = contour.node;
		var isLeft = contour.isLeft;
		var modifierSum = contour.modifierSum;
		var _v0 = A2(
			$elm$core$Maybe$andThen,
			$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
			node);
		if (_v0.$ === 'Just') {
			var current = _v0.a;
			if (isLeft) {
				if ($elm$core$Array$isEmpty(current.children)) {
					return _Utils_update(
						contour,
						{
							modifierSum: modifierSum + current.modifierThreadLeft,
							node: A2($gampleman$elm_visualization$Hierarchy$Tidy$refToMaybe, current.threadLeft, lay)
						});
				} else {
					var newNode = A2($elm$core$Array$get, 0, current.children);
					var mod = A2(
						$elm$core$Maybe$withDefault,
						0,
						A2(
							$elm$core$Maybe$map,
							function (c) {
								return c.modifierToSubtree;
							},
							A2(
								$elm$core$Maybe$andThen,
								$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
								newNode)));
					return _Utils_update(
						contour,
						{modifierSum: modifierSum + mod, node: newNode});
				}
			} else {
				if ($elm$core$Array$isEmpty(current.children)) {
					return _Utils_update(
						contour,
						{
							modifierSum: modifierSum + current.modifierThreadRight,
							node: A2($gampleman$elm_visualization$Hierarchy$Tidy$refToMaybe, current.threadRight, lay)
						});
				} else {
					var newNode = A2(
						$elm$core$Array$get,
						$elm$core$Array$length(current.children) - 1,
						current.children);
					var mod = A2(
						$elm$core$Maybe$withDefault,
						0,
						A2(
							$elm$core$Maybe$map,
							function (c) {
								return c.modifierToSubtree;
							},
							A2(
								$elm$core$Maybe$andThen,
								$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
								newNode)));
					return _Utils_update(
						contour,
						{modifierSum: modifierSum + mod, node: newNode});
				}
			}
		} else {
			return contour;
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$moveSubtree = F5(
	function (currentIndex, fromMaybe, currentId, dist, lay) {
		if (fromMaybe.$ === 'Just') {
			var from = fromMaybe.a;
			if (!_Utils_eq(from.index, currentIndex - 1)) {
				var normDist = dist / (currentIndex - from.index);
				return A3(
					$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
					function (from_) {
						return _Utils_update(
							from_,
							{shiftAcceleration: from_.shiftAcceleration + normDist});
					},
					from.id,
					A3(
						$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
						function (current) {
							return _Utils_update(
								current,
								{modifierToSubtree: current.modifierToSubtree + dist, shiftAcceleration: current.shiftAcceleration - normDist, shiftChange: current.shiftChange - (dist - normDist)});
						},
						currentId,
						lay));
			} else {
				return A3(
					$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
					function (current) {
						return _Utils_update(
							current,
							{modifierToSubtree: current.modifierToSubtree + dist});
					},
					currentId,
					lay);
			}
		} else {
			return A3(
				$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
				function (current) {
					return _Utils_update(
						current,
						{modifierToSubtree: current.modifierToSubtree + dist});
				},
				currentId,
				lay);
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$setLeftThread = F5(
	function (modifier, nodeId, targetId, currentIndex, lay) {
		var _v0 = A2(
			$elm$core$Maybe$andThen,
			function (c) {
				return A3(
					$elm$core$Maybe$map2,
					$elm$core$Tuple$pair,
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2($elm$core$Array$get, 0, c)),
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2($elm$core$Array$get, currentIndex, c)));
			},
			A2(
				$elm$core$Maybe$map,
				function ($) {
					return $.children;
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, nodeId)));
		if (_v0.$ === 'Just') {
			var _v1 = _v0.a;
			var first = _v1.a;
			var current = _v1.b;
			var diff = (modifier - first.modifierExtremeLeft) - first.modifierToSubtree;
			return A3(
				$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
				function (first_) {
					return _Utils_update(
						first_,
						{extremeLeft: current.extremeLeft, modifierExtremeLeft: (current.modifierExtremeLeft + current.modifierToSubtree) - first_.modifierToSubtree});
				},
				first.id,
				A3(
					$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
					function (extremeLeft) {
						return _Utils_update(
							extremeLeft,
							{modifierThreadLeft: diff, threadLeft: targetId});
					},
					first.extremeLeft,
					lay));
		} else {
			return lay;
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$setRightThread = F5(
	function (modifier, nodeId, targetId, currentIndex, lay) {
		var _v0 = A2(
			$elm$core$Maybe$andThen,
			function (c) {
				return A3(
					$elm$core$Maybe$map2,
					$elm$core$Tuple$pair,
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2($elm$core$Array$get, currentIndex - 1, c)),
					A2(
						$elm$core$Maybe$andThen,
						$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
						A2($elm$core$Array$get, currentIndex, c)));
			},
			A2(
				$elm$core$Maybe$map,
				function ($) {
					return $.children;
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, nodeId)));
		if (_v0.$ === 'Just') {
			var _v1 = _v0.a;
			var prev = _v1.a;
			var current = _v1.b;
			var diff = (modifier - current.modifierExtremeRight) - current.modifierToSubtree;
			return A3(
				$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
				function (current_) {
					return _Utils_update(
						current_,
						{extremeRight: prev.extremeRight, modifierExtremeRight: (prev.modifierExtremeRight + prev.modifierToSubtree) - current_.modifierToSubtree});
				},
				current.id,
				A3(
					$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
					function (extremeRight) {
						return _Utils_update(
							extremeRight,
							{modifierThreadRight: diff, threadRight: targetId});
					},
					current.extremeRight,
					lay));
		} else {
			return lay;
		}
	});
var $elm$core$List$tail = function (list) {
	if (list.b) {
		var x = list.a;
		var xs = list.b;
		return $elm$core$Maybe$Just(xs);
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $gampleman$elm_visualization$Hierarchy$Tidy$separate = F5(
	function (peerMargin, childIndex, nodeId, lay_, ylist_) {
		var nodeChildren = A2(
			$elm$core$Maybe$map,
			function ($) {
				return $.children;
			},
			A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay_, nodeId));
		var newContour = F2(
			function (isLeft, index) {
				var node = A2(
					$elm$core$Maybe$andThen,
					$elm$core$Array$get(index),
					nodeChildren);
				return {
					isLeft: isLeft,
					modifierSum: A2(
						$elm$core$Maybe$withDefault,
						0,
						A2(
							$elm$core$Maybe$map,
							function ($) {
								return $.modifierToSubtree;
							},
							A2(
								$elm$core$Maybe$andThen,
								$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay_),
								node))),
					node: node
				};
			});
		var go = F4(
			function (leftContour, rightContour, lay, yList) {
				go:
				while (true) {
					var _v0 = _Utils_Tuple2(leftContour.node, rightContour.node);
					if (_v0.a.$ === 'Just') {
						if (_v0.b.$ === 'Just') {
							var left = _v0.a.a;
							var right = _v0.b.a;
							var yList2 = (_Utils_cmp(
								A2($gampleman$elm_visualization$Hierarchy$Tidy$derefBottom, left, lay),
								A2(
									$elm$core$Maybe$withDefault,
									0,
									A2(
										$elm$core$Maybe$map,
										function ($) {
											return $.y;
										},
										$elm$core$List$head(yList)))) > 0) ? A2(
								$elm$core$Maybe$withDefault,
								_List_Nil,
								$elm$core$List$tail(yList)) : yList;
							var dist = (A2(
								$elm$core$Maybe$withDefault,
								0,
								A2(
									$elm$core$Maybe$map,
									function (_v2) {
										var relativeX = _v2.relativeX;
										var width = _v2.width;
										return (leftContour.modifierSum + relativeX) + (width / 2);
									},
									A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, left))) - A2(
								$elm$core$Maybe$withDefault,
								0,
								A2(
									$elm$core$Maybe$map,
									function (_v3) {
										var relativeX = _v3.relativeX;
										var width = _v3.width;
										return (rightContour.modifierSum + relativeX) - (width / 2);
									},
									A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, right)))) + peerMargin;
							var _v1 = (dist > 0) ? _Utils_Tuple2(
								_Utils_update(
									rightContour,
									{modifierSum: rightContour.modifierSum + dist}),
								A5(
									$gampleman$elm_visualization$Hierarchy$Tidy$moveSubtree,
									childIndex,
									$elm$core$List$head(yList2),
									A2(
										$elm$core$Maybe$withDefault,
										-1,
										A2(
											$elm$core$Maybe$andThen,
											$elm$core$Array$get(childIndex),
											nodeChildren)),
									dist,
									lay)) : _Utils_Tuple2(rightContour, lay);
							var rightContour1 = _v1.a;
							var lay1 = _v1.b;
							var leftBottom = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefBottom, left, lay1);
							var rightBottom = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefBottom, right, lay1);
							if (_Utils_cmp(leftBottom, rightBottom) < 0) {
								var $temp$leftContour = A2($gampleman$elm_visualization$Hierarchy$Tidy$contourNext, lay1, leftContour),
									$temp$rightContour = rightContour1,
									$temp$lay = lay1,
									$temp$yList = yList2;
								leftContour = $temp$leftContour;
								rightContour = $temp$rightContour;
								lay = $temp$lay;
								yList = $temp$yList;
								continue go;
							} else {
								if (_Utils_cmp(leftBottom, rightBottom) > 0) {
									var $temp$leftContour = leftContour,
										$temp$rightContour = A2($gampleman$elm_visualization$Hierarchy$Tidy$contourNext, lay1, rightContour1),
										$temp$lay = lay1,
										$temp$yList = yList2;
									leftContour = $temp$leftContour;
									rightContour = $temp$rightContour;
									lay = $temp$lay;
									yList = $temp$yList;
									continue go;
								} else {
									var $temp$leftContour = A2($gampleman$elm_visualization$Hierarchy$Tidy$contourNext, lay1, leftContour),
										$temp$rightContour = A2($gampleman$elm_visualization$Hierarchy$Tidy$contourNext, lay1, rightContour1),
										$temp$lay = lay1,
										$temp$yList = yList2;
									leftContour = $temp$leftContour;
									rightContour = $temp$rightContour;
									lay = $temp$lay;
									yList = $temp$yList;
									continue go;
								}
							}
						} else {
							var left = _v0.a.a;
							var _v5 = _v0.b;
							return _Utils_Tuple2(
								A5($gampleman$elm_visualization$Hierarchy$Tidy$setRightThread, leftContour.modifierSum, nodeId, left, childIndex, lay),
								yList);
						}
					} else {
						if (_v0.b.$ === 'Just') {
							var _v4 = _v0.a;
							var right = _v0.b.a;
							return _Utils_Tuple2(
								A5($gampleman$elm_visualization$Hierarchy$Tidy$setLeftThread, rightContour.modifierSum, nodeId, right, childIndex, lay),
								yList);
						} else {
							var _v6 = _v0.a;
							var _v7 = _v0.b;
							return _Utils_Tuple2(lay, yList);
						}
					}
				}
			});
		return A4(
			go,
			A2(newContour, false, childIndex - 1),
			A2(newContour, true, childIndex),
			lay_,
			ylist_);
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$firstChild = F2(
	function (idx, lay) {
		return A2(
			$elm$core$Maybe$andThen,
			$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
			A2(
				$elm$core$Maybe$andThen,
				function (td) {
					return A2($elm$core$Array$get, 0, td.children);
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, idx)));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$lastChild = F2(
	function (idx, lay) {
		return A2(
			$elm$core$Maybe$andThen,
			$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(lay),
			A2(
				$elm$core$Maybe$andThen,
				function (td) {
					return A2(
						$elm$core$Array$get,
						$elm$core$Array$length(td.children) - 1,
						td.children);
				},
				A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, idx)));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$setExtreme = F2(
	function (id, tidyLayout) {
		return A3(
			$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
			function (tidy) {
				var _v0 = A3(
					$elm$core$Maybe$map2,
					$elm$core$Tuple$pair,
					A2($gampleman$elm_visualization$Hierarchy$Tidy$firstChild, id, tidyLayout),
					A2($gampleman$elm_visualization$Hierarchy$Tidy$lastChild, id, tidyLayout));
				if (_v0.$ === 'Nothing') {
					return _Utils_update(
						tidy,
						{extremeLeft: tidy.id, extremeRight: tidy.id, modifierExtremeLeft: 0, modifierExtremeRight: 0});
				} else {
					var _v1 = _v0.a;
					var first = _v1.a;
					var last = _v1.b;
					return _Utils_update(
						tidy,
						{extremeLeft: first.extremeLeft, extremeRight: last.extremeRight, modifierExtremeLeft: first.modifierToSubtree + first.modifierExtremeLeft, modifierExtremeRight: last.modifierToSubtree + last.modifierExtremeRight});
				}
			},
			id,
			tidyLayout);
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$traverseBFSWithDepth = F3(
	function (fn, init, lay) {
		var help = F4(
			function (accu, front, back, l) {
				help:
				while (true) {
					if (!front.b) {
						if (!back.b) {
							return l;
						} else {
							var $temp$accu = accu,
								$temp$front = $elm$core$List$reverse(back),
								$temp$back = _List_Nil,
								$temp$l = l;
							accu = $temp$accu;
							front = $temp$front;
							back = $temp$back;
							l = $temp$l;
							continue help;
						}
					} else {
						var _v2 = front.a;
						var depth = _v2.a;
						var x = _v2.b;
						var xs = front.b;
						var _v3 = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, l, x);
						if (_v3.$ === 'Just') {
							var node = _v3.a;
							var _v4 = A3(fn, depth, accu, node);
							var newAccu = _v4.a;
							var newNode = _v4.b;
							var $temp$accu = newAccu,
								$temp$front = xs,
								$temp$back = _Utils_ap(
								A2(
									$elm$core$List$map,
									$elm$core$Tuple$pair(depth + 1),
									$elm$core$List$reverse(
										$elm$core$Array$toList(newNode.children))),
								back),
								$temp$l = A3($elm$core$Array$set, x, newNode, l);
							accu = $temp$accu;
							front = $temp$front;
							back = $temp$back;
							l = $temp$l;
							continue help;
						} else {
							var $temp$accu = accu,
								$temp$front = xs,
								$temp$back = back,
								$temp$l = l;
							accu = $temp$accu;
							front = $temp$front;
							back = $temp$back;
							l = $temp$l;
							continue help;
						}
					}
				}
			});
		return A4(
			help,
			init,
			_List_fromArray(
				[
					_Utils_Tuple2(0, 0)
				]),
			_List_Nil,
			lay);
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$derefChildren = F2(
	function (l, node) {
		return A2(
			$elm$core$List$filterMap,
			$gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData(l),
			$elm$core$Array$toList(node.children));
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$traverseWithParent = F2(
	function (fn, l) {
		var help = F3(
			function (maybeParent, val, lay) {
				var newL = A3(
					$gampleman$elm_visualization$Hierarchy$Tidy$updateTidyData,
					function (tidy) {
						return fn(
							{
								node: tidy,
								parent: A2(
									$elm$core$Maybe$andThen,
									function (parent) {
										return A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, parent.id);
									},
									maybeParent)
							});
					},
					val.id,
					lay);
				return A3(
					$elm$core$List$foldl,
					help(
						$elm$core$Maybe$Just(val)),
					newL,
					A2($gampleman$elm_visualization$Hierarchy$Tidy$derefChildren, l, val));
			});
		var _v0 = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, l, 0);
		if (_v0.$ === 'Just') {
			var root = _v0.a;
			return A3(help, $elm$core$Maybe$Nothing, root, l);
		} else {
			return l;
		}
	});
var $gampleman$elm_visualization$Hierarchy$Tidy$layout = F2(
	function (getters, tree) {
		var setYRecursive = getters.layered ? A2(
			$gampleman$elm_visualization$Hierarchy$Tidy$traverseBFSWithDepth,
			F3(
				function (depth, depths, tidy) {
					var _v8 = A2($elm$core$Dict$get, depth - 1, depths);
					if (_v8.$ === 'Just') {
						var prevMax = _v8.a;
						return _Utils_Tuple2(
							A3(
								$elm$core$Dict$insert,
								depth,
								A2(
									$elm$core$Basics$max,
									A2(
										$elm$core$Maybe$withDefault,
										0,
										A2($elm$core$Dict$get, depth, depths)),
									(prevMax + tidy.height) + getters.parentChildMargin),
								depths),
							_Utils_update(
								tidy,
								{y: prevMax}));
					} else {
						return _Utils_Tuple2(
							A3($elm$core$Dict$insert, depth, tidy.height + getters.parentChildMargin, depths),
							_Utils_update(
								tidy,
								{y: 0}));
					}
				}),
			$elm$core$Dict$empty) : $gampleman$elm_visualization$Hierarchy$Tidy$traverseWithParent(
			function (_v9) {
				var parent = _v9.parent;
				var node = _v9.node;
				return _Utils_update(
					node,
					{
						y: A2(
							$elm$core$Maybe$withDefault,
							0,
							A2(
								$elm$core$Maybe$map,
								function (parents) {
									return (parents.height + parents.y) + getters.parentChildMargin;
								},
								parent))
					});
			});
		var runWalk = F2(
			function (fn, lay) {
				return A2(fn, 0, lay);
			});
		var init = $gampleman$elm_visualization$Hierarchy$Tidy$initialize(getters.nodeSize);
		var firstWalk = F2(
			function (idx, lay) {
				var _v0 = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, idx);
				if (_v0.$ === 'Nothing') {
					return lay;
				} else {
					var node = _v0.a;
					var _v1 = $elm$core$Array$toList(node.children);
					if (!_v1.b) {
						return A2($gampleman$elm_visualization$Hierarchy$Tidy$setExtreme, idx, lay);
					} else {
						var firstChildId = _v1.a;
						var rest = _v1.b;
						var lay1 = A2(firstWalk, firstChildId, lay);
						var _v2 = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay1, firstChildId);
						if (_v2.$ === 'Nothing') {
							return lay1;
						} else {
							var firstChildData = _v2.a;
							var yListInitDatum = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefBottom, firstChildData.extremeRight, lay1);
							var yListInit = _List_fromArray(
								[
									{id: firstChildId, index: 0, y: yListInitDatum}
								]);
							var res = A3(
								$elm$core$List$foldl,
								F2(
									function (id, _v3) {
										var yList = _v3.yList;
										var layN = _v3.layN;
										var index = _v3.index;
										var lay2 = A2(firstWalk, id, layN);
										var maxY = A2(
											$elm$core$Maybe$withDefault,
											0,
											A2(
												$elm$core$Maybe$map,
												function (_v6) {
													var extremeLeft = _v6.extremeLeft;
													return A2($gampleman$elm_visualization$Hierarchy$Tidy$derefBottom, extremeLeft, lay2);
												},
												A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay2, id)));
										var update = function (lst) {
											update:
											while (true) {
												if (!lst.b) {
													return _List_fromArray(
														[
															{id: id, index: index, y: maxY}
														]);
												} else {
													var head = lst.a;
													var tail = lst.b;
													if (_Utils_cmp(head.y, maxY) < 1) {
														var $temp$lst = tail;
														lst = $temp$lst;
														continue update;
													} else {
														return A2(
															$elm$core$List$cons,
															{id: id, index: index, y: maxY},
															tail);
													}
												}
											}
										};
										var _v5 = A5($gampleman$elm_visualization$Hierarchy$Tidy$separate, getters.peerMargin, index, idx, lay2, yList);
										var lay3 = _v5.a;
										var yList1 = _v5.b;
										return {
											index: index + 1,
											layN: lay3,
											yList: update(yList1)
										};
									}),
								{index: 1, layN: lay1, yList: yListInit},
								rest);
							return A2(
								$gampleman$elm_visualization$Hierarchy$Tidy$setExtreme,
								idx,
								A2($gampleman$elm_visualization$Hierarchy$Tidy$positionRoot, idx, res.layN));
						}
					}
				}
			});
		var defaultValue = $gampleman$elm_rosetree$Tree$label(tree);
		var secondWalk = F3(
			function (modSum, idx, lay) {
				var _v7 = A2($gampleman$elm_visualization$Hierarchy$Tidy$derefTidyData, lay, idx);
				if (_v7.$ === 'Just') {
					var width = _v7.a.width;
					var height = _v7.a.height;
					var y = _v7.a.y;
					var modifierToSubtree = _v7.a.modifierToSubtree;
					var relativeX = _v7.a.relativeX;
					var value = _v7.a.value;
					var children = _v7.a.children;
					return A2(
						$gampleman$elm_rosetree$Tree$tree,
						{height: height, node: value, width: width, x: ((relativeX + modSum) + modifierToSubtree) - (width / 2), y: y},
						$elm$core$Array$toList(
							A2(
								$elm$core$Array$map,
								function (a) {
									return A3(
										secondWalk,
										modSum + modifierToSubtree,
										a,
										A2($gampleman$elm_visualization$Hierarchy$Tidy$addChildSpacing, children, lay));
								},
								children)));
				} else {
					return $gampleman$elm_rosetree$Tree$singleton(
						{height: 0 / 0, node: defaultValue, width: 0 / 0, x: 0 / 0, y: 0 / 0});
				}
			});
		return A2(
			runWalk,
			secondWalk(0),
			A2(
				runWalk,
				firstWalk,
				setYRecursive(
					init(tree))));
	});
var $gampleman$elm_rosetree$Tree$map = F2(
	function (f, t) {
		return A3(
			$gampleman$elm_rosetree$Tree$mapAccumulate,
			F2(
				function (_v0, e) {
					return _Utils_Tuple2(
						_Utils_Tuple0,
						f(e));
				}),
			_Utils_Tuple0,
			t).b;
	});
var $gampleman$elm_visualization$Hierarchy$processAttributes = function (assigner) {
	return $elm$core$List$foldl(
		F2(
			function (a, d) {
				if (a.$ === 'Batch') {
					var l = a.a;
					return A3($gampleman$elm_visualization$Hierarchy$processAttributes, assigner, d, l);
				} else {
					return A2(assigner, a, d);
				}
			}));
};
var $gampleman$elm_visualization$Hierarchy$tidy = F2(
	function (attrs, t) {
		var _v0 = A3(
			$gampleman$elm_visualization$Hierarchy$processAttributes,
			F2(
				function (attr, _v1) {
					var s = _v1.a;
					var r = _v1.b;
					var a = _v1.c;
					switch (attr.$) {
						case 'Size':
							var x = attr.a;
							var y = attr.b;
							return _Utils_Tuple3(
								$elm$core$Maybe$Just(
									_Utils_Tuple2(x, y)),
								r,
								a);
						case 'Layered':
							return _Utils_Tuple3(
								s,
								_Utils_update(
									r,
									{layered: true}),
								a);
						case 'ParentChildMargin':
							var m = attr.a;
							return _Utils_Tuple3(
								s,
								_Utils_update(
									r,
									{parentChildMargin: m}),
								a);
						case 'PeerMargin':
							var m = attr.a;
							return _Utils_Tuple3(
								s,
								_Utils_update(
									r,
									{peerMargin: m}),
								a);
						case 'NodeSize':
							var ns = attr.a;
							return _Utils_Tuple3(
								s,
								_Utils_update(
									r,
									{nodeSize: ns}),
								true);
						default:
							return _Utils_Tuple3(s, r, a);
					}
				}),
			_Utils_Tuple3(
				$elm$core$Maybe$Nothing,
				{
					layered: false,
					nodeSize: $elm$core$Basics$always(
						_Utils_Tuple2(1, 1)),
					parentChildMargin: 1,
					peerMargin: 1
				},
				false),
			attrs);
		var resize = _v0.a;
		var settings = _v0.b;
		var aspectRatio = _v0.c;
		var layout = A2($gampleman$elm_visualization$Hierarchy$Tidy$layout, settings, t);
		if (resize.$ === 'Just') {
			var _v4 = resize.a;
			var w = _v4.a;
			var h = _v4.b;
			var _v5 = A3(
				$gampleman$elm_rosetree$Tree$foldl,
				F2(
					function (l, _v6) {
						var minX = _v6.a;
						var maxX = _v6.b;
						var maxY = _v6.c;
						return _Utils_Tuple3(
							A2($elm$core$Basics$min, minX, l.x),
							A2($elm$core$Basics$max, maxX, l.x + l.width),
							A2($elm$core$Basics$max, maxY, l.y + l.height));
					}),
				_Utils_Tuple3(0, 0, 0),
				layout);
			var minX_ = _v5.a;
			var maxX_ = _v5.b;
			var height = _v5.c;
			var hS_ = h / height;
			var width = maxX_ - minX_;
			var wS_ = w / width;
			var _v7 = aspectRatio ? _Utils_Tuple2(
				A2($elm$core$Basics$min, wS_, hS_),
				A2($elm$core$Basics$min, wS_, hS_)) : _Utils_Tuple2(wS_, hS_);
			var wS = _v7.a;
			var hS = _v7.b;
			return A2(
				$gampleman$elm_rosetree$Tree$map,
				function (l) {
					return aspectRatio ? _Utils_update(
						l,
						{height: l.height * hS, width: l.width * wS, x: (l.x - minX_) * wS, y: l.y * hS}) : _Utils_update(
						l,
						{height: 1, width: 1, x: (((l.x - minX_) + (l.width / 2)) * wS) - 0.5, y: ((l.y + (l.height / 2)) * hS) - 0.5});
				},
				layout);
		} else {
			return layout;
		}
	});
var $author$project$TreeView$Leaf = {$: 'Leaf'};
var $author$project$TreeView$Node = {$: 'Node'};
var $author$project$TreeView$fromBrand = F2(
	function (model, smartphone) {
		return (_Utils_eq(
			model.treeOption.selectedFilter.brand,
			A2($elm$core$Maybe$withDefault, '', smartphone.brand)) || (model.treeOption.selectedFilter.brand === 'all')) ? true : false;
	});
var $author$project$TreeView$has5G = F2(
	function (model, smartphone) {
		return (((model.treeOption.selectedFilter.g5 === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.g5)) || (model.treeOption.selectedFilter.g5 === 'all')) ? true : (((model.treeOption.selectedFilter.g5 === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.g5))) ? true : false);
	});
var $author$project$TreeView$hasIRBlaster = F2(
	function (model, smartphone) {
		return (((model.treeOption.selectedFilter.ir_blaster === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.ir_blaster)) || (model.treeOption.selectedFilter.ir_blaster === 'all')) ? true : (((model.treeOption.selectedFilter.ir_blaster === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.ir_blaster))) ? true : false);
	});
var $author$project$TreeView$hasNFC = F2(
	function (model, smartphone) {
		return (((model.treeOption.selectedFilter.nfc === 'true') && A2($elm$core$Maybe$withDefault, false, smartphone.nfc)) || (model.treeOption.selectedFilter.nfc === 'all')) ? true : (((model.treeOption.selectedFilter.nfc === 'false') && (!A2($elm$core$Maybe$withDefault, true, smartphone.nfc))) ? true : false);
	});
var $author$project$TreeView$filterSPData = F2(
	function (model, smartphones) {
		var smartphoneList = A2(
			$elm$core$List$filter,
			$author$project$TreeView$hasIRBlaster(model),
			A2(
				$elm$core$List$filter,
				$author$project$TreeView$hasNFC(model),
				A2(
					$elm$core$List$filter,
					$author$project$TreeView$has5G(model),
					A2(
						$elm$core$List$filter,
						$author$project$TreeView$fromBrand(model),
						smartphones))));
		return smartphoneList;
	});
var $author$project$TreeView$getTreeString = F2(
	function (nodeCount, smartphone) {
		return {
			id: A2($elm$core$Maybe$withDefault, '-1', smartphone.id),
			name: 'Smartphone.' + (A2($elm$core$Maybe$withDefault, '', smartphone.brand) + ('.' + A2($elm$core$Maybe$withDefault, '', smartphone.model))),
			size: (nodeCount < 20) ? 1000000 : (((nodeCount >= 20) && (nodeCount < 40)) ? 500000 : (((nodeCount >= 40) && (nodeCount < 70)) ? 200000 : (((nodeCount >= 70) && (nodeCount < 100)) ? 50000 : (((nodeCount >= 100) && (nodeCount < 200)) ? 20000 : (((nodeCount >= 200) && (nodeCount < 300)) ? 5000 : (((nodeCount >= 300) && (nodeCount < 500)) ? 1000 : 500))))))
		};
	});
var $author$project$TreeView$getTreeData = function (smartphones) {
	var listlength = $elm$core$List$length(smartphones);
	return A2(
		$elm$core$List$map,
		$author$project$TreeView$getTreeString(listlength),
		smartphones);
};
var $elm$core$List$sortWith = _List_sortWith;
var $gampleman$elm_rosetree$Tree$sortWith = F2(
	function (compareFn, t) {
		return A4(
			$gampleman$elm_rosetree$Tree$depthFirstTraversal,
			$gampleman$elm_rosetree$Tree$defaultTopDown,
			F4(
				function (s, a, l, c) {
					return _Utils_Tuple2(
						s,
						A2(
							$gampleman$elm_rosetree$Tree$tree,
							l,
							A2(
								$elm$core$List$sortWith,
								compareFn(a),
								c)));
				}),
			_Utils_Tuple0,
			t).b;
	});
var $gampleman$elm_rosetree$Tree$sortBy = F2(
	function (fn, t) {
		return A2(
			$gampleman$elm_rosetree$Tree$sortWith,
			F3(
				function (_v0, a, b) {
					return A2(
						$elm$core$Basics$compare,
						fn(a),
						fn(b));
				}),
			t);
	});
var $gampleman$elm_rosetree$Tree$children = function (_v0) {
	var c = _v0.b;
	return c;
};
var $elm$core$Dict$member = F2(
	function (key, dict) {
		var _v0 = A2($elm$core$Dict$get, key, dict);
		if (_v0.$ === 'Just') {
			return true;
		} else {
			return false;
		}
	});
var $elm$core$Set$member = F2(
	function (key, _v0) {
		var dict = _v0.a;
		return A2($elm$core$Dict$member, key, dict);
	});
var $gampleman$elm_rosetree$Tree$DisconnectedNodes = function (a) {
	return {$: 'DisconnectedNodes', a: a};
};
var $gampleman$elm_rosetree$Tree$DuplicateId = function (a) {
	return {$: 'DuplicateId', a: a};
};
var $gampleman$elm_rosetree$Tree$MultipleRoots = F2(
	function (a, b) {
		return {$: 'MultipleRoots', a: a, b: b};
	});
var $gampleman$elm_rosetree$Tree$NoRoot = {$: 'NoRoot'};
var $gampleman$elm_rosetree$Tree$NodeItsOwnParent = function (a) {
	return {$: 'NodeItsOwnParent', a: a};
};
var $gampleman$elm_rosetree$Tree$length = function (t) {
	return A3(
		$gampleman$elm_rosetree$Tree$foldl,
		F2(
			function (_v0, x) {
				return x + 1;
			}),
		0,
		t);
};
var $gampleman$elm_rosetree$Tree$unfold = F2(
	function (f, seed) {
		return A4(
			$gampleman$elm_rosetree$Tree$depthFirstTraversal,
			F4(
				function (s, _v0, l, _v1) {
					var _v2 = f(l);
					var l_ = _v2.a;
					var c = _v2.b;
					return _Utils_Tuple3(
						s,
						l_,
						A2($elm$core$List$map, $gampleman$elm_rosetree$Tree$singleton, c));
				}),
			$gampleman$elm_rosetree$Tree$defaultBottomUp,
			_Utils_Tuple0,
			$gampleman$elm_rosetree$Tree$singleton(seed)).b;
	});
var $gampleman$elm_rosetree$Tree$stratify = F2(
	function (_v0, nodes) {
		var id = _v0.id;
		var parentId = _v0.parentId;
		var transform = _v0.transform;
		return A2(
			$elm$core$Result$andThen,
			function (_v5) {
				var maybeRoot = _v5.a;
				var parentBag = _v5.b;
				if (maybeRoot.$ === 'Just') {
					var root = maybeRoot.a;
					var completed = A2(
						$gampleman$elm_rosetree$Tree$unfold,
						function (_v7) {
							var itemId = _v7.a;
							var item = _v7.b;
							return _Utils_Tuple2(
								item,
								A2(
									$elm$core$Maybe$withDefault,
									_List_Nil,
									A2($elm$core$Dict$get, itemId, parentBag)));
						},
						root);
					return _Utils_eq(
						$gampleman$elm_rosetree$Tree$length(completed),
						$elm$core$List$length(nodes)) ? $elm$core$Result$Ok(completed) : $elm$core$Result$Err(
						$gampleman$elm_rosetree$Tree$DisconnectedNodes(completed));
				} else {
					return $elm$core$Result$Err($gampleman$elm_rosetree$Tree$NoRoot);
				}
			},
			A3(
				$elm$core$List$foldr,
				function (item) {
					return $elm$core$Result$andThen(
						function (_v1) {
							var maybeRoot = _v1.a;
							var parentBag = _v1.b;
							var seenIds = _v1.c;
							var node_ = transform(item);
							var nodeId = id(item);
							if (A2($elm$core$Set$member, nodeId, seenIds)) {
								return $elm$core$Result$Err(
									$gampleman$elm_rosetree$Tree$DuplicateId(node_));
							} else {
								var _v2 = parentId(item);
								if (_v2.$ === 'Nothing') {
									if (maybeRoot.$ === 'Nothing') {
										return $elm$core$Result$Ok(
											_Utils_Tuple3(
												$elm$core$Maybe$Just(
													_Utils_Tuple2(nodeId, node_)),
												parentBag,
												A2($elm$core$Set$insert, nodeId, seenIds)));
									} else {
										var _v4 = maybeRoot.a;
										var prevRoot = _v4.b;
										return $elm$core$Result$Err(
											A2($gampleman$elm_rosetree$Tree$MultipleRoots, node_, prevRoot));
									}
								} else {
									var actualNodeParentId = _v2.a;
									return _Utils_eq(actualNodeParentId, nodeId) ? $elm$core$Result$Err(
										$gampleman$elm_rosetree$Tree$NodeItsOwnParent(node_)) : $elm$core$Result$Ok(
										_Utils_Tuple3(
											maybeRoot,
											A3(
												$elm$core$Dict$update,
												actualNodeParentId,
												function (items) {
													return $elm$core$Maybe$Just(
														A2(
															$elm$core$List$cons,
															_Utils_Tuple2(nodeId, node_),
															A2($elm$core$Maybe$withDefault, _List_Nil, items)));
												},
												parentBag),
											A2($elm$core$Set$insert, nodeId, seenIds)));
								}
							}
						});
				},
				$elm$core$Result$Ok(
					_Utils_Tuple3($elm$core$Maybe$Nothing, $elm$core$Dict$empty, $elm$core$Set$empty)),
				nodes));
	});
var $gampleman$elm_rosetree$Tree$stratifyWithPath = F2(
	function (_v0, nodes) {
		var path = _v0.path;
		var createMissingNode = _v0.createMissingNode;
		return A2(
			$elm$core$Result$map,
			function (t) {
				var _v7 = $gampleman$elm_rosetree$Tree$children(t);
				if (_v7.b && (!_v7.b.b)) {
					var x = _v7.a;
					return x;
				} else {
					return t;
				}
			},
			A2(
				$elm$core$Result$mapError,
				function (e) {
					if (e.$ === 'DuplicateId') {
						var n = e.a;
						return path(n);
					} else {
						return _List_Nil;
					}
				},
				A2(
					$gampleman$elm_rosetree$Tree$stratify,
					{
						id: function ($) {
							return $.id;
						},
						parentId: function ($) {
							return $.parentId;
						},
						transform: function ($) {
							return $.node;
						}
					},
					function (n) {
						return $elm$core$List$isEmpty(n) ? _List_fromArray(
							[
								{
								id: _List_Nil,
								node: createMissingNode(_List_Nil),
								parentId: $elm$core$Maybe$Nothing
							}
							]) : n;
					}(
						$elm$core$List$reverse(
							$elm$core$List$concat(
								A3(
									$elm$core$List$foldl,
									F2(
										function (_v1, _v2) {
											var reversedPath = _v1.a;
											var item = _v1.b;
											var seenSoFar = _v2.a;
											var nodes_ = _v2.b;
											var wrapNode = F2(
												function (revPath, n) {
													if (!revPath.b) {
														return {id: _List_Nil, node: n, parentId: $elm$core$Maybe$Nothing};
													} else {
														var xs = revPath.b;
														return {
															id: revPath,
															node: n,
															parentId: $elm$core$Maybe$Just(xs)
														};
													}
												});
											var current = A2(wrapNode, reversedPath, item);
											var createParentNodes = F2(
												function (revPath, newNodes) {
													createParentNodes:
													while (true) {
														if (!revPath.b) {
															return A2($elm$core$Set$member, _List_Nil, seenSoFar) ? newNodes : A2(
																$elm$core$List$cons,
																A2(
																	wrapNode,
																	revPath,
																	createMissingNode(_List_Nil)),
																newNodes);
														} else {
															var xs = revPath.b;
															if (A2($elm$core$Set$member, revPath, seenSoFar)) {
																var $temp$revPath = xs,
																	$temp$newNodes = newNodes;
																revPath = $temp$revPath;
																newNodes = $temp$newNodes;
																continue createParentNodes;
															} else {
																var $temp$revPath = xs,
																	$temp$newNodes = A2(
																	$elm$core$List$cons,
																	A2(
																		wrapNode,
																		revPath,
																		createMissingNode(
																			$elm$core$List$reverse(revPath))),
																	newNodes);
																revPath = $temp$revPath;
																newNodes = $temp$newNodes;
																continue createParentNodes;
															}
														}
													}
												});
											var nodesToCreate = function () {
												if (!reversedPath.b) {
													return _List_fromArray(
														[current]);
												} else {
													var xs = reversedPath.b;
													return A2(
														createParentNodes,
														xs,
														_List_fromArray(
															[current]));
												}
											}();
											return _Utils_Tuple2(
												A3(
													$elm$core$List$foldl,
													function (i) {
														return $elm$core$Set$insert(i.id);
													},
													seenSoFar,
													nodesToCreate),
												A2($elm$core$List$cons, nodesToCreate, nodes_));
										}),
									_Utils_Tuple2($elm$core$Set$empty, _List_Nil),
									A2(
										$elm$core$List$sortBy,
										A2($elm$core$Basics$composeR, $elm$core$Tuple$first, $elm$core$List$length),
										A2(
											$elm$core$List$map,
											function (item) {
												return _Utils_Tuple2(
													$elm$core$List$reverse(
														path(item)),
													item);
											},
											nodes))).b))))));
	});
var $elm$core$List$sum = function (numbers) {
	return A3($elm$core$List$foldl, $elm$core$Basics$add, 0, numbers);
};
var $elm$core$Result$withDefault = F2(
	function (def, result) {
		if (result.$ === 'Ok') {
			var a = result.a;
			return a;
		} else {
			return def;
		}
	});
var $author$project$TreeView$tree = function (model) {
	var notfilteredSmartphoneNodeCount = $elm$core$List$length(model.data);
	var filteredSmartphoneData = A2($author$project$TreeView$filterSPData, model, model.data);
	var filteredSmartphoneNodeCount = $elm$core$List$length(filteredSmartphoneData);
	var limitedfilteredSmartphones = A2($elm$core$List$drop, model.treeOption.dropCount, filteredSmartphoneData);
	return _Utils_Tuple2(
		A2(
			$gampleman$elm_rosetree$Tree$sortBy,
			A2(
				$elm$core$Basics$composeR,
				$gampleman$elm_rosetree$Tree$label,
				function ($) {
					return $.name;
				}),
			A3(
				$gampleman$elm_rosetree$Tree$sumUp,
				function (n) {
					return {id: n.id, kind: $author$project$TreeView$Leaf, name: n.name, size: n.size};
				},
				F2(
					function (node, children) {
						return {
							id: node.id,
							kind: $author$project$TreeView$Node,
							name: node.name,
							size: $elm$core$List$sum(
								A2(
									$elm$core$List$map,
									function ($) {
										return $.size;
									},
									children))
						};
					}),
				A2(
					$elm$core$Result$withDefault,
					$gampleman$elm_rosetree$Tree$singleton(
						{id: '-1', name: 'Smartphone', size: 0}),
					A2(
						$gampleman$elm_rosetree$Tree$stratifyWithPath,
						{
							createMissingNode: function (path) {
								return {
									id: '-1',
									name: A2($elm$core$String$join, '.', path),
									size: 0
								};
							},
							path: function (item) {
								return A2($elm$core$String$split, '.', item.name);
							}
						},
						$author$project$TreeView$getTreeData(limitedfilteredSmartphones))))),
		_Utils_Tuple2(notfilteredSmartphoneNodeCount, filteredSmartphoneNodeCount));
};
var $author$project$TreeView$layedOut = function (model) {
	var treeModelInfo = $author$project$TreeView$tree(model);
	var treeNodeCounts = treeModelInfo.b;
	var treeModel = treeModelInfo.a;
	return _Utils_Tuple2(
		A3(
			$gampleman$elm_rosetree$Tree$sumUp,
			function (n) {
				return {
					bbox: {height: n.height, width: n.width, x: n.x, y: n.y},
					height: n.height,
					node: n.node,
					width: n.width,
					x: n.x,
					y: n.y
				};
			},
			F2(
				function (n, c) {
					return {
						bbox: A3(
							$elm$core$List$foldl,
							F2(
								function (item, t) {
									return A2($author$project$TreeView$maxBBoxes, item.bbox, t);
								}),
							{height: n.height, width: n.width, x: n.x, y: n.y},
							c),
						height: n.height,
						node: n.node,
						width: n.width,
						x: n.x,
						y: n.y
					};
				}),
			A2(
				$gampleman$elm_visualization$Hierarchy$tidy,
				_List_fromArray(
					[
						$gampleman$elm_visualization$Hierarchy$nodeSize(
						function (_v0) {
							var kind = _v0.kind;
							var size = _v0.size;
							if (kind.$ === 'Leaf') {
								return _Utils_Tuple2(
									$elm$core$Basics$sqrt(size) / 1.1,
									$elm$core$Basics$sqrt(size) * 2.5);
							} else {
								return _Utils_Tuple2(
									$elm$core$Basics$sqrt(size) * 1.7,
									$elm$core$Basics$sqrt(size) / 1.1);
							}
						}),
						$gampleman$elm_visualization$Hierarchy$parentChildMargin(900),
						$gampleman$elm_visualization$Hierarchy$peerMargin(60),
						A2($gampleman$elm_visualization$Hierarchy$size, $author$project$TreeView$w - ($author$project$TreeView$padding * 2), $author$project$TreeView$h - ($author$project$TreeView$padding * 2))
					]),
				treeModel)),
		treeNodeCounts);
};
var $gampleman$elm_rosetree$Tree$breadthFirstFoldHelp = F5(
	function (f, acc, parents, trees, nextSets) {
		breadthFirstFoldHelp:
		while (true) {
			if (!trees.b) {
				if (nextSets.b) {
					var _v2 = nextSets.a;
					var p = _v2.a;
					var set = _v2.b;
					var sets = nextSets.b;
					var $temp$f = f,
						$temp$acc = acc,
						$temp$parents = p,
						$temp$trees = set,
						$temp$nextSets = sets;
					f = $temp$f;
					acc = $temp$acc;
					parents = $temp$parents;
					trees = $temp$trees;
					nextSets = $temp$nextSets;
					continue breadthFirstFoldHelp;
				} else {
					return acc;
				}
			} else {
				var _v3 = trees.a;
				var d = _v3.a;
				var ch = _v3.b;
				var rest = trees.b;
				var _v4 = A4(f, acc, parents, d, ch);
				if (_v4.$ === 'Continue') {
					var a = _v4.a;
					if (!ch.b) {
						var $temp$f = f,
							$temp$acc = a,
							$temp$parents = parents,
							$temp$trees = rest,
							$temp$nextSets = nextSets;
						f = $temp$f;
						acc = $temp$acc;
						parents = $temp$parents;
						trees = $temp$trees;
						nextSets = $temp$nextSets;
						continue breadthFirstFoldHelp;
					} else {
						var xs = ch;
						var $temp$f = f,
							$temp$acc = a,
							$temp$parents = parents,
							$temp$trees = rest,
							$temp$nextSets = A2(
							$elm$core$List$cons,
							_Utils_Tuple2(
								A2($elm$core$List$cons, d, parents),
								xs),
							nextSets);
						f = $temp$f;
						acc = $temp$acc;
						parents = $temp$parents;
						trees = $temp$trees;
						nextSets = $temp$nextSets;
						continue breadthFirstFoldHelp;
					}
				} else {
					var a = _v4.a;
					return a;
				}
			}
		}
	});
var $gampleman$elm_rosetree$Tree$breadthFirstFold = F3(
	function (f, acc, t) {
		return A5(
			$gampleman$elm_rosetree$Tree$breadthFirstFoldHelp,
			f,
			acc,
			_List_Nil,
			_List_fromArray(
				[t]),
			_List_Nil);
	});
var $gampleman$elm_rosetree$Tree$links = function (t) {
	return $elm$core$List$reverse(
		A3(
			$gampleman$elm_rosetree$Tree$breadthFirstFold,
			F4(
				function (s, a, l, _v0) {
					if (a.b) {
						var parent = a.a;
						return $gampleman$elm_rosetree$Tree$Continue(
							A2(
								$elm$core$List$cons,
								_Utils_Tuple2(parent, l),
								s));
					} else {
						return $gampleman$elm_rosetree$Tree$Continue(s);
					}
				}),
			_List_Nil,
			t));
};
var $elm_community$typed_svg$TypedSvg$rect = $elm_community$typed_svg$TypedSvg$Core$node('rect');
var $avh4$elm_color$Color$rgba = F4(
	function (r, g, b, a) {
		return A4($avh4$elm_color$Color$RgbaSpace, r, g, b, a);
	});
var $gampleman$elm_rosetree$Tree$foldr = F3(
	function (f, acc, t) {
		return A3(
			$elm$core$List$foldl,
			f,
			acc,
			A3($gampleman$elm_rosetree$Tree$foldl, $elm$core$List$cons, _List_Nil, t));
	});
var $gampleman$elm_rosetree$Tree$toList = function (t) {
	return A3($gampleman$elm_rosetree$Tree$foldr, $elm$core$List$cons, _List_Nil, t);
};
var $gampleman$elm_visualization$Zoom$Transform$toString = function (_v0) {
	var k = _v0.k;
	var x = _v0.x;
	var y = _v0.y;
	return 'translate(' + ($elm$core$String$fromFloat(x) + (',' + ($elm$core$String$fromFloat(y) + (') scale(' + ($elm$core$String$fromFloat(k) + ')')))));
};
var $gampleman$elm_visualization$Zoom$transform = function (_v0) {
	var zoom = _v0.a;
	return $elm$svg$Svg$Attributes$transform(
		$gampleman$elm_visualization$Zoom$Transform$toString(zoom.transform));
};
var $elm_community$typed_svg$TypedSvg$Attributes$InPx$width = function (value) {
	return $elm_community$typed_svg$TypedSvg$Attributes$width(
		$elm_community$typed_svg$TypedSvg$Types$px(value));
};
var $author$project$TreeView$createViewTree = function (model) {
	var layoutTreeInfo = $author$project$TreeView$layedOut(model);
	var nodeCounts = layoutTreeInfo.b;
	var layoutTree = layoutTreeInfo.a;
	return _Utils_Tuple2(
		A2(
			$elm_community$typed_svg$TypedSvg$svg,
			_List_fromArray(
				[
					A4($elm_community$typed_svg$TypedSvg$Attributes$viewBox, 0, 0, $author$project$TreeView$w, $author$project$TreeView$h),
					$elm_community$typed_svg$TypedSvg$Attributes$width(
					$elm_community$typed_svg$TypedSvg$Types$Percent(100)),
					$elm_community$typed_svg$TypedSvg$Attributes$height(
					$elm_community$typed_svg$TypedSvg$Types$Percent(100))
				]),
			_List_fromArray(
				[
					A2(
					$elm_community$typed_svg$TypedSvg$rect,
					A2(
						$elm$core$List$cons,
						$elm_community$typed_svg$TypedSvg$Attributes$InPx$width($author$project$TreeView$w),
						A2(
							$elm$core$List$cons,
							$elm_community$typed_svg$TypedSvg$Attributes$InPx$height($author$project$TreeView$h),
							A2(
								$elm$core$List$cons,
								$elm_community$typed_svg$TypedSvg$Attributes$fill(
									$elm_community$typed_svg$TypedSvg$Types$Paint(
										A4($avh4$elm_color$Color$rgba, 0, 0, 0, 0))),
								A2(
									$elm$core$List$cons,
									$elm_community$typed_svg$TypedSvg$Attributes$stroke(
										$elm_community$typed_svg$TypedSvg$Types$Paint($avh4$elm_color$Color$black)),
									A2(
										$elm$core$List$cons,
										$elm_community$typed_svg$TypedSvg$Attributes$InPx$strokeWidth(2),
										A2($gampleman$elm_visualization$Zoom$events, model.treeOption.zoomOption, $author$project$TreeView$ZoomMsg)))))),
					_List_Nil),
					A2(
					$elm_community$typed_svg$TypedSvg$g,
					_List_fromArray(
						[
							$gampleman$elm_visualization$Zoom$transform(model.treeOption.zoomOption)
						]),
					_List_fromArray(
						[
							A2(
							$elm_community$typed_svg$TypedSvg$g,
							_List_fromArray(
								[
									$elm_community$typed_svg$TypedSvg$Attributes$transform(
									_List_fromArray(
										[
											A2($elm_community$typed_svg$TypedSvg$Types$Translate, $author$project$TreeView$padding, $author$project$TreeView$padding)
										]))
								]),
							_List_fromArray(
								[
									function (p) {
									return A2(
										$folkertdev$one_true_path_experiment$Path$element,
										p,
										_List_fromArray(
											[
												$elm_community$typed_svg$TypedSvg$Attributes$fill($elm_community$typed_svg$TypedSvg$Types$PaintNone),
												$elm_community$typed_svg$TypedSvg$Attributes$stroke(
												$elm_community$typed_svg$TypedSvg$Types$Paint(
													A3($avh4$elm_color$Color$rgb, 0.3, 0.3, 0.3))),
												$elm_community$typed_svg$TypedSvg$Attributes$style('vector-effect: non-scaling-stroke'),
												$elm_community$typed_svg$TypedSvg$Attributes$pointerEvents('none')
											]));
								}(
									A2(
										$elm$core$List$map,
										function (_v0) {
											var from = _v0.a;
											var to = _v0.b;
											return $gampleman$elm_visualization$Shape$bumpYCurve(
												_List_fromArray(
													[
														_Utils_Tuple2(from.x + (from.width / 2), from.y + from.height),
														_Utils_Tuple2(to.x + (to.width / 2), to.y + (to.height * 0.1))
													]));
										},
										$gampleman$elm_rosetree$Tree$links(layoutTree))),
									A2(
									$elm_community$typed_svg$TypedSvg$g,
									_List_Nil,
									A2(
										$elm$core$List$map,
										$author$project$TreeView$label,
										$gampleman$elm_rosetree$Tree$toList(layoutTree)))
								]))
						]))
				])),
		nodeCounts);
};
var $author$project$TreeView$viewTree = function (model) {
	var treeViewInfo = $author$project$TreeView$createViewTree(model);
	var treeView = treeViewInfo.a;
	var otherFilterValues = _List_fromArray(
		['all', 'true', 'false']);
	var nodeCounts = treeViewInfo.b;
	var brandList = $elm$core$Set$toList(
		$elm$core$Set$fromList(
			A2(
				$elm$core$List$filterMap,
				function ($) {
					return $.brand;
				},
				model.data)));
	var brandFilterValues = A2($elm$core$List$cons, 'all', brandList);
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['description'])),
						$elm$html$Html$Attributes$align('center')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Hints: By scrolling you can zoom out or in the visualization and you can move the tree. By clicking on a node (not a leaf), the tree focuses and zooms on this node. By clicking on a leaf node, you switch to the starplot of the node. You can select different filters to bound the result.')
							]))
					])),
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotTreeInfo']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotAttributeSelect']))
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text(
										'Smartphones in Tree: ' + $elm$core$Debug$toString(nodeCounts.b))
									]))
							])),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotAttributeSelect']))
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text(
										'Total Smartphones: ' + $elm$core$Debug$toString(nodeCounts.a))
									]))
							]))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' Brand: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$TreeView$SetBrandTree)
							]),
						A2(
							$elm$core$List$map,
							$author$project$TreeView$createSelectorOptions(model.treeOption.selectedFilter.brand),
							brandFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' 5G:  ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$TreeView$Set5GTree)
							]),
						A2(
							$elm$core$List$map,
							$author$project$TreeView$createSelectorOptions(model.treeOption.selectedFilter.g5),
							otherFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' NFC: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$TreeView$SetNFCTree)
							]),
						A2(
							$elm$core$List$map,
							$author$project$TreeView$createSelectorOptions(model.treeOption.selectedFilter.nfc),
							otherFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(' IR-Blaster: ')
							])),
						A2(
						$elm$html$Html$select,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$TreeView$SetIRBlasterTree)
							]),
						A2(
							$elm$core$List$map,
							$author$project$TreeView$createSelectorOptions(model.treeOption.selectedFilter.ir_blaster),
							otherFilterValues))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Number of nodes to remove: ')
							])),
						A2(
						$elm$html$Html$input,
						_List_fromArray(
							[
								$elm$html$Html$Events$onInput($author$project$TreeView$SetDropCountInput)
							]),
						_List_Nil),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Events$onClick($author$project$TreeView$SetDropCount)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text('Remove nodes')
							]))
					])),
				A2(
				$elm$html$Html$span,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['plotAttributeSelect']))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(
								'Manual removed nodes: ' + $elm$core$Debug$toString(model.treeOption.dropCount))
							]))
					])),
				treeView
			]));
};
var $author$project$Main$view = function (model) {
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['caption'])),
						$elm$html$Html$Attributes$align('center')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$b,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('Smartphone Analysis Visualization')
							]))
					])),
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm_community$typed_svg$TypedSvg$Attributes$class(
						_List_fromArray(
							['buttonMenu'])),
						$elm$html$Html$Attributes$align('center')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotButton'])),
								$elm$html$Html$Events$onClick($author$project$Main$SetViewScatterplot)
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text('Scatterplot')
									]))
							])),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotButton'])),
								$elm$html$Html$Events$onClick($author$project$Main$SetViewParallelCoordesPlot)
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text('ParallelCoordinates')
									]))
							])),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotButton'])),
								$elm$html$Html$Events$onClick($author$project$Main$SetViewTree)
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text('TreeView')
									]))
							])),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm_community$typed_svg$TypedSvg$Attributes$class(
								_List_fromArray(
									['plotButton'])),
								$elm$html$Html$Events$onClick($author$project$Main$SetViewStarPlot)
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$b,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text('Starplot')
									]))
							]))
					])),
				model.plotVisible.scatterPlot ? A2(
				$elm$html$Html$map,
				$author$project$Main$ScatterplotMsg,
				$author$project$Scatterplot$viewScatterplot(model)) : A2($elm$html$Html$div, _List_Nil, _List_Nil),
				model.plotVisible.parallelCoordinatesPlot ? A2(
				$elm$html$Html$map,
				$author$project$Main$ParallelCoordinatesMsg,
				$author$project$ParallelCoordinates$viewParallelCoordinates(model)) : A2($elm$html$Html$div, _List_Nil, _List_Nil),
				model.plotVisible.treeView ? A2(
				$elm$html$Html$map,
				$author$project$Main$TreeViewMsg,
				$author$project$TreeView$viewTree(model)) : A2($elm$html$Html$div, _List_Nil, _List_Nil),
				model.plotVisible.starPlot ? A2(
				$elm$html$Html$map,
				$author$project$Main$StarplotMsg,
				$author$project$Starplot$viewStarplot(model)) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
			]));
};
var $author$project$Main$main = $elm$browser$Browser$element(
	{init: $author$project$Main$init, subscriptions: $author$project$Main$subscriptions, update: $author$project$Main$update, view: $author$project$Main$view});
_Platform_export({'Main':{'init':$author$project$Main$main(
	$elm$json$Json$Decode$succeed(_Utils_Tuple0))(0)}});}(this));